//-----------------------------------------------------------------------------
// The confidential and proprietary information contained in this file may
// only be used by a person authorised under and to the extent permitted
// by a subsisting licensing agreement from Arm Limited or its affiliates.
//
//            (C) COPYRIGHT 2012-2016 Arm Limited or its affiliates.
//                ALL RIGHTS RESERVED
//
// This entire notice must be reproduced on all copies of this file
// and copies of this file may only be made by a person if such person is
// permitted to do so under the terms of a subsisting license agreement
// from Arm Limited or its affiliates.
//
//            Release Information : MERCURY-r1p0-00rel0
//
//-----------------------------------------------------------------------------
// Verilog-2001 (IEEE Std 1364-2001)
//-----------------------------------------------------------------------------


`include "mercury_params.v"
`include "mercury_dpu_params.v"

module mercury_dpu_crypto_alu_sha (
  input  wire  [63:0] fad_a_data_f2_i,
  input  wire  [63:0] fad_b_data_f2_i,
  input  wire  [63:0] fad_c_data_f2_i,
  output wire  [63:0] sha1h_res_f2_o,
  output wire  [63:0] sha1su0_opa_f2_o,
  output wire  [63:0] sha1su0_opb_f2_o,
  output wire  [63:0] sha256su0_opa_f2_o,
  output wire  [63:0] sha256su0_opb_f2_o
);


  assign sha1h_res_f2_o = { {32{1'b0}}, fad_a_data_f2_i[1:0], fad_a_data_f2_i[31:2]};

  assign sha1su0_opa_f2_o = fad_a_data_f2_i;
  assign sha1su0_opb_f2_o = fad_b_data_f2_i ^ fad_c_data_f2_i;

  assign sha256su0_opa_f2_o[31: 0] = {fad_a_data_f2_i[38:32], fad_a_data_f2_i[63:39]} ^ {fad_a_data_f2_i[49:32], fad_a_data_f2_i[63:50]} ^ {3'b000, fad_a_data_f2_i[63:35]};
  assign sha256su0_opa_f2_o[63:32] = {fad_b_data_f2_i[ 6: 0], fad_b_data_f2_i[31: 7]} ^ {fad_b_data_f2_i[17: 0], fad_b_data_f2_i[31:18]} ^ {3'b000, fad_b_data_f2_i[31: 3]};

  assign sha256su0_opb_f2_o = fad_a_data_f2_i;

endmodule

`define MERCURY_UNDEFINE
`include "mercury_params.v"
`include "mercury_dpu_params.v"
`undef MERCURY_UNDEFINE
