//-----------------------------------------------------------------------------
// The confidential and proprietary information contained in this file may
// only be used by a person authorised under and to the extent permitted
// by a subsisting licensing agreement from Arm Limited or its affiliates.
//
//            (C) COPYRIGHT 2004-2016 Arm Limited or its affiliates.
//                ALL RIGHTS RESERVED
//
// This entire notice must be reproduced on all copies of this file
// and copies of this file may only be made by a person if such person is
// permitted to do so under the terms of a subsisting license agreement
// from Arm Limited or its affiliates.
//
//            Release Information : MERCURY-r1p0-00rel0
//
//-----------------------------------------------------------------------------
// Verilog-2001 (IEEE Std 1364-2001)
//-----------------------------------------------------------------------------


`ifndef MERCURY_UNDEFINE

`define MERCURY_DP_WIDTH   64
`define MERCURY_DP_BITS_W   6
`define MERCURY_DP_COUNT_W  7


`define MERCURY_RP_RD_3_0          0
`define MERCURY_RP_RD_11_8         1
`define MERCURY_RP_RD_15_12        2
`define MERCURY_RP_RD_19_16        3
`define MERCURY_RP_RD_STM          4
`define MERCURY_RP_RD_MCR          5
`define MERCURY_RP_RD_ERET         6

`define MERCURY_RP0_RD_2_0         4
`define MERCURY_RP0_RD_R13         7

`define MERCURY_RP2_RD_R14         7
`define MERCURY_RP2_RD_RMOD        8

`define MERCURY_RD_CTL_EN          0
`define MERCURY_RD_CTL_PC          1
`define MERCURY_RD_CTL_ZR          2
`define MERCURY_RD_CTL_STM         3

`define MERCURY_WR_CTL_EN          0
`define MERCURY_WR_CTL_19_16       1
`define MERCURY_WR_CTL_15_12       2
`define MERCURY_WR_CTL_11_8        3
`define MERCURY_WR_CTL_3_0         4
`define MERCURY_WR_CTL_LDM         5
`define MERCURY_WR_CTL_ART         6
`define MERCURY_WR_CTL_R30         7
`define MERCURY_WR_CTL_RMOD        8
`define MERCURY_WR_CTL_R13         9
`define MERCURY_WR_CTL_R14         10
`define MERCURY_WR_CTL_R15         11
`define MERCURY_WR_CTL_ZR          12


`define mercury_dpu_sel_0x 2'b00, 2'b01
`define mercury_dpu_sel_1x 2'b10, 2'b11

`define mercury_dpu_sel_0x0 3'b000, 3'b010
`define mercury_dpu_sel_0x1 3'b001, 3'b011
`define mercury_dpu_sel_0xx 3'b000, 3'b001, 3'b010, 3'b011
`define mercury_dpu_sel_00x 3'b000, 3'b001
`define mercury_dpu_sel_10x 3'b100, 3'b101
`define mercury_dpu_sel_1x0 3'b100, 3'b110
`define mercury_dpu_sel_1x1 3'b101, 3'b111
`define mercury_dpu_sel_11x 3'b110, 3'b111

`define mercury_dpu_sel_000 3'b000
`define mercury_dpu_sel_001 3'b001
`define mercury_dpu_sel_01x 3'b010, 3'b011
`define mercury_dpu_sel_1xx 3'b100, 3'b101, 3'b110, 3'b111

`define mercury_dpu_sel_100 3'b100
`define mercury_dpu_sel_x10 3'b010, 3'b110
`define mercury_dpu_sel_xx1 3'b001, 3'b011, 3'b101, 3'b111

`define mercury_dpu_sel_1n00 3'b101, 3'b110, 3'b111

`define mercury_dpu_sel_1xxx 4'b1000, 4'b1001, 4'b1010, 4'b1011, 4'b1100, 4'b1101, 4'b1110, 4'b1111
`define mercury_dpu_sel_01xx 4'b0100, 4'b0101, 4'b0110, 4'b0111
`define mercury_dpu_sel_001x 4'b0010, 4'b0011

`define mercury_dpu_sel_0xxx 4'b0000, 4'b0001, 4'b0010, 4'b0011, 4'b0100, 4'b0101, 4'b0110, 4'b0111
`define mercury_dpu_sel_00xx 4'b0000, 4'b0001, 4'b0010, 4'b0011
`define mercury_dpu_sel_xx00 4'b0000, 4'b0100, 4'b1000, 4'b1100
`define mercury_dpu_sel_000x 4'b0000, 4'b0001
`define mercury_dpu_sel_010x 4'b0100, 4'b0101
`define mercury_dpu_sel_10xx 4'b1000, 4'b1001, 4'b1010, 4'b1011
`define mercury_dpu_sel_100x 4'b1000, 4'b1001
`define mercury_dpu_sel_101x 4'b1010, 4'b1011
`define mercury_dpu_sel_xx00_not_0000 4'b0100, 4'b1000, 4'b1100

`define mercury_dpu_sel_1000 4'b1000
`define mercury_dpu_sel_x100 4'b0100, 4'b1100
`define mercury_dpu_sel_xx10 4'b0010, 4'b0110, 4'b1010, 4'b1110
`define mercury_dpu_sel_xx11 4'b0011, 4'b0111, 4'b1011, 4'b1111
`define mercury_dpu_sel_xx01 4'b0001, 4'b0101, 4'b1001, 4'b1101
`define mercury_dpu_sel_xxx1 `mercury_dpu_sel_xx01, `mercury_dpu_sel_xx11
`define mercury_dpu_sel_xx01_not_0001 4'b0101, 4'b1001, 4'b1101

`define mercury_dpu_sel_0x00 4'b0000, 4'b0100
`define mercury_dpu_sel_0x01 4'b0001, 4'b0101
`define mercury_dpu_sel_0x1x 4'b0010, 4'b0011, 4'b0110, 4'b0111
`define mercury_dpu_sel_10x0 4'b1000, 4'b1010
`define mercury_dpu_sel_10x1 4'b1001, 4'b1011
`define mercury_dpu_sel_11xx 4'b1100, 4'b1101, 4'b1110, 4'b1111

`define mercury_dpu_sel_000xx 5'b0_0000, 5'b0_0001, 5'b0_0010, 5'b0_0011
`define mercury_dpu_sel_001xx 5'b0_0100, 5'b0_0101, 5'b0_0110, 5'b0_0111
`define mercury_dpu_sel_100xx 5'b1_0000, 5'b1_0001, 5'b1_0010, 5'b1_0011
`define mercury_dpu_sel_101xx 5'b1_0100, 5'b1_0101, 5'b1_0110, 5'b1_0111
`define mercury_dpu_sel_x000x 5'b0_0000, 5'b0_0001, 5'b1_0000, 5'b1_0001
`define mercury_dpu_sel_x001x 5'b0_0010, 5'b0_0011, 5'b1_0010, 5'b1_0011
`define mercury_dpu_sel_x010x 5'b0_0100, 5'b0_0101, 5'b1_0100, 5'b1_0101
`define mercury_dpu_sel_x011x 5'b0_0110, 5'b0_0111, 5'b1_0110, 5'b1_0111
`define mercury_dpu_sel_x100x 5'b0_1000, 5'b0_1001, 5'b1_1000, 5'b1_1001
`define mercury_dpu_sel_x101x 5'b0_1010, 5'b0_1011, 5'b1_1010, 5'b1_1011
`define mercury_dpu_sel_x1100 5'b01100, 5'b11100
`define mercury_dpu_sel_x1101 5'b01101, 5'b11101
`define mercury_dpu_sel_x1110 5'b01110, 5'b11110
`define mercury_dpu_sel_x1111 5'b01111, 5'b11111
`define mercury_dpu_sel_00xxx  5'b0_0000, 5'b0_0001, 5'b0_0010, 5'b0_0011, 5'b0_0100, 5'b0_0101, 5'b0_0110, 5'b0_0111
`define mercury_dpu_sel_1xxxx  5'b1_0000, 5'b1_0001, 5'b1_0010, 5'b1_0011, 5'b1_0100, 5'b1_0101, 5'b1_0110, 5'b1_0111, 5'b1_1000, 5'b1_1001, 5'b1_1010, 5'b1_1011, 5'b1_1100, 5'b1_1101, 5'b1_1110, 5'b1_1111
`define mercury_dpu_sel_01xxx  5'b0_1000, 5'b0_1001, 5'b0_1010, 5'b0_1011, 5'b0_1100, 5'b0_1101, 5'b0_1110, 5'b0_1111
`define mercury_dpu_sel_0001x  5'b0_0010, 5'b0_0011

`define mercury_dpu_sel_1x_xxxx__p0 6'b10_0000, 6'b10_0001, 6'b10_0010, 6'b10_0011, 6'b10_0100, 6'b10_0101
`define mercury_dpu_sel_1x_xxxx__p1 6'b10_0110, 6'b10_0111, 6'b10_1000, 6'b10_1001, 6'b10_1010, 6'b10_1011
`define mercury_dpu_sel_1x_xxxx__p2 6'b10_1100, 6'b10_1101, 6'b10_1110, 6'b10_1111, 6'b11_0000, 6'b11_0001
`define mercury_dpu_sel_1x_xxxx__p3 6'b11_0010, 6'b11_0011, 6'b11_0100, 6'b11_0101, 6'b11_0110, 6'b11_0111
`define mercury_dpu_sel_1x_xxxx__p4 6'b11_1000, 6'b11_1001, 6'b11_1010, 6'b11_1011, 6'b11_1100, 6'b11_1101
`define mercury_dpu_sel_1x_xxxx__p5 6'b11_1110, 6'b11_1111
`define mercury_dpu_sel_1x_xxxx `mercury_dpu_sel_1x_xxxx__p0, `mercury_dpu_sel_1x_xxxx__p1, `mercury_dpu_sel_1x_xxxx__p2, `mercury_dpu_sel_1x_xxxx__p3, `mercury_dpu_sel_1x_xxxx__p4, `mercury_dpu_sel_1x_xxxx__p5

`define mercury_dpu_sel_01_xxxx_p0 6'b01_0000, 6'b01_0001, 6'b01_0010, 6'b01_0011, 6'b01_0100, 6'b01_0101
`define mercury_dpu_sel_01_xxxx_p1 6'b01_0110, 6'b01_0111, 6'b01_1000, 6'b01_1001, 6'b01_1010, 6'b01_1011
`define mercury_dpu_sel_01_xxxx_p2 6'b01_1100, 6'b01_1101, 6'b01_1110, 6'b01_1111
`define mercury_dpu_sel_01_xxxx `mercury_dpu_sel_01_xxxx_p0, `mercury_dpu_sel_01_xxxx_p1, `mercury_dpu_sel_01_xxxx_p2

`define mercury_dpu_sel_00_1xxx 6'b00_1000, 6'b00_1001, 6'b00_1010, 6'b00_1011, 6'b00_1100, 6'b00_1101, 6'b00_1110, 6'b00_1111
`define mercury_dpu_sel_00_01xx 6'b00_0100, 6'b00_0101, 6'b00_0110, 6'b00_0111
`define mercury_dpu_sel_00_001x 6'b00_0010, 6'b00_0011

`define mercury_dpu_sel_1xx_xxxx_p0 7'b100_0000, 7'b100_0001, 7'b100_0010, 7'b100_0011, 7'b100_0100, 7'b100_0101
`define mercury_dpu_sel_1xx_xxxx_p1 7'b100_0110, 7'b100_0111, 7'b100_1000, 7'b100_1001, 7'b100_1010, 7'b100_1011
`define mercury_dpu_sel_1xx_xxxx_p2 7'b100_1100, 7'b100_1101, 7'b100_1110, 7'b100_1111, 7'b101_0000, 7'b101_0001
`define mercury_dpu_sel_1xx_xxxx_p3 7'b101_0010, 7'b101_0011, 7'b101_0100, 7'b101_0101, 7'b101_0110, 7'b101_0111
`define mercury_dpu_sel_1xx_xxxx_p4 7'b101_1000, 7'b101_1001, 7'b101_1010, 7'b101_1011, 7'b101_1100, 7'b101_1101
`define mercury_dpu_sel_1xx_xxxx_p5 7'b101_1110, 7'b101_1111, 7'b110_0000, 7'b110_0001, 7'b110_0010, 7'b110_0011
`define mercury_dpu_sel_1xx_xxxx_p6 7'b110_0100, 7'b110_0101, 7'b110_0110, 7'b110_0111, 7'b110_1000, 7'b110_1001
`define mercury_dpu_sel_1xx_xxxx_p7 7'b110_1010, 7'b110_1011, 7'b110_1100, 7'b110_1101, 7'b110_1110, 7'b110_1111
`define mercury_dpu_sel_1xx_xxxx_p8 7'b111_0000, 7'b111_0001, 7'b111_0010, 7'b111_0011, 7'b111_0100, 7'b111_0101
`define mercury_dpu_sel_1xx_xxxx_p9 7'b111_0110, 7'b111_0111, 7'b111_1000, 7'b111_1001, 7'b111_1010, 7'b111_1011
`define mercury_dpu_sel_1xx_xxxx_p10 7'b111_1100, 7'b111_1101, 7'b111_1110, 7'b111_1111
`define mercury_dpu_sel_1xx_xxxx `mercury_dpu_sel_1xx_xxxx_p0, `mercury_dpu_sel_1xx_xxxx_p1, `mercury_dpu_sel_1xx_xxxx_p2, `mercury_dpu_sel_1xx_xxxx_p3, `mercury_dpu_sel_1xx_xxxx_p4, `mercury_dpu_sel_1xx_xxxx_p5, \
`mercury_dpu_sel_1xx_xxxx_p6, `mercury_dpu_sel_1xx_xxxx_p7, `mercury_dpu_sel_1xx_xxxx_p8, `mercury_dpu_sel_1xx_xxxx_p9, `mercury_dpu_sel_1xx_xxxx_p10


`define mercury_dpu_sel_01x_xxxx_p0 7'b010_0000, 7'b010_0001, 7'b010_0010, 7'b010_0011, 7'b010_0100, 7'b010_0101
`define mercury_dpu_sel_01x_xxxx_p1 7'b010_0110, 7'b010_0111, 7'b010_1000, 7'b010_1001, 7'b010_1010, 7'b010_1011
`define mercury_dpu_sel_01x_xxxx_p2 7'b010_1100, 7'b010_1101, 7'b010_1110, 7'b010_1111, 7'b011_0000, 7'b011_0001
`define mercury_dpu_sel_01x_xxxx_p3 7'b011_0010, 7'b011_0011, 7'b011_0100, 7'b011_0101, 7'b011_0110, 7'b011_0111
`define mercury_dpu_sel_01x_xxxx_p4 7'b011_1000, 7'b011_1001, 7'b011_1010, 7'b011_1011, 7'b011_1100, 7'b011_1101
`define mercury_dpu_sel_01x_xxxx_p5 7'b011_1110, 7'b011_1111
`define mercury_dpu_sel_01x_xxxx `mercury_dpu_sel_01x_xxxx_p0, `mercury_dpu_sel_01x_xxxx_p1, `mercury_dpu_sel_01x_xxxx_p2, `mercury_dpu_sel_01x_xxxx_p3, `mercury_dpu_sel_01x_xxxx_p4, `mercury_dpu_sel_01x_xxxx_p5

`define mercury_dpu_sel_001_xxxx_p0 7'b001_0000, 7'b001_0001, 7'b001_0010, 7'b001_0011, 7'b001_0100, 7'b001_0101
`define mercury_dpu_sel_001_xxxx_p1 7'b001_0110, 7'b001_0111, 7'b001_1000, 7'b001_1001, 7'b001_1010, 7'b001_1011
`define mercury_dpu_sel_001_xxxx_p2 7'b001_1100, 7'b001_1101, 7'b001_1110, 7'b001_1111
`define mercury_dpu_sel_001_xxxx `mercury_dpu_sel_001_xxxx_p0, `mercury_dpu_sel_001_xxxx_p1, `mercury_dpu_sel_001_xxxx_p2

`define mercury_dpu_sel_000_1xxx 7'b000_1000, 7'b000_1001, 7'b000_1010, 7'b000_1011, 7'b000_1100, 7'b000_1101, 7'b000_1110, 7'b000_1111
`define mercury_dpu_sel_000_01xx 7'b000_0100, 7'b000_0101, 7'b000_0110, 7'b000_0111
`define mercury_dpu_sel_000_001x 7'b000_0010, 7'b000_0011

`define mercury_dpu_sel_0000_01xx 8'b0000_0100, 8'b0000_0101, 8'b0000_0110, 8'b0000_0111
`define mercury_dpu_sel_0000_001x 8'b0000_0010, 8'b0000_0011
`define mercury_dpu_sel_0000_1xx0 8'b0000_1000, 8'b0000_1010, 8'b0000_1100, 8'b0000_1110
`define mercury_dpu_sel_0000_1xx1 8'b0000_1001, 8'b0000_1011, 8'b0000_1101, 8'b0000_1111

`define mercury_dpu_sel_0000_1xxx `mercury_dpu_sel_0000_1xx0, `mercury_dpu_sel_0000_1xx1

`define mercury_dpu_sel_0001_00xx 8'b0001_0000, 8'b0001_0001, 8'b0001_0010, 8'b0001_0011
`define mercury_dpu_sel_0001_01xx 8'b0001_0100, 8'b0001_0101, 8'b0001_0110, 8'b0001_0111
`define mercury_dpu_sel_0001_10xx 8'b0001_1000, 8'b0001_1001, 8'b0001_1010, 8'b0001_1011
`define mercury_dpu_sel_0001_11xx 8'b0001_1100, 8'b0001_1101, 8'b0001_1110, 8'b0001_1111

`define mercury_dpu_sel_0010_00xx 8'b0010_0000, 8'b0010_0001, 8'b0010_0010, 8'b0010_0011
`define mercury_dpu_sel_0010_01xx 8'b0010_0100, 8'b0010_0101, 8'b0010_0110, 8'b0010_0111
`define mercury_dpu_sel_0010_10xx 8'b0010_1000, 8'b0010_1001, 8'b0010_1010, 8'b0010_1011
`define mercury_dpu_sel_0010_11xx 8'b0010_1100, 8'b0010_1101, 8'b0010_1110, 8'b0010_1111

`define mercury_dpu_sel_0011_00xx 8'b0011_0000, 8'b0011_0001, 8'b0011_0010, 8'b0011_0011
`define mercury_dpu_sel_0011_01xx 8'b0011_0100, 8'b0011_0101, 8'b0011_0110, 8'b0011_0111
`define mercury_dpu_sel_0011_10xx 8'b0011_1000, 8'b0011_1001, 8'b0011_1010, 8'b0011_1011
`define mercury_dpu_sel_0011_11xx 8'b0011_1100, 8'b0011_1101, 8'b0011_1110, 8'b0011_1111

`define mercury_dpu_sel_0100_00xx 8'b0100_0000, 8'b0100_0001, 8'b0100_0010, 8'b0100_0011
`define mercury_dpu_sel_0100_01xx 8'b0100_0100, 8'b0100_0101, 8'b0100_0110, 8'b0100_0111
`define mercury_dpu_sel_0100_10xx 8'b0100_1000, 8'b0100_1001, 8'b0100_1010, 8'b0100_1011
`define mercury_dpu_sel_0100_11xx 8'b0100_1100, 8'b0100_1101, 8'b0100_1110, 8'b0100_1111

`define mercury_dpu_sel_0101_00xx 8'b0101_0000, 8'b0101_0001, 8'b0101_0010, 8'b0101_0011
`define mercury_dpu_sel_0101_01xx 8'b0101_0100, 8'b0101_0101, 8'b0101_0110, 8'b0101_0111
`define mercury_dpu_sel_0101_10xx 8'b0101_1000, 8'b0101_1001, 8'b0101_1010, 8'b0101_1011
`define mercury_dpu_sel_0101_11xx 8'b0101_1100, 8'b0101_1101, 8'b0101_1110, 8'b0101_1111

`define mercury_dpu_sel_0110_00xx 8'b0110_0000, 8'b0110_0001, 8'b0110_0010, 8'b0110_0011
`define mercury_dpu_sel_0110_01xx 8'b0110_0100, 8'b0110_0101, 8'b0110_0110, 8'b0110_0111
`define mercury_dpu_sel_0110_10xx 8'b0110_1000, 8'b0110_1001, 8'b0110_1010, 8'b0110_1011
`define mercury_dpu_sel_0110_11xx 8'b0110_1100, 8'b0110_1101, 8'b0110_1110, 8'b0110_1111

`define mercury_dpu_sel_0111_00xx 8'b0111_0000, 8'b0111_0001, 8'b0111_0010, 8'b0111_0011
`define mercury_dpu_sel_0111_01xx 8'b0111_0100, 8'b0111_0101, 8'b0111_0110, 8'b0111_0111
`define mercury_dpu_sel_0111_10xx 8'b0111_1000, 8'b0111_1001, 8'b0111_1010, 8'b0111_1011
`define mercury_dpu_sel_0111_11xx 8'b0111_1100, 8'b0111_1101, 8'b0111_1110, 8'b0111_1111

`define mercury_dpu_sel_1000_00xx 8'b1000_0000, 8'b1000_0001, 8'b1000_0010, 8'b1000_0011
`define mercury_dpu_sel_1000_01xx 8'b1000_0100, 8'b1000_0101, 8'b1000_0110, 8'b1000_0111
`define mercury_dpu_sel_1000_10xx 8'b1000_1000, 8'b1000_1001, 8'b1000_1010, 8'b1000_1011
`define mercury_dpu_sel_1000_11xx 8'b1000_1100, 8'b1000_1101, 8'b1000_1110, 8'b1000_1111

`define mercury_dpu_sel_1001_00xx 8'b1001_0000, 8'b1001_0001, 8'b1001_0010, 8'b1001_0011
`define mercury_dpu_sel_1001_01xx 8'b1001_0100, 8'b1001_0101, 8'b1001_0110, 8'b1001_0111
`define mercury_dpu_sel_1001_10xx 8'b1001_1000, 8'b1001_1001, 8'b1001_1010, 8'b1001_1011
`define mercury_dpu_sel_1001_11xx 8'b1001_1100, 8'b1001_1101, 8'b1001_1110, 8'b1001_1111

`define mercury_dpu_sel_1010_00xx 8'b1010_0000, 8'b1010_0001, 8'b1010_0010, 8'b1010_0011
`define mercury_dpu_sel_1010_01xx 8'b1010_0100, 8'b1010_0101, 8'b1010_0110, 8'b1010_0111
`define mercury_dpu_sel_1010_10xx 8'b1010_1000, 8'b1010_1001, 8'b1010_1010, 8'b1010_1011
`define mercury_dpu_sel_1010_11xx 8'b1010_1100, 8'b1010_1101, 8'b1010_1110, 8'b1010_1111

`define mercury_dpu_sel_1011_00xx 8'b1011_0000, 8'b1011_0001, 8'b1011_0010, 8'b1011_0011
`define mercury_dpu_sel_1011_01xx 8'b1011_0100, 8'b1011_0101, 8'b1011_0110, 8'b1011_0111
`define mercury_dpu_sel_1011_10xx 8'b1011_1000, 8'b1011_1001, 8'b1011_1010, 8'b1011_1011
`define mercury_dpu_sel_1011_11xx 8'b1011_1100, 8'b1011_1101, 8'b1011_1110, 8'b1011_1111

`define mercury_dpu_sel_1100_00xx 8'b1100_0000, 8'b1100_0001, 8'b1100_0010, 8'b1100_0011
`define mercury_dpu_sel_1100_01xx 8'b1100_0100, 8'b1100_0101, 8'b1100_0110, 8'b1100_0111
`define mercury_dpu_sel_1100_10xx 8'b1100_1000, 8'b1100_1001, 8'b1100_1010, 8'b1100_1011
`define mercury_dpu_sel_1100_11xx 8'b1100_1100, 8'b1100_1101, 8'b1100_1110, 8'b1100_1111

`define mercury_dpu_sel_1101_00xx 8'b1101_0000, 8'b1101_0001, 8'b1101_0010, 8'b1101_0011
`define mercury_dpu_sel_1101_01xx 8'b1101_0100, 8'b1101_0101, 8'b1101_0110, 8'b1101_0111
`define mercury_dpu_sel_1101_10xx 8'b1101_1000, 8'b1101_1001, 8'b1101_1010, 8'b1101_1011
`define mercury_dpu_sel_1101_11xx 8'b1101_1100, 8'b1101_1101, 8'b1101_1110, 8'b1101_1111

`define mercury_dpu_sel_1110_00xx 8'b1110_0000, 8'b1110_0001, 8'b1110_0010, 8'b1110_0011
`define mercury_dpu_sel_1110_01xx 8'b1110_0100, 8'b1110_0101, 8'b1110_0110, 8'b1110_0111
`define mercury_dpu_sel_1110_10xx 8'b1110_1000, 8'b1110_1001, 8'b1110_1010, 8'b1110_1011
`define mercury_dpu_sel_1110_11xx 8'b1110_1100, 8'b1110_1101, 8'b1110_1110, 8'b1110_1111

`define mercury_dpu_sel_1111_00xx 8'b1111_0000, 8'b1111_0001, 8'b1111_0010, 8'b1111_0011
`define mercury_dpu_sel_1111_01xx 8'b1111_0100, 8'b1111_0101, 8'b1111_0110, 8'b1111_0111
`define mercury_dpu_sel_1111_10xx 8'b1111_1000, 8'b1111_1001, 8'b1111_1010, 8'b1111_1011
`define mercury_dpu_sel_1111_11xx 8'b1111_1100, 8'b1111_1101, 8'b1111_1110, 8'b1111_1111

`define mercury_dpu_sel_0001_xxxx `mercury_dpu_sel_0001_00xx, `mercury_dpu_sel_0001_01xx, `mercury_dpu_sel_0001_10xx, `mercury_dpu_sel_0001_11xx
`define mercury_dpu_sel_0010_xxxx `mercury_dpu_sel_0010_00xx, `mercury_dpu_sel_0010_01xx, `mercury_dpu_sel_0010_10xx, `mercury_dpu_sel_0010_11xx
`define mercury_dpu_sel_0011_xxxx `mercury_dpu_sel_0011_00xx, `mercury_dpu_sel_0011_01xx, `mercury_dpu_sel_0011_10xx, `mercury_dpu_sel_0011_11xx
`define mercury_dpu_sel_0100_xxxx `mercury_dpu_sel_0100_00xx, `mercury_dpu_sel_0100_01xx, `mercury_dpu_sel_0100_10xx, `mercury_dpu_sel_0100_11xx
`define mercury_dpu_sel_0101_xxxx `mercury_dpu_sel_0101_00xx, `mercury_dpu_sel_0101_01xx, `mercury_dpu_sel_0101_10xx, `mercury_dpu_sel_0101_11xx
`define mercury_dpu_sel_0110_xxxx `mercury_dpu_sel_0110_00xx, `mercury_dpu_sel_0110_01xx, `mercury_dpu_sel_0110_10xx, `mercury_dpu_sel_0110_11xx
`define mercury_dpu_sel_0111_xxxx `mercury_dpu_sel_0111_00xx, `mercury_dpu_sel_0111_01xx, `mercury_dpu_sel_0111_10xx, `mercury_dpu_sel_0111_11xx

`define mercury_dpu_sel_1000_xxxx `mercury_dpu_sel_1000_00xx, `mercury_dpu_sel_1000_01xx, `mercury_dpu_sel_1000_10xx, `mercury_dpu_sel_1000_11xx
`define mercury_dpu_sel_1001_xxxx `mercury_dpu_sel_1001_00xx, `mercury_dpu_sel_1001_01xx, `mercury_dpu_sel_1001_10xx, `mercury_dpu_sel_1001_11xx
`define mercury_dpu_sel_1010_xxxx `mercury_dpu_sel_1010_00xx, `mercury_dpu_sel_1010_01xx, `mercury_dpu_sel_1010_10xx, `mercury_dpu_sel_1010_11xx
`define mercury_dpu_sel_1011_xxxx `mercury_dpu_sel_1011_00xx, `mercury_dpu_sel_1011_01xx, `mercury_dpu_sel_1011_10xx, `mercury_dpu_sel_1011_11xx
`define mercury_dpu_sel_1100_xxxx `mercury_dpu_sel_1100_00xx, `mercury_dpu_sel_1100_01xx, `mercury_dpu_sel_1100_10xx, `mercury_dpu_sel_1100_11xx
`define mercury_dpu_sel_1101_xxxx `mercury_dpu_sel_1101_00xx, `mercury_dpu_sel_1101_01xx, `mercury_dpu_sel_1101_10xx, `mercury_dpu_sel_1101_11xx
`define mercury_dpu_sel_1110_xxxx `mercury_dpu_sel_1110_00xx, `mercury_dpu_sel_1110_01xx, `mercury_dpu_sel_1110_10xx, `mercury_dpu_sel_1110_11xx
`define mercury_dpu_sel_1111_xxxx `mercury_dpu_sel_1111_00xx, `mercury_dpu_sel_1111_01xx, `mercury_dpu_sel_1111_10xx, `mercury_dpu_sel_1111_11xx

`define mercury_dpu_sel_1xxx_xxxx `mercury_dpu_sel_1000_xxxx, `mercury_dpu_sel_1001_xxxx, `mercury_dpu_sel_1010_xxxx, `mercury_dpu_sel_1011_xxxx, \
                              `mercury_dpu_sel_1100_xxxx, `mercury_dpu_sel_1101_xxxx, `mercury_dpu_sel_1110_xxxx, `mercury_dpu_sel_1111_xxxx
`define mercury_dpu_sel_01xx_xxxx `mercury_dpu_sel_0100_xxxx, `mercury_dpu_sel_0101_xxxx, `mercury_dpu_sel_0110_xxxx, `mercury_dpu_sel_0111_xxxx
`define mercury_dpu_sel_001x_xxxx `mercury_dpu_sel_0010_xxxx, `mercury_dpu_sel_0011_xxxx


`define MERCURY_VADDR_R00 5'b00000
`define MERCURY_VADDR_R01 5'b00001
`define MERCURY_VADDR_R02 5'b00010
`define MERCURY_VADDR_R03 5'b00011
`define MERCURY_VADDR_R04 5'b00100
`define MERCURY_VADDR_R05 5'b00101
`define MERCURY_VADDR_R06 5'b00110
`define MERCURY_VADDR_R07 5'b00111
`define MERCURY_VADDR_R08 5'b01000
`define MERCURY_VADDR_R09 5'b01001
`define MERCURY_VADDR_R10 5'b01010
`define MERCURY_VADDR_R11 5'b01011
`define MERCURY_VADDR_R12 5'b01100
`define MERCURY_VADDR_R13 5'b01101
`define MERCURY_VADDR_R14 5'b01110
`define MERCURY_VADDR_R15 5'b01111
`define MERCURY_VADDR_R16 5'b10000
`define MERCURY_VADDR_R17 5'b10001
`define MERCURY_VADDR_R18 5'b10010
`define MERCURY_VADDR_R19 5'b10011
`define MERCURY_VADDR_R20 5'b10100
`define MERCURY_VADDR_R21 5'b10101
`define MERCURY_VADDR_R22 5'b10110
`define MERCURY_VADDR_R23 5'b10111
`define MERCURY_VADDR_R24 5'b11000
`define MERCURY_VADDR_R25 5'b11001
`define MERCURY_VADDR_R26 5'b11010
`define MERCURY_VADDR_R27 5'b11011
`define MERCURY_VADDR_R28 5'b11100
`define MERCURY_VADDR_R29 5'b11101
`define MERCURY_VADDR_R30 5'b11110
`define MERCURY_VADDR_R31 5'b11111

`define MERCURY_ADDR_X0      6'b00_0000
`define MERCURY_ADDR_X1      6'b00_0001
`define MERCURY_ADDR_X2      6'b00_0010
`define MERCURY_ADDR_X3      6'b00_0011
`define MERCURY_ADDR_X4      6'b00_0100
`define MERCURY_ADDR_X5      6'b00_0101
`define MERCURY_ADDR_X6      6'b00_0110
`define MERCURY_ADDR_X7      6'b00_0111
`define MERCURY_ADDR_X8      6'b10_0000
`define MERCURY_ADDR_X9      6'b10_0001
`define MERCURY_ADDR_X10     6'b10_0010
`define MERCURY_ADDR_X11     6'b10_0011
`define MERCURY_ADDR_X12     6'b10_0100
`define MERCURY_ADDR_X13     6'b10_0101
`define MERCURY_ADDR_X14     6'b10_0110
`define MERCURY_ADDR_X15     6'b11_1111
`define MERCURY_ADDR_X16     6'b11_0000
`define MERCURY_ADDR_X17     6'b11_0001
`define MERCURY_ADDR_X18     6'b11_0010
`define MERCURY_ADDR_X19     6'b11_0011
`define MERCURY_ADDR_X20     6'b11_0100
`define MERCURY_ADDR_X21     6'b11_0101
`define MERCURY_ADDR_X22     6'b11_0110
`define MERCURY_ADDR_X23     6'b11_0111
`define MERCURY_ADDR_X24     6'b10_1000
`define MERCURY_ADDR_X25     6'b10_1001
`define MERCURY_ADDR_X26     6'b10_1010
`define MERCURY_ADDR_X27     6'b10_1011
`define MERCURY_ADDR_X28     6'b10_1100
`define MERCURY_ADDR_X29     6'b10_1101
`define MERCURY_ADDR_X30     6'b10_1110

`define MERCURY_ADDR_SP_EL0  6'b01_0000
`define MERCURY_ADDR_SP_EL1  6'b01_0001
`define MERCURY_ADDR_SP_EL2  6'b01_0010
`define MERCURY_ADDR_SP_EL3  6'b11_1101
`define MERCURY_ADDR_ELR_EL1 6'b01_0101
`define MERCURY_ADDR_ELR_EL2 6'b11_1110
`define MERCURY_ADDR_ELR_EL3 6'b11_1100

`define MERCURY_ADDR_R00     `MERCURY_ADDR_X0       
`define MERCURY_ADDR_R01     `MERCURY_ADDR_X1       
`define MERCURY_ADDR_R02     `MERCURY_ADDR_X2       
`define MERCURY_ADDR_R03     `MERCURY_ADDR_X3       
`define MERCURY_ADDR_R04     `MERCURY_ADDR_X4       
`define MERCURY_ADDR_R05     `MERCURY_ADDR_X5       
`define MERCURY_ADDR_R06     `MERCURY_ADDR_X6       
`define MERCURY_ADDR_R07     `MERCURY_ADDR_X7       
`define MERCURY_ADDR_R08     `MERCURY_ADDR_X8       
`define MERCURY_ADDR_R09     `MERCURY_ADDR_X9       
`define MERCURY_ADDR_R10     `MERCURY_ADDR_X10      
`define MERCURY_ADDR_R11     `MERCURY_ADDR_X11      
`define MERCURY_ADDR_R12     `MERCURY_ADDR_X12      
`define MERCURY_ADDR_R13     `MERCURY_ADDR_X13      
`define MERCURY_ADDR_R14     `MERCURY_ADDR_X14      
`define MERCURY_ADDR_R13_HYP `MERCURY_ADDR_X15      
`define MERCURY_ADDR_R14_IRQ `MERCURY_ADDR_X16      
`define MERCURY_ADDR_R13_IRQ `MERCURY_ADDR_X17      
`define MERCURY_ADDR_R14_SVC `MERCURY_ADDR_X18      
`define MERCURY_ADDR_R13_SVC `MERCURY_ADDR_X19      
`define MERCURY_ADDR_R14_ABT `MERCURY_ADDR_X20      
`define MERCURY_ADDR_R13_ABT `MERCURY_ADDR_X21      
`define MERCURY_ADDR_R14_UND `MERCURY_ADDR_X22      
`define MERCURY_ADDR_R13_UND `MERCURY_ADDR_X23      
`define MERCURY_ADDR_R08_FIQ `MERCURY_ADDR_X24      
`define MERCURY_ADDR_R09_FIQ `MERCURY_ADDR_X25      
`define MERCURY_ADDR_R10_FIQ `MERCURY_ADDR_X26      
`define MERCURY_ADDR_R11_FIQ `MERCURY_ADDR_X27      
`define MERCURY_ADDR_R12_FIQ `MERCURY_ADDR_X28      
`define MERCURY_ADDR_R13_FIQ `MERCURY_ADDR_X29      
`define MERCURY_ADDR_R14_FIQ `MERCURY_ADDR_X30      
`define MERCURY_ADDR_ELR_HYP `MERCURY_ADDR_ELR_EL2  

`define MERCURY_ADDR_R14_MON `MERCURY_ADDR_ELR_EL3  
`define MERCURY_ADDR_R13_MON `MERCURY_ADDR_SP_EL3   

`define MERCURY_LONG_RF_ADDR_W   38

`define MERCURY_ADDR_BIT_X0      0
`define MERCURY_ADDR_BIT_X1      1
`define MERCURY_ADDR_BIT_X2      2
`define MERCURY_ADDR_BIT_X3      3
`define MERCURY_ADDR_BIT_X4      4
`define MERCURY_ADDR_BIT_X5      5
`define MERCURY_ADDR_BIT_X6      6
`define MERCURY_ADDR_BIT_X7      7
`define MERCURY_ADDR_BIT_X8      8
`define MERCURY_ADDR_BIT_X9      9
`define MERCURY_ADDR_BIT_X10     10
`define MERCURY_ADDR_BIT_X11     11
`define MERCURY_ADDR_BIT_X12     12
`define MERCURY_ADDR_BIT_X13     13
`define MERCURY_ADDR_BIT_X14     14
`define MERCURY_ADDR_BIT_X15     15
`define MERCURY_ADDR_BIT_X16     16
`define MERCURY_ADDR_BIT_X17     17
`define MERCURY_ADDR_BIT_X18     18
`define MERCURY_ADDR_BIT_X19     19
`define MERCURY_ADDR_BIT_X20     20
`define MERCURY_ADDR_BIT_X21     21
`define MERCURY_ADDR_BIT_X22     22
`define MERCURY_ADDR_BIT_X23     23
`define MERCURY_ADDR_BIT_X24     24
`define MERCURY_ADDR_BIT_X25     25
`define MERCURY_ADDR_BIT_X26     26
`define MERCURY_ADDR_BIT_X27     27
`define MERCURY_ADDR_BIT_X28     28
`define MERCURY_ADDR_BIT_X29     29
`define MERCURY_ADDR_BIT_X30     30

`define MERCURY_ADDR_BIT_SP_EL0  31
`define MERCURY_ADDR_BIT_SP_EL1  32
`define MERCURY_ADDR_BIT_SP_EL2  33
`define MERCURY_ADDR_BIT_SP_EL3  34
`define MERCURY_ADDR_BIT_ELR_EL1 35
`define MERCURY_ADDR_BIT_ELR_EL2 36
`define MERCURY_ADDR_BIT_ELR_EL3 37

`define MERCURY_ADDR_BIT_R00     `MERCURY_ADDR_BIT_X0
`define MERCURY_ADDR_BIT_R01     `MERCURY_ADDR_BIT_X1
`define MERCURY_ADDR_BIT_R02     `MERCURY_ADDR_BIT_X2
`define MERCURY_ADDR_BIT_R03     `MERCURY_ADDR_BIT_X3
`define MERCURY_ADDR_BIT_R04     `MERCURY_ADDR_BIT_X4
`define MERCURY_ADDR_BIT_R05     `MERCURY_ADDR_BIT_X5
`define MERCURY_ADDR_BIT_R06     `MERCURY_ADDR_BIT_X6
`define MERCURY_ADDR_BIT_R07     `MERCURY_ADDR_BIT_X7
`define MERCURY_ADDR_BIT_R08     `MERCURY_ADDR_BIT_X8
`define MERCURY_ADDR_BIT_R09     `MERCURY_ADDR_BIT_X9
`define MERCURY_ADDR_BIT_R10     `MERCURY_ADDR_BIT_X10
`define MERCURY_ADDR_BIT_R11     `MERCURY_ADDR_BIT_X11
`define MERCURY_ADDR_BIT_R12     `MERCURY_ADDR_BIT_X12
`define MERCURY_ADDR_BIT_R13     `MERCURY_ADDR_BIT_X13
`define MERCURY_ADDR_BIT_R14     `MERCURY_ADDR_BIT_X14
`define MERCURY_ADDR_BIT_R13_HYP `MERCURY_ADDR_BIT_X15
`define MERCURY_ADDR_BIT_R14_IRQ `MERCURY_ADDR_BIT_X16
`define MERCURY_ADDR_BIT_R13_IRQ `MERCURY_ADDR_BIT_X17
`define MERCURY_ADDR_BIT_R14_SVC `MERCURY_ADDR_BIT_X18
`define MERCURY_ADDR_BIT_R13_SVC `MERCURY_ADDR_BIT_X19
`define MERCURY_ADDR_BIT_R14_ABT `MERCURY_ADDR_BIT_X20
`define MERCURY_ADDR_BIT_R13_ABT `MERCURY_ADDR_BIT_X21
`define MERCURY_ADDR_BIT_R14_UND `MERCURY_ADDR_BIT_X22
`define MERCURY_ADDR_BIT_R13_UND `MERCURY_ADDR_BIT_X23
`define MERCURY_ADDR_BIT_R08_FIQ `MERCURY_ADDR_BIT_X24
`define MERCURY_ADDR_BIT_R09_FIQ `MERCURY_ADDR_BIT_X25
`define MERCURY_ADDR_BIT_R10_FIQ `MERCURY_ADDR_BIT_X26
`define MERCURY_ADDR_BIT_R11_FIQ `MERCURY_ADDR_BIT_X27
`define MERCURY_ADDR_BIT_R12_FIQ `MERCURY_ADDR_BIT_X28
`define MERCURY_ADDR_BIT_R13_FIQ `MERCURY_ADDR_BIT_X29
`define MERCURY_ADDR_BIT_R14_FIQ `MERCURY_ADDR_BIT_X30
`define MERCURY_ADDR_BIT_R13_MON `MERCURY_ADDR_BIT_SP_EL3
`define MERCURY_ADDR_BIT_R14_MON `MERCURY_ADDR_BIT_ELR_EL3
`define MERCURY_ADDR_BIT_ELR_HYP `MERCURY_ADDR_BIT_ELR_EL2

`define MERCURY_SPSR_CRNT 3'b000
`define MERCURY_SPSR_FIQ  3'b001
`define MERCURY_SPSR_IRQ  3'b010
`define MERCURY_SPSR_SVC  3'b011
`define MERCURY_SPSR_ABT  3'b100
`define MERCURY_SPSR_UND  3'b101
`define MERCURY_SPSR_MON  3'b110
`define MERCURY_SPSR_HYP  3'b111

`define MERCURY_EX_PIPE_W           6
`define MERCURY_EX_PIPE_NULL        6'b000000 
`define MERCURY_EX_PIPE_ALU         6'b000001
`define MERCURY_EX_PIPE_BR          6'b000100
`define MERCURY_EX_PIPE_DCU         6'b001000
`define MERCURY_EX_PIPE_DIV         6'b010000
`define MERCURY_EX_PIPE_STR         6'b100000

`define MERCURY_EX_PIPE_ALU_BIT     0
`define MERCURY_EX_PIPE_MAC_BIT     1
`define MERCURY_EX_PIPE_BR_BIT      2
`define MERCURY_EX_PIPE_DCU_BIT     3
`define MERCURY_EX_PIPE_DIV_BIT     4
`define MERCURY_EX_PIPE_STR_BIT     5


`define MERCURY_EXPT_INSTR_TYPE_W               7
`define MERCURY_EXPT_INSTR_TYPE_NULL            7'b0000000
`define MERCURY_EXPT_INSTR_TYPE_UNDEF           7'b0000001
`define MERCURY_EXPT_INSTR_TYPE_PD_UNDEF        7'b0000010
`define MERCURY_EXPT_INSTR_TYPE_FABORT          7'b0000011
`define MERCURY_EXPT_INSTR_TYPE_SVC             7'b0000100
`define MERCURY_EXPT_INSTR_TYPE_HVC             7'b0000101
`define MERCURY_EXPT_INSTR_TYPE_SMC             7'b0000110
`define MERCURY_EXPT_INSTR_TYPE_WFI             7'b0000111
`define MERCURY_EXPT_INSTR_TYPE_WFE             7'b0001000
`define MERCURY_EXPT_INSTR_TYPE_BKPT            7'b0001001
`define MERCURY_EXPT_INSTR_TYPE_HW_BKPT         7'b0001010
`define MERCURY_EXPT_INSTR_TYPE_MON_ACCESS      7'b0001011
`define MERCURY_EXPT_INSTR_TYPE_VIRTUAL_MEM_CTL 7'b0001100
`define MERCURY_EXPT_INSTR_TYPE_DCZVA           7'b0001101
`define MERCURY_EXPT_INSTR_TYPE_TLB             7'b0001110
`define MERCURY_EXPT_INSTR_TYPE_CACHE_POU       7'b0001111
`define MERCURY_EXPT_INSTR_TYPE_DCACHE_POC      7'b0010000
`define MERCURY_EXPT_INSTR_TYPE_DCACHE_SETWAY   7'b0010001
`define MERCURY_EXPT_INSTR_TYPE_ACTLR           7'b0010010
`define MERCURY_EXPT_INSTR_TYPE_ID_GROUP0       7'b0010011
`define MERCURY_EXPT_INSTR_TYPE_ID_GROUP1       7'b0010100
`define MERCURY_EXPT_INSTR_TYPE_ID_GROUP2       7'b0010101
`define MERCURY_EXPT_INSTR_TYPE_ID_GROUP3       7'b0010110
`define MERCURY_EXPT_INSTR_TYPE_CPACR           7'b0010111
`define MERCURY_EXPT_INSTR_TYPE_CNTPS           7'b0011000
`define MERCURY_EXPT_INSTR_TYPE_FP              7'b0011001
`define MERCURY_EXPT_INSTR_TYPE_FP_ID           7'b0011010
`define MERCURY_EXPT_INSTR_TYPE_FP_ID0          7'b0011011
`define MERCURY_EXPT_INSTR_TYPE_FP_ID3          7'b0011100
`define MERCURY_EXPT_INSTR_TYPE_NEON            7'b0011101
`define MERCURY_EXPT_INSTR_TYPE_CRYPTO          7'b0011110
`define MERCURY_EXPT_INSTR_TYPE_DBG_ROM         7'b0011111
`define MERCURY_EXPT_INSTR_TYPE_DBG_OS          7'b0100000
`define MERCURY_EXPT_INSTR_TYPE_DBG_ACCESS      7'b0100001
`define MERCURY_EXPT_INSTR_TYPE_DBG_SHARED      7'b0100010
`define MERCURY_EXPT_INSTR_TYPE_DBG_DTR         7'b0100011
`define MERCURY_EXPT_INSTR_TYPE_PMU_PMCR        7'b0100100
`define MERCURY_EXPT_INSTR_TYPE_PMU_REG         7'b0100101
`define MERCURY_EXPT_INSTR_TYPE_CNTPCT          7'b0100110
`define MERCURY_EXPT_INSTR_TYPE_CNTP            7'b0100111
`define MERCURY_EXPT_INSTR_TYPE_CNTV            7'b0101000
`define MERCURY_EXPT_INSTR_TYPE_CNTVCT          7'b0101001
`define MERCURY_EXPT_INSTR_TYPE_CNTFRQ          7'b0101010
`define MERCURY_EXPT_INSTR_TYPE_MCR_MRC_MISC    7'b0101011
`define MERCURY_EXPT_INSTR_TYPE_CPUACTLR        7'b0101100
`define MERCURY_EXPT_INSTR_TYPE_CPUECTLR        7'b0101101
`define MERCURY_EXPT_INSTR_TYPE_HLT             7'b0101110
`define MERCURY_EXPT_INSTR_TYPE_VECT_CATCH      7'b0101111
`define MERCURY_EXPT_INSTR_TYPE_DCPS1           7'b0110000
`define MERCURY_EXPT_INSTR_TYPE_DCPS2           7'b0110001
`define MERCURY_EXPT_INSTR_TYPE_DCPS3           7'b0110010
`define MERCURY_EXPT_INSTR_TYPE_L2CTLR          7'b0110011
`define MERCURY_EXPT_INSTR_TYPE_L2ECTLR         7'b0110100
`define MERCURY_EXPT_INSTR_TYPE_L2ACTLR         7'b0110101
`define MERCURY_EXPT_INSTR_TYPE_PMU_SWINC       7'b0110110
`define MERCURY_EXPT_INSTR_TYPE_PMU_EVREG       7'b0110111
`define MERCURY_EXPT_INSTR_TYPE_PMU_CCNT_RD     7'b0111000
`define MERCURY_EXPT_INSTR_TYPE_PMU_USERENR     7'b0111001
`define MERCURY_EXPT_INSTR_TYPE_DAIF            7'b0111010
`define MERCURY_EXPT_INSTR_TYPE_CP15BAR         7'b0111011
`define MERCURY_EXPT_INSTR_TYPE_SETEND          7'b0111100
`define MERCURY_EXPT_INSTR_TYPE_RESET_CATCH     7'b0111101
`define MERCURY_EXPT_INSTR_TYPE_EXPT_CATCH      7'b0111110
`define MERCURY_EXPT_INSTR_TYPE_IFU_PARITY      7'b0111111
`define MERCURY_EXPT_INSTR_TYPE_GIC_GROUP0      7'b1000000
`define MERCURY_EXPT_INSTR_TYPE_GIC_GROUP1      7'b1000001
`define MERCURY_EXPT_INSTR_TYPE_GIC_DIR         7'b1000010
`define MERCURY_EXPT_INSTR_TYPE_GIC_COMMON      7'b1000011
`define MERCURY_EXPT_INSTR_TYPE_GIC_SRE         7'b1000100
`define MERCURY_EXPT_INSTR_TYPE_GIC_SGI         7'b1000101
`define MERCURY_EXPT_INSTR_TYPE_GIC_MISC        7'b1000110
`define MERCURY_EXPT_INSTR_TYPE_MON_MCR_MRC     7'b1000111

`define MERCURY_EXPT_INSTR_TYPE_EX1_W           2
`define MERCURY_EXPT_INSTR_TYPE_EX1_WFE         2'b00
`define MERCURY_EXPT_INSTR_TYPE_EX1_FP          2'b00
`define MERCURY_EXPT_INSTR_TYPE_EX1_NEON        2'b11
`define MERCURY_EXPT_INSTR_TYPE_EX1_SVC         2'b00
`define MERCURY_EXPT_INSTR_TYPE_EX1_HVC         2'b01
`define MERCURY_EXPT_INSTR_TYPE_EX1_SMC         2'b10
`define MERCURY_EXPT_INSTR_TYPE_EX1_HW_BKPT     2'b10
`define MERCURY_EXPT_INSTR_TYPE_EX1_BKPT        2'b01
`define MERCURY_EXPT_INSTR_TYPE_EX1_VECT_CATCH  2'b11

`define MERCURY_INSTR_TYPE_W                    3
`define MERCURY_INSTR_TYPE_NULL                 3'b000
`define MERCURY_INSTR_TYPE_SYNC_EXPT            3'b001
`define MERCURY_INSTR_TYPE_WFI                  3'b010
`define MERCURY_INSTR_TYPE_WFE                  3'b011
`define MERCURY_INSTR_TYPE_SEV                  3'b100
`define MERCURY_INSTR_TYPE_ISB                  3'b101
`define MERCURY_INSTR_TYPE_SEVL                 3'b110

`define MERCURY_SLOT1_INSTR_TYPE_NULL     1'b0
`define MERCURY_SLOT1_INSTR_TYPE_BRANCH   1'b1


`define MERCURY_LU_CTL_W            4
`define MERCURY_LU_CTL_0            4'b0000
`define MERCURY_LU_CTL_ADD          4'b0000  
`define MERCURY_LU_CTL_SUB          4'b0001  
`define MERCURY_LU_CTL_ADC          4'b0010  
`define MERCURY_LU_CTL_SBC          4'b0011  

`define MERCURY_LU_CTL_BIC          4'b0100  
`define MERCURY_LU_CTL_EOR          4'b0110  
`define MERCURY_LU_CTL_AND          4'b1000  
`define MERCURY_LU_CTL_EON          4'b1001  
`define MERCURY_LU_CTL_ORR          4'b1110  
`define MERCURY_LU_CTL_ORN          4'b1101  

`define MERCURY_LU_CTL_CSEL         4'b1010  

`define MERCURY_LU_CTL_CRC32        4'b0101  

`define MERCURY_LU_CTL_CLZ          4'b0111  
`define MERCURY_LU_CTL_GEN_SAT      4'b1100  
`define MERCURY_LU_CTL_EXTRACT      4'b1011  
`define MERCURY_LU_CTL_MASKSEL      4'b1111  

`define MERCURY_ALU_LU_MASK_SEL       3'b001



`define MERCURY_MULT_TYPE_W        4
`define MERCURY_MULT_TYPE_0        4'b0000

`define MERCURY_MULT_TYPE_ACCONLY  4'b0000

`define MERCURY_MULT_TYPE_USAD     4'b0001

`define MERCURY_MULT_TYPE_16x16    4'b0100
`define MERCURY_MULT_TYPE_32x32    4'b0101
`define MERCURY_MULT_TYPE_2x16x16  4'b0110
`define MERCURY_MULT_TYPE_32x16    4'b0111

`define MERCURY_MULT_TYPE_64x64    4'b1100
`define MERCURY_MULT_TYPE_64x64_LH 4'b1101
`define MERCURY_MULT_TYPE_64x64_HL 4'b1110
`define MERCURY_MULT_TYPE_64x64_HH 4'b1111


`define MERCURY_SEL_SHF_A_W 2
`define MERCURY_SEL_SHF_B_W 3
`define MERCURY_SEL_SHF_C_W 2

`define MERCURY_SEL_SHF_A_ZERO      2'b00
`define MERCURY_SEL_SHF_A_R0        2'b01
`define MERCURY_SEL_SHF_A_PC        2'b10
`define MERCURY_SEL_SHF_A_R2        2'b11
`define MERCURY_SEL_SHF_A_0         2'b00

`define MERCURY_SEL_SHF_B_ZERO      3'b000
`define MERCURY_SEL_SHF_B_R1        3'b001
`define MERCURY_SEL_SHF_B_PC        3'b010
`define MERCURY_SEL_SHF_B_IMM_DATA  3'b011
`define MERCURY_SEL_SHF_B_R4        3'b111
`define MERCURY_SEL_SHF_B_0         3'b000

`define MERCURY_SEL_SHF_C_ZERO      2'b00
`define MERCURY_SEL_SHF_C_R2        2'b01
`define MERCURY_SEL_SHF_C_IMM_SHIFT 2'b10
`define MERCURY_SEL_SHF_C_0         2'b00

`define MERCURY_SEL_MSK_B_W         1
`define MERCURY_SEL_MSK_B_IMM_DATA  1'b1
`define MERCURY_SEL_MSK_B_0         1'b0


`define MERCURY_MASK_W              3
`define MERCURY_MASK_0              3'b000
`define MERCURY_MASK_ZERO           3'b000
`define MERCURY_MASK_COMB           3'b001
`define MERCURY_MASK_SNGL           3'b010
`define MERCURY_MASK_TOP            3'b011
`define MERCURY_MASK_BOT            3'b100
`define MERCURY_MASK_MOVK           3'b101
`define MERCURY_MASK_C              3'b110

`define MERCURY_REV_MUX_W           3
`define MERCURY_REV_MUX_NORMAL      3'b000
`define MERCURY_REV_MUX_REV32       3'b001
`define MERCURY_REV_MUX_REVSH       3'b010
`define MERCURY_REV_MUX_REV16       3'b011
`define MERCURY_REV_MUX_RBIT        3'b100
`define MERCURY_REV_MUX_SAT_DBL     3'b101
`define MERCURY_REV_MUX_ZERO        3'b110
`define MERCURY_REV_MUX_REV64       3'b111
`define MERCURY_REV_MUX_0           3'b000

`define MERCURY_SEL_MAC_A_W         1
`define MERCURY_SEL_MAC_A_0         1'b0
`define MERCURY_SEL_MAC_A_ZERO      1'b0
`define MERCURY_SEL_MAC_A_R0        1'b1

`define MERCURY_SEL_MAC_B_W         1
`define MERCURY_SEL_MAC_B_0         1'b0
`define MERCURY_SEL_MAC_B_ZERO      1'b0
`define MERCURY_SEL_MAC_B_R1        1'b1

`define MERCURY_SEL_DIV_A_W         1
`define MERCURY_SEL_DIV_A_0         1'b0
`define MERCURY_SEL_DIV_A_ZERO      1'b0
`define MERCURY_SEL_DIV_A_R0        1'b1

`define MERCURY_SEL_DIV_B_W         1
`define MERCURY_SEL_DIV_B_0         1'b0
`define MERCURY_SEL_DIV_B_ZERO      1'b0
`define MERCURY_SEL_DIV_B_R1        1'b1

`define MERCURY_SEL_STR_A_W         3
`define MERCURY_SEL_STR_A_ZERO      3'b000
`define MERCURY_SEL_STR_A_0         3'b000
`define MERCURY_SEL_STR_A_R2        3'b001
`define MERCURY_SEL_STR_A_PC        3'b010
`define MERCURY_SEL_STR_A_FR0       3'b011
`define MERCURY_SEL_STR_A_R1        3'b100
`define MERCURY_SEL_STR_A_FR1       3'b101
`define MERCURY_SEL_STR_A_R4        3'b110

`define MERCURY_SEL_STR_B_0         3'b000
`define MERCURY_SEL_STR_B_ZERO      3'b000
`define MERCURY_SEL_STR_B_R3        3'b001
`define MERCURY_SEL_STR_B_PC        3'b010
`define MERCURY_SEL_STR_B_FR1       3'b011
`define MERCURY_SEL_STR_B_A_H       3'b100
`define MERCURY_SEL_STR_B_FP        3'b101
`define MERCURY_SEL_STR_B_ALU       3'b111
`define MERCURY_SEL_STR_B_R2        3'b110
`define MERCURY_SEL_STR_B_W         3

`define MERCURY_SEL_STR_HI_W        2
`define MERCURY_SEL_STR_HI_0        2'b00
`define MERCURY_SEL_STR_HI_FP       2'b01
`define MERCURY_SEL_STR_HI_ALU      2'b10

`define MERCURY_ALU_OP_COMP_NULL    2'b00
`define MERCURY_ALU_OP_COMP_SHF_B   2'b10
`define MERCURY_ALU_OP_COMP_W       2

`define MERCURY_NULL                1'b0

`define MERCURY_STR0_FP_SEL_NONE    2'b00
`define MERCURY_STR0_FP_SEL_FR0     2'b01
`define MERCURY_STR0_FP_SEL_FR0_FR1 2'b11


`define MERCURY_SHIFT_OP_NOP     3'b000
`define MERCURY_SHIFT_OP_EXTR    3'b001
`define MERCURY_SHIFT_OP_SP1     3'b010  
`define MERCURY_SHIFT_OP_SP2     3'b011  
`define MERCURY_SHIFT_OP_ASR     3'b110
`define MERCURY_SHIFT_OP_LSL     3'b100
`define MERCURY_SHIFT_OP_LSR     3'b101
`define MERCURY_SHIFT_OP_ROR     3'b111
`define MERCURY_SHIFT_OP_W 3

`define MERCURY_SHIFT_MOD_W 1


`define MERCURY_BR_PIPECTL_W 4

`define MERCURY_BR_NO_BRANCH                   3'b000
`define MERCURY_BR_DIRECT                      3'b001
`define MERCURY_BR_PREFETCH_FLUSH              3'b010
`define MERCURY_BR_WFX_RESTART                 3'b100
`define MERCURY_BR_INDIRECT_TBB                3'b011
`define MERCURY_BR_INDIRECT_DP                 3'b101
`define MERCURY_BR_INDIRECT_ST                 3'b110
`define MERCURY_BR_INDIRECT_LD                 3'b111

`define MERCURY_STANDARD_BRANCH                2'b00
`define MERCURY_ILLEGAL_BX_IMM                 2'b01
`define MERCURY_BRANCH_AND_LINK                2'b10
`define MERCURY_BRANCH_AND_LINK_WITH_EXCHANGE  2'b11

`define MERCURY_IS_NOT_PREDICTABLE             1'b0
`define MERCURY_IS_PREDICTABLE                 1'b1

`define MERCURY_RF_RD_EN_IMMED_BR              4'b0000
`define MERCURY_BR_OFFSET_BITS                 23:0
`define MERCURY_H_BIT                          24
`define MERCURY_TAKEN_PRED_BIT                 25
`define MERCURY_EXCHANGE_BIT                   26

`define MERCURY_IS_NOT_RETURN                  1'b0
`define MERCURY_IS_RETURN                      1'b1
`define MERCURY_IS_NOT_CALL                    1'b0
`define MERCURY_IS_CALL                        1'b1
`define MERCURY_IS_DIRECT                      1'b1
`define MERCURY_IS_NOT_DIRECT                  1'b0

`define MERCURY_RETURN_ADDR_VALID              1'b1
`define MERCURY_RETURN_ADDR_INVALID            1'b0

`define MERCURY_RF_RD_SPECIAL_BR               4'b0000
`define MERCURY_BR_IS_NOT_VALID                1'b0
`define MERCURY_BR_IS_VALID                    1'b1

`define MERCURY_BR_X_BIT_W                     2
`define MERCURY_BX_RM_VALID                    2'b10
`define MERCURY_BX_IMM_VALID_FROM_ARM          2'b01   
`define MERCURY_BX_IMM_VALID_FROM_THUMB        2'b11   

`define MERCURY_LDR_U_BIT 23
`define MERCURY_LDR_SHIFT_LSL 2'b00
`define MERCURY_LDR_SHIFT_BITS 6:5
`define MERCURY_LDR_SHIFT_IMM_BITS 11:7
`define MERCURY_LDR_OFFSET_12_BITS 11:0
`define MERCURY_LDR_RD_BITS 15:12
`define MERCURY_LDR_RN_BITS 19:16
`define MERCURY_LDR_RM_BITS 3:0

`define MERCURY_REG_UNUSED 4'b0000


`define MERCURY_CC_EQ 4'b0000
`define MERCURY_CC_NE 4'b0001
`define MERCURY_CC_CS 4'b0010
`define MERCURY_CC_CC 4'b0011
`define MERCURY_CC_MI 4'b0100
`define MERCURY_CC_PL 4'b0101
`define MERCURY_CC_VS 4'b0110
`define MERCURY_CC_VC 4'b0111
`define MERCURY_CC_HI 4'b1000
`define MERCURY_CC_LS 4'b1001
`define MERCURY_CC_GE 4'b1010
`define MERCURY_CC_LT 4'b1011
`define MERCURY_CC_GT 4'b1100
`define MERCURY_CC_LE 4'b1101
`define MERCURY_CC_AL 4'b1110
`define MERCURY_CC_NV 4'b1111
`define MERCURY_CC_AL_or_NV 3'b111

`define MERCURY_CC_FLAGS_N    3
`define MERCURY_CC_FLAGS_Z    2
`define MERCURY_CC_FLAGS_C    1
`define MERCURY_CC_FLAGS_V    0


`define MERCURY_SEL_DCU_A_ZERO    2'b00 
`define MERCURY_SEL_DCU_A_R0      2'b01 
`define MERCURY_SEL_DCU_A_PC      2'b10 
`define MERCURY_SEL_DCU_A_MUL     2'b11 
`define MERCURY_SEL_DCU_A_W 2

`define MERCURY_SEL_DCU_B_ZERO    8'b0000_0000 
`define MERCURY_SEL_DCU_B_1       8'b0100_0000 
`define MERCURY_SEL_DCU_B_2       8'b0101_0000 
`define MERCURY_SEL_DCU_B_4       8'b0110_0000 
`define MERCURY_SEL_DCU_B_8       8'b0000_1000 

`define MERCURY_SEL_DCU_B_BIT_R1      0 
`define MERCURY_SEL_DCU_B_BIT_IMM_LS  1 
`define MERCURY_SEL_DCU_B_BIT_SH      2 
`define MERCURY_SEL_DCU_B_BIT_PM_8    3 
`define MERCURY_SEL_DCU_B_BIT_NEON    7 
`define MERCURY_SEL_DCU_B_W 8

`define MERCURY_SEL_FWD_DCU_W            4
`define MERCURY_SEL_FWD_DCU_BIT_W0F_WR   0 
`define MERCURY_SEL_FWD_DCU_BIT_W1F_WR   1 
`define MERCURY_SEL_FWD_DCU_BIT_NOF      2 
`define MERCURY_SEL_FWD_DCU_BIT_W1F_EX2  3 


`define MERCURY_IMM_SEL_W            3
`define MERCURY_IMM_SEL_NULL         3'b000
`define MERCURY_IMM_SEL_T32_1        3'b001
`define MERCURY_IMM_SEL_T32_2        3'b010
`define MERCURY_IMM_SEL_T32_3        3'b011
`define MERCURY_IMM_SEL_A64_LOG_IMM  3'b100
`define MERCURY_IMM_SEL_TBB          3'b101
`define MERCURY_IMM_SEL_ROR          3'b110
`define MERCURY_IMM_SEL_LSL          3'b111
`define MERCURY_IMM_SEL_X            3'bxxx

`define MERCURY_IMM_LSL_0            6'b000001
`define MERCURY_IMM_LSL_16           6'b000010
`define MERCURY_IMM_LSL_32           6'b000100
`define MERCURY_IMM_LSL_48           6'b001000
`define MERCURY_IMM_LSL_ADRP         6'b010000
`define MERCURY_IMM_LSL_12           6'b100000

`define MERCURY_RF_WR_SRC_W0_W       3
`define MERCURY_RF_WR_SRC_W0_0       3'b000
`define MERCURY_RF_WR_SRC_W0_STREX   3'b000
`define MERCURY_RF_WR_SRC_W0_DCU_0   3'b001
`define MERCURY_RF_WR_SRC_W0_CPSR    3'b010
`define MERCURY_RF_WR_SRC_W0_MAC_HI  3'b011
`define MERCURY_RF_WR_SRC_W0_STR     3'b100
`define MERCURY_RF_WR_SRC_W0_CP      3'b101
`define MERCURY_RF_WR_SRC_W0_SPSR    3'b110
`define MERCURY_RF_WR_SRC_W0_BASE    3'b111

`define MERCURY_RF_WR_SRC_W1_W       3
`define MERCURY_RF_WR_SRC_W1_0       3'b000
`define MERCURY_RF_WR_SRC_W1_ALU     3'b001
`define MERCURY_RF_WR_SRC_W1_MAC_LO  3'b010
`define MERCURY_RF_WR_SRC_W1_DIV     3'b011
`define MERCURY_RF_WR_SRC_W1_CP      3'b100
`define MERCURY_RF_WR_SRC_W1_FP_ALU  3'b101
`define MERCURY_RF_WR_SRC_W1_STR     3'b110
`define MERCURY_RF_WR_SRC_W1_DCU_1   3'b111

`define MERCURY_RF_WR_WHEN_W         3
`define MERCURY_RF_WR_WHEN_LATE_WR   3'b111
`define MERCURY_RF_WR_WHEN_EARLY_WR  3'b011
`define MERCURY_RF_WR_WHEN_EX2       3'b001
`define MERCURY_RF_WR_WHEN_EX1       3'b000
`define MERCURY_RF_WR_WHEN_0         3'b000

`define MERCURY_RF_RD_NEED_W         3
`define MERCURY_RF_RD_NEED_0         3'b000
`define MERCURY_RF_RD_NEED_EARLY_ISS 3'b111
`define MERCURY_RF_RD_NEED_LATE_ISS  3'b110
`define MERCURY_RF_RD_NEED_EX1       3'b100
`define MERCURY_RF_RD_NEED_EX2       3'b000

`define MERCURY_RF_FWR_WHEN_W     3
`define MERCURY_RF_FWR_WHEN_0     3'b000
`define MERCURY_RF_FWR_WHEN_F3    3'b000
`define MERCURY_RF_FWR_WHEN_F4    3'b001
`define MERCURY_RF_FWR_WHEN_F5    3'b011
`define MERCURY_RF_FWR_WHEN_L_F5  3'b111

`define MERCURY_RF_FRD_NEED_W     1
`define MERCURY_RF_FRD_NEED_0     1'b0
`define MERCURY_RF_FRD_NEED_F1    1'b1
`define MERCURY_RF_FRD_NEED_F2    1'b0

`define MERCURY_RF_FWR_SRC_W           4
`define MERCURY_RF_FWR_SRC_0           4'b0000
`define MERCURY_RF_FWR_SRC_NONE        4'b0000
`define MERCURY_RF_FWR_SRC_DCU_DUP     4'b0101
`define MERCURY_RF_FWR_SRC_DCU_DUP_RE  4'b1101
`define MERCURY_RF_FWR_SRC_FAD_Q       4'b0010
`define MERCURY_RF_FWR_SRC_FAD_NARROW  4'b1011
`define MERCURY_RF_FWR_SRC_FML_Q       4'b0011
`define MERCURY_RF_FWR_SRC_DCU_PERM    4'b0100
`define MERCURY_RF_FWR_SRC_DCU_SGL     4'b1100
`define MERCURY_RF_FWR_SRC_STR         4'b0001
`define MERCURY_RF_FWR_SRC_DCU_DBL     4'b1000
`define MERCURY_RF_FWR_SRC_STR_SP      4'b0110
`define MERCURY_RF_FWR_SRC_STR_2SP     4'b1110
`define MERCURY_RF_FWR_SRC_CRYPTO_F3   4'b1111
`define MERCURY_RF_FWR_SRC_CRYPTO_F5   4'b1001
`define MERCURY_RF_FWR_SRC_HELD_F5     4'b0111

`define MERCURY_FWD_W        4
`define MERCURY_FWD_W0       4'b0001
`define MERCURY_FWD_W1       4'b0010
`define MERCURY_FWD_W2       4'b0100
`define MERCURY_FWD_ALU0_EX2 4'b0011
`define MERCURY_FWD_NULL     4'b0000
`define MERCURY_FWD_ALU0_EX1 4'b0110
`define MERCURY_FWD_FP       4'b1011
`define MERCURY_FWD_FP_LO    4'b1001
`define MERCURY_FWD_FP_HI    4'b1010


`define MERCURY_LS_INSTR_TYPE_W             4

`define MERCURY_LS_INSTR_SINGLE             4'b0000
`define MERCURY_LS_INSTR_MULTIPLE           4'b0001
`define MERCURY_LS_INSTR_SIGN_EXT           4'b0010
`define MERCURY_LS_INSTR_LDC_STC            4'b0011
`define MERCURY_LS_INSTR_SRS                4'b0100
`define MERCURY_LS_INSTR_EXCL_SGL           4'b0110
`define MERCURY_LS_INSTR_PLD_L1KEEP         4'b1000
`define MERCURY_LS_INSTR_PLD_L1STRM         4'b1001
`define MERCURY_LS_INSTR_PLD_L2KEEP         4'b1010
`define MERCURY_LS_INSTR_PLD_L2STRM         4'b1011
`define MERCURY_LS_INSTR_ORDERED            4'b1100
`define MERCURY_LS_INSTR_ORD_EXCL_SGL       4'b1101
`define MERCURY_LS_INSTR_NON_TEMPORAL       4'b1110
`define MERCURY_LS_INSTR_DCZVA              4'b1111

`define MERCURY_LS_ELEM_SIZE_8BIT           3'b000
`define MERCURY_LS_ELEM_SIZE_16BIT          3'b001
`define MERCURY_LS_ELEM_SIZE_32BIT          3'b010
`define MERCURY_LS_ELEM_SIZE_64BIT          3'b011
`define MERCURY_LS_ELEM_SIZE_128BIT         3'b100


`define MERCURY_PMN_SEL_OTHERS \
                                                                        8'h1A, 8'h1B, 8'h1C,        8'h1E, 8'h1F, \
  8'h20, 8'h21, 8'h22, 8'h23, 8'h24, 8'h25, 8'h26, 8'h27, 8'h28, 8'h29, 8'h2A, 8'h2B, 8'h2C, 8'h2D, 8'h2E, 8'h2F, \
  8'h30, 8'h31, 8'h32, 8'h33, 8'h34, 8'h35, 8'h36, 8'h37, 8'h38, 8'h39, 8'h3A, 8'h3B, 8'h3C, 8'h3D, 8'h3E, 8'h3F, \
  8'h40, 8'h41, 8'h42, 8'h43, 8'h44, 8'h45, 8'h46, 8'h47, 8'h48, 8'h49, 8'h4A, 8'h4B, 8'h4C, 8'h4D, 8'h4E, 8'h4F, \
  8'h50, 8'h51, 8'h52, 8'h53, 8'h54, 8'h55, 8'h56, 8'h57, 8'h58, 8'h59, 8'h5A, 8'h5B, 8'h5C, 8'h5D, 8'h5E, 8'h5F, \
                8'h62, 8'h63, 8'h64, 8'h65, 8'h66, 8'h67, 8'h68, 8'h69, 8'h6A, 8'h6B, 8'h6C, 8'h6D, 8'h6E, 8'h6F, \
  8'h70, 8'h71, 8'h72, 8'h73, 8'h74, 8'h75, 8'h76, 8'h77, 8'h78, 8'h79, 8'h7A, 8'h7B, 8'h7C, 8'h7D, 8'h7E, 8'h7F, \
  8'h80, 8'h81, 8'h82, 8'h83, 8'h84, 8'h85,               8'h88, 8'h89, 8'h8A, 8'h8B, 8'h8C, 8'h8D, 8'h8E, 8'h8F, \
  8'h90, 8'h91, 8'h92, 8'h93, 8'h94, 8'h95, 8'h96, 8'h97, 8'h98, 8'h99, 8'h9A, 8'h9B, 8'h9C, 8'h9D, 8'h9E, 8'h9F, \
  8'hA0, 8'hA1, 8'hA2, 8'hA3, 8'hA4, 8'hA5, 8'hA6, 8'hA7, 8'hA8, 8'hA9, 8'hAA, 8'hAB, 8'hAC, 8'hAD, 8'hAE, 8'hAF, \
  8'hB0, 8'hB1, 8'hB2, 8'hB3, 8'hB4, 8'hB5, 8'hB6, 8'hB7, 8'hB8, 8'hB9, 8'hBA, 8'hBB, 8'hBC, 8'hBD, 8'hBE, 8'hBF, \
                                                                               8'hCB, 8'hCC, 8'hCD, 8'hCE, 8'hCF, \
  8'hD0, 8'hD1, 8'hD2, 8'hD3, 8'hD4, 8'hD5, 8'hD6, 8'hD7, 8'hD8, 8'hD9, 8'hDA, 8'hDB, 8'hDC, 8'hDD, 8'hDE, 8'hDF, \
  8'hE0, 8'hE1, 8'hE2, 8'hE3, 8'hE4, 8'hE5, 8'hE6, 8'hE7, 8'hE8, 8'hE9, 8'hEA, 8'hEB, 8'hEC, 8'hED, 8'hEE, 8'hEF, \
  8'hF0, 8'hF1, 8'hF2, 8'hF3, 8'hF4, 8'hF5, 8'hF6, 8'hF7, 8'hF8, 8'hF9, 8'hFA, 8'hFB, 8'hFC, 8'hFD, 8'hFE, 8'hFF

`define MERCURY_CRN0_MIDR              8'b00000001
`define MERCURY_CRN0_CTR               8'b00000010
`define MERCURY_CRN0_TLBTR             8'b00000011
`define MERCURY_CRN0_MPIDR             8'b00000100
`define MERCURY_CRN0_REVIDR            8'b01101100
`define MERCURY_CRN0_DCZID_EL0         8'b10010100
`define MERCURY_CRN0_ID_PFR0           8'b00000101
`define MERCURY_CRN0_ID_PFR1           8'b00000110
`define MERCURY_CRN0_ID_DFR0           8'b00000111
`define MERCURY_CRN0_ID_MMFR0          8'b00001000
`define MERCURY_CRN0_ID_MMFR1          8'b00001001
`define MERCURY_CRN0_ID_MMFR2          8'b00001010
`define MERCURY_CRN0_ID_MMFR3          8'b00001011
`define MERCURY_CRN0_ID_ISAR0          8'b00001100
`define MERCURY_CRN0_ID_ISAR1          8'b00001101
`define MERCURY_CRN0_ID_ISAR2          8'b00001110
`define MERCURY_CRN0_ID_ISAR3          8'b00001111
`define MERCURY_CRN0_ID_ISAR4          8'b00010000
`define MERCURY_CRN0_ID_ISAR5          8'b10111010
`define MERCURY_CRN0_ID_CCSIDR         8'b00010001
`define MERCURY_CRN0_ID_CLIDR          8'b00010010
`define MERCURY_CRN0_CSSELR            8'b00010011
`define MERCURY_CRN0_VPIDR             8'b01101001
`define MERCURY_CRN0_VMPIDR            8'b01101010
`define MERCURY_CRN1_SCTLR             8'b00010100
`define MERCURY_CRN1_SCTLR_EL1         8'b10101001
`define MERCURY_CRN1_SCTLR_EL3         8'b10101000
`define MERCURY_CRN1_CPUACTLR          8'b00010101
`define MERCURY_CRN1_CPUECTLR          8'b10111011
`define MERCURY_CRN1_ACTLR_EL3         8'b10011000
`define MERCURY_CRN1_ACTLR_EL2         8'b10010110
`define MERCURY_CRN1_CPACR             8'b00010110
`define MERCURY_CRN1_SCR               8'b00010111
`define MERCURY_CRN1_SDER              8'b00011000
`define MERCURY_CRN5_FPEXC             8'b10110100
`define MERCURY_CRN1_NSACR             8'b00011001
`define MERCURY_CRN1_VCR               8'b01001100
`define MERCURY_CRN1_HCR               8'b01010000
`define MERCURY_CRN1_HCR2              8'b10101011
`define MERCURY_CRN1_HDCR              8'b01010001
`define MERCURY_CRN1_MDCR_EL3          8'b10101100
`define MERCURY_CRN1_HCPTR             8'b01010010
`define MERCURY_CRN1_CPTR_EL3          8'b10101010
`define MERCURY_CRN1_HSTR              8'b01010011
`define MERCURY_CRN1_HSCTLR            8'b01011000
`define MERCURY_CRN3_DACR              8'b01101000
`define MERCURY_CRN4_SPSEL             8'b10010000
`define MERCURY_CRN4_DAIF              8'b10010001
`define MERCURY_CRN4_CURRENTEL         8'b10010010
`define MERCURY_CRN4_NZCV              8'b10010011
`define MERCURY_CRN4_FPCR              8'b10110101
`define MERCURY_CRN4_FPSR              8'b10110110
`define MERCURY_CRN5_DFSR              8'b00011010
`define MERCURY_CRN5_IFSR              8'b00011011
`define MERCURY_CRN5_ESR_EL2           8'b01010100
`define MERCURY_CRN5_ESR_EL3           8'b10010101
`define MERCURY_CRN6_DFAR              8'b00011100
`define MERCURY_CRN6_IFAR              8'b00011101
`define MERCURY_CRN6_FAR_EL2           8'b10101101
`define MERCURY_CRN6_FAR_EL3           8'b10101110
`define MERCURY_CRN6_HDFAR             8'b01101101
`define MERCURY_CRN6_HIFAR             8'b01101110
`define MERCURY_CRN6_HPFAR             8'b01010101
`define MERCURY_CRN7_WFI               8'b00011110
`define MERCURY_CRN7_ICIMVAU           8'b01011110
`define MERCURY_CRN7_ISB               8'b00011111
`define MERCURY_CRN9_PMCR              8'b00100000
`define MERCURY_CRN9_PMNCNTENSET       8'b00100001
`define MERCURY_CRN9_PMNCNTENCLR       8'b00100010
`define MERCURY_CRN9_PMOVSR            8'b00100011
`define MERCURY_CRN9_PMOVSSET          8'b01110011
`define MERCURY_CRN9_PMSWINC           8'b00100100
`define MERCURY_CRN9_PMSELR            8'b00100101
`define MERCURY_CRN9_PMCCNTR           8'b00100110
`define MERCURY_CRN9_PMCCNTR_64        8'b01110110
`define MERCURY_CRN9_PMXEVTYPER        8'b00100111
`define MERCURY_CRN9_PMXEVCNTR         8'b00101000
`define MERCURY_CRN9_PMUSERENR         8'b00101001
`define MERCURY_CRN9_PMINTENSET        8'b00101010
`define MERCURY_CRN9_PMINTENCLR        8'b00101011
`define MERCURY_CRN14_PMEVCNTRn(n)     {5'b10000, n[2:0]}
`define MERCURY_CRN14_PMEVCNTR0        8'b10000000
`define MERCURY_CRN14_PMEVCNTR1        8'b10000001
`define MERCURY_CRN14_PMEVCNTR2        8'b10000010
`define MERCURY_CRN14_PMEVCNTR3        8'b10000011
`define MERCURY_CRN14_PMEVCNTR4        8'b10000100
`define MERCURY_CRN14_PMEVCNTR5        8'b10000101
`define MERCURY_CRN14_PMEVTYPERn(n)    {5'b10001, n[2:0]}
`define MERCURY_CRN14_PMEVTYPER0       8'b10001000
`define MERCURY_CRN14_PMEVTYPER1       8'b10001001
`define MERCURY_CRN14_PMEVTYPER2       8'b10001010
`define MERCURY_CRN14_PMEVTYPER3       8'b10001011
`define MERCURY_CRN14_PMEVTYPER4       8'b10001100
`define MERCURY_CRN14_PMEVTYPER5       8'b10001101
`define MERCURY_CRN14_PMCCFILTR        8'b01110111
`define MERCURY_CRN9_PMCEID0           8'b01001101
`define MERCURY_CRN12_VBAR             8'b00101100
`define MERCURY_CRN12_VBAR_EL3         8'b10011010
`define MERCURY_CRN12_MVBAR            8'b00101101
`define MERCURY_CRN12_ISR              8'b00101110
`define MERCURY_CRN12_VIR              8'b01001011
`define MERCURY_CRN12_HVBAR            8'b01010110
`define MERCURY_CRN13_HTPIDR           8'b01010111
`define MERCURY_CRN13_CID              8'b00111111
`define MERCURY_CRN13_TPIDRURW         8'b00101111
`define MERCURY_CRN13_TPIDRURO         8'b00110000
`define MERCURY_CRN13_TPIDRPRW         8'b00110001
`define MERCURY_CRN15_CSOR             8'b00110010
`define MERCURY_CRM2_VTTBR             8'b01101111
`define MERCURY_CP14_DBG_DIDR          8'b00110011
`define MERCURY_CP14_DBG_DRAR          8'b00110100
`define MERCURY_CP14_DBG_DSAR          8'b00110101
`define MERCURY_CP14_DBG_DSCR_INT      8'b00110110
`define MERCURY_CP14_DBG_DTR_INT       8'b00110111
`define MERCURY_CP14_DBG_DSCR_FLAGS    8'b01000000
`define MERCURY_CP14_DBG_WFAR          8'b01000001
`define MERCURY_CP14_DBG_DTRRX_EXT     8'b01000010
`define MERCURY_CP14_DBG_DSCR_EXT      8'b01000011
`define MERCURY_CP14_DBG_DTRTX_EXT     8'b01000100
`define MERCURY_CP14_DBG_PRCR          8'b01000101
`define MERCURY_CP14_DBG_OSLAR         8'b01110001
`define MERCURY_CP14_DBG_OSDLR         8'b01110010
`define MERCURY_CP14_DBG_OSLSR         8'b01001111
`define MERCURY_CP14_DBG_CLAIMSET      8'b01000111
`define MERCURY_CP14_DBG_CLAIMCLR      8'b01001000
`define MERCURY_CP14_DBG_AUTHSTATUS    8'b01001001
`define MERCURY_CP14_DBG_DEVID         8'b01001010
`define MERCURY_CP14_DBG_DEVID1        8'b01110100
`define MERCURY_CP14_MDCCINT_EL1       8'b10110010
`define MERCURY_CP14_DBG_MDSCR_EL1     8'b10111001
`define MERCURY_CP14_DBG_DTR_EL0       8'b10110011
`define MERCURY_CP14_DBG_OSECCR_EL1    8'b10111100
`define MERCURY_CP15_CBAR              8'b01001110
`define MERCURY_CP15_MRC_EXTERNAL      8'b01111111
`define MERCURY_CRN0_ID_AA64PFR0_EL1   8'b10010111
`define MERCURY_CRN0_ID_AA64PFR1_EL1   8'b10011001
`define MERCURY_CRN0_MVFR0_EL1         8'b10011011
`define MERCURY_CRN0_MVFR1_EL1         8'b10011100
`define MERCURY_CRN0_MVFR2_EL1         8'b10011101
`define MERCURY_CRN0_AA64PFR0_EL1      8'b10100110
`define MERCURY_CRN0_AA64PFR1_EL1      8'b10100111
`define MERCURY_CRN0_AA64DFR0_EL1      8'b10011110
`define MERCURY_CRN0_AA64DFR1_EL1      8'b10011111
`define MERCURY_CRN0_AA64AFR0_EL1      8'b10100000
`define MERCURY_CRN0_AA64AFR1_EL1      8'b10100001
`define MERCURY_CRN0_AA64ISAR0_EL1     8'b10100010
`define MERCURY_CRN0_AA64ISAR1_EL1     8'b10100011
`define MERCURY_CRN0_AA64MMFR0_EL1     8'b10100100
`define MERCURY_CRN0_AA64MMFR1_EL1     8'b10100101
`define MERCURY_CRN12_RVBAR_EL3        8'b10101111
`define MERCURY_CRN12_RMR_EL3          8'b10110000
`define MERCURY_CRN13_TPIDR_EL3        8'b10110001
`define MERCURY_VFP_FPSID              8'b10110111
`define MERCURY_VFP_FPSCR              8'b10111000
`define MERCURY_CP15_DBG_DSPSR_EL0     8'b10111101
`define MERCURY_CRN15_CPUMERRSR        8'b10111110

`define MERCURY_DPU_CP15_DSIZE(cp_encoding) ((cp_encoding[7:2] == 6'b011001)   | \
                                        (cp_encoding[7:1] == 7'b0110001)  | \
                                        (cp_encoding      == `MERCURY_CRN9_PMCCNTR_64))

`define MERCURY_DPU_CP14_DSIZE(cp_encoding) ((cp_encoding == `MERCURY_CP14_DBG_DRAR) | \
                                        (cp_encoding == `MERCURY_CP14_DBG_DSAR))




`define MERCURY_ALU_CTL_64BIT_OP_W               1
`define MERCURY_ALU_CTL_64BIT_OP_BITS            0

`define MERCURY_ALU_FLAG_SET_W                   2
`define MERCURY_ALU_RD_IS_R15_W                  1

`define MERCURY_ALU_EX1_CTL_SHIFT_OP_BITS        2:0
`define MERCURY_ALU_EX1_CTL_SHIFT_RRX_FOR_0_BITS 3
`define MERCURY_ALU_EX1_XTRACT_TYP_W             3
`define MERCURY_ALU_EX1_XTRACT_TYP_BITS          6:4
`define MERCURY_ALU_EX1_SIGN_XTEND_W             1
`define MERCURY_ALU_EX1_SIGN_XTEND_BITS          7
`define MERCURY_ALU_EX1_XTRCT_VAL_W              1
`define MERCURY_ALU_EX1_XTRCT_VAL_BITS           8
`define MERCURY_ALU_EX1_MASK_SEL_W               3
`define MERCURY_ALU_EX1_MASK_SEL_BITS            11:9
`define MERCURY_ALU_EX1_REV_TYPE_W               3
`define MERCURY_ALU_EX1_REV_TYPE_BITS            14:12

`define MERCURY_ALU_AU_CARRY_LU_OPCODE_W         `MERCURY_LU_CTL_W

`define MERCURY_ALU_EX2_CTL_LU_CTL_BITS          3:0
`define MERCURY_ALU_EX2_CTL_OP_COMP_SHF_A_BIT    4
`define MERCURY_ALU_EX2_CTL_OP_COMP_SHF_B_BIT    5
`define MERCURY_ALU_EX2_CTL_FLAG_ID_BITS         7:6
`define MERCURY_ALU_EX2_CTL_CCMP_BIT             7 
`define MERCURY_SIMD_ADDSUBX_W                   1
`define MERCURY_ALU_EX2_CTL_SIMD_ADD_SUB_X_BITS  8
`define MERCURY_ALU_EX2_VALID_SIMD_W             1
`define MERCURY_ALU_EX2_CTL_VALID_SIMD_BITS      9
`define MERCURY_ALU_EX2_SIMD_SIZE_W              1
`define MERCURY_ALU_EX2_CTL_SIMD_SIZE_BITS       10
`define MERCURY_ALU_EX2_SIMD_HALVING_W           1
`define MERCURY_ALU_EX2_CTL_HALVING_BITS         11
`define MERCURY_ALU_EX2_SIMD_SIGN_ARTH_W         1
`define MERCURY_ALU_EX2_SIMD_SIGN_ARTH_BITS      12
`define MERCURY_ALU_EX2_SEL_VALID_W              1
`define MERCURY_ALU_EX2_SEL_VALID_BITS           13
`define MERCURY_ALU_EX2_CBZ_BYPASS_W             1
`define MERCURY_ALU_EX2_CBZ_BYPASS_BITS          14
`define MERCURY_ALU_EX2_SIGN_REPLICATE_W         1
`define MERCURY_ALU_EX2_SIGN_REPLICATE_BITS      15

`define MERCURY_SIMD_SAT_VALID_W                 1
`define MERCURY_ALU_WR_CTL_SAT_VALID_BITS        0

`define MERCURY_ALU_GEN_CTL_W    (`MERCURY_ALU_CTL_64BIT_OP_W)

`define MERCURY_ALU_WR_CTL_W     (`MERCURY_SIMD_SAT_VALID_W)

`define MERCURY_ALU_EX2_CTL_W    (`MERCURY_ALU_EX2_SIGN_REPLICATE_W + `MERCURY_ALU_EX2_CBZ_BYPASS_W +                                          \
                               `MERCURY_ALU_EX2_SEL_VALID_W + `MERCURY_ALU_EX2_SIMD_SIGN_ARTH_W + `MERCURY_ALU_EX2_SIMD_HALVING_W +            \
                               `MERCURY_ALU_EX2_SIMD_SIZE_W + `MERCURY_ALU_EX2_VALID_SIMD_W + `MERCURY_SIMD_ADDSUBX_W + `MERCURY_ALU_FLAG_SET_W + \
                               `MERCURY_ALU_OP_COMP_W + `MERCURY_ALU_AU_CARRY_LU_OPCODE_W)
`define MERCURY_ALU_EX2_CTL_LOW  (`MERCURY_ALU_OP_COMP_W + `MERCURY_ALU_AU_CARRY_LU_OPCODE_W)
`define MERCURY_ALU_EX2_CTL_HIGH (`MERCURY_ALU_EX2_CTL_W - `MERCURY_ALU_EX2_CTL_LOW)

`define MERCURY_ALU_EX1_CTL_W    (`MERCURY_ALU_EX1_REV_TYPE_W + `MERCURY_ALU_EX1_MASK_SEL_W + `MERCURY_ALU_EX1_XTRCT_VAL_W + \
                               `MERCURY_ALU_EX1_SIGN_XTEND_W + `MERCURY_ALU_EX1_XTRACT_TYP_W + `MERCURY_SHIFT_MOD_W + `MERCURY_SHIFT_OP_W)

`define MERCURY_ALU_PIPECTL_W    (`MERCURY_ALU_GEN_CTL_W + `MERCURY_ALU_WR_CTL_W + `MERCURY_ALU_EX2_CTL_W + `MERCURY_ALU_EX1_CTL_W)

`define MERCURY_ALU_PIPECTL_ALU_WR_CTL_BITS  (`MERCURY_ALU_PIPECTL_W-1):(`MERCURY_ALU_EX2_CTL_W+`MERCURY_ALU_EX1_CTL_W+`MERCURY_ALU_GEN_CTL_W)
`define MERCURY_ALU_PIPECTL_ALU_EX2_CTL_BITS (`MERCURY_ALU_EX2_CTL_W+`MERCURY_ALU_EX1_CTL_W+`MERCURY_ALU_GEN_CTL_W-1):(`MERCURY_ALU_EX1_CTL_W+`MERCURY_ALU_GEN_CTL_W)
`define MERCURY_ALU_PIPECTL_ALU_EX1_CTL_BITS (`MERCURY_ALU_EX1_CTL_W+`MERCURY_ALU_GEN_CTL_W-1):(`MERCURY_ALU_GEN_CTL_W)
`define MERCURY_ALU_PIPECTL_ALU_GEN_CTL_BITS (`MERCURY_ALU_GEN_CTL_W-1):0

`define MERCURY_MAC_PIPECTL_W            14

`define MERCURY_MAC_CTL_64BIT_OP_BIT      0
`define MERCURY_MAC_CTL_MULT_TYPE_BITS  4:1
`define MERCURY_MAC_CTL_NEG_SECOND_BIT    5
`define MERCURY_MAC_CTL_NEG_MUL_BIT       6
`define MERCURY_MAC_CTL_MAC_A_SEL_BIT     7
`define MERCURY_MAC_CTL_MAC_B_SEL_BIT     8
`define MERCURY_MAC_CTL_SIGNED_BIT        9
`define MERCURY_MAC_CTL_ACC_HIGH_BIT     10
`define MERCURY_MAC_CTL_ROUND_BIT        11
`define MERCURY_MAC_CTL_ACCUM_LO_BIT     12
`define MERCURY_MAC_CTL_ACCUM_HI_BIT     13


`define MERCURY_IMM_SHIFT_W 8
`define MERCURY_IMM_DATA_W 21
`define MERCURY_AGU_IMM_DATA_W 33
`define MERCURY_XTRCT_SHIFT_W 5

`define MERCURY_IMM_OT_W               2
`define MERCURY_IMM_OT_0               2'b00
`define MERCURY_IMM_OT_B_1             2'b01
`define MERCURY_IMM_OT_B_4             2'b10

`define MERCURY_IMM_DP_W               14
`define MERCURY_IMM_DP_0               14'b00000000000000
`define MERCURY_IMM_DP_A32_SHIFT       14'b00000000000001
`define MERCURY_IMM_DP_T32_SHIFT       14'b00000000000010
`define MERCURY_IMM_DP_ADDW            14'b00000000000100
`define MERCURY_IMM_DP_T32_IMM         14'b00000000001000
`define MERCURY_IMM_DP_MOVW            14'b00000000010000
`define MERCURY_IMM_DP_EXTEND          14'b00000000100000
`define MERCURY_IMM_DP_A32_IMM         14'b00000001000000
`define MERCURY_IMM_DP_BFM             14'b00000010000000
`define MERCURY_IMM_DP_A64_ADR         14'b00000100000000
`define MERCURY_IMM_DP_EXT_REG         14'b00001000000000
`define MERCURY_IMM_DP_LOG_IMM         14'b00010000000000
`define MERCURY_IMM_DP_EXTR            14'b00100000000000
`define MERCURY_IMM_DP_CSEL            14'b01000000000000
`define MERCURY_IMM_DP_CRC32           14'b10000000000000

`define MERCURY_IMM_LS_W               10
`define MERCURY_IMM_LS_0               10'b0000000000
`define MERCURY_IMM_LS_8               10'b0000000001
`define MERCURY_IMM_LS_A32_SHIFT       10'b0000000010
`define MERCURY_IMM_LS_SCALED          10'b0000000100
`define MERCURY_IMM_LS_LDP_STP         10'b0000001000
`define MERCURY_IMM_LS_SIGNED          10'b0000010000
`define MERCURY_IMM_LS_IMM4HL          10'b0000100000
`define MERCURY_IMM_LS_LSM1            10'b0001000000
`define MERCURY_IMM_LS_LSM2            10'b0010000000
`define MERCURY_IMM_LS_A64_LIT         10'b0100000000
`define MERCURY_IMM_LS_TBB             10'b1000000000

`define MERCURY_IMM_NEON_W             22
`define MERCURY_IMM_NEON_0             22'b0000000000000000000000
`define MERCURY_IMM_NEON_32            22'b0000000000000000000001
`define MERCURY_IMM_NEON_64            22'b0000000000000000000010
`define MERCURY_IMM_NEON_LDC_STC       22'b0000000000000000000100
`define MERCURY_IMM_NEON_VFP_IMM       22'b0000000000000000001000
`define MERCURY_IMM_NEON_VCVT_16       22'b0000000000000000010000
`define MERCURY_IMM_NEON_VCVT_32       22'b0000000000000000100000
`define MERCURY_IMM_NEON_VCVT_64       22'b0000000000000001000000
`define MERCURY_IMM_NEON_VEXT          22'b0000000000000010000000
`define MERCURY_IMM_NEON_VDUP_VCVT     22'b0000000000000100000000
`define MERCURY_IMM_NEON_NEON_VCVT_64  22'b0000000000001000000000
`define MERCURY_IMM_NEON_VSHL          22'b0000000000010000000000
`define MERCURY_IMM_NEON_VSHR          22'b0000000000100000000000
`define MERCURY_IMM_NEON_VMOV_SCAL     22'b0000000001000000000000
`define MERCURY_IMM_NEON_NEON_IMM      22'b0000000010000000000000
`define MERCURY_IMM_NEON_NEON_LSM      22'b0000000100000000000000
`define MERCURY_IMM_NEON_LDR_LITERAL   22'b0000001000000000000000
`define MERCURY_IMM_NEON_LS_PAIR       22'b0000010000000000000000
`define MERCURY_IMM_NEON_LS_UNSCALED   22'b0000100000000000000000
`define MERCURY_IMM_NEON_LS_IMM12      22'b0001000000000000000000
`define MERCURY_IMM_NEON_CCMP_CSEL     22'b0010000000000000000000
`define MERCURY_IMM_NEON_INS_VECTOR    22'b0100000000000000000000
`define MERCURY_IMM_NEON_VDUP_SCAL     22'b1000000000000000000000


`define MERCURY_FORCEOP_TYPE_W     2
`define MERCURY_FORCEOP_TYPE_NULL  2'b00
`define MERCURY_FORCEOP_TYPE_EL2   2'b01
`define MERCURY_FORCEOP_TYPE_SUB   2'b10
`define MERCURY_FORCEOP_TYPE_ADD   2'b11

`define MERCURY_FORCEOP_OFFSET_W   2
`define MERCURY_FORCEOP_OFFSET_0   2'b00
`define MERCURY_FORCEOP_OFFSET_2   2'b01
`define MERCURY_FORCEOP_OFFSET_4   2'b10
`define MERCURY_FORCEOP_OFFSET_8   2'b11

`define MERCURY_FORCEOP_OFFSET_TYPE_W    2
`define MERCURY_FORCEOP_OFFSET_TYPE_0_4  2'b00
`define MERCURY_FORCEOP_OFFSET_TYPE_2_4  2'b01
`define MERCURY_FORCEOP_OFFSET_TYPE_4_8  2'b10
`define MERCURY_FORCEOP_OFFSET_TYPE_4_0  2'b11

`define MERCURY_FAULT_REG_EN_W         14
`define MERCURY_FAULT_REG_EN_DFSR      13
`define MERCURY_FAULT_REG_EN_DFAR      12
`define MERCURY_FAULT_REG_EN_IFSR      11
`define MERCURY_FAULT_REG_EN_IFAR      10
`define MERCURY_FAULT_REG_EN_HSR        9
`define MERCURY_FAULT_REG_EN_HIFAR      8
`define MERCURY_FAULT_REG_EN_HDFAR      7
`define MERCURY_FAULT_REG_EN_HPFAR      6
`define MERCURY_FAULT_REG_EN_ESR_EL1    5
`define MERCURY_FAULT_REG_EN_FAR_EL1    4
`define MERCURY_FAULT_REG_EN_ESR_EL2    3
`define MERCURY_FAULT_REG_EN_FAR_EL2    2
`define MERCURY_FAULT_REG_EN_ESR_EL3    1
`define MERCURY_FAULT_REG_EN_FAR_EL3    0

`define MERCURY_CPSR_WR_EN_EARLY_W     2
`define MERCURY_CPSR_WR_EN_EARLY_NULL  2'b00
`define MERCURY_CPSR_WR_EN_EARLY_IM    2'b01
`define MERCURY_CPSR_WR_EN_EARLY_AIM   2'b10
`define MERCURY_CPSR_WR_EN_EARLY_AIFM  2'b11

`define MERCURY_SEL_CPSR_SRC_TYPE_W      1
`define MERCURY_SEL_CPSR_SRC_TYPE_FORCE  1'b0
`define MERCURY_SEL_CPSR_SRC_TYPE_DSPSR  1'b1

`define MERCURY_SYND_TYPE_W            3
`define MERCURY_SYND_TYPE_UNSPEC       3'b000
`define MERCURY_SYND_TYPE_DEBUG        3'b001
`define MERCURY_SYND_TYPE_FABORT       3'b010
`define MERCURY_SYND_TYPE_CALL         3'b011
`define MERCURY_SYND_TYPE_WFX          3'b100
`define MERCURY_SYND_TYPE_SYS_REG      3'b101
`define MERCURY_SYND_TYPE_FP_NEON      3'b110
`define MERCURY_SYND_TYPE_IL_BIT       3'b111

`define MERCURY_EXPT_TYPE_W                5
`define MERCURY_EXPT_TYPE_RESET            5'b00001
`define MERCURY_EXPT_TYPE_WPT              5'b00010
`define MERCURY_EXPT_TYPE_DATA             5'b00011
`define MERCURY_EXPT_TYPE_FIQ              5'b00100
`define MERCURY_EXPT_TYPE_IRQ              5'b00101
`define MERCURY_EXPT_TYPE_IMPRECISE        5'b00110
`define MERCURY_EXPT_TYPE_DEBUG_HLT        5'b00111
`define MERCURY_EXPT_TYPE_DEBUG_EXPT       5'b01000
`define MERCURY_EXPT_TYPE_INSTR_FAULT      5'b01001
`define MERCURY_EXPT_TYPE_TRAP             5'b01010
`define MERCURY_EXPT_TYPE_CALL             5'b01011
`define MERCURY_EXPT_TYPE_WFI              5'b01100
`define MERCURY_EXPT_TYPE_WFE              5'b01101
`define MERCURY_EXPT_TYPE_COND_TRAP        5'b01110
`define MERCURY_EXPT_TYPE_DEBUG_EXIT       5'b01111
`define MERCURY_EXPT_TYPE_SP_ALIGNMENT     5'b10000
`define MERCURY_EXPT_TYPE_ECC_REEXEC       5'b10001
`define MERCURY_EXPT_TYPE_COND_TRAP_OR_UND 5'b10010
`define MERCURY_EXPT_TYPE_PC_ALIGNMENT     5'b10011

`define MERCURY_DBG_STATUS_W               4
`define MERCURY_DBG_STATUS_NULL            4'b0000
`define MERCURY_DBG_STATUS_BKPT            4'b0001
`define MERCURY_DBG_STATUS_BKPT_INSTR      4'b0011
`define MERCURY_DBG_STATUS_EXT_DBG_REQ     4'b0100
`define MERCURY_DBG_STATUS_VECTOR_CATCH    4'b0101
`define MERCURY_DBG_STATUS_HLT_STEP_NORM   4'b0110
`define MERCURY_DBG_STATUS_HLT_STEP_EXCL   4'b0111
`define MERCURY_DBG_STATUS_OS_UNLOCK       4'b1000
`define MERCURY_DBG_STATUS_RESET_CATCH     4'b1001
`define MERCURY_DBG_STATUS_WPT             4'b1010
`define MERCURY_DBG_STATUS_HLT             4'b1011
`define MERCURY_DBG_STATUS_DEBUG_REG       4'b1100
`define MERCURY_DBG_STATUS_EXPT_CATCH      4'b1101
`define MERCURY_DBG_STATUS_HLT_STEP_MISC   4'b1110

`define MERCURY_EXPT_INSTR_BUS_W             32
`define MERCURY_EXPT_INSTR_BUS_MISC_BIT      31
`define MERCURY_EXPT_INSTR_BUS_IS_OTHER_BIT  30
`define MERCURY_EXPT_INSTR_BUS_IS_LS_BIT     29
`define MERCURY_EXPT_INSTR_BUS_INSTR_D_BIT   28
`define MERCURY_EXPT_INSTR_BUS_INSTR_BITS    27:0

`define MERCURY_EXPT_BUS_W                 58
`define MERCURY_EXPT_BUS_ESR_BITS          25:0
`define MERCURY_EXPT_BUS_EC_BITS           31:26
`define MERCURY_EXPT_BUS_TARGET_MODE_BITS  36:32
`define MERCURY_EXPT_BUS_TARGET_EL_BITS    38:37
`define MERCURY_EXPT_BUS_QUASH_BIT         39
`define MERCURY_EXPT_BUS_CPSR_BITS         41:40
`define MERCURY_EXPT_BUS_VEC_OFFSET_BITS   44:42
`define MERCURY_EXPT_BUS_ENTER_HALT_BIT    45
`define MERCURY_EXPT_BUS_HIGH_PRI_BIT      46
`define MERCURY_EXPT_BUS_EXPT_TYPE_BITS    51:47
`define MERCURY_EXPT_BUS_FORCEOP_BITS      53:52
`define MERCURY_EXPT_BUS_DBG_STATUS_BITS   57:54

`define MERCURY_ETM_EXPT_TYPE_W               4
`define MERCURY_ETM_EXPT_TYPE_NULL            4'b0000
`define MERCURY_ETM_EXPT_TYPE_DATA_ABORT      4'b1100
`define MERCURY_ETM_EXPT_TYPE_FIQ             4'b1111
`define MERCURY_ETM_EXPT_TYPE_IRQ             4'b1110
`define MERCURY_ETM_EXPT_TYPE_IMPRECISE_ABORT 4'b0100
`define MERCURY_ETM_EXPT_TYPE_PREFETCH_ABORT  4'b1011
`define MERCURY_ETM_EXPT_TYPE_SVC             4'b1010
`define MERCURY_ETM_EXPT_TYPE_SMC             4'b0010
`define MERCURY_ETM_EXPT_TYPE_HVC             4'b0011
`define MERCURY_ETM_EXPT_TYPE_UNDEF           4'b1001
`define MERCURY_ETM_EXPT_TYPE_IBKPT           4'b1011
`define MERCURY_ETM_EXPT_TYPE_HALT            4'b0001
`define MERCURY_ETM_EXPT_TYPE_GENERIC         4'b1101
`define MERCURY_ETM_EXPT_TYPE_RESET           4'b1000
`define MERCURY_ETM_EXPT_TYPE_X               4'bxxxx


`define MERCURY_CPSR_RET_W 29

`define MERCURY_CPSR_RET_N_BITS        28
`define MERCURY_CPSR_RET_Z_BITS        27
`define MERCURY_CPSR_RET_C_BITS        26
`define MERCURY_CPSR_RET_V_BITS        25
`define MERCURY_CPSR_RET_Q_BITS        24
`define MERCURY_CPSR_RET_NZCV_BITS     28:25
`define MERCURY_CPSR_RET_CV_BITS       26:25
`define MERCURY_CPSR_RET_NZCVQ_BITS    28:24
`define MERCURY_CPSR_RET_IT_LOW_BITS   23:22  
`define MERCURY_CPSR_RET_SS_BITS       21
`define MERCURY_CPSR_RET_IL_BITS       20
`define MERCURY_CPSR_RET_GE_BITS       19:16
`define MERCURY_CPSR_RET_IT_COND_BITS  15:12  
`define MERCURY_CPSR_RET_IT_HIGH_BITS  11:10  
`define MERCURY_CPSR_RET_IT_HICM_BITS  15:10  
`define MERCURY_CPSR_RET_DAIF_BITS     9:6
`define MERCURY_CPSR_RET_EAIF_BITS     9:6
`define MERCURY_CPSR_RET_D_BITS        9
`define MERCURY_CPSR_RET_E_BITS        9
`define MERCURY_CPSR_RET_A_BITS        8
`define MERCURY_CPSR_RET_I_BITS        7
`define MERCURY_CPSR_RET_F_BITS        6
`define MERCURY_CPSR_RET_T_BITS        5
`define MERCURY_CPSR_RET_MODE_BITS     4:0

`define MERCURY_SPSR_RET_W 29

`define MERCURY_SPSR_RET_N_BITS        28
`define MERCURY_SPSR_RET_Z_BITS        27
`define MERCURY_SPSR_RET_C_BITS        26
`define MERCURY_SPSR_RET_V_BITS        25
`define MERCURY_SPSR_RET_Q_BITS        24
`define MERCURY_SPSR_RET_NZCV_BITS     28:25
`define MERCURY_SPSR_RET_CVQ_BITS      26:24
`define MERCURY_SPSR_RET_NZCVQ_BITS    28:24
`define MERCURY_SPSR_RET_IT_LOW_BITS   23:22
`define MERCURY_SPSR_RET_SS_BITS       21
`define MERCURY_SPSR_RET_IL_BITS       20
`define MERCURY_SPSR_RET_GE_BITS       19:16
`define MERCURY_SPSR_RET_IT_COND_BITS  15:12
`define MERCURY_SPSR_RET_IT_HIGH_BITS  11:10
`define MERCURY_SPSR_RET_IT_HICM_BITS  15:10
`define MERCURY_SPSR_RET_DAIF_BITS     9:6
`define MERCURY_SPSR_RET_EAIF_BITS     9:6
`define MERCURY_SPSR_RET_D_BITS        9
`define MERCURY_SPSR_RET_E_BITS        9
`define MERCURY_SPSR_RET_A_BITS        8
`define MERCURY_SPSR_RET_I_BITS        7
`define MERCURY_SPSR_RET_F_BITS        6
`define MERCURY_SPSR_RET_T_BITS        5
`define MERCURY_SPSR_RET_MODE_BITS     4:0


`define MERCURY_PSR_ARCH_N_BITS        31
`define MERCURY_PSR_ARCH_Z_BITS        30
`define MERCURY_PSR_ARCH_C_BITS        29
`define MERCURY_PSR_ARCH_V_BITS        28
`define MERCURY_PSR_ARCH_Q_BITS        27
`define MERCURY_PSR_ARCH_NZ_BITS       31:30
`define MERCURY_PSR_ARCH_NZCV_BITS     31:28
`define MERCURY_PSR_ARCH_NZCVQ_BITS    31:27
`define MERCURY_PSR_ARCH_IT_LOW_BITS   26:25
`define MERCURY_PSR_ARCH_J_BITS        24
`define MERCURY_PSR_ARCH_SS_BITS       21
`define MERCURY_PSR_ARCH_IL_BITS       20
`define MERCURY_PSR_ARCH_GE_BITS       19:16
`define MERCURY_PSR_ARCH_IT_COND_BITS  15:12
`define MERCURY_PSR_ARCH_IT_HIGH_BITS  11:10
`define MERCURY_PSR_ARCH_IT_HICM_BITS  15:10
`define MERCURY_PSR_ARCH_DAIF_BITS     9:6
`define MERCURY_PSR_ARCH_EAIF_BITS     9:6
`define MERCURY_PSR_ARCH_D_BITS        9
`define MERCURY_PSR_ARCH_E_BITS        9
`define MERCURY_PSR_ARCH_A_BITS        8
`define MERCURY_PSR_ARCH_I_BITS        7
`define MERCURY_PSR_ARCH_F_BITS        6
`define MERCURY_PSR_ARCH_T_BITS        5
`define MERCURY_PSR_ARCH_MODE_BITS     4:0

`define MERCURY_SEL_CPSR_SRC_W            4
`define MERCURY_SEL_CPSR_SRC_CPSR         4'b0000
`define MERCURY_SEL_CPSR_SRC_FORCE        4'b0001
`define MERCURY_SEL_CPSR_SRC_DP           4'b0010
`define MERCURY_SEL_CPSR_SRC_MUL          4'b0011
`define MERCURY_SEL_CPSR_SRC_LOAD_DATA    4'b0100
`define MERCURY_SEL_CPSR_SRC_SPSR         4'b0101
`define MERCURY_SEL_CPSR_SRC_CCFLAGS      4'b0110
`define MERCURY_SEL_CPSR_SRC_DSCR         4'b0111
`define MERCURY_SEL_CPSR_SRC_QFLAG        4'b1000
`define MERCURY_SEL_CPSR_SRC_DSPSR        4'b1001
`define MERCURY_SEL_CPSR_SRC_RFE          4'b1010
`define MERCURY_SEL_CPSR_SRC_BLX          4'b1011
`define MERCURY_SEL_CPSR_SRC_CPS          4'b1100
`define MERCURY_SEL_CPSR_SRC_INSTR1       4'b1111

`define MERCURY_SEL_CPSR_EN_W             6
`define MERCURY_SEL_CPSR_EN_NULL          6'b00_0000
`define MERCURY_SEL_CPSR_EN_IT            6'b00_0001
`define MERCURY_SEL_CPSR_EN_T             6'b00_0010
`define MERCURY_SEL_CPSR_EN_E             6'b00_0011
`define MERCURY_SEL_CPSR_EN_M0            6'b00_0100
`define MERCURY_SEL_CPSR_EN_ETIM          6'b00_0101
`define MERCURY_SEL_CPSR_EN_ETAIM         6'b00_0110
`define MERCURY_SEL_CPSR_EN_ETAIFM        6'b00_0111
`define MERCURY_SEL_CPSR_EN_GE            6'b00_1000
`define MERCURY_SEL_CPSR_EN_Q             6'b00_1010
`define MERCURY_SEL_CPSR_EN_CC            6'b00_1011
`define MERCURY_SEL_CPSR_EN_SPSR          6'b00_1100

`define MERCURY_SEL_MRS_CPSR_RET          1'b0
`define MERCURY_SEL_MRS_SPSR_RET          1'b1

`define MERCURY_FLAGEN_INSTR1_W           2
`define MERCURY_FLAGEN_INSTR1_NONE        2'b00
`define MERCURY_FLAGEN_INSTR1_CC          2'b01
`define MERCURY_FLAGEN_INSTR1_GE          2'b10
`define MERCURY_FLAGEN_INSTR1_Q           2'b11

`define MERCURY_SIMD_SIGNED_SAT_ARITH    3'b001
`define MERCURY_SIMD_SIGNED_ARITH        3'b000
`define MERCURY_SIMD_SIGNED_HALF_ARITH   3'b010
`define MERCURY_SIMD_UNSIGNED_ARITH      3'b100
`define MERCURY_SIMD_UNSIGNED_HALF_ARITH 3'b110
`define MERCURY_SIMD_UNSIGNED_SAT_ARITH  3'b101
`define MERCURY_SIMD_X                   3'b000, 3'b100
`define MERCURY_SIMD_SIZE_16              1'b1
`define MERCURY_SIMD_SIZE_8               1'b0

`define MERCURY_MEDIA_SIGNED_SAT_ARITH    3'b010
`define MERCURY_MEDIA_SIGNED_ARITH        3'b001
`define MERCURY_MEDIA_SIGNED_HALF_ARITH   3'b011
`define MERCURY_MEDIA_UNSIGNED_ARITH      3'b101
`define MERCURY_MEDIA_UNSIGNED_HALF_ARITH 3'b111
`define MERCURY_MEDIA_UNSIGNED_SAT_ARITH  3'b110
`define MERCURY_MEDIA_X                   3'b000, 3'b100

`define MERCURY_EXTRACT_LS_BYTE     3'b011
`define MERCURY_EXTRACT_LS_HWORD    3'b001
`define MERCURY_EXTRACT_TWO_BYTES   3'b010
`define MERCURY_EXTRACT_SH_BYTE     3'b100
`define MERCURY_EXTRACT_SH_HWORD    3'b101
`define MERCURY_EXTRACT_SH_WORD     3'b110
`define MERCURY_EXTRACT_SH_XWORD    3'b111

`define MERCURY_SAT_POS_32_VALUE 32'h7fff_ffff
`define MERCURY_SAT_NEG_32_VALUE 32'h8000_0000


`define MERCURY_FP_RF_RD_ADDR_W  6
`define MERCURY_FP_RF_WR_ADDR_W  6
`define MERCURY_FP_RF_ADDR_L_W  64

`define MERCURY_FPU_ADDR_D00 5'b0_0000
`define MERCURY_FPU_ADDR_D01 5'b0_0001
`define MERCURY_FPU_ADDR_D02 5'b0_0010
`define MERCURY_FPU_ADDR_D03 5'b0_0011
`define MERCURY_FPU_ADDR_D04 5'b0_0100
`define MERCURY_FPU_ADDR_D05 5'b0_0101
`define MERCURY_FPU_ADDR_D06 5'b0_0110
`define MERCURY_FPU_ADDR_D07 5'b0_0111
`define MERCURY_FPU_ADDR_D08 5'b0_1000
`define MERCURY_FPU_ADDR_D09 5'b0_1001
`define MERCURY_FPU_ADDR_D10 5'b0_1010
`define MERCURY_FPU_ADDR_D11 5'b0_1011
`define MERCURY_FPU_ADDR_D12 5'b0_1100
`define MERCURY_FPU_ADDR_D13 5'b0_1101
`define MERCURY_FPU_ADDR_D14 5'b0_1110
`define MERCURY_FPU_ADDR_D15 5'b0_1111
`define MERCURY_FPU_ADDR_D16 5'b1_0000
`define MERCURY_FPU_ADDR_D17 5'b1_0001
`define MERCURY_FPU_ADDR_D18 5'b1_0010
`define MERCURY_FPU_ADDR_D19 5'b1_0011
`define MERCURY_FPU_ADDR_D20 5'b1_0100
`define MERCURY_FPU_ADDR_D21 5'b1_0101
`define MERCURY_FPU_ADDR_D22 5'b1_0110
`define MERCURY_FPU_ADDR_D23 5'b1_0111
`define MERCURY_FPU_ADDR_D24 5'b1_1000
`define MERCURY_FPU_ADDR_D25 5'b1_1001
`define MERCURY_FPU_ADDR_D26 5'b1_1010
`define MERCURY_FPU_ADDR_D27 5'b1_1011
`define MERCURY_FPU_ADDR_D28 5'b1_1100
`define MERCURY_FPU_ADDR_D29 5'b1_1101
`define MERCURY_FPU_ADDR_D30 5'b1_1110
`define MERCURY_FPU_ADDR_D31 5'b1_1111

`define MERCURY_FPU_ADDR_S00 5'b0_0000
`define MERCURY_FPU_ADDR_S01 5'b0_0001
`define MERCURY_FPU_ADDR_S02 5'b0_0010
`define MERCURY_FPU_ADDR_S03 5'b0_0011
`define MERCURY_FPU_ADDR_S04 5'b0_0100
`define MERCURY_FPU_ADDR_S05 5'b0_0101
`define MERCURY_FPU_ADDR_S06 5'b0_0110
`define MERCURY_FPU_ADDR_S07 5'b0_0111
`define MERCURY_FPU_ADDR_S08 5'b0_1000
`define MERCURY_FPU_ADDR_S09 5'b0_1001
`define MERCURY_FPU_ADDR_S10 5'b0_1010
`define MERCURY_FPU_ADDR_S11 5'b0_1011
`define MERCURY_FPU_ADDR_S12 5'b0_1100
`define MERCURY_FPU_ADDR_S13 5'b0_1101
`define MERCURY_FPU_ADDR_S14 5'b0_1110
`define MERCURY_FPU_ADDR_S15 5'b0_1111
`define MERCURY_FPU_ADDR_S16 5'b1_0000
`define MERCURY_FPU_ADDR_S17 5'b1_0001
`define MERCURY_FPU_ADDR_S18 5'b1_0010
`define MERCURY_FPU_ADDR_S19 5'b1_0011
`define MERCURY_FPU_ADDR_S20 5'b1_0100
`define MERCURY_FPU_ADDR_S21 5'b1_0101
`define MERCURY_FPU_ADDR_S22 5'b1_0110
`define MERCURY_FPU_ADDR_S23 5'b1_0111
`define MERCURY_FPU_ADDR_S24 5'b1_1000
`define MERCURY_FPU_ADDR_S25 5'b1_1001
`define MERCURY_FPU_ADDR_S26 5'b1_1010
`define MERCURY_FPU_ADDR_S27 5'b1_1011
`define MERCURY_FPU_ADDR_S28 5'b1_1100
`define MERCURY_FPU_ADDR_S29 5'b1_1101
`define MERCURY_FPU_ADDR_S30 5'b1_1110
`define MERCURY_FPU_ADDR_S31 5'b1_1111

`define MERCURY_NEON_ADDR_S00 6'b00_0000
`define MERCURY_NEON_ADDR_S01 6'b00_0001
`define MERCURY_NEON_ADDR_S02 6'b00_0010
`define MERCURY_NEON_ADDR_S03 6'b00_0011
`define MERCURY_NEON_ADDR_S04 6'b00_0100
`define MERCURY_NEON_ADDR_S05 6'b00_0101
`define MERCURY_NEON_ADDR_S06 6'b00_0110
`define MERCURY_NEON_ADDR_S07 6'b00_0111
`define MERCURY_NEON_ADDR_S08 6'b00_1000
`define MERCURY_NEON_ADDR_S09 6'b00_1001
`define MERCURY_NEON_ADDR_S10 6'b00_1010
`define MERCURY_NEON_ADDR_S11 6'b00_1011
`define MERCURY_NEON_ADDR_S12 6'b00_1100
`define MERCURY_NEON_ADDR_S13 6'b00_1101
`define MERCURY_NEON_ADDR_S14 6'b00_1110
`define MERCURY_NEON_ADDR_S15 6'b00_1111
`define MERCURY_NEON_ADDR_S16 6'b01_0000
`define MERCURY_NEON_ADDR_S17 6'b01_0001
`define MERCURY_NEON_ADDR_S18 6'b01_0010
`define MERCURY_NEON_ADDR_S19 6'b01_0011
`define MERCURY_NEON_ADDR_S20 6'b01_0100
`define MERCURY_NEON_ADDR_S21 6'b01_0101
`define MERCURY_NEON_ADDR_S22 6'b01_0110
`define MERCURY_NEON_ADDR_S23 6'b01_0111
`define MERCURY_NEON_ADDR_S24 6'b01_1000
`define MERCURY_NEON_ADDR_S25 6'b01_1001
`define MERCURY_NEON_ADDR_S26 6'b01_1010
`define MERCURY_NEON_ADDR_S27 6'b01_1011
`define MERCURY_NEON_ADDR_S28 6'b01_1100
`define MERCURY_NEON_ADDR_S29 6'b01_1101
`define MERCURY_NEON_ADDR_S30 6'b01_1110
`define MERCURY_NEON_ADDR_S31 6'b01_1111
`define MERCURY_NEON_ADDR_S32 6'b10_0000
`define MERCURY_NEON_ADDR_S33 6'b10_0001
`define MERCURY_NEON_ADDR_S34 6'b10_0010
`define MERCURY_NEON_ADDR_S35 6'b10_0011
`define MERCURY_NEON_ADDR_S36 6'b10_0100
`define MERCURY_NEON_ADDR_S37 6'b10_0101
`define MERCURY_NEON_ADDR_S38 6'b10_0110
`define MERCURY_NEON_ADDR_S39 6'b10_0111
`define MERCURY_NEON_ADDR_S40 6'b10_1000
`define MERCURY_NEON_ADDR_S41 6'b10_1001
`define MERCURY_NEON_ADDR_S42 6'b10_1010
`define MERCURY_NEON_ADDR_S43 6'b10_1011
`define MERCURY_NEON_ADDR_S44 6'b10_1100
`define MERCURY_NEON_ADDR_S45 6'b10_1101
`define MERCURY_NEON_ADDR_S46 6'b10_1110
`define MERCURY_NEON_ADDR_S47 6'b10_1111
`define MERCURY_NEON_ADDR_S48 6'b11_0000
`define MERCURY_NEON_ADDR_S49 6'b11_0001
`define MERCURY_NEON_ADDR_S50 6'b11_0010
`define MERCURY_NEON_ADDR_S51 6'b11_0011
`define MERCURY_NEON_ADDR_S52 6'b11_0100
`define MERCURY_NEON_ADDR_S53 6'b11_0101
`define MERCURY_NEON_ADDR_S54 6'b11_0110
`define MERCURY_NEON_ADDR_S55 6'b11_0111
`define MERCURY_NEON_ADDR_S56 6'b11_1000
`define MERCURY_NEON_ADDR_S57 6'b11_1001
`define MERCURY_NEON_ADDR_S58 6'b11_1010
`define MERCURY_NEON_ADDR_S59 6'b11_1011
`define MERCURY_NEON_ADDR_S60 6'b11_1100
`define MERCURY_NEON_ADDR_S61 6'b11_1101
`define MERCURY_NEON_ADDR_S62 6'b11_1110
`define MERCURY_NEON_ADDR_S63 6'b11_1111

`define MERCURY_SEL_FML_A_W 1
`define MERCURY_SEL_FML_A_ZERO 1'b0
`define MERCURY_SEL_FML_A_FR0  1'b1

`define MERCURY_SEL_FML_B_W 1
`define MERCURY_SEL_FML_B_ZERO 1'b0
`define MERCURY_SEL_FML_B_FR1  1'b1

`define MERCURY_SEL_FML_C_W 1
`define MERCURY_SEL_FML_C_ZERO 1'b0
`define MERCURY_SEL_FML_C_FR2  1'b1

`define MERCURY_SEL_FAD_A_W 3
`define MERCURY_SEL_FAD_A_ZERO  3'b000
`define MERCURY_SEL_FAD_A_FR2   3'b001
`define MERCURY_SEL_FAD_A_TWO   3'b010
`define MERCURY_SEL_FAD_A_THREE 3'b011
`define MERCURY_SEL_FAD_A_TRN32 3'b100

`define MERCURY_SEL_FAD_B_W 3
`define MERCURY_SEL_FAD_B_ZERO  3'b000
`define MERCURY_SEL_FAD_B_FR1   3'b001
`define MERCURY_SEL_FAD_B_IMM   3'b010
`define MERCURY_SEL_FAD_B_FML_Q 3'b011
`define MERCURY_SEL_FAD_B_TRN32 3'b100
`define MERCURY_SEL_FAD_B_STR   3'b110

`define MERCURY_SEL_FAD_C_W 2
`define MERCURY_SEL_FAD_C_ZERO  2'b00
`define MERCURY_SEL_FAD_C_FR0   2'b01
`define MERCURY_SEL_FAD_C_IMM   2'b10

`define MERCURY_FWD_FNULL       3'b000
`define MERCURY_FWD_ZERO        3'b001
`define MERCURY_FWD_FW0_F3      3'b010
`define MERCURY_FWD_FW0_F4      3'b100
`define MERCURY_FWD_FW0_F5      3'b110

`define MERCURY_FP_FORMAT_F32   3'b000
`define MERCURY_FP_FORMAT_F64   3'b001
`define MERCURY_FP_FORMAT_F16_B 3'b010
`define MERCURY_FP_FORMAT_F16_T 3'b011
`define MERCURY_FP_FORMAT_S16   3'b110
`define MERCURY_FP_FORMAT_U16   3'b111
`define MERCURY_FP_FORMAT_S32   3'b100
`define MERCURY_FP_FORMAT_U32   3'b101

`define MERCURY_FPEXC_W 1
`define MERCURY_FPEXC_EN_BITS  0

`define MERCURY_FPEXC_ST_EN_BITS  13

`define MERCURY_FPSCR_ARCH_NZCV_BITS    31:28
`define MERCURY_FPSCR_ARCH_QC_BITS      27
`define MERCURY_FPSCR_ARCH_AHP_BITS     26
`define MERCURY_FPSCR_ARCH_DN_BITS      25
`define MERCURY_FPSCR_ARCH_FZ_BITS      24
`define MERCURY_FPSCR_ARCH_RMODE_BITS   23:22
`define MERCURY_FPSCR_ARCH_STRIDE_BITS  21:20
`define MERCURY_FPSCR_ARCH_LEN_BITS     18:16
`define MERCURY_FPSCR_ARCH_IDC_BITS     7
`define MERCURY_FPSCR_ARCH_IXC_BITS     4
`define MERCURY_FPSCR_ARCH_UFC_BITS     3
`define MERCURY_FPSCR_ARCH_OFC_BITS     2
`define MERCURY_FPSCR_ARCH_DZC_BITS     1
`define MERCURY_FPSCR_ARCH_IOC_BITS     0

`define MERCURY_FPEXC_ARCH_EN_BITS  30

`define MERCURY_FPSCR_W               16
`define MERCURY_FPSCR_FP_BITS         14:0
`define MERCURY_FPSCR_QC_BITS         15    
`define MERCURY_FPSCR_NZCV_BITS       14:11
`define MERCURY_FPSCR_AHP_BITS        10
`define MERCURY_FPSCR_DN_BITS         9
`define MERCURY_FPSCR_FZ_BITS         8
`define MERCURY_FPSCR_RMODE_BITS      7:6
`define MERCURY_FPSCR_CONFIG_BITS     10:6
`define MERCURY_FPSCR_FP_XFLAGS_BITS  5:0

`define MERCURY_FPSCR_IDC_BITS 5
`define MERCURY_FPSCR_IXC_BITS 4
`define MERCURY_FPSCR_UFC_BITS 3
`define MERCURY_FPSCR_OFC_BITS 2
`define MERCURY_FPSCR_DZC_BITS 1
`define MERCURY_FPSCR_IOC_BITS 0

`define MERCURY_XFLAGS_W        7
`define MERCURY_XFLAGS_QC_BITS  6
`define MERCURY_XFLAGS_IDC_BITS `MERCURY_FPSCR_IDC_BITS
`define MERCURY_XFLAGS_IXC_BITS `MERCURY_FPSCR_IXC_BITS
`define MERCURY_XFLAGS_UFC_BITS `MERCURY_FPSCR_UFC_BITS
`define MERCURY_XFLAGS_OFC_BITS `MERCURY_FPSCR_OFC_BITS
`define MERCURY_XFLAGS_DZC_BITS `MERCURY_FPSCR_DZC_BITS
`define MERCURY_XFLAGS_IOC_BITS `MERCURY_FPSCR_IOC_BITS

`define MERCURY_XFLAGS_FP_BITS  `MERCURY_FPSCR_FP_XFLAGS_BITS

`define MERCURY_FP_CFLAG_SRC_W 1
`define MERCURY_FP_CFLAG_SRC_FPSCR   2'b0
`define MERCURY_FP_CFLAG_SRC_ALU     2'b1

`define MERCURY_FP_XFLAG_SRC_W 2
`define MERCURY_FP_XFLAG_SRC_FPSCR   2'b00
`define MERCURY_FP_XFLAG_SRC_MUL     2'b01
`define MERCURY_FP_XFLAG_SRC_ALU     2'b10

`define MERCURY_FP_RMODE_W           3
`define MERCURY_FP_RMODE_0           3'b000
`define MERCURY_FP_RMODE_RN          3'b000 
`define MERCURY_FP_RMODE_RP          3'b001 
`define MERCURY_FP_RMODE_RM          3'b010 
`define MERCURY_FP_RMODE_RZ          3'b011 
`define MERCURY_FP_RMODE_RA          3'b100 
`define MERCURY_FP_RMODE_RX          3'b101 
`define MERCURY_FP_RMODE_NEON        3'b110 
`define MERCURY_FP_RMODE_FPCR        3'b111

`define MERCURY_FP_OP_W              5
`define MERCURY_FP_OP_0              5'b00000
`define MERCURY_FP_OP_ADD            5'b00001
`define MERCURY_FP_OP_SUB            5'b00010
`define MERCURY_FP_OP_ABD            5'b00011
`define MERCURY_FP_OP_CMP            5'b00100
`define MERCURY_FP_OP_CMPE           5'b00101
`define MERCURY_FP_OP_ACMPE          5'b00110
`define MERCURY_FP_OP_MOV            5'b00111
`define MERCURY_FP_OP_ABS            5'b01000
`define MERCURY_FP_OP_NEG            5'b01001
`define MERCURY_FP_OP_RINT           5'b01010
`define MERCURY_FP_OP_RINTX          5'b01011
`define MERCURY_FP_OP_MAX            5'b01100
`define MERCURY_FP_OP_MAXNM          5'b01101
`define MERCURY_FP_OP_MIN            5'b01110
`define MERCURY_FP_OP_MINNM          5'b01111
`define MERCURY_FP_OP_F2H_B          5'b10000
`define MERCURY_FP_OP_F2H_T          5'b10001
`define MERCURY_FP_OP_H2F_B          5'b10010
`define MERCURY_FP_OP_H2F_T          5'b10011
`define MERCURY_FP_OP_I2S            5'b10100
`define MERCURY_FP_OP_I2D            5'b10101
`define MERCURY_FP_OP_S2I            5'b10110
`define MERCURY_FP_OP_D2I            5'b10111
`define MERCURY_FP_OP_D2FP           5'b11111
`define MERCURY_FP_OP_S2D            5'b11000
`define MERCURY_FP_OP_D2S            5'b11001
`define MERCURY_FP_OP_RSB            5'b11010
`define MERCURY_FP_OP_HADD           5'b11011
`define MERCURY_FP_OP_RECPX          5'b11100

`define MERCURY_NEON_FCTN_W          5
`define MERCURY_NEON_FCTN_0          5'b00000
`define MERCURY_NEON_FCTN_FP         5'b00000
`define MERCURY_NEON_FCTN_PERM       5'b00001
`define MERCURY_NEON_FCTN_ADDSUBHN   5'b00010
`define MERCURY_NEON_FCTN_TBL_TBX    5'b00011
`define MERCURY_NEON_FCTN_TBX_FINAL  5'b00100
`define MERCURY_NEON_FCTN_SWAP_MAX   5'b00101
`define MERCURY_NEON_FCTN_CMP        5'b00110
`define MERCURY_NEON_FCTN_SHIFT      5'b00111
`define MERCURY_NEON_FCTN_NONE       5'b01000
`define MERCURY_NEON_FCTN_CLS        5'b01001
`define MERCURY_NEON_FCTN_CNT        5'b01010
`define MERCURY_NEON_FCTN_ACCUM      5'b01011
`define MERCURY_NEON_FCTN_PERM_FB    5'b01100
`define MERCURY_NEON_FCTN_RND_SHIFT  5'b01101
`define MERCURY_NEON_FCTN_INS_SHIFT  5'b01110
`define MERCURY_NEON_FCTN_SHA256SU0  5'b01111
`define MERCURY_NEON_FCTN_RBIT       5'b10000
`define MERCURY_NEON_FCTN_SHA1H      5'b10001
`define MERCURY_NEON_FCTN_SHA1SU0    5'b10010
`define MERCURY_NEON_FCTN_ADDV       5'b10011
`define MERCURY_NEON_FCTN_MAXV       5'b10100
`define MERCURY_NEON_FCTN_MINV       5'b10101

`define MERCURY_NEON_MUX_SEL_W       3
`define MERCURY_NEON_MUX_SEL_0       3'b000
`define MERCURY_NEON_MUX_SEL_AU      3'b001
`define MERCURY_NEON_MUX_SEL_LU      3'b010
`define MERCURY_NEON_MUX_SEL_CLZ     3'b011
`define MERCURY_NEON_MUX_SEL_PMUL    3'b100
`define MERCURY_NEON_MUX_SEL_MAXMIN  3'b101
`define MERCURY_NEON_MUX_SEL_FMAXMIN 3'b110

`define MERCURY_CRYPTO_OP_W            4
`define MERCURY_CRYPTO_OP_0            4'b0000
`define MERCURY_CRYPTO_OP_AESD         4'b0001
`define MERCURY_CRYPTO_OP_AESE         4'b0010
`define MERCURY_CRYPTO_OP_AESMC        4'b0011
`define MERCURY_CRYPTO_OP_AESIMC       4'b0100
`define MERCURY_CRYPTO_OP_AESD_AESIMC  4'b0101
`define MERCURY_CRYPTO_OP_AESE_AESMC   4'b0110
`define MERCURY_CRYPTO_OP_PMULL64      4'b0111
`define MERCURY_CRYPTO_OP_SHA1C        4'b1000
`define MERCURY_CRYPTO_OP_SHA1P        4'b1001
`define MERCURY_CRYPTO_OP_SHA1M        4'b1010
`define MERCURY_CRYPTO_OP_SHA1SU1      4'b1011
`define MERCURY_CRYPTO_OP_SHA256H      4'b1100
`define MERCURY_CRYPTO_OP_SHA256H2     4'b1101
`define MERCURY_CRYPTO_OP_SHA256SU1    4'b1110


`define MERCURY_FP_EX_PIPE_ADD                    0
`define MERCURY_FP_EX_PIPE_MUL                    1

`define MERCURY_FP_EX_PIPE_W                      2

`define MERCURY_FP_ADD_VECTOR_FP_OP_W             1
`define MERCURY_FP_ADD_VECTOR_FP_OP_BITS          0
`define MERCURY_FP_ADD_FP_OP_W                    `MERCURY_FP_OP_W
`define MERCURY_FP_ADD_FP_OP_BITS                 5:1

`define MERCURY_FP_NEON_ADD_NEON_INT_SEL_W        1
`define MERCURY_FP_NEON_ADD_NEON_INT_SEL_BITS     6
`define MERCURY_FP_NEON_ADD_NEON_MUX_SEL_W        `MERCURY_NEON_MUX_SEL_W
`define MERCURY_FP_NEON_ADD_NEON_MUX_SEL_BITS     9:7
`define MERCURY_FP_NEON_ADD_LU_CTL_W              4
`define MERCURY_FP_NEON_ADD_LU_CTL_BITS           13:10
`define MERCURY_FP_NEON_ADD_SIZE_SEL_W            2
`define MERCURY_FP_NEON_ADD_SIZE_SEL_BITS         15:14
`define MERCURY_FP_NEON_ADD_PERM_SEL_W            4
`define MERCURY_FP_NEON_ADD_PERM_SEL_BITS         19:16
`define MERCURY_FP_NEON_ADD_VTB_CYCLE_W           1
`define MERCURY_FP_NEON_ADD_VTB_CYCLE_BITS        20
`define MERCURY_FP_NEON_ADD_UNSIGNED_OP_W         1
`define MERCURY_FP_NEON_ADD_UNSIGNED_OP_BITS      21
`define MERCURY_FP_NEON_ADD_FCTN_SEL_W            `MERCURY_NEON_FCTN_W
`define MERCURY_FP_NEON_ADD_FCTN_SEL_BITS         26:22
`define MERCURY_FP_NEON_ADD_WIDTH_OP_SEL_W        3
`define MERCURY_FP_NEON_ADD_WIDTH_OP_SEL_BITS     29:27
`define MERCURY_FP_NEON_ADD_SAT_OP_SEL_W          3
`define MERCURY_FP_NEON_ADD_SAT_OP_SEL_BITS       32:30
`define MERCURY_FP_NEON_ADD_VTST_OP_SEL_W         1
`define MERCURY_FP_NEON_ADD_VTST_OP_SEL_BITS      33
`define MERCURY_FP_NEON_ADD_MASK_SEL_W            1
`define MERCURY_FP_NEON_ADD_MASK_SEL_BITS         34

`define MERCURY_FP_MUL_NEG_SQRT_W                 1
`define MERCURY_FP_MUL_NEG_SQRT_BITS              0
`define MERCURY_FP_MUL_DIVIDE_W                   1
`define MERCURY_FP_MUL_DIVIDE_BITS                1
`define MERCURY_FP_MUL_PRECISION_W                1
`define MERCURY_FP_MUL_PRECISION_BITS             2
`define MERCURY_FP_MUL_FUSED_MAC_W                1
`define MERCURY_FP_MUL_FUSED_MAC_BITS             3

`define MERCURY_FP_MUL_NEON_VECTOR_OP_W           1
`define MERCURY_FP_MUL_NEON_VECTOR_OP_BITS        4
`define MERCURY_FP_MUL_NEON_INT_OP_W              1
`define MERCURY_FP_MUL_NEON_INT_OP_BITS           5
`define MERCURY_FP_MUL_NEON_FIXUP_W               1
`define MERCURY_FP_MUL_NEON_FIXUP_BITS            6
`define MERCURY_FP_MUL_NEON_SAT_DBL_W             1
`define MERCURY_FP_MUL_NEON_SAT_DBL_BITS          7
`define MERCURY_FP_MUL_NEON_ROUND_W               1
`define MERCURY_FP_MUL_NEON_ROUND_BITS            8
`define MERCURY_FP_MUL_NEON_TYPE_W                3
`define MERCURY_FP_MUL_NEON_TYPE_BITS             11:9
`define MERCURY_FP_MUL_NEON_OUT_FMT_W             3
`define MERCURY_FP_MUL_NEON_OUT_FMT_BITS          14:12
`define MERCURY_FP_MUL_NEON_INV_IS_ZERO_W         1
`define MERCURY_FP_MUL_NEON_INV_IS_ZERO_BITS      15

`define MERCURY_NEON_VLD_PERM_EN_W                1
`define MERCURY_NEON_VLD_PERM_EN_BITS             0
`define MERCURY_NEON_VLD_DUP_W                    1
`define MERCURY_NEON_VLD_DUP_BITS                 1
`define MERCURY_NEON_VLD_SHR1_W                   2
`define MERCURY_NEON_VLD_SHR1_BITS                3:2
`define MERCURY_NEON_VLD_SHR2_W                   2
`define MERCURY_NEON_VLD_SHR2_BITS                5:4

`define MERCURY_FP_NEON_ADD_CTL_W (`MERCURY_FP_NEON_ADD_NEON_INT_SEL_W + `MERCURY_FP_NEON_ADD_NEON_MUX_SEL_W + `MERCURY_FP_NEON_ADD_LU_CTL_W       + \
                              `MERCURY_FP_NEON_ADD_SIZE_SEL_W     + `MERCURY_FP_NEON_ADD_PERM_SEL_W     + `MERCURY_FP_NEON_ADD_VTB_CYCLE_W    + \
                              `MERCURY_FP_NEON_ADD_UNSIGNED_OP_W  + `MERCURY_FP_NEON_ADD_FCTN_SEL_W     + `MERCURY_FP_NEON_ADD_WIDTH_OP_SEL_W + \
                              `MERCURY_FP_NEON_ADD_SAT_OP_SEL_W   + `MERCURY_FP_NEON_ADD_VTST_OP_SEL_W  + `MERCURY_FP_NEON_ADD_MASK_SEL_W)

`define MERCURY_FP_ADD_CTL_W  (`MERCURY_FP_NEON_ADD_CTL_W + `MERCURY_FP_ADD_VECTOR_FP_OP_W + `MERCURY_FP_ADD_FP_OP_W)

`define MERCURY_FP_NEON_MUL_CTL_W (`MERCURY_FP_MUL_NEON_INV_IS_ZERO_W + `MERCURY_FP_MUL_NEON_OUT_FMT_W + `MERCURY_FP_MUL_NEON_TYPE_W  + \
                              `MERCURY_FP_MUL_NEON_ROUND_W       + `MERCURY_FP_MUL_NEON_SAT_DBL_W + `MERCURY_FP_MUL_NEON_FIXUP_W + \
                              `MERCURY_FP_MUL_NEON_INT_OP_W      + `MERCURY_FP_MUL_NEON_VECTOR_OP_W)
`define MERCURY_FP_MUL_CTL_W  (`MERCURY_FP_NEON_MUL_CTL_W + `MERCURY_FP_MUL_FUSED_MAC_W + `MERCURY_FP_MUL_PRECISION_W + `MERCURY_FP_MUL_DIVIDE_W + `MERCURY_FP_MUL_NEG_SQRT_W)

`define MERCURY_NEON_VLD_CTL_W (`MERCURY_NEON_VLD_SHR2_W + `MERCURY_NEON_VLD_SHR1_W + `MERCURY_NEON_VLD_DUP_W + `MERCURY_NEON_VLD_PERM_EN_W)

`define MERCURY_FP_PIPECTL_RMODE_W                `MERCURY_FP_RMODE_W
`define MERCURY_FP_PIPECTL_RMODE_BITS             (`MERCURY_FP_MUL_CTL_W + `MERCURY_FP_ADD_CTL_W + `MERCURY_FP_PIPECTL_RMODE_W - 1):(`MERCURY_FP_MUL_CTL_W + `MERCURY_FP_ADD_CTL_W)
`define MERCURY_FP_PIPECTL_FORCE_DN_FZ_W          1
`define MERCURY_FP_PIPECTL_FORCE_DN_FZ_BITS       (`MERCURY_FP_MUL_CTL_W + `MERCURY_FP_ADD_CTL_W + `MERCURY_FP_PIPECTL_RMODE_W)

`define MERCURY_FP_PIPECTL_TOP_W (`MERCURY_FP_PIPECTL_FORCE_DN_FZ_W + `MERCURY_FP_PIPECTL_RMODE_W + \
                              `MERCURY_FP_MUL_CTL_W)
`define MERCURY_FP_PIPECTL_W     (`MERCURY_FP_PIPECTL_TOP_W + `MERCURY_FP_ADD_CTL_W)

`define MERCURY_FP_PIPECTL_TOP_BITS     (`MERCURY_FP_PIPECTL_W-1):(`MERCURY_FP_ADD_CTL_W)
`define MERCURY_FP_PIPECTL_MUL_CTL_BITS (`MERCURY_FP_MUL_CTL_W+`MERCURY_FP_ADD_CTL_W-1):(`MERCURY_FP_ADD_CTL_W)
`define MERCURY_FP_PIPECTL_ADD_CTL_BITS (`MERCURY_FP_ADD_CTL_W-1):0


`define MERCURY_NEON_LD_PERM_8_0        4'b0000
`define MERCURY_NEON_LD_PERM_8_1        4'b0001
`define MERCURY_NEON_LD_PERM_8_2        4'b0010
`define MERCURY_NEON_LD_PERM_8_3        4'b0011

`define MERCURY_NEON_LD_PERM_16_0       4'b0100
`define MERCURY_NEON_LD_PERM_16_1       4'b0101
`define MERCURY_NEON_LD_PERM_16_2       4'b0110
`define MERCURY_NEON_LD_PERM_16_3       4'b0111

`define MERCURY_NEON_LD_PERM_32_0       4'b1000
`define MERCURY_NEON_LD_PERM_32_1       4'b1001
`define MERCURY_NEON_LD_PERM_32_2       4'b1010
`define MERCURY_NEON_LD_PERM_32_3       4'b1011

`define MERCURY_NEON_LD_PERM_64         4'b1100

`define MERCURY_NEON_MUL_TYPE_I8        3'b000
`define MERCURY_NEON_MUL_TYPE_I16       3'b010
`define MERCURY_NEON_MUL_TYPE_I16_LO    3'b100
`define MERCURY_NEON_MUL_TYPE_I16_HI    3'b101
`define MERCURY_NEON_MUL_TYPE_I32       3'b011
`define MERCURY_NEON_MUL_TYPE_I32_LO    3'b110

`define MERCURY_NEON_MUL_OUT_FMT_64     3'b000
`define MERCURY_NEON_MUL_OUT_FMT_32_L   3'b001
`define MERCURY_NEON_MUL_OUT_FMT_32_H   3'b010
`define MERCURY_NEON_MUL_OUT_FMT_4_8    3'b011
`define MERCURY_NEON_MUL_OUT_FMT_4_16   3'b100
`define MERCURY_NEON_MUL_OUT_FMT_2_32   3'b101
`define MERCURY_NEON_MUL_OUT_FMT_2_16_H 3'b110
`define MERCURY_NEON_MUL_OUT_FMT_VREC   3'b111



`define MERCURY_NEON_SAT_NONE           3'b000
`define MERCURY_NEON_SAT_ADD            3'b001
`define MERCURY_NEON_SAT_SHF_SIGNED     3'b010
`define MERCURY_NEON_SAT_SHF_UNSIGNED   3'b011
`define MERCURY_NEON_SAT_SUQADD         3'b100
`define MERCURY_NEON_SAT_USQADD         3'b101
`define MERCURY_NEON_SAT_MAXV           3'b110
`define MERCURY_NEON_SAT_MINV           3'b111

`define MERCURY_NEON_LU_AND   4'b0001
`define MERCURY_NEON_LU_BIC   4'b0010
`define MERCURY_NEON_LU_BIF   4'b0011
`define MERCURY_NEON_LU_BIT   4'b0100
`define MERCURY_NEON_LU_BSL   4'b0101
`define MERCURY_NEON_LU_EOR   4'b0110
`define MERCURY_NEON_LU_MOV   4'b0111
`define MERCURY_NEON_LU_MVN   4'b1000
`define MERCURY_NEON_LU_ORN   4'b1001
`define MERCURY_NEON_LU_ORR   4'b1010
`define MERCURY_NEON_LU_VCGT  4'b1100
`define MERCURY_NEON_LU_VCEQ  4'b1101

`else

`undef MERCURY_DP_WIDTH
`undef MERCURY_DP_BITS_W
`undef MERCURY_DP_COUNT_W
`undef MERCURY_RP_RD_3_0
`undef MERCURY_RP_RD_11_8
`undef MERCURY_RP_RD_15_12
`undef MERCURY_RP_RD_19_16
`undef MERCURY_RP_RD_STM
`undef MERCURY_RP_RD_MCR
`undef MERCURY_RP_RD_ERET
`undef MERCURY_RP0_RD_2_0
`undef MERCURY_RP0_RD_R13
`undef MERCURY_RP2_RD_R14
`undef MERCURY_RP2_RD_RMOD
`undef MERCURY_RD_CTL_EN
`undef MERCURY_RD_CTL_PC
`undef MERCURY_RD_CTL_ZR
`undef MERCURY_RD_CTL_STM
`undef MERCURY_WR_CTL_EN
`undef MERCURY_WR_CTL_19_16
`undef MERCURY_WR_CTL_15_12
`undef MERCURY_WR_CTL_11_8
`undef MERCURY_WR_CTL_3_0
`undef MERCURY_WR_CTL_LDM
`undef MERCURY_WR_CTL_ART
`undef MERCURY_WR_CTL_R30
`undef MERCURY_WR_CTL_RMOD
`undef MERCURY_WR_CTL_R13
`undef MERCURY_WR_CTL_R14
`undef MERCURY_WR_CTL_R15
`undef MERCURY_WR_CTL_ZR
`undef mercury_dpu_sel_0x
`undef mercury_dpu_sel_1x
`undef mercury_dpu_sel_0x0
`undef mercury_dpu_sel_0x1
`undef mercury_dpu_sel_0xx
`undef mercury_dpu_sel_00x
`undef mercury_dpu_sel_10x
`undef mercury_dpu_sel_1x0
`undef mercury_dpu_sel_1x1
`undef mercury_dpu_sel_11x
`undef mercury_dpu_sel_000
`undef mercury_dpu_sel_001
`undef mercury_dpu_sel_01x
`undef mercury_dpu_sel_1xx
`undef mercury_dpu_sel_100
`undef mercury_dpu_sel_x10
`undef mercury_dpu_sel_xx1
`undef mercury_dpu_sel_1n00
`undef mercury_dpu_sel_1xxx
`undef mercury_dpu_sel_01xx
`undef mercury_dpu_sel_001x
`undef mercury_dpu_sel_0xxx
`undef mercury_dpu_sel_00xx
`undef mercury_dpu_sel_xx00
`undef mercury_dpu_sel_000x
`undef mercury_dpu_sel_010x
`undef mercury_dpu_sel_10xx
`undef mercury_dpu_sel_100x
`undef mercury_dpu_sel_101x
`undef mercury_dpu_sel_xx00_not_0000
`undef mercury_dpu_sel_1000
`undef mercury_dpu_sel_x100
`undef mercury_dpu_sel_xx10
`undef mercury_dpu_sel_xx11
`undef mercury_dpu_sel_xx01
`undef mercury_dpu_sel_xxx1
`undef mercury_dpu_sel_xx01_not_0001
`undef mercury_dpu_sel_0x00
`undef mercury_dpu_sel_0x01
`undef mercury_dpu_sel_0x1x
`undef mercury_dpu_sel_10x0
`undef mercury_dpu_sel_10x1
`undef mercury_dpu_sel_11xx
`undef mercury_dpu_sel_000xx
`undef mercury_dpu_sel_001xx
`undef mercury_dpu_sel_100xx
`undef mercury_dpu_sel_101xx
`undef mercury_dpu_sel_x000x
`undef mercury_dpu_sel_x001x
`undef mercury_dpu_sel_x010x
`undef mercury_dpu_sel_x011x
`undef mercury_dpu_sel_x100x
`undef mercury_dpu_sel_x101x
`undef mercury_dpu_sel_x1100
`undef mercury_dpu_sel_x1101
`undef mercury_dpu_sel_x1110
`undef mercury_dpu_sel_x1111
`undef mercury_dpu_sel_00xxx
`undef mercury_dpu_sel_1xxxx
`undef mercury_dpu_sel_01xxx
`undef mercury_dpu_sel_0001x
`undef mercury_dpu_sel_1x_xxxx__p0
`undef mercury_dpu_sel_1x_xxxx__p1
`undef mercury_dpu_sel_1x_xxxx__p2
`undef mercury_dpu_sel_1x_xxxx__p3
`undef mercury_dpu_sel_1x_xxxx__p4
`undef mercury_dpu_sel_1x_xxxx__p5
`undef mercury_dpu_sel_1x_xxxx
`undef mercury_dpu_sel_01_xxxx_p0
`undef mercury_dpu_sel_01_xxxx_p1
`undef mercury_dpu_sel_01_xxxx_p2
`undef mercury_dpu_sel_01_xxxx
`undef mercury_dpu_sel_00_1xxx
`undef mercury_dpu_sel_00_01xx
`undef mercury_dpu_sel_00_001x
`undef mercury_dpu_sel_1xx_xxxx_p0
`undef mercury_dpu_sel_1xx_xxxx_p1
`undef mercury_dpu_sel_1xx_xxxx_p2
`undef mercury_dpu_sel_1xx_xxxx_p3
`undef mercury_dpu_sel_1xx_xxxx_p4
`undef mercury_dpu_sel_1xx_xxxx_p5
`undef mercury_dpu_sel_1xx_xxxx_p6
`undef mercury_dpu_sel_1xx_xxxx_p7
`undef mercury_dpu_sel_1xx_xxxx_p8
`undef mercury_dpu_sel_1xx_xxxx_p9
`undef mercury_dpu_sel_1xx_xxxx_p10
`undef mercury_dpu_sel_1xx_xxxx
`undef mercury_dpu_sel_01x_xxxx_p0
`undef mercury_dpu_sel_01x_xxxx_p1
`undef mercury_dpu_sel_01x_xxxx_p2
`undef mercury_dpu_sel_01x_xxxx_p3
`undef mercury_dpu_sel_01x_xxxx_p4
`undef mercury_dpu_sel_01x_xxxx_p5
`undef mercury_dpu_sel_01x_xxxx
`undef mercury_dpu_sel_001_xxxx_p0
`undef mercury_dpu_sel_001_xxxx_p1
`undef mercury_dpu_sel_001_xxxx_p2
`undef mercury_dpu_sel_001_xxxx
`undef mercury_dpu_sel_000_1xxx
`undef mercury_dpu_sel_000_01xx
`undef mercury_dpu_sel_000_001x
`undef mercury_dpu_sel_0000_01xx
`undef mercury_dpu_sel_0000_001x
`undef mercury_dpu_sel_0000_1xx0
`undef mercury_dpu_sel_0000_1xx1
`undef mercury_dpu_sel_0000_1xxx
`undef mercury_dpu_sel_0001_00xx
`undef mercury_dpu_sel_0001_01xx
`undef mercury_dpu_sel_0001_10xx
`undef mercury_dpu_sel_0001_11xx
`undef mercury_dpu_sel_0010_00xx
`undef mercury_dpu_sel_0010_01xx
`undef mercury_dpu_sel_0010_10xx
`undef mercury_dpu_sel_0010_11xx
`undef mercury_dpu_sel_0011_00xx
`undef mercury_dpu_sel_0011_01xx
`undef mercury_dpu_sel_0011_10xx
`undef mercury_dpu_sel_0011_11xx
`undef mercury_dpu_sel_0100_00xx
`undef mercury_dpu_sel_0100_01xx
`undef mercury_dpu_sel_0100_10xx
`undef mercury_dpu_sel_0100_11xx
`undef mercury_dpu_sel_0101_00xx
`undef mercury_dpu_sel_0101_01xx
`undef mercury_dpu_sel_0101_10xx
`undef mercury_dpu_sel_0101_11xx
`undef mercury_dpu_sel_0110_00xx
`undef mercury_dpu_sel_0110_01xx
`undef mercury_dpu_sel_0110_10xx
`undef mercury_dpu_sel_0110_11xx
`undef mercury_dpu_sel_0111_00xx
`undef mercury_dpu_sel_0111_01xx
`undef mercury_dpu_sel_0111_10xx
`undef mercury_dpu_sel_0111_11xx
`undef mercury_dpu_sel_1000_00xx
`undef mercury_dpu_sel_1000_01xx
`undef mercury_dpu_sel_1000_10xx
`undef mercury_dpu_sel_1000_11xx
`undef mercury_dpu_sel_1001_00xx
`undef mercury_dpu_sel_1001_01xx
`undef mercury_dpu_sel_1001_10xx
`undef mercury_dpu_sel_1001_11xx
`undef mercury_dpu_sel_1010_00xx
`undef mercury_dpu_sel_1010_01xx
`undef mercury_dpu_sel_1010_10xx
`undef mercury_dpu_sel_1010_11xx
`undef mercury_dpu_sel_1011_00xx
`undef mercury_dpu_sel_1011_01xx
`undef mercury_dpu_sel_1011_10xx
`undef mercury_dpu_sel_1011_11xx
`undef mercury_dpu_sel_1100_00xx
`undef mercury_dpu_sel_1100_01xx
`undef mercury_dpu_sel_1100_10xx
`undef mercury_dpu_sel_1100_11xx
`undef mercury_dpu_sel_1101_00xx
`undef mercury_dpu_sel_1101_01xx
`undef mercury_dpu_sel_1101_10xx
`undef mercury_dpu_sel_1101_11xx
`undef mercury_dpu_sel_1110_00xx
`undef mercury_dpu_sel_1110_01xx
`undef mercury_dpu_sel_1110_10xx
`undef mercury_dpu_sel_1110_11xx
`undef mercury_dpu_sel_1111_00xx
`undef mercury_dpu_sel_1111_01xx
`undef mercury_dpu_sel_1111_10xx
`undef mercury_dpu_sel_1111_11xx
`undef mercury_dpu_sel_0001_xxxx
`undef mercury_dpu_sel_0010_xxxx
`undef mercury_dpu_sel_0011_xxxx
`undef mercury_dpu_sel_0100_xxxx
`undef mercury_dpu_sel_0101_xxxx
`undef mercury_dpu_sel_0110_xxxx
`undef mercury_dpu_sel_0111_xxxx
`undef mercury_dpu_sel_1000_xxxx
`undef mercury_dpu_sel_1001_xxxx
`undef mercury_dpu_sel_1010_xxxx
`undef mercury_dpu_sel_1011_xxxx
`undef mercury_dpu_sel_1100_xxxx
`undef mercury_dpu_sel_1101_xxxx
`undef mercury_dpu_sel_1110_xxxx
`undef mercury_dpu_sel_1111_xxxx
`undef mercury_dpu_sel_1xxx_xxxx
`undef mercury_dpu_sel_01xx_xxxx
`undef mercury_dpu_sel_001x_xxxx
`undef MERCURY_VADDR_R00
`undef MERCURY_VADDR_R01
`undef MERCURY_VADDR_R02
`undef MERCURY_VADDR_R03
`undef MERCURY_VADDR_R04
`undef MERCURY_VADDR_R05
`undef MERCURY_VADDR_R06
`undef MERCURY_VADDR_R07
`undef MERCURY_VADDR_R08
`undef MERCURY_VADDR_R09
`undef MERCURY_VADDR_R10
`undef MERCURY_VADDR_R11
`undef MERCURY_VADDR_R12
`undef MERCURY_VADDR_R13
`undef MERCURY_VADDR_R14
`undef MERCURY_VADDR_R15
`undef MERCURY_VADDR_R16
`undef MERCURY_VADDR_R17
`undef MERCURY_VADDR_R18
`undef MERCURY_VADDR_R19
`undef MERCURY_VADDR_R20
`undef MERCURY_VADDR_R21
`undef MERCURY_VADDR_R22
`undef MERCURY_VADDR_R23
`undef MERCURY_VADDR_R24
`undef MERCURY_VADDR_R25
`undef MERCURY_VADDR_R26
`undef MERCURY_VADDR_R27
`undef MERCURY_VADDR_R28
`undef MERCURY_VADDR_R29
`undef MERCURY_VADDR_R30
`undef MERCURY_VADDR_R31
`undef MERCURY_ADDR_X0
`undef MERCURY_ADDR_X1
`undef MERCURY_ADDR_X2
`undef MERCURY_ADDR_X3
`undef MERCURY_ADDR_X4
`undef MERCURY_ADDR_X5
`undef MERCURY_ADDR_X6
`undef MERCURY_ADDR_X7
`undef MERCURY_ADDR_X8
`undef MERCURY_ADDR_X9
`undef MERCURY_ADDR_X10
`undef MERCURY_ADDR_X11
`undef MERCURY_ADDR_X12
`undef MERCURY_ADDR_X13
`undef MERCURY_ADDR_X14
`undef MERCURY_ADDR_X15
`undef MERCURY_ADDR_X16
`undef MERCURY_ADDR_X17
`undef MERCURY_ADDR_X18
`undef MERCURY_ADDR_X19
`undef MERCURY_ADDR_X20
`undef MERCURY_ADDR_X21
`undef MERCURY_ADDR_X22
`undef MERCURY_ADDR_X23
`undef MERCURY_ADDR_X24
`undef MERCURY_ADDR_X25
`undef MERCURY_ADDR_X26
`undef MERCURY_ADDR_X27
`undef MERCURY_ADDR_X28
`undef MERCURY_ADDR_X29
`undef MERCURY_ADDR_X30
`undef MERCURY_ADDR_SP_EL0
`undef MERCURY_ADDR_SP_EL1
`undef MERCURY_ADDR_SP_EL2
`undef MERCURY_ADDR_SP_EL3
`undef MERCURY_ADDR_ELR_EL1
`undef MERCURY_ADDR_ELR_EL2
`undef MERCURY_ADDR_ELR_EL3
`undef MERCURY_ADDR_R00
`undef MERCURY_ADDR_R01
`undef MERCURY_ADDR_R02
`undef MERCURY_ADDR_R03
`undef MERCURY_ADDR_R04
`undef MERCURY_ADDR_R05
`undef MERCURY_ADDR_R06
`undef MERCURY_ADDR_R07
`undef MERCURY_ADDR_R08
`undef MERCURY_ADDR_R09
`undef MERCURY_ADDR_R10
`undef MERCURY_ADDR_R11
`undef MERCURY_ADDR_R12
`undef MERCURY_ADDR_R13
`undef MERCURY_ADDR_R14
`undef MERCURY_ADDR_R13_HYP
`undef MERCURY_ADDR_R14_IRQ
`undef MERCURY_ADDR_R13_IRQ
`undef MERCURY_ADDR_R14_SVC
`undef MERCURY_ADDR_R13_SVC
`undef MERCURY_ADDR_R14_ABT
`undef MERCURY_ADDR_R13_ABT
`undef MERCURY_ADDR_R14_UND
`undef MERCURY_ADDR_R13_UND
`undef MERCURY_ADDR_R08_FIQ
`undef MERCURY_ADDR_R09_FIQ
`undef MERCURY_ADDR_R10_FIQ
`undef MERCURY_ADDR_R11_FIQ
`undef MERCURY_ADDR_R12_FIQ
`undef MERCURY_ADDR_R13_FIQ
`undef MERCURY_ADDR_R14_FIQ
`undef MERCURY_ADDR_ELR_HYP
`undef MERCURY_ADDR_R14_MON
`undef MERCURY_ADDR_R13_MON
`undef MERCURY_LONG_RF_ADDR_W
`undef MERCURY_ADDR_BIT_X0
`undef MERCURY_ADDR_BIT_X1
`undef MERCURY_ADDR_BIT_X2
`undef MERCURY_ADDR_BIT_X3
`undef MERCURY_ADDR_BIT_X4
`undef MERCURY_ADDR_BIT_X5
`undef MERCURY_ADDR_BIT_X6
`undef MERCURY_ADDR_BIT_X7
`undef MERCURY_ADDR_BIT_X8
`undef MERCURY_ADDR_BIT_X9
`undef MERCURY_ADDR_BIT_X10
`undef MERCURY_ADDR_BIT_X11
`undef MERCURY_ADDR_BIT_X12
`undef MERCURY_ADDR_BIT_X13
`undef MERCURY_ADDR_BIT_X14
`undef MERCURY_ADDR_BIT_X15
`undef MERCURY_ADDR_BIT_X16
`undef MERCURY_ADDR_BIT_X17
`undef MERCURY_ADDR_BIT_X18
`undef MERCURY_ADDR_BIT_X19
`undef MERCURY_ADDR_BIT_X20
`undef MERCURY_ADDR_BIT_X21
`undef MERCURY_ADDR_BIT_X22
`undef MERCURY_ADDR_BIT_X23
`undef MERCURY_ADDR_BIT_X24
`undef MERCURY_ADDR_BIT_X25
`undef MERCURY_ADDR_BIT_X26
`undef MERCURY_ADDR_BIT_X27
`undef MERCURY_ADDR_BIT_X28
`undef MERCURY_ADDR_BIT_X29
`undef MERCURY_ADDR_BIT_X30
`undef MERCURY_ADDR_BIT_SP_EL3
`undef MERCURY_ADDR_BIT_ELR_EL2
`undef MERCURY_ADDR_BIT_ELR_EL3
`undef MERCURY_ADDR_BIT_SP_EL0
`undef MERCURY_ADDR_BIT_SP_EL1
`undef MERCURY_ADDR_BIT_SP_EL2
`undef MERCURY_ADDR_BIT_ELR_EL1
`undef MERCURY_ADDR_BIT_R00
`undef MERCURY_ADDR_BIT_R01
`undef MERCURY_ADDR_BIT_R02
`undef MERCURY_ADDR_BIT_R03
`undef MERCURY_ADDR_BIT_R04
`undef MERCURY_ADDR_BIT_R05
`undef MERCURY_ADDR_BIT_R06
`undef MERCURY_ADDR_BIT_R07
`undef MERCURY_ADDR_BIT_R08
`undef MERCURY_ADDR_BIT_R09
`undef MERCURY_ADDR_BIT_R10
`undef MERCURY_ADDR_BIT_R11
`undef MERCURY_ADDR_BIT_R12
`undef MERCURY_ADDR_BIT_R13
`undef MERCURY_ADDR_BIT_R14
`undef MERCURY_ADDR_BIT_R13_HYP
`undef MERCURY_ADDR_BIT_R14_IRQ
`undef MERCURY_ADDR_BIT_R13_IRQ
`undef MERCURY_ADDR_BIT_R14_SVC
`undef MERCURY_ADDR_BIT_R13_SVC
`undef MERCURY_ADDR_BIT_R14_ABT
`undef MERCURY_ADDR_BIT_R13_ABT
`undef MERCURY_ADDR_BIT_R14_UND
`undef MERCURY_ADDR_BIT_R13_UND
`undef MERCURY_ADDR_BIT_R08_FIQ
`undef MERCURY_ADDR_BIT_R09_FIQ
`undef MERCURY_ADDR_BIT_R10_FIQ
`undef MERCURY_ADDR_BIT_R11_FIQ
`undef MERCURY_ADDR_BIT_R12_FIQ
`undef MERCURY_ADDR_BIT_R13_FIQ
`undef MERCURY_ADDR_BIT_R14_FIQ
`undef MERCURY_ADDR_BIT_R13_MON
`undef MERCURY_ADDR_BIT_R14_MON
`undef MERCURY_ADDR_BIT_ELR_HYP
`undef MERCURY_SPSR_CRNT
`undef MERCURY_SPSR_FIQ
`undef MERCURY_SPSR_IRQ
`undef MERCURY_SPSR_SVC
`undef MERCURY_SPSR_ABT
`undef MERCURY_SPSR_UND
`undef MERCURY_SPSR_MON
`undef MERCURY_SPSR_HYP
`undef MERCURY_EX_PIPE_W
`undef MERCURY_EX_PIPE_NULL
`undef MERCURY_EX_PIPE_ALU
`undef MERCURY_EX_PIPE_BR
`undef MERCURY_EX_PIPE_DCU
`undef MERCURY_EX_PIPE_DIV
`undef MERCURY_EX_PIPE_STR
`undef MERCURY_EX_PIPE_ALU_BIT
`undef MERCURY_EX_PIPE_MAC_BIT
`undef MERCURY_EX_PIPE_BR_BIT
`undef MERCURY_EX_PIPE_DCU_BIT
`undef MERCURY_EX_PIPE_DIV_BIT
`undef MERCURY_EX_PIPE_STR_BIT
`undef MERCURY_EXPT_INSTR_TYPE_W
`undef MERCURY_EXPT_INSTR_TYPE_NULL
`undef MERCURY_EXPT_INSTR_TYPE_UNDEF
`undef MERCURY_EXPT_INSTR_TYPE_PD_UNDEF
`undef MERCURY_EXPT_INSTR_TYPE_FABORT
`undef MERCURY_EXPT_INSTR_TYPE_SVC
`undef MERCURY_EXPT_INSTR_TYPE_HVC
`undef MERCURY_EXPT_INSTR_TYPE_SMC
`undef MERCURY_EXPT_INSTR_TYPE_WFI
`undef MERCURY_EXPT_INSTR_TYPE_WFE
`undef MERCURY_EXPT_INSTR_TYPE_BKPT
`undef MERCURY_EXPT_INSTR_TYPE_HW_BKPT
`undef MERCURY_EXPT_INSTR_TYPE_MON_ACCESS
`undef MERCURY_EXPT_INSTR_TYPE_VIRTUAL_MEM_CTL
`undef MERCURY_EXPT_INSTR_TYPE_DCZVA
`undef MERCURY_EXPT_INSTR_TYPE_TLB
`undef MERCURY_EXPT_INSTR_TYPE_CACHE_POU
`undef MERCURY_EXPT_INSTR_TYPE_DCACHE_POC
`undef MERCURY_EXPT_INSTR_TYPE_DCACHE_SETWAY
`undef MERCURY_EXPT_INSTR_TYPE_ACTLR
`undef MERCURY_EXPT_INSTR_TYPE_ID_GROUP0
`undef MERCURY_EXPT_INSTR_TYPE_ID_GROUP1
`undef MERCURY_EXPT_INSTR_TYPE_ID_GROUP2
`undef MERCURY_EXPT_INSTR_TYPE_ID_GROUP3
`undef MERCURY_EXPT_INSTR_TYPE_CPACR
`undef MERCURY_EXPT_INSTR_TYPE_CNTPS
`undef MERCURY_EXPT_INSTR_TYPE_FP
`undef MERCURY_EXPT_INSTR_TYPE_FP_ID
`undef MERCURY_EXPT_INSTR_TYPE_FP_ID0
`undef MERCURY_EXPT_INSTR_TYPE_FP_ID3
`undef MERCURY_EXPT_INSTR_TYPE_NEON
`undef MERCURY_EXPT_INSTR_TYPE_CRYPTO
`undef MERCURY_EXPT_INSTR_TYPE_DBG_ROM
`undef MERCURY_EXPT_INSTR_TYPE_DBG_OS
`undef MERCURY_EXPT_INSTR_TYPE_DBG_ACCESS
`undef MERCURY_EXPT_INSTR_TYPE_DBG_SHARED
`undef MERCURY_EXPT_INSTR_TYPE_DBG_DTR
`undef MERCURY_EXPT_INSTR_TYPE_PMU_PMCR
`undef MERCURY_EXPT_INSTR_TYPE_PMU_REG
`undef MERCURY_EXPT_INSTR_TYPE_CNTPCT
`undef MERCURY_EXPT_INSTR_TYPE_CNTP
`undef MERCURY_EXPT_INSTR_TYPE_CNTV
`undef MERCURY_EXPT_INSTR_TYPE_CNTVCT
`undef MERCURY_EXPT_INSTR_TYPE_CNTFRQ
`undef MERCURY_EXPT_INSTR_TYPE_MCR_MRC_MISC
`undef MERCURY_EXPT_INSTR_TYPE_CPUACTLR
`undef MERCURY_EXPT_INSTR_TYPE_CPUECTLR
`undef MERCURY_EXPT_INSTR_TYPE_HLT
`undef MERCURY_EXPT_INSTR_TYPE_VECT_CATCH
`undef MERCURY_EXPT_INSTR_TYPE_DCPS1
`undef MERCURY_EXPT_INSTR_TYPE_DCPS2
`undef MERCURY_EXPT_INSTR_TYPE_DCPS3
`undef MERCURY_EXPT_INSTR_TYPE_L2CTLR
`undef MERCURY_EXPT_INSTR_TYPE_L2ECTLR
`undef MERCURY_EXPT_INSTR_TYPE_L2ACTLR
`undef MERCURY_EXPT_INSTR_TYPE_PMU_SWINC
`undef MERCURY_EXPT_INSTR_TYPE_PMU_EVREG
`undef MERCURY_EXPT_INSTR_TYPE_PMU_CCNT_RD
`undef MERCURY_EXPT_INSTR_TYPE_PMU_USERENR
`undef MERCURY_EXPT_INSTR_TYPE_DAIF
`undef MERCURY_EXPT_INSTR_TYPE_CP15BAR
`undef MERCURY_EXPT_INSTR_TYPE_SETEND
`undef MERCURY_EXPT_INSTR_TYPE_RESET_CATCH
`undef MERCURY_EXPT_INSTR_TYPE_EXPT_CATCH
`undef MERCURY_EXPT_INSTR_TYPE_IFU_PARITY
`undef MERCURY_EXPT_INSTR_TYPE_GIC_GROUP0
`undef MERCURY_EXPT_INSTR_TYPE_GIC_GROUP1
`undef MERCURY_EXPT_INSTR_TYPE_GIC_DIR
`undef MERCURY_EXPT_INSTR_TYPE_GIC_COMMON
`undef MERCURY_EXPT_INSTR_TYPE_GIC_SRE
`undef MERCURY_EXPT_INSTR_TYPE_GIC_SGI
`undef MERCURY_EXPT_INSTR_TYPE_GIC_MISC
`undef MERCURY_EXPT_INSTR_TYPE_MON_MCR_MRC
`undef MERCURY_EXPT_INSTR_TYPE_EX1_W
`undef MERCURY_EXPT_INSTR_TYPE_EX1_WFE
`undef MERCURY_EXPT_INSTR_TYPE_EX1_FP
`undef MERCURY_EXPT_INSTR_TYPE_EX1_NEON
`undef MERCURY_EXPT_INSTR_TYPE_EX1_SVC
`undef MERCURY_EXPT_INSTR_TYPE_EX1_HVC
`undef MERCURY_EXPT_INSTR_TYPE_EX1_SMC
`undef MERCURY_EXPT_INSTR_TYPE_EX1_HW_BKPT
`undef MERCURY_EXPT_INSTR_TYPE_EX1_BKPT
`undef MERCURY_EXPT_INSTR_TYPE_EX1_VECT_CATCH
`undef MERCURY_INSTR_TYPE_W
`undef MERCURY_INSTR_TYPE_NULL
`undef MERCURY_INSTR_TYPE_SYNC_EXPT
`undef MERCURY_INSTR_TYPE_WFI
`undef MERCURY_INSTR_TYPE_WFE
`undef MERCURY_INSTR_TYPE_SEV
`undef MERCURY_INSTR_TYPE_ISB
`undef MERCURY_INSTR_TYPE_SEVL
`undef MERCURY_SLOT1_INSTR_TYPE_NULL
`undef MERCURY_SLOT1_INSTR_TYPE_BRANCH
`undef MERCURY_LU_CTL_W
`undef MERCURY_LU_CTL_0
`undef MERCURY_LU_CTL_ADD
`undef MERCURY_LU_CTL_SUB
`undef MERCURY_LU_CTL_ADC
`undef MERCURY_LU_CTL_SBC
`undef MERCURY_LU_CTL_BIC
`undef MERCURY_LU_CTL_EOR
`undef MERCURY_LU_CTL_AND
`undef MERCURY_LU_CTL_EON
`undef MERCURY_LU_CTL_ORR
`undef MERCURY_LU_CTL_ORN
`undef MERCURY_LU_CTL_CSEL
`undef MERCURY_LU_CTL_CRC32
`undef MERCURY_LU_CTL_CLZ
`undef MERCURY_LU_CTL_GEN_SAT
`undef MERCURY_LU_CTL_EXTRACT
`undef MERCURY_LU_CTL_MASKSEL
`undef MERCURY_ALU_LU_MASK_SEL
`undef MERCURY_MULT_TYPE_W
`undef MERCURY_MULT_TYPE_0
`undef MERCURY_MULT_TYPE_ACCONLY
`undef MERCURY_MULT_TYPE_USAD
`undef MERCURY_MULT_TYPE_16x16
`undef MERCURY_MULT_TYPE_32x32
`undef MERCURY_MULT_TYPE_2x16x16
`undef MERCURY_MULT_TYPE_32x16
`undef MERCURY_MULT_TYPE_64x64
`undef MERCURY_MULT_TYPE_64x64_LH
`undef MERCURY_MULT_TYPE_64x64_HL
`undef MERCURY_MULT_TYPE_64x64_HH
`undef MERCURY_SEL_SHF_A_W
`undef MERCURY_SEL_SHF_B_W
`undef MERCURY_SEL_SHF_C_W
`undef MERCURY_SEL_SHF_A_ZERO
`undef MERCURY_SEL_SHF_A_R0
`undef MERCURY_SEL_SHF_A_PC
`undef MERCURY_SEL_SHF_A_R2
`undef MERCURY_SEL_SHF_A_0
`undef MERCURY_SEL_SHF_B_ZERO
`undef MERCURY_SEL_SHF_B_R1
`undef MERCURY_SEL_SHF_B_PC
`undef MERCURY_SEL_SHF_B_IMM_DATA
`undef MERCURY_SEL_SHF_B_R4
`undef MERCURY_SEL_SHF_B_0
`undef MERCURY_SEL_SHF_C_ZERO
`undef MERCURY_SEL_SHF_C_R2
`undef MERCURY_SEL_SHF_C_IMM_SHIFT
`undef MERCURY_SEL_SHF_C_0
`undef MERCURY_SEL_MSK_B_W
`undef MERCURY_SEL_MSK_B_IMM_DATA
`undef MERCURY_SEL_MSK_B_0
`undef MERCURY_MASK_W
`undef MERCURY_MASK_0
`undef MERCURY_MASK_ZERO
`undef MERCURY_MASK_COMB
`undef MERCURY_MASK_SNGL
`undef MERCURY_MASK_TOP
`undef MERCURY_MASK_BOT
`undef MERCURY_MASK_MOVK
`undef MERCURY_MASK_C
`undef MERCURY_REV_MUX_W
`undef MERCURY_REV_MUX_NORMAL
`undef MERCURY_REV_MUX_REV32
`undef MERCURY_REV_MUX_REVSH
`undef MERCURY_REV_MUX_REV16
`undef MERCURY_REV_MUX_RBIT
`undef MERCURY_REV_MUX_SAT_DBL
`undef MERCURY_REV_MUX_ZERO
`undef MERCURY_REV_MUX_REV64
`undef MERCURY_REV_MUX_0
`undef MERCURY_SEL_MAC_A_W
`undef MERCURY_SEL_MAC_A_0
`undef MERCURY_SEL_MAC_A_ZERO
`undef MERCURY_SEL_MAC_A_R0
`undef MERCURY_SEL_MAC_B_W
`undef MERCURY_SEL_MAC_B_0
`undef MERCURY_SEL_MAC_B_ZERO
`undef MERCURY_SEL_MAC_B_R1
`undef MERCURY_SEL_DIV_A_W
`undef MERCURY_SEL_DIV_A_0
`undef MERCURY_SEL_DIV_A_ZERO
`undef MERCURY_SEL_DIV_A_R0
`undef MERCURY_SEL_DIV_B_W
`undef MERCURY_SEL_DIV_B_0
`undef MERCURY_SEL_DIV_B_ZERO
`undef MERCURY_SEL_DIV_B_R1
`undef MERCURY_SEL_STR_A_W
`undef MERCURY_SEL_STR_A_ZERO
`undef MERCURY_SEL_STR_A_0
`undef MERCURY_SEL_STR_A_R2
`undef MERCURY_SEL_STR_A_PC
`undef MERCURY_SEL_STR_A_FR0
`undef MERCURY_SEL_STR_A_R1
`undef MERCURY_SEL_STR_A_FR1
`undef MERCURY_SEL_STR_A_R4
`undef MERCURY_SEL_STR_B_0
`undef MERCURY_SEL_STR_B_ZERO
`undef MERCURY_SEL_STR_B_R3
`undef MERCURY_SEL_STR_B_PC
`undef MERCURY_SEL_STR_B_FR1
`undef MERCURY_SEL_STR_B_A_H
`undef MERCURY_SEL_STR_B_FP
`undef MERCURY_SEL_STR_B_ALU
`undef MERCURY_SEL_STR_B_R2
`undef MERCURY_SEL_STR_B_W
`undef MERCURY_SEL_STR_HI_W
`undef MERCURY_SEL_STR_HI_0
`undef MERCURY_SEL_STR_HI_FP
`undef MERCURY_SEL_STR_HI_ALU
`undef MERCURY_ALU_OP_COMP_NULL
`undef MERCURY_ALU_OP_COMP_SHF_B
`undef MERCURY_ALU_OP_COMP_W
`undef MERCURY_NULL
`undef MERCURY_STR0_FP_SEL_NONE
`undef MERCURY_STR0_FP_SEL_FR0
`undef MERCURY_STR0_FP_SEL_FR0_FR1
`undef MERCURY_SHIFT_OP_NOP
`undef MERCURY_SHIFT_OP_EXTR
`undef MERCURY_SHIFT_OP_SP1
`undef MERCURY_SHIFT_OP_SP2
`undef MERCURY_SHIFT_OP_ASR
`undef MERCURY_SHIFT_OP_LSL
`undef MERCURY_SHIFT_OP_LSR
`undef MERCURY_SHIFT_OP_ROR
`undef MERCURY_SHIFT_OP_W
`undef MERCURY_SHIFT_MOD_W
`undef MERCURY_BR_PIPECTL_W
`undef MERCURY_BR_NO_BRANCH
`undef MERCURY_BR_DIRECT
`undef MERCURY_BR_PREFETCH_FLUSH
`undef MERCURY_BR_WFX_RESTART
`undef MERCURY_BR_INDIRECT_TBB
`undef MERCURY_BR_INDIRECT_DP
`undef MERCURY_BR_INDIRECT_ST
`undef MERCURY_BR_INDIRECT_LD
`undef MERCURY_STANDARD_BRANCH
`undef MERCURY_ILLEGAL_BX_IMM
`undef MERCURY_BRANCH_AND_LINK
`undef MERCURY_BRANCH_AND_LINK_WITH_EXCHANGE
`undef MERCURY_IS_NOT_PREDICTABLE
`undef MERCURY_IS_PREDICTABLE
`undef MERCURY_RF_RD_EN_IMMED_BR
`undef MERCURY_BR_OFFSET_BITS
`undef MERCURY_H_BIT
`undef MERCURY_TAKEN_PRED_BIT
`undef MERCURY_EXCHANGE_BIT
`undef MERCURY_IS_NOT_RETURN
`undef MERCURY_IS_RETURN
`undef MERCURY_IS_NOT_CALL
`undef MERCURY_IS_CALL
`undef MERCURY_IS_DIRECT
`undef MERCURY_IS_NOT_DIRECT
`undef MERCURY_RETURN_ADDR_VALID
`undef MERCURY_RETURN_ADDR_INVALID
`undef MERCURY_RF_RD_SPECIAL_BR
`undef MERCURY_BR_IS_NOT_VALID
`undef MERCURY_BR_IS_VALID
`undef MERCURY_BR_X_BIT_W
`undef MERCURY_BX_RM_VALID
`undef MERCURY_BX_IMM_VALID_FROM_ARM
`undef MERCURY_BX_IMM_VALID_FROM_THUMB
`undef MERCURY_LDR_U_BIT
`undef MERCURY_LDR_SHIFT_LSL
`undef MERCURY_LDR_SHIFT_BITS
`undef MERCURY_LDR_SHIFT_IMM_BITS
`undef MERCURY_LDR_OFFSET_12_BITS
`undef MERCURY_LDR_RD_BITS
`undef MERCURY_LDR_RN_BITS
`undef MERCURY_LDR_RM_BITS
`undef MERCURY_REG_UNUSED
`undef MERCURY_CC_EQ
`undef MERCURY_CC_NE
`undef MERCURY_CC_CS
`undef MERCURY_CC_CC
`undef MERCURY_CC_MI
`undef MERCURY_CC_PL
`undef MERCURY_CC_VS
`undef MERCURY_CC_VC
`undef MERCURY_CC_HI
`undef MERCURY_CC_LS
`undef MERCURY_CC_GE
`undef MERCURY_CC_LT
`undef MERCURY_CC_GT
`undef MERCURY_CC_LE
`undef MERCURY_CC_AL
`undef MERCURY_CC_NV
`undef MERCURY_CC_AL_or_NV
`undef MERCURY_CC_FLAGS_N
`undef MERCURY_CC_FLAGS_Z
`undef MERCURY_CC_FLAGS_C
`undef MERCURY_CC_FLAGS_V
`undef MERCURY_SEL_DCU_A_ZERO
`undef MERCURY_SEL_DCU_A_R0
`undef MERCURY_SEL_DCU_A_PC
`undef MERCURY_SEL_DCU_A_MUL
`undef MERCURY_SEL_DCU_A_W
`undef MERCURY_SEL_DCU_B_ZERO
`undef MERCURY_SEL_DCU_B_1
`undef MERCURY_SEL_DCU_B_2
`undef MERCURY_SEL_DCU_B_4
`undef MERCURY_SEL_DCU_B_8
`undef MERCURY_SEL_DCU_B_BIT_R1
`undef MERCURY_SEL_DCU_B_BIT_IMM_LS
`undef MERCURY_SEL_DCU_B_BIT_SH
`undef MERCURY_SEL_DCU_B_BIT_PM_8
`undef MERCURY_SEL_DCU_B_BIT_NEON
`undef MERCURY_SEL_DCU_B_W
`undef MERCURY_SEL_FWD_DCU_W
`undef MERCURY_SEL_FWD_DCU_BIT_W0F_WR
`undef MERCURY_SEL_FWD_DCU_BIT_W1F_WR
`undef MERCURY_SEL_FWD_DCU_BIT_NOF
`undef MERCURY_SEL_FWD_DCU_BIT_W1F_EX2
`undef MERCURY_IMM_SEL_W
`undef MERCURY_IMM_SEL_NULL
`undef MERCURY_IMM_SEL_T32_1
`undef MERCURY_IMM_SEL_T32_2
`undef MERCURY_IMM_SEL_T32_3
`undef MERCURY_IMM_SEL_A64_LOG_IMM
`undef MERCURY_IMM_SEL_TBB
`undef MERCURY_IMM_SEL_ROR
`undef MERCURY_IMM_SEL_LSL
`undef MERCURY_IMM_SEL_X
`undef MERCURY_IMM_LSL_0
`undef MERCURY_IMM_LSL_16
`undef MERCURY_IMM_LSL_32
`undef MERCURY_IMM_LSL_48
`undef MERCURY_IMM_LSL_ADRP
`undef MERCURY_IMM_LSL_12
`undef MERCURY_RF_WR_SRC_W0_W
`undef MERCURY_RF_WR_SRC_W0_0
`undef MERCURY_RF_WR_SRC_W0_STREX
`undef MERCURY_RF_WR_SRC_W0_DCU_0
`undef MERCURY_RF_WR_SRC_W0_CPSR
`undef MERCURY_RF_WR_SRC_W0_MAC_HI
`undef MERCURY_RF_WR_SRC_W0_STR
`undef MERCURY_RF_WR_SRC_W0_CP
`undef MERCURY_RF_WR_SRC_W0_SPSR
`undef MERCURY_RF_WR_SRC_W0_BASE
`undef MERCURY_RF_WR_SRC_W1_W
`undef MERCURY_RF_WR_SRC_W1_0
`undef MERCURY_RF_WR_SRC_W1_ALU
`undef MERCURY_RF_WR_SRC_W1_MAC_LO
`undef MERCURY_RF_WR_SRC_W1_DIV
`undef MERCURY_RF_WR_SRC_W1_CP
`undef MERCURY_RF_WR_SRC_W1_FP_ALU
`undef MERCURY_RF_WR_SRC_W1_STR
`undef MERCURY_RF_WR_SRC_W1_DCU_1
`undef MERCURY_RF_WR_WHEN_W
`undef MERCURY_RF_WR_WHEN_LATE_WR
`undef MERCURY_RF_WR_WHEN_EARLY_WR
`undef MERCURY_RF_WR_WHEN_EX2
`undef MERCURY_RF_WR_WHEN_EX1
`undef MERCURY_RF_WR_WHEN_0
`undef MERCURY_RF_RD_NEED_W
`undef MERCURY_RF_RD_NEED_0
`undef MERCURY_RF_RD_NEED_EARLY_ISS
`undef MERCURY_RF_RD_NEED_LATE_ISS
`undef MERCURY_RF_RD_NEED_EX1
`undef MERCURY_RF_RD_NEED_EX2
`undef MERCURY_RF_FWR_WHEN_W
`undef MERCURY_RF_FWR_WHEN_0
`undef MERCURY_RF_FWR_WHEN_F3
`undef MERCURY_RF_FWR_WHEN_F4
`undef MERCURY_RF_FWR_WHEN_F5
`undef MERCURY_RF_FWR_WHEN_L_F5
`undef MERCURY_RF_FRD_NEED_W
`undef MERCURY_RF_FRD_NEED_0
`undef MERCURY_RF_FRD_NEED_F1
`undef MERCURY_RF_FRD_NEED_F2
`undef MERCURY_RF_FWR_SRC_W
`undef MERCURY_RF_FWR_SRC_0
`undef MERCURY_RF_FWR_SRC_NONE
`undef MERCURY_RF_FWR_SRC_DCU_DUP
`undef MERCURY_RF_FWR_SRC_DCU_DUP_RE
`undef MERCURY_RF_FWR_SRC_FAD_Q
`undef MERCURY_RF_FWR_SRC_FAD_NARROW
`undef MERCURY_RF_FWR_SRC_FML_Q
`undef MERCURY_RF_FWR_SRC_DCU_PERM
`undef MERCURY_RF_FWR_SRC_DCU_SGL
`undef MERCURY_RF_FWR_SRC_STR
`undef MERCURY_RF_FWR_SRC_DCU_DBL
`undef MERCURY_RF_FWR_SRC_STR_SP
`undef MERCURY_RF_FWR_SRC_STR_2SP
`undef MERCURY_RF_FWR_SRC_CRYPTO_F3
`undef MERCURY_RF_FWR_SRC_CRYPTO_F5
`undef MERCURY_RF_FWR_SRC_HELD_F5
`undef MERCURY_FWD_W
`undef MERCURY_FWD_W0
`undef MERCURY_FWD_W1
`undef MERCURY_FWD_W2
`undef MERCURY_FWD_ALU0_EX2
`undef MERCURY_FWD_NULL
`undef MERCURY_FWD_ALU0_EX1
`undef MERCURY_FWD_FP
`undef MERCURY_FWD_FP_LO
`undef MERCURY_FWD_FP_HI
`undef MERCURY_LS_INSTR_TYPE_W
`undef MERCURY_LS_INSTR_SINGLE
`undef MERCURY_LS_INSTR_MULTIPLE
`undef MERCURY_LS_INSTR_SIGN_EXT
`undef MERCURY_LS_INSTR_LDC_STC
`undef MERCURY_LS_INSTR_SRS
`undef MERCURY_LS_INSTR_EXCL_SGL
`undef MERCURY_LS_INSTR_PLD_L1KEEP
`undef MERCURY_LS_INSTR_PLD_L1STRM
`undef MERCURY_LS_INSTR_PLD_L2KEEP
`undef MERCURY_LS_INSTR_PLD_L2STRM
`undef MERCURY_LS_INSTR_ORDERED
`undef MERCURY_LS_INSTR_ORD_EXCL_SGL
`undef MERCURY_LS_INSTR_NON_TEMPORAL
`undef MERCURY_LS_INSTR_DCZVA
`undef MERCURY_LS_ELEM_SIZE_8BIT
`undef MERCURY_LS_ELEM_SIZE_16BIT
`undef MERCURY_LS_ELEM_SIZE_32BIT
`undef MERCURY_LS_ELEM_SIZE_64BIT
`undef MERCURY_LS_ELEM_SIZE_128BIT
`undef MERCURY_PMN_SEL_OTHERS
`undef MERCURY_CRN0_MIDR
`undef MERCURY_CRN0_CTR
`undef MERCURY_CRN0_TLBTR
`undef MERCURY_CRN0_MPIDR
`undef MERCURY_CRN0_REVIDR
`undef MERCURY_CRN0_DCZID_EL0
`undef MERCURY_CRN0_ID_PFR0
`undef MERCURY_CRN0_ID_PFR1
`undef MERCURY_CRN0_ID_DFR0
`undef MERCURY_CRN0_ID_MMFR0
`undef MERCURY_CRN0_ID_MMFR1
`undef MERCURY_CRN0_ID_MMFR2
`undef MERCURY_CRN0_ID_MMFR3
`undef MERCURY_CRN0_ID_ISAR0
`undef MERCURY_CRN0_ID_ISAR1
`undef MERCURY_CRN0_ID_ISAR2
`undef MERCURY_CRN0_ID_ISAR3
`undef MERCURY_CRN0_ID_ISAR4
`undef MERCURY_CRN0_ID_ISAR5
`undef MERCURY_CRN0_ID_CCSIDR
`undef MERCURY_CRN0_ID_CLIDR
`undef MERCURY_CRN0_CSSELR
`undef MERCURY_CRN0_VPIDR
`undef MERCURY_CRN0_VMPIDR
`undef MERCURY_CRN1_SCTLR
`undef MERCURY_CRN1_SCTLR_EL1
`undef MERCURY_CRN1_SCTLR_EL3
`undef MERCURY_CRN1_CPUACTLR
`undef MERCURY_CRN1_CPUECTLR
`undef MERCURY_CRN1_ACTLR_EL3
`undef MERCURY_CRN1_ACTLR_EL2
`undef MERCURY_CRN1_CPACR
`undef MERCURY_CRN1_SCR
`undef MERCURY_CRN1_SDER
`undef MERCURY_CRN5_FPEXC
`undef MERCURY_CRN1_NSACR
`undef MERCURY_CRN1_VCR
`undef MERCURY_CRN1_HCR
`undef MERCURY_CRN1_HCR2
`undef MERCURY_CRN1_HDCR
`undef MERCURY_CRN1_MDCR_EL3
`undef MERCURY_CRN1_HCPTR
`undef MERCURY_CRN1_CPTR_EL3
`undef MERCURY_CRN1_HSTR
`undef MERCURY_CRN1_HSCTLR
`undef MERCURY_CRN3_DACR
`undef MERCURY_CRN4_SPSEL
`undef MERCURY_CRN4_DAIF
`undef MERCURY_CRN4_CURRENTEL
`undef MERCURY_CRN4_NZCV
`undef MERCURY_CRN4_FPCR
`undef MERCURY_CRN4_FPSR
`undef MERCURY_CRN5_DFSR
`undef MERCURY_CRN5_IFSR
`undef MERCURY_CRN5_ESR_EL2
`undef MERCURY_CRN5_ESR_EL3
`undef MERCURY_CRN6_DFAR
`undef MERCURY_CRN6_IFAR
`undef MERCURY_CRN6_FAR_EL2
`undef MERCURY_CRN6_FAR_EL3
`undef MERCURY_CRN6_HDFAR
`undef MERCURY_CRN6_HIFAR
`undef MERCURY_CRN6_HPFAR
`undef MERCURY_CRN7_WFI
`undef MERCURY_CRN7_ICIMVAU
`undef MERCURY_CRN7_ISB
`undef MERCURY_CRN9_PMCR
`undef MERCURY_CRN9_PMNCNTENSET
`undef MERCURY_CRN9_PMNCNTENCLR
`undef MERCURY_CRN9_PMOVSR
`undef MERCURY_CRN9_PMOVSSET
`undef MERCURY_CRN9_PMSWINC
`undef MERCURY_CRN9_PMSELR
`undef MERCURY_CRN9_PMCCNTR
`undef MERCURY_CRN9_PMCCNTR_64
`undef MERCURY_CRN9_PMXEVTYPER
`undef MERCURY_CRN9_PMXEVCNTR
`undef MERCURY_CRN9_PMUSERENR
`undef MERCURY_CRN9_PMINTENSET
`undef MERCURY_CRN9_PMINTENCLR
`undef MERCURY_CRN14_PMEVCNTRn
`undef MERCURY_CRN14_PMEVCNTR0
`undef MERCURY_CRN14_PMEVCNTR1
`undef MERCURY_CRN14_PMEVCNTR2
`undef MERCURY_CRN14_PMEVCNTR3
`undef MERCURY_CRN14_PMEVCNTR4
`undef MERCURY_CRN14_PMEVCNTR5
`undef MERCURY_CRN14_PMEVTYPERn
`undef MERCURY_CRN14_PMEVTYPER0
`undef MERCURY_CRN14_PMEVTYPER1
`undef MERCURY_CRN14_PMEVTYPER2
`undef MERCURY_CRN14_PMEVTYPER3
`undef MERCURY_CRN14_PMEVTYPER4
`undef MERCURY_CRN14_PMEVTYPER5
`undef MERCURY_CRN14_PMCCFILTR
`undef MERCURY_CRN9_PMCEID0
`undef MERCURY_CRN12_VBAR
`undef MERCURY_CRN12_VBAR_EL3
`undef MERCURY_CRN12_MVBAR
`undef MERCURY_CRN12_ISR
`undef MERCURY_CRN12_VIR
`undef MERCURY_CRN12_HVBAR
`undef MERCURY_CRN13_HTPIDR
`undef MERCURY_CRN13_CID
`undef MERCURY_CRN13_TPIDRURW
`undef MERCURY_CRN13_TPIDRURO
`undef MERCURY_CRN13_TPIDRPRW
`undef MERCURY_CRN15_CSOR
`undef MERCURY_CRM2_VTTBR
`undef MERCURY_CP14_DBG_DIDR
`undef MERCURY_CP14_DBG_DRAR
`undef MERCURY_CP14_DBG_DSAR
`undef MERCURY_CP14_DBG_DSCR_INT
`undef MERCURY_CP14_DBG_DTR_INT
`undef MERCURY_CP14_DBG_DSCR_FLAGS
`undef MERCURY_CP14_DBG_WFAR
`undef MERCURY_CP14_DBG_DTRRX_EXT
`undef MERCURY_CP14_DBG_DSCR_EXT
`undef MERCURY_CP14_DBG_DTRTX_EXT
`undef MERCURY_CP14_DBG_PRCR
`undef MERCURY_CP14_DBG_OSLAR
`undef MERCURY_CP14_DBG_OSDLR
`undef MERCURY_CP14_DBG_OSLSR
`undef MERCURY_CP14_DBG_CLAIMSET
`undef MERCURY_CP14_DBG_CLAIMCLR
`undef MERCURY_CP14_DBG_AUTHSTATUS
`undef MERCURY_CP14_DBG_DEVID
`undef MERCURY_CP14_DBG_DEVID1
`undef MERCURY_CP14_MDCCINT_EL1
`undef MERCURY_CP14_DBG_MDSCR_EL1
`undef MERCURY_CP14_DBG_DTR_EL0
`undef MERCURY_CP14_DBG_OSECCR_EL1
`undef MERCURY_CP15_CBAR
`undef MERCURY_CP15_MRC_EXTERNAL
`undef MERCURY_CRN0_ID_AA64PFR0_EL1
`undef MERCURY_CRN0_ID_AA64PFR1_EL1
`undef MERCURY_CRN0_MVFR0_EL1
`undef MERCURY_CRN0_MVFR1_EL1
`undef MERCURY_CRN0_MVFR2_EL1
`undef MERCURY_CRN0_AA64PFR0_EL1
`undef MERCURY_CRN0_AA64PFR1_EL1
`undef MERCURY_CRN0_AA64DFR0_EL1
`undef MERCURY_CRN0_AA64DFR1_EL1
`undef MERCURY_CRN0_AA64AFR0_EL1
`undef MERCURY_CRN0_AA64AFR1_EL1
`undef MERCURY_CRN0_AA64ISAR0_EL1
`undef MERCURY_CRN0_AA64ISAR1_EL1
`undef MERCURY_CRN0_AA64MMFR0_EL1
`undef MERCURY_CRN0_AA64MMFR1_EL1
`undef MERCURY_CRN12_RVBAR_EL3
`undef MERCURY_CRN12_RMR_EL3
`undef MERCURY_CRN13_TPIDR_EL3
`undef MERCURY_VFP_FPSID
`undef MERCURY_VFP_FPSCR
`undef MERCURY_CP15_DBG_DSPSR_EL0
`undef MERCURY_CRN15_CPUMERRSR
`undef MERCURY_DPU_CP15_DSIZE
`undef MERCURY_DPU_CP14_DSIZE
`undef MERCURY_ALU_CTL_64BIT_OP_W
`undef MERCURY_ALU_CTL_64BIT_OP_BITS
`undef MERCURY_ALU_FLAG_SET_W
`undef MERCURY_ALU_RD_IS_R15_W
`undef MERCURY_ALU_EX1_CTL_SHIFT_OP_BITS
`undef MERCURY_ALU_EX1_CTL_SHIFT_RRX_FOR_0_BITS
`undef MERCURY_ALU_EX1_XTRACT_TYP_W
`undef MERCURY_ALU_EX1_XTRACT_TYP_BITS
`undef MERCURY_ALU_EX1_SIGN_XTEND_W
`undef MERCURY_ALU_EX1_SIGN_XTEND_BITS
`undef MERCURY_ALU_EX1_XTRCT_VAL_W
`undef MERCURY_ALU_EX1_XTRCT_VAL_BITS
`undef MERCURY_ALU_EX1_MASK_SEL_W
`undef MERCURY_ALU_EX1_MASK_SEL_BITS
`undef MERCURY_ALU_EX1_REV_TYPE_W
`undef MERCURY_ALU_EX1_REV_TYPE_BITS
`undef MERCURY_ALU_AU_CARRY_LU_OPCODE_W
`undef MERCURY_ALU_EX2_CTL_LU_CTL_BITS
`undef MERCURY_ALU_EX2_CTL_OP_COMP_SHF_A_BIT
`undef MERCURY_ALU_EX2_CTL_OP_COMP_SHF_B_BIT
`undef MERCURY_ALU_EX2_CTL_FLAG_ID_BITS
`undef MERCURY_ALU_EX2_CTL_CCMP_BIT
`undef MERCURY_SIMD_ADDSUBX_W
`undef MERCURY_ALU_EX2_CTL_SIMD_ADD_SUB_X_BITS
`undef MERCURY_ALU_EX2_VALID_SIMD_W
`undef MERCURY_ALU_EX2_CTL_VALID_SIMD_BITS
`undef MERCURY_ALU_EX2_SIMD_SIZE_W
`undef MERCURY_ALU_EX2_CTL_SIMD_SIZE_BITS
`undef MERCURY_ALU_EX2_SIMD_HALVING_W
`undef MERCURY_ALU_EX2_CTL_HALVING_BITS
`undef MERCURY_ALU_EX2_SIMD_SIGN_ARTH_W
`undef MERCURY_ALU_EX2_SIMD_SIGN_ARTH_BITS
`undef MERCURY_ALU_EX2_SEL_VALID_W
`undef MERCURY_ALU_EX2_SEL_VALID_BITS
`undef MERCURY_ALU_EX2_CBZ_BYPASS_W
`undef MERCURY_ALU_EX2_CBZ_BYPASS_BITS
`undef MERCURY_ALU_EX2_SIGN_REPLICATE_W
`undef MERCURY_ALU_EX2_SIGN_REPLICATE_BITS
`undef MERCURY_SIMD_SAT_VALID_W
`undef MERCURY_ALU_WR_CTL_SAT_VALID_BITS
`undef MERCURY_ALU_GEN_CTL_W
`undef MERCURY_ALU_WR_CTL_W
`undef MERCURY_ALU_EX2_CTL_W
`undef MERCURY_ALU_EX2_CTL_LOW
`undef MERCURY_ALU_EX2_CTL_HIGH
`undef MERCURY_ALU_EX1_CTL_W
`undef MERCURY_ALU_PIPECTL_W
`undef MERCURY_ALU_PIPECTL_ALU_WR_CTL_BITS
`undef MERCURY_ALU_PIPECTL_ALU_EX2_CTL_BITS
`undef MERCURY_ALU_PIPECTL_ALU_EX1_CTL_BITS
`undef MERCURY_ALU_PIPECTL_ALU_GEN_CTL_BITS
`undef MERCURY_MAC_PIPECTL_W
`undef MERCURY_MAC_CTL_64BIT_OP_BIT
`undef MERCURY_MAC_CTL_MULT_TYPE_BITS
`undef MERCURY_MAC_CTL_NEG_SECOND_BIT
`undef MERCURY_MAC_CTL_NEG_MUL_BIT
`undef MERCURY_MAC_CTL_MAC_A_SEL_BIT
`undef MERCURY_MAC_CTL_MAC_B_SEL_BIT
`undef MERCURY_MAC_CTL_SIGNED_BIT
`undef MERCURY_MAC_CTL_ACC_HIGH_BIT
`undef MERCURY_MAC_CTL_ROUND_BIT
`undef MERCURY_MAC_CTL_ACCUM_LO_BIT
`undef MERCURY_MAC_CTL_ACCUM_HI_BIT
`undef MERCURY_IMM_SHIFT_W
`undef MERCURY_IMM_DATA_W
`undef MERCURY_AGU_IMM_DATA_W
`undef MERCURY_XTRCT_SHIFT_W
`undef MERCURY_IMM_OT_W
`undef MERCURY_IMM_OT_0
`undef MERCURY_IMM_OT_B_1
`undef MERCURY_IMM_OT_B_4
`undef MERCURY_IMM_DP_W
`undef MERCURY_IMM_DP_0
`undef MERCURY_IMM_DP_A32_SHIFT
`undef MERCURY_IMM_DP_T32_SHIFT
`undef MERCURY_IMM_DP_ADDW
`undef MERCURY_IMM_DP_T32_IMM
`undef MERCURY_IMM_DP_MOVW
`undef MERCURY_IMM_DP_EXTEND
`undef MERCURY_IMM_DP_A32_IMM
`undef MERCURY_IMM_DP_BFM
`undef MERCURY_IMM_DP_A64_ADR
`undef MERCURY_IMM_DP_EXT_REG
`undef MERCURY_IMM_DP_LOG_IMM
`undef MERCURY_IMM_DP_EXTR
`undef MERCURY_IMM_DP_CSEL
`undef MERCURY_IMM_DP_CRC32
`undef MERCURY_IMM_LS_W
`undef MERCURY_IMM_LS_0
`undef MERCURY_IMM_LS_8
`undef MERCURY_IMM_LS_A32_SHIFT
`undef MERCURY_IMM_LS_SCALED
`undef MERCURY_IMM_LS_LDP_STP
`undef MERCURY_IMM_LS_SIGNED
`undef MERCURY_IMM_LS_IMM4HL
`undef MERCURY_IMM_LS_LSM1
`undef MERCURY_IMM_LS_LSM2
`undef MERCURY_IMM_LS_A64_LIT
`undef MERCURY_IMM_LS_TBB
`undef MERCURY_IMM_NEON_W
`undef MERCURY_IMM_NEON_0
`undef MERCURY_IMM_NEON_32
`undef MERCURY_IMM_NEON_64
`undef MERCURY_IMM_NEON_LDC_STC
`undef MERCURY_IMM_NEON_VFP_IMM
`undef MERCURY_IMM_NEON_VCVT_16
`undef MERCURY_IMM_NEON_VCVT_32
`undef MERCURY_IMM_NEON_VCVT_64
`undef MERCURY_IMM_NEON_VEXT
`undef MERCURY_IMM_NEON_VDUP_VCVT
`undef MERCURY_IMM_NEON_NEON_VCVT_64
`undef MERCURY_IMM_NEON_VSHL
`undef MERCURY_IMM_NEON_VSHR
`undef MERCURY_IMM_NEON_VMOV_SCAL
`undef MERCURY_IMM_NEON_NEON_IMM
`undef MERCURY_IMM_NEON_NEON_LSM
`undef MERCURY_IMM_NEON_LDR_LITERAL
`undef MERCURY_IMM_NEON_LS_PAIR
`undef MERCURY_IMM_NEON_LS_UNSCALED
`undef MERCURY_IMM_NEON_LS_IMM12
`undef MERCURY_IMM_NEON_CCMP_CSEL
`undef MERCURY_IMM_NEON_INS_VECTOR
`undef MERCURY_IMM_NEON_VDUP_SCAL
`undef MERCURY_FORCEOP_TYPE_W
`undef MERCURY_FORCEOP_TYPE_NULL
`undef MERCURY_FORCEOP_TYPE_EL2
`undef MERCURY_FORCEOP_TYPE_SUB
`undef MERCURY_FORCEOP_TYPE_ADD
`undef MERCURY_FORCEOP_OFFSET_W
`undef MERCURY_FORCEOP_OFFSET_0
`undef MERCURY_FORCEOP_OFFSET_2
`undef MERCURY_FORCEOP_OFFSET_4
`undef MERCURY_FORCEOP_OFFSET_8
`undef MERCURY_FORCEOP_OFFSET_TYPE_W
`undef MERCURY_FORCEOP_OFFSET_TYPE_0_4
`undef MERCURY_FORCEOP_OFFSET_TYPE_2_4
`undef MERCURY_FORCEOP_OFFSET_TYPE_4_8
`undef MERCURY_FORCEOP_OFFSET_TYPE_4_0
`undef MERCURY_FAULT_REG_EN_W
`undef MERCURY_FAULT_REG_EN_DFSR
`undef MERCURY_FAULT_REG_EN_DFAR
`undef MERCURY_FAULT_REG_EN_IFSR
`undef MERCURY_FAULT_REG_EN_IFAR
`undef MERCURY_FAULT_REG_EN_HSR
`undef MERCURY_FAULT_REG_EN_HIFAR
`undef MERCURY_FAULT_REG_EN_HDFAR
`undef MERCURY_FAULT_REG_EN_HPFAR
`undef MERCURY_FAULT_REG_EN_ESR_EL1
`undef MERCURY_FAULT_REG_EN_FAR_EL1
`undef MERCURY_FAULT_REG_EN_ESR_EL2
`undef MERCURY_FAULT_REG_EN_FAR_EL2
`undef MERCURY_FAULT_REG_EN_ESR_EL3
`undef MERCURY_FAULT_REG_EN_FAR_EL3
`undef MERCURY_CPSR_WR_EN_EARLY_W
`undef MERCURY_CPSR_WR_EN_EARLY_NULL
`undef MERCURY_CPSR_WR_EN_EARLY_IM
`undef MERCURY_CPSR_WR_EN_EARLY_AIM
`undef MERCURY_CPSR_WR_EN_EARLY_AIFM
`undef MERCURY_SEL_CPSR_SRC_TYPE_W
`undef MERCURY_SEL_CPSR_SRC_TYPE_FORCE
`undef MERCURY_SEL_CPSR_SRC_TYPE_DSPSR
`undef MERCURY_SYND_TYPE_W
`undef MERCURY_SYND_TYPE_UNSPEC
`undef MERCURY_SYND_TYPE_DEBUG
`undef MERCURY_SYND_TYPE_FABORT
`undef MERCURY_SYND_TYPE_CALL
`undef MERCURY_SYND_TYPE_WFX
`undef MERCURY_SYND_TYPE_SYS_REG
`undef MERCURY_SYND_TYPE_FP_NEON
`undef MERCURY_SYND_TYPE_IL_BIT
`undef MERCURY_EXPT_TYPE_W
`undef MERCURY_EXPT_TYPE_RESET
`undef MERCURY_EXPT_TYPE_WPT
`undef MERCURY_EXPT_TYPE_DATA
`undef MERCURY_EXPT_TYPE_FIQ
`undef MERCURY_EXPT_TYPE_IRQ
`undef MERCURY_EXPT_TYPE_IMPRECISE
`undef MERCURY_EXPT_TYPE_DEBUG_HLT
`undef MERCURY_EXPT_TYPE_DEBUG_EXPT
`undef MERCURY_EXPT_TYPE_INSTR_FAULT
`undef MERCURY_EXPT_TYPE_TRAP
`undef MERCURY_EXPT_TYPE_CALL
`undef MERCURY_EXPT_TYPE_WFI
`undef MERCURY_EXPT_TYPE_WFE
`undef MERCURY_EXPT_TYPE_COND_TRAP
`undef MERCURY_EXPT_TYPE_DEBUG_EXIT
`undef MERCURY_EXPT_TYPE_SP_ALIGNMENT
`undef MERCURY_EXPT_TYPE_ECC_REEXEC
`undef MERCURY_EXPT_TYPE_COND_TRAP_OR_UND
`undef MERCURY_EXPT_TYPE_PC_ALIGNMENT
`undef MERCURY_DBG_STATUS_W
`undef MERCURY_DBG_STATUS_NULL
`undef MERCURY_DBG_STATUS_BKPT
`undef MERCURY_DBG_STATUS_BKPT_INSTR
`undef MERCURY_DBG_STATUS_EXT_DBG_REQ
`undef MERCURY_DBG_STATUS_VECTOR_CATCH
`undef MERCURY_DBG_STATUS_HLT_STEP_NORM
`undef MERCURY_DBG_STATUS_HLT_STEP_EXCL
`undef MERCURY_DBG_STATUS_OS_UNLOCK
`undef MERCURY_DBG_STATUS_RESET_CATCH
`undef MERCURY_DBG_STATUS_WPT
`undef MERCURY_DBG_STATUS_HLT
`undef MERCURY_DBG_STATUS_DEBUG_REG
`undef MERCURY_DBG_STATUS_EXPT_CATCH
`undef MERCURY_DBG_STATUS_HLT_STEP_MISC
`undef MERCURY_EXPT_INSTR_BUS_W
`undef MERCURY_EXPT_INSTR_BUS_MISC_BIT
`undef MERCURY_EXPT_INSTR_BUS_IS_OTHER_BIT
`undef MERCURY_EXPT_INSTR_BUS_IS_LS_BIT
`undef MERCURY_EXPT_INSTR_BUS_INSTR_D_BIT
`undef MERCURY_EXPT_INSTR_BUS_INSTR_BITS
`undef MERCURY_EXPT_BUS_W
`undef MERCURY_EXPT_BUS_ESR_BITS
`undef MERCURY_EXPT_BUS_EC_BITS
`undef MERCURY_EXPT_BUS_TARGET_MODE_BITS
`undef MERCURY_EXPT_BUS_TARGET_EL_BITS
`undef MERCURY_EXPT_BUS_QUASH_BIT
`undef MERCURY_EXPT_BUS_CPSR_BITS
`undef MERCURY_EXPT_BUS_VEC_OFFSET_BITS
`undef MERCURY_EXPT_BUS_ENTER_HALT_BIT
`undef MERCURY_EXPT_BUS_HIGH_PRI_BIT
`undef MERCURY_EXPT_BUS_EXPT_TYPE_BITS
`undef MERCURY_EXPT_BUS_FORCEOP_BITS
`undef MERCURY_EXPT_BUS_DBG_STATUS_BITS
`undef MERCURY_ETM_EXPT_TYPE_W
`undef MERCURY_ETM_EXPT_TYPE_NULL
`undef MERCURY_ETM_EXPT_TYPE_DATA_ABORT
`undef MERCURY_ETM_EXPT_TYPE_FIQ
`undef MERCURY_ETM_EXPT_TYPE_IRQ
`undef MERCURY_ETM_EXPT_TYPE_IMPRECISE_ABORT
`undef MERCURY_ETM_EXPT_TYPE_PREFETCH_ABORT
`undef MERCURY_ETM_EXPT_TYPE_SVC
`undef MERCURY_ETM_EXPT_TYPE_SMC
`undef MERCURY_ETM_EXPT_TYPE_HVC
`undef MERCURY_ETM_EXPT_TYPE_UNDEF
`undef MERCURY_ETM_EXPT_TYPE_IBKPT
`undef MERCURY_ETM_EXPT_TYPE_HALT
`undef MERCURY_ETM_EXPT_TYPE_GENERIC
`undef MERCURY_ETM_EXPT_TYPE_RESET
`undef MERCURY_ETM_EXPT_TYPE_X
`undef MERCURY_CPSR_RET_W
`undef MERCURY_CPSR_RET_N_BITS
`undef MERCURY_CPSR_RET_Z_BITS
`undef MERCURY_CPSR_RET_C_BITS
`undef MERCURY_CPSR_RET_V_BITS
`undef MERCURY_CPSR_RET_NZCV_BITS
`undef MERCURY_CPSR_RET_CV_BITS
`undef MERCURY_CPSR_RET_SS_BITS
`undef MERCURY_CPSR_RET_IL_BITS
`undef MERCURY_CPSR_RET_DAIF_BITS
`undef MERCURY_CPSR_RET_EAIF_BITS
`undef MERCURY_CPSR_RET_D_BITS
`undef MERCURY_CPSR_RET_E_BITS
`undef MERCURY_CPSR_RET_A_BITS
`undef MERCURY_CPSR_RET_I_BITS
`undef MERCURY_CPSR_RET_F_BITS
`undef MERCURY_CPSR_RET_MODE_BITS
`undef MERCURY_SPSR_RET_W
`undef MERCURY_SPSR_RET_N_BITS
`undef MERCURY_SPSR_RET_Z_BITS
`undef MERCURY_SPSR_RET_C_BITS
`undef MERCURY_SPSR_RET_V_BITS
`undef MERCURY_SPSR_RET_NZCV_BITS
`undef MERCURY_SPSR_RET_SS_BITS
`undef MERCURY_SPSR_RET_IL_BITS
`undef MERCURY_SPSR_RET_DAIF_BITS
`undef MERCURY_SPSR_RET_EAIF_BITS
`undef MERCURY_SPSR_RET_D_BITS
`undef MERCURY_SPSR_RET_E_BITS
`undef MERCURY_SPSR_RET_A_BITS
`undef MERCURY_SPSR_RET_I_BITS
`undef MERCURY_SPSR_RET_F_BITS
`undef MERCURY_SPSR_RET_MODE_BITS
`undef MERCURY_CPSR_RET_Q_BITS
`undef MERCURY_CPSR_RET_NZCVQ_BITS
`undef MERCURY_CPSR_RET_IT_LOW_BITS
`undef MERCURY_CPSR_RET_GE_BITS
`undef MERCURY_CPSR_RET_IT_COND_BITS
`undef MERCURY_CPSR_RET_IT_HIGH_BITS
`undef MERCURY_CPSR_RET_IT_HICM_BITS
`undef MERCURY_CPSR_RET_T_BITS
`undef MERCURY_SPSR_RET_Q_BITS
`undef MERCURY_SPSR_RET_CVQ_BITS
`undef MERCURY_SPSR_RET_NZCVQ_BITS
`undef MERCURY_SPSR_RET_IT_LOW_BITS
`undef MERCURY_SPSR_RET_GE_BITS
`undef MERCURY_SPSR_RET_IT_COND_BITS
`undef MERCURY_SPSR_RET_IT_HIGH_BITS
`undef MERCURY_SPSR_RET_IT_HICM_BITS
`undef MERCURY_SPSR_RET_T_BITS
`undef MERCURY_PSR_ARCH_N_BITS
`undef MERCURY_PSR_ARCH_Z_BITS
`undef MERCURY_PSR_ARCH_C_BITS
`undef MERCURY_PSR_ARCH_V_BITS
`undef MERCURY_PSR_ARCH_Q_BITS
`undef MERCURY_PSR_ARCH_NZ_BITS
`undef MERCURY_PSR_ARCH_NZCV_BITS
`undef MERCURY_PSR_ARCH_NZCVQ_BITS
`undef MERCURY_PSR_ARCH_IT_LOW_BITS
`undef MERCURY_PSR_ARCH_J_BITS
`undef MERCURY_PSR_ARCH_SS_BITS
`undef MERCURY_PSR_ARCH_IL_BITS
`undef MERCURY_PSR_ARCH_GE_BITS
`undef MERCURY_PSR_ARCH_IT_COND_BITS
`undef MERCURY_PSR_ARCH_IT_HIGH_BITS
`undef MERCURY_PSR_ARCH_IT_HICM_BITS
`undef MERCURY_PSR_ARCH_DAIF_BITS
`undef MERCURY_PSR_ARCH_EAIF_BITS
`undef MERCURY_PSR_ARCH_D_BITS
`undef MERCURY_PSR_ARCH_E_BITS
`undef MERCURY_PSR_ARCH_A_BITS
`undef MERCURY_PSR_ARCH_I_BITS
`undef MERCURY_PSR_ARCH_F_BITS
`undef MERCURY_PSR_ARCH_T_BITS
`undef MERCURY_PSR_ARCH_MODE_BITS
`undef MERCURY_SEL_CPSR_SRC_W
`undef MERCURY_SEL_CPSR_SRC_CPSR
`undef MERCURY_SEL_CPSR_SRC_FORCE
`undef MERCURY_SEL_CPSR_SRC_DP
`undef MERCURY_SEL_CPSR_SRC_MUL
`undef MERCURY_SEL_CPSR_SRC_LOAD_DATA
`undef MERCURY_SEL_CPSR_SRC_SPSR
`undef MERCURY_SEL_CPSR_SRC_CCFLAGS
`undef MERCURY_SEL_CPSR_SRC_DSCR
`undef MERCURY_SEL_CPSR_SRC_QFLAG
`undef MERCURY_SEL_CPSR_SRC_DSPSR
`undef MERCURY_SEL_CPSR_SRC_RFE
`undef MERCURY_SEL_CPSR_SRC_BLX
`undef MERCURY_SEL_CPSR_SRC_CPS
`undef MERCURY_SEL_CPSR_SRC_INSTR1
`undef MERCURY_SEL_CPSR_EN_W
`undef MERCURY_SEL_CPSR_EN_NULL
`undef MERCURY_SEL_CPSR_EN_IT
`undef MERCURY_SEL_CPSR_EN_T
`undef MERCURY_SEL_CPSR_EN_E
`undef MERCURY_SEL_CPSR_EN_M0
`undef MERCURY_SEL_CPSR_EN_ETIM
`undef MERCURY_SEL_CPSR_EN_ETAIM
`undef MERCURY_SEL_CPSR_EN_ETAIFM
`undef MERCURY_SEL_CPSR_EN_GE
`undef MERCURY_SEL_CPSR_EN_Q
`undef MERCURY_SEL_CPSR_EN_CC
`undef MERCURY_SEL_CPSR_EN_SPSR
`undef MERCURY_SEL_MRS_CPSR_RET
`undef MERCURY_SEL_MRS_SPSR_RET
`undef MERCURY_FLAGEN_INSTR1_W
`undef MERCURY_FLAGEN_INSTR1_NONE
`undef MERCURY_FLAGEN_INSTR1_CC
`undef MERCURY_FLAGEN_INSTR1_GE
`undef MERCURY_FLAGEN_INSTR1_Q
`undef MERCURY_SIMD_SIGNED_SAT_ARITH
`undef MERCURY_SIMD_SIGNED_ARITH
`undef MERCURY_SIMD_SIGNED_HALF_ARITH
`undef MERCURY_SIMD_UNSIGNED_ARITH
`undef MERCURY_SIMD_UNSIGNED_HALF_ARITH
`undef MERCURY_SIMD_UNSIGNED_SAT_ARITH
`undef MERCURY_SIMD_X
`undef MERCURY_SIMD_SIZE_16
`undef MERCURY_SIMD_SIZE_8
`undef MERCURY_MEDIA_SIGNED_SAT_ARITH
`undef MERCURY_MEDIA_SIGNED_ARITH
`undef MERCURY_MEDIA_SIGNED_HALF_ARITH
`undef MERCURY_MEDIA_UNSIGNED_ARITH
`undef MERCURY_MEDIA_UNSIGNED_HALF_ARITH
`undef MERCURY_MEDIA_UNSIGNED_SAT_ARITH
`undef MERCURY_MEDIA_X
`undef MERCURY_EXTRACT_LS_BYTE
`undef MERCURY_EXTRACT_LS_HWORD
`undef MERCURY_EXTRACT_TWO_BYTES
`undef MERCURY_EXTRACT_SH_BYTE
`undef MERCURY_EXTRACT_SH_HWORD
`undef MERCURY_EXTRACT_SH_WORD
`undef MERCURY_EXTRACT_SH_XWORD
`undef MERCURY_SAT_POS_32_VALUE
`undef MERCURY_SAT_NEG_32_VALUE
`undef MERCURY_FP_RF_RD_ADDR_W
`undef MERCURY_FP_RF_WR_ADDR_W
`undef MERCURY_FP_RF_ADDR_L_W
`undef MERCURY_FPU_ADDR_D00
`undef MERCURY_FPU_ADDR_D01
`undef MERCURY_FPU_ADDR_D02
`undef MERCURY_FPU_ADDR_D03
`undef MERCURY_FPU_ADDR_D04
`undef MERCURY_FPU_ADDR_D05
`undef MERCURY_FPU_ADDR_D06
`undef MERCURY_FPU_ADDR_D07
`undef MERCURY_FPU_ADDR_D08
`undef MERCURY_FPU_ADDR_D09
`undef MERCURY_FPU_ADDR_D10
`undef MERCURY_FPU_ADDR_D11
`undef MERCURY_FPU_ADDR_D12
`undef MERCURY_FPU_ADDR_D13
`undef MERCURY_FPU_ADDR_D14
`undef MERCURY_FPU_ADDR_D15
`undef MERCURY_FPU_ADDR_D16
`undef MERCURY_FPU_ADDR_D17
`undef MERCURY_FPU_ADDR_D18
`undef MERCURY_FPU_ADDR_D19
`undef MERCURY_FPU_ADDR_D20
`undef MERCURY_FPU_ADDR_D21
`undef MERCURY_FPU_ADDR_D22
`undef MERCURY_FPU_ADDR_D23
`undef MERCURY_FPU_ADDR_D24
`undef MERCURY_FPU_ADDR_D25
`undef MERCURY_FPU_ADDR_D26
`undef MERCURY_FPU_ADDR_D27
`undef MERCURY_FPU_ADDR_D28
`undef MERCURY_FPU_ADDR_D29
`undef MERCURY_FPU_ADDR_D30
`undef MERCURY_FPU_ADDR_D31
`undef MERCURY_FPU_ADDR_S00
`undef MERCURY_FPU_ADDR_S01
`undef MERCURY_FPU_ADDR_S02
`undef MERCURY_FPU_ADDR_S03
`undef MERCURY_FPU_ADDR_S04
`undef MERCURY_FPU_ADDR_S05
`undef MERCURY_FPU_ADDR_S06
`undef MERCURY_FPU_ADDR_S07
`undef MERCURY_FPU_ADDR_S08
`undef MERCURY_FPU_ADDR_S09
`undef MERCURY_FPU_ADDR_S10
`undef MERCURY_FPU_ADDR_S11
`undef MERCURY_FPU_ADDR_S12
`undef MERCURY_FPU_ADDR_S13
`undef MERCURY_FPU_ADDR_S14
`undef MERCURY_FPU_ADDR_S15
`undef MERCURY_FPU_ADDR_S16
`undef MERCURY_FPU_ADDR_S17
`undef MERCURY_FPU_ADDR_S18
`undef MERCURY_FPU_ADDR_S19
`undef MERCURY_FPU_ADDR_S20
`undef MERCURY_FPU_ADDR_S21
`undef MERCURY_FPU_ADDR_S22
`undef MERCURY_FPU_ADDR_S23
`undef MERCURY_FPU_ADDR_S24
`undef MERCURY_FPU_ADDR_S25
`undef MERCURY_FPU_ADDR_S26
`undef MERCURY_FPU_ADDR_S27
`undef MERCURY_FPU_ADDR_S28
`undef MERCURY_FPU_ADDR_S29
`undef MERCURY_FPU_ADDR_S30
`undef MERCURY_FPU_ADDR_S31
`undef MERCURY_NEON_ADDR_S00
`undef MERCURY_NEON_ADDR_S01
`undef MERCURY_NEON_ADDR_S02
`undef MERCURY_NEON_ADDR_S03
`undef MERCURY_NEON_ADDR_S04
`undef MERCURY_NEON_ADDR_S05
`undef MERCURY_NEON_ADDR_S06
`undef MERCURY_NEON_ADDR_S07
`undef MERCURY_NEON_ADDR_S08
`undef MERCURY_NEON_ADDR_S09
`undef MERCURY_NEON_ADDR_S10
`undef MERCURY_NEON_ADDR_S11
`undef MERCURY_NEON_ADDR_S12
`undef MERCURY_NEON_ADDR_S13
`undef MERCURY_NEON_ADDR_S14
`undef MERCURY_NEON_ADDR_S15
`undef MERCURY_NEON_ADDR_S16
`undef MERCURY_NEON_ADDR_S17
`undef MERCURY_NEON_ADDR_S18
`undef MERCURY_NEON_ADDR_S19
`undef MERCURY_NEON_ADDR_S20
`undef MERCURY_NEON_ADDR_S21
`undef MERCURY_NEON_ADDR_S22
`undef MERCURY_NEON_ADDR_S23
`undef MERCURY_NEON_ADDR_S24
`undef MERCURY_NEON_ADDR_S25
`undef MERCURY_NEON_ADDR_S26
`undef MERCURY_NEON_ADDR_S27
`undef MERCURY_NEON_ADDR_S28
`undef MERCURY_NEON_ADDR_S29
`undef MERCURY_NEON_ADDR_S30
`undef MERCURY_NEON_ADDR_S31
`undef MERCURY_NEON_ADDR_S32
`undef MERCURY_NEON_ADDR_S33
`undef MERCURY_NEON_ADDR_S34
`undef MERCURY_NEON_ADDR_S35
`undef MERCURY_NEON_ADDR_S36
`undef MERCURY_NEON_ADDR_S37
`undef MERCURY_NEON_ADDR_S38
`undef MERCURY_NEON_ADDR_S39
`undef MERCURY_NEON_ADDR_S40
`undef MERCURY_NEON_ADDR_S41
`undef MERCURY_NEON_ADDR_S42
`undef MERCURY_NEON_ADDR_S43
`undef MERCURY_NEON_ADDR_S44
`undef MERCURY_NEON_ADDR_S45
`undef MERCURY_NEON_ADDR_S46
`undef MERCURY_NEON_ADDR_S47
`undef MERCURY_NEON_ADDR_S48
`undef MERCURY_NEON_ADDR_S49
`undef MERCURY_NEON_ADDR_S50
`undef MERCURY_NEON_ADDR_S51
`undef MERCURY_NEON_ADDR_S52
`undef MERCURY_NEON_ADDR_S53
`undef MERCURY_NEON_ADDR_S54
`undef MERCURY_NEON_ADDR_S55
`undef MERCURY_NEON_ADDR_S56
`undef MERCURY_NEON_ADDR_S57
`undef MERCURY_NEON_ADDR_S58
`undef MERCURY_NEON_ADDR_S59
`undef MERCURY_NEON_ADDR_S60
`undef MERCURY_NEON_ADDR_S61
`undef MERCURY_NEON_ADDR_S62
`undef MERCURY_NEON_ADDR_S63
`undef MERCURY_SEL_FML_A_W
`undef MERCURY_SEL_FML_A_ZERO
`undef MERCURY_SEL_FML_A_FR0
`undef MERCURY_SEL_FML_B_W
`undef MERCURY_SEL_FML_B_ZERO
`undef MERCURY_SEL_FML_B_FR1
`undef MERCURY_SEL_FML_C_W
`undef MERCURY_SEL_FML_C_ZERO
`undef MERCURY_SEL_FML_C_FR2
`undef MERCURY_SEL_FAD_A_W
`undef MERCURY_SEL_FAD_A_ZERO
`undef MERCURY_SEL_FAD_A_FR2
`undef MERCURY_SEL_FAD_A_TWO
`undef MERCURY_SEL_FAD_A_THREE
`undef MERCURY_SEL_FAD_A_TRN32
`undef MERCURY_SEL_FAD_B_W
`undef MERCURY_SEL_FAD_B_ZERO
`undef MERCURY_SEL_FAD_B_FR1
`undef MERCURY_SEL_FAD_B_IMM
`undef MERCURY_SEL_FAD_B_FML_Q
`undef MERCURY_SEL_FAD_B_TRN32
`undef MERCURY_SEL_FAD_B_STR
`undef MERCURY_SEL_FAD_C_W
`undef MERCURY_SEL_FAD_C_ZERO
`undef MERCURY_SEL_FAD_C_FR0
`undef MERCURY_SEL_FAD_C_IMM
`undef MERCURY_FWD_FNULL
`undef MERCURY_FWD_ZERO
`undef MERCURY_FWD_FW0_F3
`undef MERCURY_FWD_FW0_F4
`undef MERCURY_FWD_FW0_F5
`undef MERCURY_FP_FORMAT_F32
`undef MERCURY_FP_FORMAT_F64
`undef MERCURY_FP_FORMAT_F16_B
`undef MERCURY_FP_FORMAT_F16_T
`undef MERCURY_FP_FORMAT_S16
`undef MERCURY_FP_FORMAT_U16
`undef MERCURY_FP_FORMAT_S32
`undef MERCURY_FP_FORMAT_U32
`undef MERCURY_FPEXC_W
`undef MERCURY_FPEXC_EN_BITS
`undef MERCURY_FPEXC_ST_EN_BITS
`undef MERCURY_FPSCR_ARCH_NZCV_BITS
`undef MERCURY_FPSCR_ARCH_QC_BITS
`undef MERCURY_FPSCR_ARCH_AHP_BITS
`undef MERCURY_FPSCR_ARCH_DN_BITS
`undef MERCURY_FPSCR_ARCH_FZ_BITS
`undef MERCURY_FPSCR_ARCH_RMODE_BITS
`undef MERCURY_FPSCR_ARCH_STRIDE_BITS
`undef MERCURY_FPSCR_ARCH_LEN_BITS
`undef MERCURY_FPSCR_ARCH_IDC_BITS
`undef MERCURY_FPSCR_ARCH_IXC_BITS
`undef MERCURY_FPSCR_ARCH_UFC_BITS
`undef MERCURY_FPSCR_ARCH_OFC_BITS
`undef MERCURY_FPSCR_ARCH_DZC_BITS
`undef MERCURY_FPSCR_ARCH_IOC_BITS
`undef MERCURY_FPEXC_ARCH_EN_BITS
`undef MERCURY_FPSCR_W
`undef MERCURY_FPSCR_FP_BITS
`undef MERCURY_FPSCR_QC_BITS
`undef MERCURY_FPSCR_NZCV_BITS
`undef MERCURY_FPSCR_AHP_BITS
`undef MERCURY_FPSCR_DN_BITS
`undef MERCURY_FPSCR_FZ_BITS
`undef MERCURY_FPSCR_RMODE_BITS
`undef MERCURY_FPSCR_CONFIG_BITS
`undef MERCURY_FPSCR_FP_XFLAGS_BITS
`undef MERCURY_FPSCR_IDC_BITS
`undef MERCURY_FPSCR_IXC_BITS
`undef MERCURY_FPSCR_UFC_BITS
`undef MERCURY_FPSCR_OFC_BITS
`undef MERCURY_FPSCR_DZC_BITS
`undef MERCURY_FPSCR_IOC_BITS
`undef MERCURY_XFLAGS_W
`undef MERCURY_XFLAGS_QC_BITS
`undef MERCURY_XFLAGS_IDC_BITS
`undef MERCURY_XFLAGS_IXC_BITS
`undef MERCURY_XFLAGS_UFC_BITS
`undef MERCURY_XFLAGS_OFC_BITS
`undef MERCURY_XFLAGS_DZC_BITS
`undef MERCURY_XFLAGS_IOC_BITS
`undef MERCURY_XFLAGS_FP_BITS
`undef MERCURY_FP_CFLAG_SRC_W
`undef MERCURY_FP_CFLAG_SRC_FPSCR
`undef MERCURY_FP_CFLAG_SRC_ALU
`undef MERCURY_FP_XFLAG_SRC_W
`undef MERCURY_FP_XFLAG_SRC_FPSCR
`undef MERCURY_FP_XFLAG_SRC_MUL
`undef MERCURY_FP_XFLAG_SRC_ALU
`undef MERCURY_FP_RMODE_W
`undef MERCURY_FP_RMODE_0
`undef MERCURY_FP_RMODE_RN
`undef MERCURY_FP_RMODE_RP
`undef MERCURY_FP_RMODE_RM
`undef MERCURY_FP_RMODE_RZ
`undef MERCURY_FP_RMODE_RA
`undef MERCURY_FP_RMODE_RX
`undef MERCURY_FP_RMODE_NEON
`undef MERCURY_FP_RMODE_FPCR
`undef MERCURY_FP_OP_W
`undef MERCURY_FP_OP_0
`undef MERCURY_FP_OP_ADD
`undef MERCURY_FP_OP_SUB
`undef MERCURY_FP_OP_ABD
`undef MERCURY_FP_OP_CMP
`undef MERCURY_FP_OP_CMPE
`undef MERCURY_FP_OP_ACMPE
`undef MERCURY_FP_OP_MOV
`undef MERCURY_FP_OP_ABS
`undef MERCURY_FP_OP_NEG
`undef MERCURY_FP_OP_RINT
`undef MERCURY_FP_OP_RINTX
`undef MERCURY_FP_OP_MAX
`undef MERCURY_FP_OP_MAXNM
`undef MERCURY_FP_OP_MIN
`undef MERCURY_FP_OP_MINNM
`undef MERCURY_FP_OP_F2H_B
`undef MERCURY_FP_OP_F2H_T
`undef MERCURY_FP_OP_H2F_B
`undef MERCURY_FP_OP_H2F_T
`undef MERCURY_FP_OP_I2S
`undef MERCURY_FP_OP_I2D
`undef MERCURY_FP_OP_S2I
`undef MERCURY_FP_OP_D2I
`undef MERCURY_FP_OP_D2FP
`undef MERCURY_FP_OP_S2D
`undef MERCURY_FP_OP_D2S
`undef MERCURY_FP_OP_RSB
`undef MERCURY_FP_OP_HADD
`undef MERCURY_FP_OP_RECPX
`undef MERCURY_NEON_FCTN_W
`undef MERCURY_NEON_FCTN_0
`undef MERCURY_NEON_FCTN_FP
`undef MERCURY_NEON_FCTN_PERM
`undef MERCURY_NEON_FCTN_ADDSUBHN
`undef MERCURY_NEON_FCTN_TBL_TBX
`undef MERCURY_NEON_FCTN_TBX_FINAL
`undef MERCURY_NEON_FCTN_SWAP_MAX
`undef MERCURY_NEON_FCTN_CMP
`undef MERCURY_NEON_FCTN_SHIFT
`undef MERCURY_NEON_FCTN_NONE
`undef MERCURY_NEON_FCTN_CLS
`undef MERCURY_NEON_FCTN_CNT
`undef MERCURY_NEON_FCTN_ACCUM
`undef MERCURY_NEON_FCTN_PERM_FB
`undef MERCURY_NEON_FCTN_RND_SHIFT
`undef MERCURY_NEON_FCTN_INS_SHIFT
`undef MERCURY_NEON_FCTN_SHA256SU0
`undef MERCURY_NEON_FCTN_RBIT
`undef MERCURY_NEON_FCTN_SHA1H
`undef MERCURY_NEON_FCTN_SHA1SU0
`undef MERCURY_NEON_FCTN_ADDV
`undef MERCURY_NEON_FCTN_MAXV
`undef MERCURY_NEON_FCTN_MINV
`undef MERCURY_NEON_MUX_SEL_W
`undef MERCURY_NEON_MUX_SEL_0
`undef MERCURY_NEON_MUX_SEL_AU
`undef MERCURY_NEON_MUX_SEL_LU
`undef MERCURY_NEON_MUX_SEL_CLZ
`undef MERCURY_NEON_MUX_SEL_PMUL
`undef MERCURY_NEON_MUX_SEL_MAXMIN
`undef MERCURY_NEON_MUX_SEL_FMAXMIN
`undef MERCURY_CRYPTO_OP_W
`undef MERCURY_CRYPTO_OP_0
`undef MERCURY_CRYPTO_OP_AESD
`undef MERCURY_CRYPTO_OP_AESE
`undef MERCURY_CRYPTO_OP_AESMC
`undef MERCURY_CRYPTO_OP_AESIMC
`undef MERCURY_CRYPTO_OP_AESD_AESIMC
`undef MERCURY_CRYPTO_OP_AESE_AESMC
`undef MERCURY_CRYPTO_OP_PMULL64
`undef MERCURY_CRYPTO_OP_SHA1C
`undef MERCURY_CRYPTO_OP_SHA1P
`undef MERCURY_CRYPTO_OP_SHA1M
`undef MERCURY_CRYPTO_OP_SHA1SU1
`undef MERCURY_CRYPTO_OP_SHA256H
`undef MERCURY_CRYPTO_OP_SHA256H2
`undef MERCURY_CRYPTO_OP_SHA256SU1
`undef MERCURY_FP_EX_PIPE_ADD
`undef MERCURY_FP_EX_PIPE_MUL
`undef MERCURY_FP_EX_PIPE_W
`undef MERCURY_FP_ADD_VECTOR_FP_OP_W
`undef MERCURY_FP_ADD_VECTOR_FP_OP_BITS
`undef MERCURY_FP_ADD_FP_OP_W
`undef MERCURY_FP_ADD_FP_OP_BITS
`undef MERCURY_FP_NEON_ADD_NEON_INT_SEL_W
`undef MERCURY_FP_NEON_ADD_NEON_INT_SEL_BITS
`undef MERCURY_FP_NEON_ADD_NEON_MUX_SEL_W
`undef MERCURY_FP_NEON_ADD_NEON_MUX_SEL_BITS
`undef MERCURY_FP_NEON_ADD_LU_CTL_W
`undef MERCURY_FP_NEON_ADD_LU_CTL_BITS
`undef MERCURY_FP_NEON_ADD_SIZE_SEL_W
`undef MERCURY_FP_NEON_ADD_SIZE_SEL_BITS
`undef MERCURY_FP_NEON_ADD_PERM_SEL_W
`undef MERCURY_FP_NEON_ADD_PERM_SEL_BITS
`undef MERCURY_FP_NEON_ADD_VTB_CYCLE_W
`undef MERCURY_FP_NEON_ADD_VTB_CYCLE_BITS
`undef MERCURY_FP_NEON_ADD_UNSIGNED_OP_W
`undef MERCURY_FP_NEON_ADD_UNSIGNED_OP_BITS
`undef MERCURY_FP_NEON_ADD_FCTN_SEL_W
`undef MERCURY_FP_NEON_ADD_FCTN_SEL_BITS
`undef MERCURY_FP_NEON_ADD_WIDTH_OP_SEL_W
`undef MERCURY_FP_NEON_ADD_WIDTH_OP_SEL_BITS
`undef MERCURY_FP_NEON_ADD_SAT_OP_SEL_W
`undef MERCURY_FP_NEON_ADD_SAT_OP_SEL_BITS
`undef MERCURY_FP_NEON_ADD_VTST_OP_SEL_W
`undef MERCURY_FP_NEON_ADD_VTST_OP_SEL_BITS
`undef MERCURY_FP_NEON_ADD_MASK_SEL_W
`undef MERCURY_FP_NEON_ADD_MASK_SEL_BITS
`undef MERCURY_FP_MUL_NEG_SQRT_W
`undef MERCURY_FP_MUL_NEG_SQRT_BITS
`undef MERCURY_FP_MUL_DIVIDE_W
`undef MERCURY_FP_MUL_DIVIDE_BITS
`undef MERCURY_FP_MUL_PRECISION_W
`undef MERCURY_FP_MUL_PRECISION_BITS
`undef MERCURY_FP_MUL_FUSED_MAC_W
`undef MERCURY_FP_MUL_FUSED_MAC_BITS
`undef MERCURY_FP_MUL_NEON_VECTOR_OP_W
`undef MERCURY_FP_MUL_NEON_VECTOR_OP_BITS
`undef MERCURY_FP_MUL_NEON_INT_OP_W
`undef MERCURY_FP_MUL_NEON_INT_OP_BITS
`undef MERCURY_FP_MUL_NEON_FIXUP_W
`undef MERCURY_FP_MUL_NEON_FIXUP_BITS
`undef MERCURY_FP_MUL_NEON_SAT_DBL_W
`undef MERCURY_FP_MUL_NEON_SAT_DBL_BITS
`undef MERCURY_FP_MUL_NEON_ROUND_W
`undef MERCURY_FP_MUL_NEON_ROUND_BITS
`undef MERCURY_FP_MUL_NEON_TYPE_W
`undef MERCURY_FP_MUL_NEON_TYPE_BITS
`undef MERCURY_FP_MUL_NEON_OUT_FMT_W
`undef MERCURY_FP_MUL_NEON_OUT_FMT_BITS
`undef MERCURY_FP_MUL_NEON_INV_IS_ZERO_W
`undef MERCURY_FP_MUL_NEON_INV_IS_ZERO_BITS
`undef MERCURY_NEON_VLD_PERM_EN_W
`undef MERCURY_NEON_VLD_PERM_EN_BITS
`undef MERCURY_NEON_VLD_DUP_W
`undef MERCURY_NEON_VLD_DUP_BITS
`undef MERCURY_NEON_VLD_SHR1_W
`undef MERCURY_NEON_VLD_SHR1_BITS
`undef MERCURY_NEON_VLD_SHR2_W
`undef MERCURY_NEON_VLD_SHR2_BITS
`undef MERCURY_FP_NEON_ADD_CTL_W
`undef MERCURY_FP_ADD_CTL_W
`undef MERCURY_FP_NEON_MUL_CTL_W
`undef MERCURY_FP_MUL_CTL_W
`undef MERCURY_NEON_VLD_CTL_W
`undef MERCURY_FP_PIPECTL_RMODE_W
`undef MERCURY_FP_PIPECTL_RMODE_BITS
`undef MERCURY_FP_PIPECTL_FORCE_DN_FZ_W
`undef MERCURY_FP_PIPECTL_FORCE_DN_FZ_BITS
`undef MERCURY_FP_PIPECTL_TOP_W
`undef MERCURY_FP_PIPECTL_W
`undef MERCURY_FP_PIPECTL_TOP_BITS
`undef MERCURY_FP_PIPECTL_MUL_CTL_BITS
`undef MERCURY_FP_PIPECTL_ADD_CTL_BITS
`undef MERCURY_NEON_LD_PERM_8_0
`undef MERCURY_NEON_LD_PERM_8_1
`undef MERCURY_NEON_LD_PERM_8_2
`undef MERCURY_NEON_LD_PERM_8_3
`undef MERCURY_NEON_LD_PERM_16_0
`undef MERCURY_NEON_LD_PERM_16_1
`undef MERCURY_NEON_LD_PERM_16_2
`undef MERCURY_NEON_LD_PERM_16_3
`undef MERCURY_NEON_LD_PERM_32_0
`undef MERCURY_NEON_LD_PERM_32_1
`undef MERCURY_NEON_LD_PERM_32_2
`undef MERCURY_NEON_LD_PERM_32_3
`undef MERCURY_NEON_LD_PERM_64
`undef MERCURY_NEON_MUL_TYPE_I8
`undef MERCURY_NEON_MUL_TYPE_I16
`undef MERCURY_NEON_MUL_TYPE_I16_LO
`undef MERCURY_NEON_MUL_TYPE_I16_HI
`undef MERCURY_NEON_MUL_TYPE_I32
`undef MERCURY_NEON_MUL_TYPE_I32_LO
`undef MERCURY_NEON_MUL_OUT_FMT_64
`undef MERCURY_NEON_MUL_OUT_FMT_32_L
`undef MERCURY_NEON_MUL_OUT_FMT_32_H
`undef MERCURY_NEON_MUL_OUT_FMT_4_8
`undef MERCURY_NEON_MUL_OUT_FMT_4_16
`undef MERCURY_NEON_MUL_OUT_FMT_2_32
`undef MERCURY_NEON_MUL_OUT_FMT_2_16_H
`undef MERCURY_NEON_MUL_OUT_FMT_VREC
`undef MERCURY_NEON_SAT_NONE
`undef MERCURY_NEON_SAT_ADD
`undef MERCURY_NEON_SAT_SHF_SIGNED
`undef MERCURY_NEON_SAT_SHF_UNSIGNED
`undef MERCURY_NEON_SAT_SUQADD
`undef MERCURY_NEON_SAT_USQADD
`undef MERCURY_NEON_SAT_MAXV
`undef MERCURY_NEON_SAT_MINV
`undef MERCURY_NEON_LU_AND
`undef MERCURY_NEON_LU_BIC
`undef MERCURY_NEON_LU_BIF
`undef MERCURY_NEON_LU_BIT
`undef MERCURY_NEON_LU_BSL
`undef MERCURY_NEON_LU_EOR
`undef MERCURY_NEON_LU_MOV
`undef MERCURY_NEON_LU_MVN
`undef MERCURY_NEON_LU_ORN
`undef MERCURY_NEON_LU_ORR
`undef MERCURY_NEON_LU_VCGT
`undef MERCURY_NEON_LU_VCEQ

`endif
