//-----------------------------------------------------------------------------
// The confidential and proprietary information contained in this file may
// only be used by a person authorised under and to the extent permitted
// by a subsisting licensing agreement from Arm Limited or its affiliates.
//
//            (C) COPYRIGHT 2012-2017, 2019 Arm Limited or its affiliates.
//                ALL RIGHTS RESERVED
//
// This entire notice must be reproduced on all copies of this file
// and copies of this file may only be made by a person if such person is
// permitted to do so under the terms of a subsisting license agreement
// from Arm Limited or its affiliates.
//
//            Release Information : MERCURY-r1p0-00rel0
//
//-----------------------------------------------------------------------------
// Verilog-2001 (IEEE Std 1364-2001)
//-----------------------------------------------------------------------------


`ifndef MERCURY_UNDEFINE




`define MERCURY_AG_WIDTH   49


`define MERCURY_REVISION       4'b0000      
`define MERCURY_VARIANT        4'b0001      
`define MERCURY_PERPH_REVISION 4'b0011      
`define MERCURY_PERPH_REV_AND  4'b0000      

`define MERCURY_IMPLEMENTOR     8'h41       
`define MERCURY_ARCH_REVISED    4'hf        
`define MERCURY_PART_NUM_11_8   4'hd        
`define MERCURY_VFP_SUBARCH     7'b000_0011 
`define MERCURY_VFP_PART_NUM    8'h40       

`define MERCURY_PART_NUM_7_0    8'h04       
`define MERCURY_PMCR_IDCODE     8'h0A       
`define MERCURY_VFP_VARIANT     4'h4        


`define MERCURY_IDCR_READ_VALUE {`MERCURY_IMPLEMENTOR,`MERCURY_VARIANT,`MERCURY_ARCH_REVISED,`MERCURY_PART_NUM_11_8,`MERCURY_PART_NUM_7_0,`MERCURY_REVISION}


`define MERCURY_CTR_CWG        4'h4  
`define MERCURY_CTR_ERG        4'h4  
`define MERCURY_CTR_DMINLINE   4'h4  
`define MERCURY_CTR_L1IP       2'h2  
`define MERCURY_CTR_IMINLINE   4'h4  


`define MERCURY_MPIDR_READ_VALUE(aff2,aff1,cpu_id,u)  {1'b1, u, 6'h00, aff2[7:0], aff1[7:0], 6'h00, cpu_id[1:0]}

`define MERCURY_CLIDR_READ_VALUE (L2_CACHE ? (scu_broadcastinner_i ? 32'h0a400023 : 32'h0a200023) : 32'h09200003)

`define MERCURY_CCSIDR_L2_READ_VALUE(size)  {1'b0, 1'b1, 1'b1, 1'b1, {4'b0000, size[2:0], 8'b11111111}, 10'h007,       3'h2}
`define MERCURY_CCSIDR_L1D_READ_VALUE(size) {1'b0, 1'b1, 1'b1, 1'b1, {7'b0000000, size[2:0], 5'b11111}, 10'h003,       3'h2}
`define MERCURY_CCSIDR_L1I_READ_VALUE(size) {1'b0, 1'b0, 1'b1, 1'b0, {6'b000000, size[2:0], 6'b111111}, 10'h001,       3'h2}

`define MERCURY_COMP0ID_RD_VAL 32'h0000000D
`define MERCURY_COMP1ID_RD_VAL 32'h00000090
`define MERCURY_COMP2ID_RD_VAL 32'h00000005
`define MERCURY_COMP3ID_RD_VAL 32'h000000B1

`define MERCURY_PMU_PART_NUM 12'h9DA
`define MERCURY_ETM_PART_NUM 12'h9DA
`define MERCURY_CTI_PART_NUM 12'h9DA

`define MERCURY_CTI_COMPONID0_VAL   32'h0000000D 
`define MERCURY_CTI_COMPONID1_VAL   32'h00000090 
`define MERCURY_CTI_COMPONID2_VAL   32'h00000005 
`define MERCURY_CTI_COMPONID3_VAL   32'h000000B1 
`define MERCURY_CTI_DEVTYPE_VAL     8'h14        
`define MERCURY_CTI_DEVARCH_VAL     32'h47701A14 

`define MERCURY_ID_PFR0_READ_VALUE             32'h00000131
`define MERCURY_ID_PFR1_READ_VALUE(giccdis)    ((giccdis) ? 32'h00011011 : 32'h10011011)
`define MERCURY_ID_DFR0_READ_VALUE(etmen)      ((etmen)   ? 32'h03010066 : 32'h03000066)
`define MERCURY_ID_AFR0_READ_VALUE             32'h00000000

`define MERCURY_ID_MMFR0_READ_VALUE            32'h10201105
`define MERCURY_ID_MMFR1_READ_VALUE            32'h40000000
`define MERCURY_ID_MMFR2_READ_VALUE            32'h01260000
`define MERCURY_ID_MMFR3_READ_VALUE            32'h02102211
`define MERCURY_ID_ISAR0_READ_VALUE            32'h02101110
`define MERCURY_ID_ISAR1_READ_VALUE            32'h13112111
`define MERCURY_ID_ISAR2_READ_VALUE            32'h21232042
`define MERCURY_ID_ISAR3_READ_VALUE            32'h01112131
`define MERCURY_ID_ISAR4_READ_VALUE            32'h00011142
`define MERCURY_ID_ISAR5_READ_VALUE(cryptodis) ((cryptodis) ? 32'h00010001 : 32'h00011121)

`define MERCURY_FPSID_READ_VALUE {`MERCURY_IMPLEMENTOR,1'b0,`MERCURY_VFP_SUBARCH,`MERCURY_VFP_PART_NUM,`MERCURY_VFP_VARIANT,`MERCURY_PERPH_REVISION}
`define MERCURY_MVFR0_READ_VALUE (NEON_FP ? 32'h10110222 : 32'h00000000)
`define MERCURY_MVFR1_READ_VALUE (NEON_FP ? 32'h12111111 : 32'h00000000)
`define MERCURY_MVFR2_READ_VALUE (NEON_FP ? 32'h00000043 : 32'h00000000)

`define MERCURY_AA64PFR0_READ_VALUE(giccdis)     ({36'h00000000_0, ((giccdis) ? 4'h0 : 4'h1), (NEON_FP ? 8'h00 : 8'hFF), 16'h2222})
`define MERCURY_AA64PFR1_READ_VALUE              64'h00000000_00000000
`define MERCURY_AA64DFR0_READ_VALUE              {32'h00000000, `MERCURY_NUM_BRP_CID, 4'h0, `MERCURY_NUM_WRP, 4'h0, `MERCURY_NUM_BRP, 12'h106}
`define MERCURY_AA64DFR1_READ_VALUE              64'h00000000_00000000
`define MERCURY_AA64AFR0_READ_VALUE              64'h00000000_00000000
`define MERCURY_AA64AFR1_READ_VALUE              64'h00000000_00000000
`define MERCURY_AA64ISAR0_READ_VALUE(cryptodis)  ((cryptodis) ? 64'h00000000_00010000 : 64'h00000000_00011120)
`define MERCURY_AA64ISAR1_READ_VALUE             64'h00000000_00000000
`define MERCURY_AA64MMFR0_READ_VALUE             64'h00000000_00101122
`define MERCURY_AA64MMFR1_READ_VALUE             64'h00000000_00000000

`define MERCURY_NUM_PMN  6
`define MERCURY_PMCFGR_READ_VALUE   {12'h000, 1'b0, 1'b0, 1'b0, 1'b1, 1'b1, 1'b1, 6'd63, 8'd`MERCURY_NUM_PMN}
`define MERCURY_PMCEID0_READ_VALUE  (L2_CACHE ? 32'h6fffbfff : 32'h6e3fbfff)

`define MERCURY_PMDEVARCH_READ_VALUE 32'h47702a16
`define MERCURY_PMDEVTYPE_READ_VALUE 32'h00000016


`define MERCURY_DBG_EDESR          10'h008 
`define MERCURY_DBG_EDECR          10'h009 
`define MERCURY_DBG_EDWAR_LO       10'h00C 
`define MERCURY_DBG_EDWAR_HI       10'h00D 
`define MERCURY_DBG_DTRRX          10'h020 
`define MERCURY_DBG_EDITR          10'h021 
`define MERCURY_DBG_EDSCR          10'h022 
`define MERCURY_DBG_DTRTX          10'h023 
`define MERCURY_DBG_EDRCR          10'h024 
`define MERCURY_DBG_EDACR          10'h025 
`define MERCURY_DBG_EDECCR         10'h026 
`define MERCURY_DBG_EDPCSRlo       10'h028 
`define MERCURY_DBG_EDCIDSR        10'h029 
`define MERCURY_DBG_EDVIDSR        10'h02A 
`define MERCURY_DBG_EDPCSRhi       10'h02B 
`define MERCURY_DBG_OSLAR          10'h0C0 
`define MERCURY_DBG_EDPRCR         10'h0C4 
`define MERCURY_DBG_EDPRSR         10'h0C5 
`define MERCURY_DBG_BVR0lo         10'h100 
`define MERCURY_DBG_BVR0hi         10'h101 
`define MERCURY_DBG_BCR0           10'h102 
`define MERCURY_DBG_BVR1lo         10'h104 
`define MERCURY_DBG_BVR1hi         10'h105 
`define MERCURY_DBG_BCR1           10'h106 
`define MERCURY_DBG_BVR2lo         10'h108 
`define MERCURY_DBG_BVR2hi         10'h109 
`define MERCURY_DBG_BCR2           10'h10A 
`define MERCURY_DBG_BVR3lo         10'h10C 
`define MERCURY_DBG_BVR3hi         10'h10D 
`define MERCURY_DBG_BCR3           10'h10E 
`define MERCURY_DBG_BVR4lo         10'h110 
`define MERCURY_DBG_BVR4hi         10'h111 
`define MERCURY_DBG_BCR4           10'h112 
`define MERCURY_DBG_BVR5lo         10'h114 
`define MERCURY_DBG_BVR5hi         10'h115 
`define MERCURY_DBG_BCR5           10'h116 
`define MERCURY_DBG_WVR0lo         10'h200 
`define MERCURY_DBG_WVR0hi         10'h201 
`define MERCURY_DBG_WCR0           10'h202 
`define MERCURY_DBG_WVR1lo         10'h204 
`define MERCURY_DBG_WVR1hi         10'h205 
`define MERCURY_DBG_WCR1           10'h206 
`define MERCURY_DBG_WVR2lo         10'h208 
`define MERCURY_DBG_WVR2hi         10'h209 
`define MERCURY_DBG_WCR2           10'h20A 
`define MERCURY_DBG_WVR3lo         10'h20C 
`define MERCURY_DBG_WVR3hi         10'h20D 
`define MERCURY_DBG_WCR3           10'h20E 
`define MERCURY_DBG_MIDR           10'h340 
`define MERCURY_DBG_ID_AA64PFR0lo  10'h348 
`define MERCURY_DBG_ID_AA64PFR0hi  10'h349 
`define MERCURY_DBG_ID_AA64DFR0lo  10'h34A 
`define MERCURY_DBG_ID_AA64DFR0hi  10'h34B 
`define MERCURY_DBG_ID_AA64ISAR0lo 10'h34C 
`define MERCURY_DBG_ID_AA64ISAR0hi 10'h34D 
`define MERCURY_DBG_ID_AA64MMFR0lo 10'h34E 
`define MERCURY_DBG_ID_AA64MMFR0hi 10'h34F 
`define MERCURY_DBG_ID_AA64PFR1lo  10'h350 
`define MERCURY_DBG_ID_AA64PFR1hi  10'h351 
`define MERCURY_DBG_ID_AA64DFR1lo  10'h352 
`define MERCURY_DBG_ID_AA64DFR1hi  10'h353 
`define MERCURY_DBG_ID_AA64ISAR1lo 10'h354 
`define MERCURY_DBG_ID_AA64ISAR1hi 10'h355 
`define MERCURY_DBG_ID_AA64MMFR1lo 10'h356 
`define MERCURY_DBG_ID_AA64MMFR1hi 10'h357 
`define MERCURY_DBG_EDAA32PFR      10'h358 
`define MERCURY_DBG_CLAIMSET       10'h3E8 
`define MERCURY_DBG_CLAIMCLR       10'h3E9 
`define MERCURY_DBG_DEVAFF0        10'h3EA 
`define MERCURY_DBG_DEVAFF1        10'h3EB 
`define MERCURY_DBG_LAR            10'h3EC 
`define MERCURY_DBG_LSR            10'h3ED 
`define MERCURY_DBG_AUTHSTATUS     10'h3EE 
`define MERCURY_DBG_DEVARCH        10'h3EF 
`define MERCURY_DBG_DEVID2         10'h3F0 
`define MERCURY_DBG_DEVID1         10'h3F1 
`define MERCURY_DBG_DEVID          10'h3F2 
`define MERCURY_DBG_DEVTYPE        10'h3F3 
`define MERCURY_DBG_PID4           10'h3F4 
`define MERCURY_DBG_PID0           10'h3F8 
`define MERCURY_DBG_PID1           10'h3F9 
`define MERCURY_DBG_PID2           10'h3FA 
`define MERCURY_DBG_PID3           10'h3FB 
`define MERCURY_DBG_CID0           10'h3FC 
`define MERCURY_DBG_CID1           10'h3FD 
`define MERCURY_DBG_CID2           10'h3FE 
`define MERCURY_DBG_CID3           10'h3FF 

`define MERCURY_DBG_BVR             4'h4   
`define MERCURY_DBG_WVR             4'h8   


`define MERCURY_PMU_PMEVCNTRn_EL0(n)   {4'b0000, n[4:0], 1'b0} 
`define MERCURY_PMU_PMCCNTR_EL0_lo     10'h03E                 
`define MERCURY_PMU_PMCCNTR_EL0_hi     10'h03F                 
`define MERCURY_PMU_PMEVTYPER0_EL0     10'h100                 
`define MERCURY_PMU_PMEVTYPERn_EL0(n)  {5'b01000, n[4:0]}      
`define MERCURY_PMU_PMCCFILTR_EL0      10'h11F                 
`define MERCURY_PMU_PMCNTENSET_EL0     10'h300                 
`define MERCURY_PMU_PMCNTENCLR_EL0     10'h308                 
`define MERCURY_PMU_PMINTENSET_EL1     10'h310                 
`define MERCURY_PMU_PMINTENCLR_EL1     10'h318                 
`define MERCURY_PMU_PMOVSCLR_EL0       10'h320                 
`define MERCURY_PMU_PMSWINC_EL0        10'h328                 
`define MERCURY_PMU_PMOVSSET_EL0       10'h330                 
`define MERCURY_PMU_PMCFGR             10'h380                 
`define MERCURY_PMU_PMCR_EL0           10'h381                 
`define MERCURY_PMU_PMCEID0_EL0        10'h388                 
`define MERCURY_PMU_PMCEID1_EL0        10'h389                 
`define MERCURY_PMU_DEVAFF0            10'h3EA                 
`define MERCURY_PMU_DEVAFF1            10'h3EB                 
`define MERCURY_PMU_LAR                10'h3EC                 
`define MERCURY_PMU_LSR                10'h3ED                 
`define MERCURY_PMU_AUTHSTATUS         10'h3EE                 
`define MERCURY_PMU_DEVARCH            10'h3EF                 
`define MERCURY_PMU_DEVTYPE            10'h3F3                 
`define MERCURY_PMU_PID4               10'h3F4                 
`define MERCURY_PMU_PID0               10'h3F8                 
`define MERCURY_PMU_PID1               10'h3F9                 
`define MERCURY_PMU_PID2               10'h3FA                 
`define MERCURY_PMU_PID3               10'h3FB                 
`define MERCURY_PMU_CID0               10'h3FC                 
`define MERCURY_PMU_CID1               10'h3FD                 
`define MERCURY_PMU_CID2               10'h3FE                 
`define MERCURY_PMU_CID3               10'h3FF                 

`define MERCURY_ETM_OSLAR       10'h0C0 
`define MERCURY_ETM_OSLSR       10'h0C1 
`define MERCURY_ETM_PDCR        10'h0C4 
`define MERCURY_ETM_PDSR        10'h0C5 
`define MERCURY_ETM_DEVAFF0     10'h3EA 
`define MERCURY_ETM_DEVAFF1     10'h3EB 
`define MERCURY_ETM_LAR         10'h3EC 
`define MERCURY_ETM_LSR         10'h3ED 
`define MERCURY_ETM_AUTHSTATUS  10'h3EE 
`define MERCURY_ETM_DEVARCH     10'h3EF 
`define MERCURY_ETM_DEVTYPE     10'h3F3 
`define MERCURY_ETM_PID4        10'h3F4 
`define MERCURY_ETM_PID0        10'h3F8 
`define MERCURY_ETM_PID1        10'h3F9 
`define MERCURY_ETM_PID2        10'h3FA 
`define MERCURY_ETM_PID3        10'h3FB 
`define MERCURY_ETM_CID0        10'h3FC 
`define MERCURY_ETM_CID1        10'h3FD 
`define MERCURY_ETM_CID2        10'h3FE 
`define MERCURY_ETM_CID3        10'h3FF 

`define MERCURY_CTI_CONTROL_ADD       10'h000
`define MERCURY_CTI_INTACK_ADD        10'h004
`define MERCURY_CTI_APPSET_ADD        10'h005
`define MERCURY_CTI_APPCLR_ADD        10'h006
`define MERCURY_CTI_APPPULSE_ADD      10'h007

`define MERCURY_CTI_TRIGINSTATUS_ADD  10'h04C
`define MERCURY_CTI_TRIGOUTSTATUS_ADD 10'h04D
`define MERCURY_CTI_CHINSTATUS_ADD    10'h04E
`define MERCURY_CTI_CHOUTSTATUS_ADD   10'h04F

`define MERCURY_CTI_ITCONTROL_ADD     10'b1111_0000_00 

`define MERCURY_CTI_CHANNELGATE_ADD   10'b0001_0100_00

`define MERCURY_CTI_CLAIMSET_ADD    10'h3E8    
`define MERCURY_CTI_CLAIMCLR_ADD    10'h3E9    
`define MERCURY_CTI_DEVAFF0         10'h3EA    
`define MERCURY_CTI_DEVAFF1         10'h3EB    
`define MERCURY_CTI_LOCKACCESS_ADD  10'h3EC    
`define MERCURY_CTI_LOCKSTATUS_ADD  10'h3ED    
`define MERCURY_CTI_AUTHSTATUS_ADD  10'h3EE    
`define MERCURY_CTI_DEVARCH_ADD     10'h3EF    
`define MERCURY_CTI_DEVID2_ADD      10'h3F0    
`define MERCURY_CTI_DEVID1_ADD      10'h3F1    
`define MERCURY_CTI_DEVID_ADD       10'h3F2    
`define MERCURY_CTI_DEVTYPE_ADD     10'h3F3    

`define MERCURY_CTI_PERIPHID4_ADD   10'h3F4    
`define MERCURY_CTI_PERIPHID5_ADD   10'h3F5    
`define MERCURY_CTI_PERIPHID6_ADD   10'h3F6    
`define MERCURY_CTI_PERIPHID7_ADD   10'h3F7    
`define MERCURY_CTI_PERIPHID0_ADD   10'h3F8    
`define MERCURY_CTI_PERIPHID1_ADD   10'h3F9    
`define MERCURY_CTI_PERIPHID2_ADD   10'h3FA    
`define MERCURY_CTI_PERIPHID3_ADD   10'h3FB    
`define MERCURY_CTI_COMPONID0_ADD   10'h3FC    
`define MERCURY_CTI_COMPONID1_ADD   10'h3FD    
`define MERCURY_CTI_COMPONID2_ADD   10'h3FE    
`define MERCURY_CTI_COMPONID3_ADD   10'h3FF    



`define MERCURY_DBG_VER     4'b0110 
`define MERCURY_NUM_BRP_CID 4'h1    

`define MERCURY_NUM_BRP     4'h5        
`define MERCURY_NUM_WRP     4'h3        

`define MERCURY_DIDR_READ_VALUE {`MERCURY_NUM_WRP,`MERCURY_NUM_BRP,`MERCURY_NUM_BRP_CID,`MERCURY_DBG_VER,1'b1,1'b1,1'b0,1'b1,12'h000}

`define MERCURY_DBGDEVID_READ_VALUE  32'h00110F13
`define MERCURY_DBGDEVID1_READ_VALUE 32'h00000002
`define MERCURY_DBGDEVID2_READ_VALUE 32'h00000000

`define MERCURY_EDDEVID_READ_VALUE  32'h00000003
`define MERCURY_EDDEVID1_READ_VALUE 32'h00000002
`define MERCURY_EDDEVID2_READ_VALUE 32'h00000000

`define MERCURY_EDDEVARCH_READ_VALUE 32'h47706a15
`define MERCURY_EDDEVTYPE_READ_VALUE 32'h00000015


`ifdef ARM_ASSERT_ON
`include "std_ovl_defines.h"
`endif


`define MERCURY_ECC_ODD  1'b1
`define MERCURY_ECC_EVEN 1'b0


`define MERCURY_FAULT_VMSA_ALIGNMENT            7'b0000001  
`define MERCURY_FAULT_VMSA_PAGEWALK_EXT1_DEC    7'b0001100  
`define MERCURY_FAULT_VMSA_PAGEWALK_EXT1_SLV    7'b1001100  
`define MERCURY_FAULT_VMSA_PAGEWALK_EXT1_ECC    7'b0011100  
`define MERCURY_FAULT_VMSA_PAGEWALK_EXT2_DEC    7'b0001110  
`define MERCURY_FAULT_VMSA_PAGEWALK_EXT2_SLV    7'b1001110  
`define MERCURY_FAULT_VMSA_PAGEWALK_EXT2_ECC    7'b0011110  
`define MERCURY_FAULT_VMSA_TRANSLATION_SEC      7'b0000101  
`define MERCURY_FAULT_VMSA_TRANSLATION_PAGE     7'b0000111  
`define MERCURY_FAULT_VMSA_ACCESS_SEC           7'b0000011  
`define MERCURY_FAULT_VMSA_ACCESS_PAGE          7'b0000110  
`define MERCURY_FAULT_VMSA_DOMAIN_SEC           7'b0001001  
`define MERCURY_FAULT_VMSA_DOMAIN_PAGE          7'b0001011  
`define MERCURY_FAULT_VMSA_PERMISSION_SEC       7'b0001101  
`define MERCURY_FAULT_VMSA_PERMISSION_PAGE      7'b0001111  
`define MERCURY_FAULT_VMSA_EXT_DEC              7'b0001000  
`define MERCURY_FAULT_VMSA_EXT_SLV              7'b1001000  
`define MERCURY_FAULT_VMSA_ECC                  7'b0011001  
`define MERCURY_FAULT_VMSA_LDREX                7'b0010101  

`define MERCURY_FAULT_LPAE_ALIGNMENT            7'b0100001
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_DEC     5'b00101
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_DEC_L0  7'b0010100
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_DEC_L1  7'b0010101
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_DEC_L2  7'b0010110
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_DEC_L3  7'b0010111
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_SLV     5'b10101
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_SLV_L0  7'b1010100
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_SLV_L1  7'b1010101
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_SLV_L2  7'b1010110
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_SLV_L3  7'b1010111
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_ECC     5'b00111
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_ECC_L0  7'b0011100
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_ECC_L1  7'b0011101
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_ECC_L2  7'b0011110
`define MERCURY_FAULT_LPAE_PAGEWALK_EXT_ECC_L3  7'b0011111
`define MERCURY_FAULT_LPAE_TRANSLATION          5'b00001
`define MERCURY_FAULT_LPAE_TRANSLATION_L0       7'b0000100
`define MERCURY_FAULT_LPAE_TRANSLATION_L1       7'b0000101
`define MERCURY_FAULT_LPAE_TRANSLATION_L2       7'b0000110
`define MERCURY_FAULT_LPAE_TRANSLATION_L3       7'b0000111
`define MERCURY_FAULT_LPAE_ACCESS               5'b00010
`define MERCURY_FAULT_LPAE_ACCESS_L0            7'b0001000
`define MERCURY_FAULT_LPAE_ACCESS_L1            7'b0001001
`define MERCURY_FAULT_LPAE_ACCESS_L2            7'b0001010
`define MERCURY_FAULT_LPAE_ACCESS_L3            7'b0001011
`define MERCURY_FAULT_LPAE_PERMISSION           5'b00011
`define MERCURY_FAULT_LPAE_PERMISSION_L0        7'b0001100
`define MERCURY_FAULT_LPAE_PERMISSION_L1        7'b0001101
`define MERCURY_FAULT_LPAE_PERMISSION_L2        7'b0001110
`define MERCURY_FAULT_LPAE_PERMISSION_L3        7'b0001111
`define MERCURY_FAULT_LPAE_DOMAIN               5'b01111
`define MERCURY_FAULT_LPAE_DOMAIN_L1            7'b0111101
`define MERCURY_FAULT_LPAE_DOMAIN_L2            7'b0111110
`define MERCURY_FAULT_LPAE_ADDR_SIZE            5'b00000
`define MERCURY_FAULT_LPAE_ADDR_SIZE_L0         7'b0000000
`define MERCURY_FAULT_LPAE_ADDR_SIZE_L1         7'b0000001
`define MERCURY_FAULT_LPAE_ADDR_SIZE_L2         7'b0000010
`define MERCURY_FAULT_LPAE_ADDR_SIZE_L3         7'b0000011
`define MERCURY_FAULT_LPAE_EXT_DEC              7'b0010000
`define MERCURY_FAULT_LPAE_EXT_SLV              7'b1010000
`define MERCURY_FAULT_LPAE_LDREX                7'b0110101
`define MERCURY_FAULT_LPAE_ECC                  7'b0011000

`define MERCURY_FAULT_LPAE_STACK_ALIGN          7'b1111111

`define MERCURY_FAULT_PAGEWALK_EXT(fault)     ((fault[5:4] == 2'b01) & fault[2])
`define MERCURY_FAULT_DOMAIN(fault)           (fault[6:3] == 4'b0111)
`define MERCURY_FAULT_ECC(fault)              (fault[5:3] == 3'b011)
`define MERCURY_FAULT_ALIGNMENT(fault)        (fault[5:4] == 2'b10)
`define MERCURY_FAULT_EXT(fault)              (fault[4] & ~fault[2])
`define MERCURY_FAULT_GEN_EXT(fault)          (fault[5:4] == 2'b01)
`define MERCURY_FAULT_STACK_ALIGN(fault)      (fault[6:4] == 3'b111)




`define MERCURY_MEM_NORMAL(attrs)             (|attrs[7:5])
`define MERCURY_MEM_DEVICE(attrs)             (~|attrs[7:5])
`define MERCURY_MEM_DEVICE_nG(attrs)          (~|attrs[7:5] & ~&attrs[3:2])
`define MERCURY_MEM_nGnRnE(attrs)             ((~|attrs[7:5]) & (attrs[3:2] == 2'b00))
`define MERCURY_MEM_nGnRE(attrs)              ((~|attrs[7:5]) & (attrs[3:2] == 2'b01))
`define MERCURY_MEM_nGRE(attrs)               ((~|attrs[7:5]) & (attrs[3:2] == 2'b10))
`define MERCURY_MEM_GRE(attrs)                ((~|attrs[7:5]) & (attrs[3:2] == 2'b11))
`define MERCURY_MEM_WB(attrs)                 (attrs[7] | (attrs[6] & ((attrs[5:2] == 4'b1101) | (attrs[5:4] == 2'b01))))
`define MERCURY_MEM_WBWA(attrs)               (attrs[7] & attrs[4])
`define MERCURY_MEM_WBRA(attrs)               (attrs[7] & attrs[5])
`define MERCURY_MEM_WT(attrs)                 (~attrs[7] & ((attrs[6:4] == 3'b011) | (attrs[6:4] == 3'b110) | (attrs[6:2] == 5'b11110)))
`define MERCURY_MEM_NC(attrs)                 (~attrs[7] & ((attrs[6:4] == 3'b010) | (attrs[6:4] == 3'b100) | (attrs[6:2] == 5'b11100)))
`define MERCURY_MEM_OUTER_WB(attrs)           (attrs[7] | (attrs[6:5] == 2'b01))
`define MERCURY_MEM_OUTER_WT(attrs)           ((attrs[7:6] == 2'b01) & ~&attrs[5:4])
`define MERCURY_MEM_OUTER_NC(attrs)           (attrs[7:4] == 4'b0111)
`define MERCURY_MEM_OUTER_RA(attrs)           ((attrs[7] | (attrs[6] & ~&attrs[5:4]) | attrs[5]) & attrs[3])
`define MERCURY_MEM_OUTER_WA(attrs)           ((attrs[7] | (attrs[6] & ~&attrs[5:4]) | attrs[5]) & attrs[2])
`define MERCURY_MEM_SHAREABLE(attrs)          (attrs[1])
`define MERCURY_MEM_O_SHAREABLE(attrs)        (attrs[1:0] == 2'b10)
`define MERCURY_MEM_COHERENT(attrs)           (attrs[7])
`define MERCURY_MEM_COHERENT_SHAREABLE(attrs) (attrs[7] & attrs[1])
`define MERCURY_MEM_MERGEABLE(attrs)          (`MERCURY_MEM_NORMAL(attrs) | `MERCURY_MEM_GRE(attrs))
`define MERCURY_MEM_REORDERABLE(attrs)        (`MERCURY_MEM_NORMAL(attrs) | `MERCURY_MEM_GRE(attrs) | `MERCURY_MEM_nGRE(attrs))
`define MERCURY_MEM_DEV_OVERRIDE(attrs)       (attrs[4])
`define MERCURY_MEM_TRANSIENT(attrs)          (&attrs[7:6])
`define MERCURY_MEM_UNUSED(attrs)             ((attrs[1:0] == 2'b01) | (attrs[7:2] == 6'b011111) | (((attrs[7:5] == 3'b000) | (attrs[7:2] == 6'b011100)) & (attrs[1:0] != 2'b10)))

`define MERCURY_ATTR_MATCH(attr1, attr2) ((attr1[7:0] == attr2[7:0]) | ((`MERCURY_MEM_COHERENT(attr1) & `MERCURY_MEM_COHERENT(attr2) & (attr1[1:0] == attr2[1:0]))))



`define MERCURY_MEM_ICACHE_DISABLED   8'b01110010
`define MERCURY_MEM_DCACHE_DISABLED   8'b01110010
`define MERCURY_MEM_DEFAULT_CACHEABLE 8'b10111100
`define MERCURY_MEM_MMUOFF_ION        8'b01101000
`define MERCURY_MEM_MMUOFF_IOFF       8'b01110010
`define MERCURY_MEM_MMUOFF_D          8'b00000010

`define MERCURY_PAGE_DEV_STAGE1_NGNRNE_SHARE_OS       8'b00000010
`define MERCURY_PAGE_DEV_STAGE1_NGNRE_SHARE_OS        8'b00000110
`define MERCURY_PAGE_DEV_STAGE1_NGRE_SHARE_OS         8'b00001010
`define MERCURY_PAGE_DEV_STAGE1_GRE_SHARE_OS          8'b00001110
`define MERCURY_PAGE_DEV_STAGE2_NGNRNE_SHARE_OS       8'b00010010
`define MERCURY_PAGE_DEV_STAGE2_NGNRE_SHARE_OS        8'b00010110
`define MERCURY_PAGE_DEV_STAGE2_NGRE_SHARE_OS         8'b00011010
`define MERCURY_PAGE_DEV_STAGE2_GRE_SHARE_OS          8'b00011110
`define MERCURY_PAGE_INNER_NC_OUTER_NC_SHARE_OS       8'b01110010
`define MERCURY_PAGE_INNER_NC_OUTER_WT_SHARE_NS       8'b01001000
`define MERCURY_PAGE_INNER_NC_OUTER_WT_SHARE_OS       8'b01001010
`define MERCURY_PAGE_INNER_NC_OUTER_WB_SHARE_NS       8'b00101100
`define MERCURY_PAGE_INNER_NC_OUTER_WB_SHARE_OS       8'b00101110
`define MERCURY_PAGE_INNER_WT_OUTER_NC_SHARE_NS       8'b01111000
`define MERCURY_PAGE_INNER_WT_OUTER_NC_SHARE_OS       8'b01111010
`define MERCURY_PAGE_INNER_WT_OUTER_WT_SHARE_NS       8'b01101000
`define MERCURY_PAGE_INNER_WT_OUTER_WT_SHARE_OS       8'b01101010
`define MERCURY_PAGE_INNER_WT_OUTER_WB_SHARE_NS       8'b00111100
`define MERCURY_PAGE_INNER_WT_OUTER_WB_SHARE_OS       8'b00111110
`define MERCURY_PAGE_INNER_WBRA_OUTER_WBRA_SHARE_NS   8'b10101000
`define MERCURY_PAGE_INNER_WBRA_OUTER_WBRA_SHARE_OS   8'b10101010
`define MERCURY_PAGE_INNER_WBRWA_OUTER_WBRWA_SHARE_NS 8'b10111100
`define MERCURY_PAGE_INNER_WBRWA_OUTER_WBRWA_SHARE_OS 8'b10111110
`define MERCURY_PAGE_INNER_WBWA_OUTER_WBWA_SHARE_NS   8'b10010100
`define MERCURY_PAGE_INNER_WBRA_OUTER_WBRWA_SHARE_NS  8'b10101100
`define MERCURY_PAGE_INNER_WBRA_OUTER_WBRWA_SHARE_OS  8'b10101110
`define MERCURY_PAGE_INNER_WBRWA_OUTER_WBRA_SHARE_NS  8'b10111000
`define MERCURY_PAGE_INNER_WBRWA_OUTER_WBRA_SHARE_OS  8'b10111010


`define MERCURY_LDST_SIZE_BYTE    2'b00 
`define MERCURY_LDST_SIZE_HWORD   2'b01 
`define MERCURY_LDST_SIZE_WORD    2'b10 
`define MERCURY_LDST_SIZE_DWORD   2'b11 

`define MERCURY_MOESI_INVALID      2'b00
`define MERCURY_MOESI_SHARED       2'b01
`define MERCURY_MOESI_UNIQUE       2'b10

`define MERCURY_TAG_INVALID(moesi)    (~|moesi[1:0])
`define MERCURY_TAG_VALID(moesi)      (|moesi[1:0])
`define MERCURY_TAG_SHARED(moesi)     (moesi == `MERCURY_MOESI_SHARED)
`define MERCURY_TAG_UNIQUE(moesi)     (moesi[1])
`define MERCURY_TAG_MIGRATORY(moesi)  (&moesi[1:0])

`define MERCURY_CP15_REG_CDBGDR0        6'b000100
`define MERCURY_CP15_REG_CDBGDR1        6'b000101
`define MERCURY_CP15_REG_CDBGDR2        6'b000110
`define MERCURY_CP15_REG_CDBGDR3        6'b000111  
`define MERCURY_CP15_V2P_PAR            6'b001000
`define MERCURY_CP15_REG_TTBR0          6'b010000
`define MERCURY_CP15_REG_TTBR1          6'b010001
`define MERCURY_CP15_REG_TTBR0_EL1      6'b010000  
`define MERCURY_CP15_REG_TTBR1_EL1      6'b010001  
`define MERCURY_CP15_REG_TTBCR          6'b010010
`define MERCURY_CP15_REG_TCR_EL1        6'b010010  
`define MERCURY_CP15_REG_HTTBR          6'b010011
`define MERCURY_CP15_REG_VTTBR          6'b010100
`define MERCURY_CP15_REG_TTBR0_EL2      6'b010011  
`define MERCURY_CP15_REG_VTTBR_EL2      6'b010100  
`define MERCURY_CP15_REG_HTCR           6'b010101
`define MERCURY_CP15_REG_VTCR           6'b010110
`define MERCURY_CP15_REG_TCR_EL2        6'b010101  
`define MERCURY_CP15_REG_VTCR_EL2       6'b010110  
`define MERCURY_CP15_REG_PAR            6'b011000
`define MERCURY_CP15_REG_PAR_EL1        6'b011000  
`define MERCURY_CP15_REG_MAIR0          6'b011001
`define MERCURY_CP15_REG_MAIR_EL1       6'b011001  
`define MERCURY_CP15_REG_MAIR1          6'b011010
`define MERCURY_CP15_REG_HMAIR0         6'b011011
`define MERCURY_CP15_REG_MAIR_EL2       6'b011011  
`define MERCURY_CP15_REG_HMAIR1         6'b011100
`define MERCURY_CP15_REG_CTXTID         6'b011101
`define MERCURY_CP15_REG_CTXTID_EL1     6'b011101  
`define MERCURY_CP15_REG_TTBR0_EL3      6'b010111  
`define MERCURY_CP15_REG_TCR_EL3        6'b011110  
`define MERCURY_CP15_REG_MAIR_EL3       6'b011111  
`define MERCURY_CP15_REG_DBGBVR0        6'b100000
`define MERCURY_CP15_REG_DBGBVR1        6'b100001
`define MERCURY_CP15_REG_DBGBVR2        6'b100010
`define MERCURY_CP15_REG_DBGBVR3        6'b100011
`define MERCURY_CP15_REG_DBGBVR4        6'b100100
`define MERCURY_CP15_REG_DBGBVR5        6'b100101
`define MERCURY_CP15_REG_DBGBCR0        6'b101000
`define MERCURY_CP15_REG_DBGBCR1        6'b101001
`define MERCURY_CP15_REG_DBGBCR2        6'b101010
`define MERCURY_CP15_REG_DBGBCR3        6'b101011
`define MERCURY_CP15_REG_DBGBCR4        6'b101100
`define MERCURY_CP15_REG_DBGBCR5        6'b101101
`define MERCURY_CP15_REG_DBGWVR0        6'b110000
`define MERCURY_CP15_REG_DBGWVR1        6'b110001
`define MERCURY_CP15_REG_DBGWVR2        6'b110010
`define MERCURY_CP15_REG_DBGWVR3        6'b110011
`define MERCURY_CP15_REG_DBGWCR0        6'b111000
`define MERCURY_CP15_REG_DBGWCR1        6'b111001
`define MERCURY_CP15_REG_DBGWCR2        6'b111010
`define MERCURY_CP15_REG_DBGWCR3        6'b111011
`define MERCURY_CP15_REG_DBGVCR         6'b111111
`define MERCURY_CP15_REG_DBGBXVR4       6'b111100
`define MERCURY_CP15_REG_DBGBXVR5       6'b111101



`define MERCURY_GICREG_PCPU              1'b0
`define MERCURY_GICREG_PCPU_W            5
`define MERCURY_GICREG_PCPU_RESERVED     5'b0_00_00  
`define MERCURY_GICREG_GICC_IAR1_EL1     5'b0_00_01
`define MERCURY_GICREG_GICC_IAR0_EL1     5'b0_00_10
`define MERCURY_GICREG_GICC_EOIR1_EL1    5'b0_00_11
`define MERCURY_GICREG_GICC_EOIR0_EL1    5'b0_01_00
`define MERCURY_GICREG_GICC_HPPIR1_EL1   5'b0_01_01
`define MERCURY_GICREG_GICC_HPPIR0_EL1   5'b0_01_10
`define MERCURY_GICREG_GICC_BPR1_EL1     5'b0_10_00
`define MERCURY_GICREG_GICC_BPR0_EL1     5'b0_10_01
`define MERCURY_GICREG_GICC_DIR_EL1      5'b0_10_10
`define MERCURY_GICREG_GICC_PMR_EL1      5'b0_10_11
`define MERCURY_GICREG_GICC_RPR          5'b0_11_00
`define MERCURY_GICREG_GICC_AP0R0_EL1    5'b0_11_01
`define MERCURY_GICREG_GICC_AP1R0_EL1    5'b0_11_10
`define MERCURY_GICREG_GICC_IGRPEN0_EL1  5'b0_11_11
`define MERCURY_GICREG_GICC_IGRPEN1_EL1  5'b1_00_00
`define MERCURY_GICREG_GICC_IGRPEN1_EL3  5'b1_00_01
`define MERCURY_GICREG_GICC_SRE_EL1      5'b1_00_11
`define MERCURY_GICREG_GICC_SRE_EL2      5'b1_01_00
`define MERCURY_GICREG_GICC_SRE_EL3      5'b1_01_01
`define MERCURY_GICREG_GICC_CTLR_EL1     5'b1_01_10
`define MERCURY_GICREG_GICC_CTLR_EL3     5'b1_01_11
`define MERCURY_GICREG_GICC_SGI0R_EL1    5'b1_10_00
`define MERCURY_GICREG_GICC_SGI1R_EL1    5'b1_10_01
`define MERCURY_GICREG_GICC_ASGI1R_EL1   5'b1_10_10

`define MERCURY_GICREG_VCPU              1'b1
`define MERCURY_GICREG_VCPU_W            6
`define MERCURY_GICREG_VCPU_RESERVED     6'b00_00_00 
`define MERCURY_GICREG_GICV_AIAR         {1'b0,`MERCURY_GICREG_GICC_IAR1_EL1}
`define MERCURY_GICREG_GICV_IAR          {1'b0,`MERCURY_GICREG_GICC_IAR0_EL1}
`define MERCURY_GICREG_GICV_AEOIR        {1'b0,`MERCURY_GICREG_GICC_EOIR1_EL1}
`define MERCURY_GICREG_GICV_EOIR         {1'b0,`MERCURY_GICREG_GICC_EOIR0_EL1}
`define MERCURY_GICREG_GICV_AHPPIR       {1'b0,`MERCURY_GICREG_GICC_HPPIR1_EL1}
`define MERCURY_GICREG_GICV_HPPIR        {1'b0,`MERCURY_GICREG_GICC_HPPIR0_EL1}
`define MERCURY_GICREG_GICH_VMCR_BPR1    {1'b0,`MERCURY_GICREG_GICC_BPR1_EL1}
`define MERCURY_GICREG_GICH_VMCR_BPR0    {1'b0,`MERCURY_GICREG_GICC_BPR0_EL1}
`define MERCURY_GICREG_GICV_DIR          {1'b0,`MERCURY_GICREG_GICC_DIR_EL1}
`define MERCURY_GICREG_GICH_VMCR_PMR     {1'b0,`MERCURY_GICREG_GICC_PMR_EL1}
`define MERCURY_GICREG_GICV_RPR          {1'b0,`MERCURY_GICREG_GICC_RPR}
`define MERCURY_GICREG_GICV_CTLR         {1'b0,`MERCURY_GICREG_GICC_CTLR_EL1}
`define MERCURY_GICREG_GICH_APR0         {1'b0,`MERCURY_GICREG_GICC_AP0R0_EL1}
`define MERCURY_GICREG_GICH_APR1         {1'b0,`MERCURY_GICREG_GICC_AP1R0_EL1}
`define MERCURY_GICREG_GICH_VMCR_VENG0   {1'b0,`MERCURY_GICREG_GICC_IGRPEN0_EL1}
`define MERCURY_GICREG_GICH_VMCR_VENG1   {1'b0,`MERCURY_GICREG_GICC_IGRPEN1_EL1}
`define MERCURY_GICREG_GICH_HCR_SRE      {1'b0,`MERCURY_GICREG_GICC_SRE_EL1}
`define MERCURY_GICREG_GICH_HCR          6'b10_00_00
`define MERCURY_GICREG_GICH_VTR          6'b10_00_01
`define MERCURY_GICREG_GICH_VMCR         6'b10_00_10
`define MERCURY_GICREG_GICH_MISR         6'b10_01_00
`define MERCURY_GICREG_GICH_EISR         6'b10_01_01
`define MERCURY_GICREG_GICH_ELSR         6'b10_01_10
`define MERCURY_GICREG_GICH_LR0          6'b11_00_00 
`define MERCURY_GICREG_GICH_LR1          6'b11_01_00 
`define MERCURY_GICREG_GICH_LR2          6'b11_10_00 
`define MERCURY_GICREG_GICH_LR3          6'b11_11_00 
`define MERCURY_GICREG_GICH_LR0_L        6'b11_00_01 
`define MERCURY_GICREG_GICH_LR1_L        6'b11_01_01 
`define MERCURY_GICREG_GICH_LR2_L        6'b11_10_01 
`define MERCURY_GICREG_GICH_LR3_L        6'b11_11_01 
`define MERCURY_GICREG_GICH_LR0_H        6'b11_00_10 
`define MERCURY_GICREG_GICH_LR1_H        6'b11_01_10 
`define MERCURY_GICREG_GICH_LR2_H        6'b11_10_10 
`define MERCURY_GICREG_GICH_LR3_H        6'b11_11_10 

`define MERCURY_GICCP_W                  7
`define MERCURY_GICCP_GICC_IAR1_EL1      {2'b00, `MERCURY_GICREG_GICC_IAR1_EL1}
`define MERCURY_GICCP_GICC_IAR0_EL1      {2'b00, `MERCURY_GICREG_GICC_IAR0_EL1}
`define MERCURY_GICCP_GICC_EOIR1_EL1     {2'b00, `MERCURY_GICREG_GICC_EOIR1_EL1}
`define MERCURY_GICCP_GICC_EOIR0_EL1     {2'b00, `MERCURY_GICREG_GICC_EOIR0_EL1}
`define MERCURY_GICCP_GICC_HPPIR1_EL1    {2'b00, `MERCURY_GICREG_GICC_HPPIR1_EL1}
`define MERCURY_GICCP_GICC_HPPIR0_EL1    {2'b00, `MERCURY_GICREG_GICC_HPPIR0_EL1}
`define MERCURY_GICCP_GICC_BPR1_EL1      {2'b00, `MERCURY_GICREG_GICC_BPR1_EL1}
`define MERCURY_GICCP_GICC_BPR0_EL1      {2'b00, `MERCURY_GICREG_GICC_BPR0_EL1}
`define MERCURY_GICCP_GICC_DIR_EL1       {2'b00, `MERCURY_GICREG_GICC_DIR_EL1}
`define MERCURY_GICCP_GICC_PMR_EL1       {2'b00, `MERCURY_GICREG_GICC_PMR_EL1}
`define MERCURY_GICCP_GICC_RPR           {2'b00, `MERCURY_GICREG_GICC_RPR}
`define MERCURY_GICCP_GICC_AP0R0_EL1     {2'b00, `MERCURY_GICREG_GICC_AP0R0_EL1}
`define MERCURY_GICCP_GICC_AP1R0_EL1     {2'b00, `MERCURY_GICREG_GICC_AP1R0_EL1}
`define MERCURY_GICCP_GICC_IGRPEN0_EL1   {2'b00, `MERCURY_GICREG_GICC_IGRPEN0_EL1}
`define MERCURY_GICCP_GICC_IGRPEN1_EL1   {2'b00, `MERCURY_GICREG_GICC_IGRPEN1_EL1}
`define MERCURY_GICCP_GICC_IGRPEN1_EL3   {2'b00, `MERCURY_GICREG_GICC_IGRPEN1_EL3}
`define MERCURY_GICCP_GICC_SRE_EL1       {2'b00, `MERCURY_GICREG_GICC_SRE_EL1}
`define MERCURY_GICCP_GICC_SRE_EL2       {2'b00, `MERCURY_GICREG_GICC_SRE_EL2}
`define MERCURY_GICCP_GICC_SRE_EL3       {2'b00, `MERCURY_GICREG_GICC_SRE_EL3}
`define MERCURY_GICCP_GICC_CTLR_EL1      {2'b00, `MERCURY_GICREG_GICC_CTLR_EL1}
`define MERCURY_GICCP_GICC_CTLR_EL3      {2'b00, `MERCURY_GICREG_GICC_CTLR_EL3}
`define MERCURY_GICCP_GICC_SGI0R_EL1     {2'b00, `MERCURY_GICREG_GICC_SGI0R_EL1}
`define MERCURY_GICCP_GICC_SGI1R_EL1     {2'b00, `MERCURY_GICREG_GICC_SGI1R_EL1}
`define MERCURY_GICCP_GICC_ASGI1R_EL1    {2'b00, `MERCURY_GICREG_GICC_ASGI1R_EL1}
`define MERCURY_GICCP_GICV_AIAR          {1'b1, `MERCURY_GICREG_GICV_AIAR}
`define MERCURY_GICCP_GICV_IAR           {1'b1, `MERCURY_GICREG_GICV_IAR}
`define MERCURY_GICCP_GICV_AEOIR         {1'b1, `MERCURY_GICREG_GICV_AEOIR}
`define MERCURY_GICCP_GICV_EOIR          {1'b1, `MERCURY_GICREG_GICV_EOIR}
`define MERCURY_GICCP_GICV_AHPPIR        {1'b1, `MERCURY_GICREG_GICV_AHPPIR}
`define MERCURY_GICCP_GICV_HPPIR         {1'b1, `MERCURY_GICREG_GICV_HPPIR}
`define MERCURY_GICCP_GICH_VMCR_BPR1     {1'b1, `MERCURY_GICREG_GICH_VMCR_BPR1}
`define MERCURY_GICCP_GICH_VMCR_BPR0     {1'b1, `MERCURY_GICREG_GICH_VMCR_BPR0}
`define MERCURY_GICCP_GICV_DIR           {1'b1, `MERCURY_GICREG_GICV_DIR}
`define MERCURY_GICCP_GICH_VMCR_PMR      {1'b1, `MERCURY_GICREG_GICH_VMCR_PMR}
`define MERCURY_GICCP_GICV_RPR           {1'b1, `MERCURY_GICREG_GICV_RPR}
`define MERCURY_GICCP_GICH_APR0          {1'b1, `MERCURY_GICREG_GICH_APR0}
`define MERCURY_GICCP_GICH_APR1          {1'b1, `MERCURY_GICREG_GICH_APR1}
`define MERCURY_GICCP_GICH_VMCR_VENG0    {1'b1, `MERCURY_GICREG_GICH_VMCR_VENG0}
`define MERCURY_GICCP_GICH_VMCR_VENG1    {1'b1, `MERCURY_GICREG_GICH_VMCR_VENG1}
`define MERCURY_GICCP_GICH_HCR_SRE       {1'b1, `MERCURY_GICREG_GICH_HCR_SRE}
`define MERCURY_GICCP_GICV_CTLR          {1'b1, `MERCURY_GICREG_GICV_CTLR}
`define MERCURY_GICCP_GICH_HCR           {1'b1, `MERCURY_GICREG_GICH_HCR}
`define MERCURY_GICCP_GICH_VTR           {1'b1, `MERCURY_GICREG_GICH_VTR}
`define MERCURY_GICCP_GICH_VMCR          {1'b1, `MERCURY_GICREG_GICH_VMCR}
`define MERCURY_GICCP_GICH_MISR          {1'b1, `MERCURY_GICREG_GICH_MISR}
`define MERCURY_GICCP_GICH_EISR          {1'b1, `MERCURY_GICREG_GICH_EISR}
`define MERCURY_GICCP_GICH_ELSR          {1'b1, `MERCURY_GICREG_GICH_ELSR}
`define MERCURY_GICCP_GICH_LR0           {1'b1, `MERCURY_GICREG_GICH_LR0}   
`define MERCURY_GICCP_GICH_LR0_L         {1'b1, `MERCURY_GICREG_GICH_LR0_L} 
`define MERCURY_GICCP_GICH_LR0_H         {1'b1, `MERCURY_GICREG_GICH_LR0_H} 
`define MERCURY_GICCP_GICH_LR1           {1'b1, `MERCURY_GICREG_GICH_LR1}   
`define MERCURY_GICCP_GICH_LR1_L         {1'b1, `MERCURY_GICREG_GICH_LR1_L} 
`define MERCURY_GICCP_GICH_LR1_H         {1'b1, `MERCURY_GICREG_GICH_LR1_H} 
`define MERCURY_GICCP_GICH_LR2           {1'b1, `MERCURY_GICREG_GICH_LR2}   
`define MERCURY_GICCP_GICH_LR2_L         {1'b1, `MERCURY_GICREG_GICH_LR2_L} 
`define MERCURY_GICCP_GICH_LR2_H         {1'b1, `MERCURY_GICREG_GICH_LR2_H} 
`define MERCURY_GICCP_GICH_LR3           {1'b1, `MERCURY_GICREG_GICH_LR3}   
`define MERCURY_GICCP_GICH_LR3_L         {1'b1, `MERCURY_GICREG_GICH_LR3_L} 
`define MERCURY_GICCP_GICH_LR3_H         {1'b1, `MERCURY_GICREG_GICH_LR3_H} 




`define MERCURY_CPOP_IS_GOV(cpop_type)       (cpop_type[8])
`define MERCURY_CPOP_IS_GIC(cpop_type)       (cpop_type[8:7] == 2'b10)
`define MERCURY_CPOP_IS_V2P(cpop_type)       (~`MERCURY_CPOP_IS_GOV(cpop_type) & (cpop_type[6:2] == 5'b00010))
`define MERCURY_CPOP_IS_TLBM(cpop_type)      (~`MERCURY_CPOP_IS_GOV(cpop_type) & `MERCURY_CPOP_8_IS_TLBM(cpop_type))
`define MERCURY_CPOP_IS_DCM(cpop_type)       (~`MERCURY_CPOP_IS_GOV(cpop_type) & `MERCURY_CPOP_8_IS_DCM(cpop_type))
`define MERCURY_CPOP_IS_ICM(cpop_type)       (~`MERCURY_CPOP_IS_GOV(cpop_type) & `MERCURY_CPOP_8_IS_ICM(cpop_type))
`define MERCURY_CPOP_IS_BPM(cpop_type)       (~`MERCURY_CPOP_IS_GOV(cpop_type) & `MERCURY_CPOP_8_IS_BPM(cpop_type))
`define MERCURY_CPOP_IS_BAR(cpop_type)       (~`MERCURY_CPOP_IS_GOV(cpop_type) & `MERCURY_CPOP_8_IS_BAR(cpop_type))
`define MERCURY_CPOP_IS_DSB(cpop_type)       (~`MERCURY_CPOP_IS_GOV(cpop_type) & `MERCURY_CPOP_8_IS_DSB(cpop_type))
`define MERCURY_CPOP_IS_DMB(cpop_type)       (~`MERCURY_CPOP_IS_GOV(cpop_type) & `MERCURY_CPOP_8_IS_DMB(cpop_type))
`define MERCURY_CPOP_IS_DMBLD(cpop_type)     (`MERCURY_CPOP_IS_BAR(cpop_type) & ~cpop_type[4])
`define MERCURY_CPOP_IS_DCM_MVA(cpop_type)   (`MERCURY_CPOP_IS_DCM(cpop_type) & cpop_type[0])
`define MERCURY_CPOP_IS_DCM_SW(cpop_type)    (`MERCURY_CPOP_IS_DCM(cpop_type) & ~cpop_type[0])
`define MERCURY_CPOP_IS_ICM_MVA(cpop_type)   (~`MERCURY_CPOP_IS_GOV(cpop_type) & `MERCURY_CPOP_8_IS_ICM_MVA(cpop_type))
`define MERCURY_CPOP_IS_CLREX(cpop_type)     (~`MERCURY_CPOP_IS_GOV(cpop_type) & cpop_type[7] & (cpop_type[5:1] == 5'b00000))
`define MERCURY_CPOP_IS_CLREX_NOP(cpop_type) (~`MERCURY_CPOP_IS_GOV(cpop_type) & cpop_type[7] & (cpop_type[5:2] == 4'b0000))
`define MERCURY_CPOP_IS_CDBG(cpop_type)      (~`MERCURY_CPOP_IS_GOV(cpop_type) & (cpop_type[6:4] == 3'b000) & (cpop_type[3:2] != 2'b10))
`define MERCURY_CPOP_IS_CDBG_DC(cpop_type)   (`MERCURY_CPOP_IS_CDBG(cpop_type) & cpop_type[2:1] == 2'b00)
`define MERCURY_CPOP_IS_CDBG_IC(cpop_type)   (`MERCURY_CPOP_IS_CDBG(cpop_type) & cpop_type[2:1] == 2'b01)
`define MERCURY_CPOP_IS_CDBG_TLB(cpop_type)  (`MERCURY_CPOP_IS_CDBG(cpop_type) & cpop_type[3:2] == 2'b11)
`define MERCURY_CPOP_IS_REG(cpop_type)       (~`MERCURY_CPOP_IS_GOV(cpop_type) & ~cpop_type[6] & ((cpop_type[5:4] != 2'b00) | (cpop_type[5:2] == 4'b0001)))

`define MERCURY_CPOP_8_IS_TLBM(cpop_type)            (cpop_type[7:6] == 2'b01)
`define MERCURY_CPOP_8_IS_DCM(cpop_type)             (cpop_type[7] & (cpop_type[5:4] == 2'b01))
`define MERCURY_CPOP_8_IS_ICM(cpop_type)             (cpop_type[7] & (cpop_type[5:4] == 2'b00) & cpop_type[2])
`define MERCURY_CPOP_8_IS_BPM(cpop_type)             (cpop_type[7] & (cpop_type[5:4] == 2'b00) & (cpop_type[3:2] == 2'b10))
`define MERCURY_CPOP_8_IS_BAR(cpop_type)             (cpop_type[7] & cpop_type[5])
`define MERCURY_CPOP_8_IS_DSB(cpop_type)             (`MERCURY_CPOP_8_IS_BAR(cpop_type) & ~cpop_type[3])
`define MERCURY_CPOP_8_IS_DMB(cpop_type)             (`MERCURY_CPOP_8_IS_BAR(cpop_type) & cpop_type[3])
`define MERCURY_CPOP_8_IS_DMBST(cpop_type)           (`MERCURY_CPOP_8_IS_BAR(cpop_type) & ~cpop_type[2])
`define MERCURY_CPOP_8_IS_DCM_SW(cpop_type)          (`MERCURY_CPOP_8_IS_DCM(cpop_type) & ~cpop_type[0])
`define MERCURY_CPOP_8_IS_ICM_MVA(cpop_type)         (`MERCURY_CPOP_8_IS_ICM(cpop_type) & cpop_type[0])
`define MERCURY_CPOP_8_TLBM_IS_AA64(cpop_type_tlb)   (cpop_type_tlb[5])
`define MERCURY_CPOP_8_TLBM_AS_AA64(cpop_type_tlb)   ({cpop_type_tlb[7:6], 1'b1, cpop_type_tlb[4:0]})
`define MERCURY_CPOP_5_TLBM_AS_NON_IS(cpop_type_tlb) ({cpop_type_tlb[4], 1'b0, cpop_type_tlb[2:0]})

`define MERCURY_CPOP_W                 9
`define MERCURY_CPOP_0                 9'b000000000
`define MERCURY_CPOP_CDBGDCT           9'b000000000                          
`define MERCURY_CPOP_CDBGDCD           9'b000000001                          
`define MERCURY_CPOP_CDBGICT           9'b000000010                          
`define MERCURY_CPOP_CDBGICD           9'b000000011                          
`define MERCURY_CPOP_CDBGTD            9'b000001100                          
`define MERCURY_CPOP_CDBGDR0           {3'b000, `MERCURY_CP15_REG_CDBGDR0}      
`define MERCURY_CPOP_CDBGDR1           {3'b000, `MERCURY_CP15_REG_CDBGDR1}      
`define MERCURY_CPOP_CDBGDR2           {3'b000, `MERCURY_CP15_REG_CDBGDR2}      
`define MERCURY_CPOP_CDBGDR3           {3'b000, `MERCURY_CP15_REG_CDBGDR3}      
`define MERCURY_CPOP_TTBR0             {3'b000, `MERCURY_CP15_REG_TTBR0}        
`define MERCURY_CPOP_TTBR0_EL1         {3'b000, `MERCURY_CP15_REG_TTBR0_EL1}    
`define MERCURY_CPOP_TTBR1             {3'b000, `MERCURY_CP15_REG_TTBR1}        
`define MERCURY_CPOP_TTBR1_EL1         {3'b000, `MERCURY_CP15_REG_TTBR1_EL1}    
`define MERCURY_CPOP_TTBCR             {3'b000, `MERCURY_CP15_REG_TTBCR}        
`define MERCURY_CPOP_TCR_EL1           {3'b000, `MERCURY_CP15_REG_TCR_EL1}      
`define MERCURY_CPOP_HTTBR             {3'b000, `MERCURY_CP15_REG_HTTBR}        
`define MERCURY_CPOP_TTBR0_EL2         {3'b000, `MERCURY_CP15_REG_TTBR0_EL2}    
`define MERCURY_CPOP_VTTBR             {3'b000, `MERCURY_CP15_REG_VTTBR}        
`define MERCURY_CPOP_VTTBR_EL2         {3'b000, `MERCURY_CP15_REG_VTTBR_EL2}   
`define MERCURY_CPOP_HTCR              {3'b000, `MERCURY_CP15_REG_HTCR}         
`define MERCURY_CPOP_TCR_EL2           {3'b000, `MERCURY_CP15_REG_TCR_EL2}      
`define MERCURY_CPOP_VTCR              {3'b000, `MERCURY_CP15_REG_VTCR}         
`define MERCURY_CPOP_VTCR_EL2          {3'b000, `MERCURY_CP15_REG_VTCR_EL2}     
`define MERCURY_CPOP_PAR               {3'b000, `MERCURY_CP15_REG_PAR}          
`define MERCURY_CPOP_PAR_EL1           {3'b000, `MERCURY_CP15_REG_PAR_EL1}      
`define MERCURY_CPOP_MAIR0             {3'b000, `MERCURY_CP15_REG_MAIR0}        
`define MERCURY_CPOP_MAIR_EL1          {3'b000, `MERCURY_CP15_REG_MAIR_EL1}     
`define MERCURY_CPOP_MAIR1             {3'b000, `MERCURY_CP15_REG_MAIR1}        
`define MERCURY_CPOP_HMAIR0            {3'b000, `MERCURY_CP15_REG_HMAIR0}       
`define MERCURY_CPOP_MAIR_EL2          {3'b000, `MERCURY_CP15_REG_MAIR_EL2}     
`define MERCURY_CPOP_HMAIR1            {3'b000, `MERCURY_CP15_REG_HMAIR1}       
`define MERCURY_CPOP_CONTEXTIDR        {3'b000, `MERCURY_CP15_REG_CTXTID}       
`define MERCURY_CPOP_CONTEXTIDR_EL1    {3'b000, `MERCURY_CP15_REG_CTXTID_EL1}   
`define MERCURY_CPOP_TTBR0_EL3         {3'b000, `MERCURY_CP15_REG_TTBR0_EL3}    
`define MERCURY_CPOP_TCR_EL3           {3'b000, `MERCURY_CP15_REG_TCR_EL3}      
`define MERCURY_CPOP_MAIR_EL3          {3'b000, `MERCURY_CP15_REG_MAIR_EL3}     
`define MERCURY_CPOP_DBGBVR0           {3'b000, `MERCURY_CP15_REG_DBGBVR0}      
`define MERCURY_CPOP_DBGBVR1           {3'b000, `MERCURY_CP15_REG_DBGBVR1}      
`define MERCURY_CPOP_DBGBVR2           {3'b000, `MERCURY_CP15_REG_DBGBVR2}      
`define MERCURY_CPOP_DBGBVR3           {3'b000, `MERCURY_CP15_REG_DBGBVR3}      
`define MERCURY_CPOP_DBGBVR4           {3'b000, `MERCURY_CP15_REG_DBGBVR4}      
`define MERCURY_CPOP_DBGBVR5           {3'b000, `MERCURY_CP15_REG_DBGBVR5}      
`define MERCURY_CPOP_DBGBCR0           {3'b000, `MERCURY_CP15_REG_DBGBCR0}      
`define MERCURY_CPOP_DBGBCR1           {3'b000, `MERCURY_CP15_REG_DBGBCR1}      
`define MERCURY_CPOP_DBGBCR2           {3'b000, `MERCURY_CP15_REG_DBGBCR2}      
`define MERCURY_CPOP_DBGBCR3           {3'b000, `MERCURY_CP15_REG_DBGBCR3}      
`define MERCURY_CPOP_DBGBCR4           {3'b000, `MERCURY_CP15_REG_DBGBCR4}      
`define MERCURY_CPOP_DBGBCR5           {3'b000, `MERCURY_CP15_REG_DBGBCR5}      
`define MERCURY_CPOP_DBGBXVR4          {3'b000, `MERCURY_CP15_REG_DBGBXVR4}     
`define MERCURY_CPOP_DBGBXVR5          {3'b000, `MERCURY_CP15_REG_DBGBXVR5}     
`define MERCURY_CPOP_DBGWVR0           {3'b000, `MERCURY_CP15_REG_DBGWVR0}      
`define MERCURY_CPOP_DBGWVR1           {3'b000, `MERCURY_CP15_REG_DBGWVR1}      
`define MERCURY_CPOP_DBGWVR2           {3'b000, `MERCURY_CP15_REG_DBGWVR2}      
`define MERCURY_CPOP_DBGWVR3           {3'b000, `MERCURY_CP15_REG_DBGWVR3}      
`define MERCURY_CPOP_DBGWCR0           {3'b000, `MERCURY_CP15_REG_DBGWCR0}      
`define MERCURY_CPOP_DBGWCR1           {3'b000, `MERCURY_CP15_REG_DBGWCR1}      
`define MERCURY_CPOP_DBGWCR2           {3'b000, `MERCURY_CP15_REG_DBGWCR2}      
`define MERCURY_CPOP_DBGWCR3           {3'b000, `MERCURY_CP15_REG_DBGWCR3}      
`define MERCURY_CPOP_DBGVCR            {3'b000, `MERCURY_CP15_REG_DBGVCR}       

`define MERCURY_CPOP_ATS1C             9'b000001000  
`define MERCURY_CPOP_ATS12NSO          9'b000001001  
`define MERCURY_CPOP_ATS1H             9'b000001010  
`define MERCURY_CPOP_ATS1E01           9'b000001000
`define MERCURY_CPOP_ATS12E01          9'b000001001
`define MERCURY_CPOP_ATS1E2            9'b000001010
`define MERCURY_CPOP_ATS1E3            9'b000001011


`define MERCURY_CPOP_5_W                 5
`define MERCURY_CPOP_5_TLBIALL           5'b00000  
`define MERCURY_CPOP_5_TLBIALLIS         5'b01000  
`define MERCURY_CPOP_5_TLBIMVA           5'b00001  
`define MERCURY_CPOP_5_TLBIMVAIS         5'b01001  
`define MERCURY_CPOP_5_TLBIASID          5'b00010  
`define MERCURY_CPOP_5_TLBIASIDIS        5'b01010  
`define MERCURY_CPOP_5_TLBIMVAA          5'b00011  
`define MERCURY_CPOP_5_TLBIMVAAIS        5'b01011  
`define MERCURY_CPOP_5_TLBIMVAH          5'b00100  
`define MERCURY_CPOP_5_TLBIMVAHIS        5'b01100  
`define MERCURY_CPOP_5_TLBIALLH          5'b00101  
`define MERCURY_CPOP_5_TLBIALLHIS        5'b01101  
`define MERCURY_CPOP_5_TLBIALLNSNH       5'b00110  
`define MERCURY_CPOP_5_TLBIALLNSNHIS     5'b01110  
`define MERCURY_CPOP_5_TLBIMVAL          5'b00111  
`define MERCURY_CPOP_5_TLBIMVALIS        5'b01111  
`define MERCURY_CPOP_5_TLBIMVAAL         5'b10000  
`define MERCURY_CPOP_5_TLBIMVAALIS       5'b11000  
`define MERCURY_CPOP_5_TLBIMVALH         5'b10001  
`define MERCURY_CPOP_5_TLBIMVALHIS       5'b11001  
`define MERCURY_CPOP_5_TLBIIPAS2         5'b10010  
`define MERCURY_CPOP_5_TLBIIPAS2IS       5'b11010  
`define MERCURY_CPOP_5_TLBIIPAS2L        5'b10011  
`define MERCURY_CPOP_5_TLBIIPAS2LIS      5'b11011  

`define MERCURY_CPOP_8_W                 8
`define MERCURY_CPOP_8_TLBIALL           {3'b010, `MERCURY_CPOP_5_TLBIALL}
`define MERCURY_CPOP_8_TLBIALLIS         {3'b010, `MERCURY_CPOP_5_TLBIALLIS}
`define MERCURY_CPOP_8_TLBIMVA           {3'b010, `MERCURY_CPOP_5_TLBIMVA}
`define MERCURY_CPOP_8_TLBIMVAIS         {3'b010, `MERCURY_CPOP_5_TLBIMVAIS}
`define MERCURY_CPOP_8_TLBIASID          {3'b010, `MERCURY_CPOP_5_TLBIASID}
`define MERCURY_CPOP_8_TLBIASIDIS        {3'b010, `MERCURY_CPOP_5_TLBIASIDIS}
`define MERCURY_CPOP_8_TLBIMVAA          {3'b010, `MERCURY_CPOP_5_TLBIMVAA}
`define MERCURY_CPOP_8_TLBIMVAAIS        {3'b010, `MERCURY_CPOP_5_TLBIMVAAIS}
`define MERCURY_CPOP_8_TLBIMVAH          {3'b010, `MERCURY_CPOP_5_TLBIMVAH}
`define MERCURY_CPOP_8_TLBIMVAHIS        {3'b010, `MERCURY_CPOP_5_TLBIMVAHIS}
`define MERCURY_CPOP_8_TLBIALLH          {3'b010, `MERCURY_CPOP_5_TLBIALLH}
`define MERCURY_CPOP_8_TLBIALLHIS        {3'b010, `MERCURY_CPOP_5_TLBIALLHIS}
`define MERCURY_CPOP_8_TLBIALLNSNH       {3'b010, `MERCURY_CPOP_5_TLBIALLNSNH}
`define MERCURY_CPOP_8_TLBIALLNSNHIS     {3'b010, `MERCURY_CPOP_5_TLBIALLNSNHIS}
`define MERCURY_CPOP_8_TLBIMVAL          {3'b010, `MERCURY_CPOP_5_TLBIMVAL}
`define MERCURY_CPOP_8_TLBIMVALIS        {3'b010, `MERCURY_CPOP_5_TLBIMVALIS}
`define MERCURY_CPOP_8_TLBIMVAAL         {3'b010, `MERCURY_CPOP_5_TLBIMVAAL}
`define MERCURY_CPOP_8_TLBIMVAALIS       {3'b010, `MERCURY_CPOP_5_TLBIMVAALIS}
`define MERCURY_CPOP_8_TLBIMVALH         {3'b010, `MERCURY_CPOP_5_TLBIMVALH}
`define MERCURY_CPOP_8_TLBIMVALHIS       {3'b010, `MERCURY_CPOP_5_TLBIMVALHIS}
`define MERCURY_CPOP_8_TLBIIPAS2         {3'b010, `MERCURY_CPOP_5_TLBIIPAS2}
`define MERCURY_CPOP_8_TLBIIPAS2IS       {3'b010, `MERCURY_CPOP_5_TLBIIPAS2IS}
`define MERCURY_CPOP_8_TLBIIPAS2L        {3'b010, `MERCURY_CPOP_5_TLBIIPAS2L}
`define MERCURY_CPOP_8_TLBIIPAS2LIS      {3'b010, `MERCURY_CPOP_5_TLBIIPAS2LIS}

`define MERCURY_CPOP_TLBIALL           {1'b0, `MERCURY_CPOP_8_TLBIALL}
`define MERCURY_CPOP_TLBIALLIS         {1'b0, `MERCURY_CPOP_8_TLBIALLIS}
`define MERCURY_CPOP_TLBIMVA           {1'b0, `MERCURY_CPOP_8_TLBIMVA}
`define MERCURY_CPOP_TLBIMVAIS         {1'b0, `MERCURY_CPOP_8_TLBIMVAIS}
`define MERCURY_CPOP_TLBIASID          {1'b0, `MERCURY_CPOP_8_TLBIASID}
`define MERCURY_CPOP_TLBIASIDIS        {1'b0, `MERCURY_CPOP_8_TLBIASIDIS}
`define MERCURY_CPOP_TLBIMVAA          {1'b0, `MERCURY_CPOP_8_TLBIMVAA}
`define MERCURY_CPOP_TLBIMVAAIS        {1'b0, `MERCURY_CPOP_8_TLBIMVAAIS}
`define MERCURY_CPOP_TLBIMVAH          {1'b0, `MERCURY_CPOP_8_TLBIMVAH}
`define MERCURY_CPOP_TLBIMVAHIS        {1'b0, `MERCURY_CPOP_8_TLBIMVAHIS}
`define MERCURY_CPOP_TLBIALLH          {1'b0, `MERCURY_CPOP_8_TLBIALLH}
`define MERCURY_CPOP_TLBIALLHIS        {1'b0, `MERCURY_CPOP_8_TLBIALLHIS}
`define MERCURY_CPOP_TLBIALLNSNH       {1'b0, `MERCURY_CPOP_8_TLBIALLNSNH}
`define MERCURY_CPOP_TLBIALLNSNHIS     {1'b0, `MERCURY_CPOP_8_TLBIALLNSNHIS}
`define MERCURY_CPOP_TLBIMVAL          {1'b0, `MERCURY_CPOP_8_TLBIMVAL}
`define MERCURY_CPOP_TLBIMVALIS        {1'b0, `MERCURY_CPOP_8_TLBIMVALIS}
`define MERCURY_CPOP_TLBIMVAAL         {1'b0, `MERCURY_CPOP_8_TLBIMVAAL}
`define MERCURY_CPOP_TLBIMVAALIS       {1'b0, `MERCURY_CPOP_8_TLBIMVAALIS}
`define MERCURY_CPOP_TLBIMVALH         {1'b0, `MERCURY_CPOP_8_TLBIMVALH}
`define MERCURY_CPOP_TLBIMVALHIS       {1'b0, `MERCURY_CPOP_8_TLBIMVALHIS}
`define MERCURY_CPOP_TLBIIPAS2         {1'b0, `MERCURY_CPOP_8_TLBIIPAS2}
`define MERCURY_CPOP_TLBIIPAS2IS       {1'b0, `MERCURY_CPOP_8_TLBIIPAS2IS}
`define MERCURY_CPOP_TLBIIPAS2L        {1'b0, `MERCURY_CPOP_8_TLBIIPAS2L}
`define MERCURY_CPOP_TLBIIPAS2LIS      {1'b0, `MERCURY_CPOP_8_TLBIIPAS2LIS}


`define MERCURY_CPOP_5_TLBIVAE1          `MERCURY_CPOP_5_TLBIMVA        
`define MERCURY_CPOP_5_TLBIVAE1IS        `MERCURY_CPOP_5_TLBIMVAIS      
`define MERCURY_CPOP_5_TLBIVALE1         `MERCURY_CPOP_5_TLBIMVAL       
`define MERCURY_CPOP_5_TLBIVALE1IS       `MERCURY_CPOP_5_TLBIMVALIS     
`define MERCURY_CPOP_5_TLBIVAAE1         `MERCURY_CPOP_5_TLBIMVAA       
`define MERCURY_CPOP_5_TLBIVAAE1IS       `MERCURY_CPOP_5_TLBIMVAAIS     
`define MERCURY_CPOP_5_TLBIVAALE1        `MERCURY_CPOP_5_TLBIMVAAL      
`define MERCURY_CPOP_5_TLBIVAALE1IS      `MERCURY_CPOP_5_TLBIMVAALIS    
`define MERCURY_CPOP_5_TLBIIPAS2E1       `MERCURY_CPOP_5_TLBIIPAS2      
`define MERCURY_CPOP_5_TLBIIPAS2E1IS     `MERCURY_CPOP_5_TLBIIPAS2IS    
`define MERCURY_CPOP_5_TLBIIPAS2LE1      `MERCURY_CPOP_5_TLBIIPAS2L     
`define MERCURY_CPOP_5_TLBIIPAS2LE1IS    `MERCURY_CPOP_5_TLBIIPAS2LIS   
`define MERCURY_CPOP_5_TLBIVAE2          `MERCURY_CPOP_5_TLBIMVAH       
`define MERCURY_CPOP_5_TLBIVAE2IS        `MERCURY_CPOP_5_TLBIMVAHIS     
`define MERCURY_CPOP_5_TLBIVALE2         `MERCURY_CPOP_5_TLBIMVALH      
`define MERCURY_CPOP_5_TLBIVALE2IS       `MERCURY_CPOP_5_TLBIMVALHIS    
`define MERCURY_CPOP_5_TLBIVAE3          5'b10100
`define MERCURY_CPOP_5_TLBIVAE3IS        5'b11100
`define MERCURY_CPOP_5_TLBIVALE3         5'b10101
`define MERCURY_CPOP_5_TLBIVALE3IS       5'b11101
`define MERCURY_CPOP_5_TLBIASIDE1        `MERCURY_CPOP_5_TLBIASID       
`define MERCURY_CPOP_5_TLBIASIDE1IS      `MERCURY_CPOP_5_TLBIASIDIS     
`define MERCURY_CPOP_5_TLBIVMALLE1       `MERCURY_CPOP_5_TLBIALL        
`define MERCURY_CPOP_5_TLBIVMALLE1IS     `MERCURY_CPOP_5_TLBIALLIS      
`define MERCURY_CPOP_5_TLBIVMALLS12E1    5'b10110
`define MERCURY_CPOP_5_TLBIVMALLS12E1IS  5'b11110
`define MERCURY_CPOP_5_TLBIALLE1         `MERCURY_CPOP_5_TLBIALLNSNH    
`define MERCURY_CPOP_5_TLBIALLE1IS       `MERCURY_CPOP_5_TLBIALLNSNHIS  
`define MERCURY_CPOP_5_TLBIALLE2         `MERCURY_CPOP_5_TLBIALLH       
`define MERCURY_CPOP_5_TLBIALLE2IS       `MERCURY_CPOP_5_TLBIALLHIS     
`define MERCURY_CPOP_5_TLBIALLE3         5'b10111
`define MERCURY_CPOP_5_TLBIALLE3IS       5'b11111

`define MERCURY_CPOP_8_W                 8
`define MERCURY_CPOP_8_TLBIVAE1          {3'b011, `MERCURY_CPOP_5_TLBIVAE1}
`define MERCURY_CPOP_8_TLBIVAE1IS        {3'b011, `MERCURY_CPOP_5_TLBIVAE1IS}
`define MERCURY_CPOP_8_TLBIVALE1         {3'b011, `MERCURY_CPOP_5_TLBIVALE1}
`define MERCURY_CPOP_8_TLBIVALE1IS       {3'b011, `MERCURY_CPOP_5_TLBIVALE1IS}
`define MERCURY_CPOP_8_TLBIVAAE1         {3'b011, `MERCURY_CPOP_5_TLBIVAAE1}
`define MERCURY_CPOP_8_TLBIVAAE1IS       {3'b011, `MERCURY_CPOP_5_TLBIVAAE1IS}
`define MERCURY_CPOP_8_TLBIVAALE1        {3'b011, `MERCURY_CPOP_5_TLBIVAALE1}
`define MERCURY_CPOP_8_TLBIVAALE1IS      {3'b011, `MERCURY_CPOP_5_TLBIVAALE1IS}
`define MERCURY_CPOP_8_TLBIIPAS2E1       {3'b011, `MERCURY_CPOP_5_TLBIIPAS2E1}
`define MERCURY_CPOP_8_TLBIIPAS2E1IS     {3'b011, `MERCURY_CPOP_5_TLBIIPAS2E1IS}
`define MERCURY_CPOP_8_TLBIIPAS2LE1      {3'b011, `MERCURY_CPOP_5_TLBIIPAS2LE1}
`define MERCURY_CPOP_8_TLBIIPAS2LE1IS    {3'b011, `MERCURY_CPOP_5_TLBIIPAS2LE1IS}
`define MERCURY_CPOP_8_TLBIVAE2          {3'b011, `MERCURY_CPOP_5_TLBIVAE2}
`define MERCURY_CPOP_8_TLBIVAE2IS        {3'b011, `MERCURY_CPOP_5_TLBIVAE2IS}
`define MERCURY_CPOP_8_TLBIVALE2         {3'b011, `MERCURY_CPOP_5_TLBIVALE2}
`define MERCURY_CPOP_8_TLBIVALE2IS       {3'b011, `MERCURY_CPOP_5_TLBIVALE2IS}
`define MERCURY_CPOP_8_TLBIVAE3          {3'b011, `MERCURY_CPOP_5_TLBIVAE3}
`define MERCURY_CPOP_8_TLBIVAE3IS        {3'b011, `MERCURY_CPOP_5_TLBIVAE3IS}
`define MERCURY_CPOP_8_TLBIVALE3         {3'b011, `MERCURY_CPOP_5_TLBIVALE3}
`define MERCURY_CPOP_8_TLBIVALE3IS       {3'b011, `MERCURY_CPOP_5_TLBIVALE3IS}
`define MERCURY_CPOP_8_TLBIASIDE1        {3'b011, `MERCURY_CPOP_5_TLBIASIDE1}
`define MERCURY_CPOP_8_TLBIASIDE1IS      {3'b011, `MERCURY_CPOP_5_TLBIASIDE1IS}
`define MERCURY_CPOP_8_TLBIVMALLE1       {3'b011, `MERCURY_CPOP_5_TLBIVMALLE1}
`define MERCURY_CPOP_8_TLBIVMALLE1IS     {3'b011, `MERCURY_CPOP_5_TLBIVMALLE1IS}
`define MERCURY_CPOP_8_TLBIVMALLS12E1    {3'b011, `MERCURY_CPOP_5_TLBIVMALLS12E1}
`define MERCURY_CPOP_8_TLBIVMALLS12E1IS  {3'b011, `MERCURY_CPOP_5_TLBIVMALLS12E1IS}
`define MERCURY_CPOP_8_TLBIALLE1         {3'b011, `MERCURY_CPOP_5_TLBIALLE1}
`define MERCURY_CPOP_8_TLBIALLE1IS       {3'b011, `MERCURY_CPOP_5_TLBIALLE1IS}
`define MERCURY_CPOP_8_TLBIALLE2         {3'b011, `MERCURY_CPOP_5_TLBIALLE2}
`define MERCURY_CPOP_8_TLBIALLE2IS       {3'b011, `MERCURY_CPOP_5_TLBIALLE2IS}
`define MERCURY_CPOP_8_TLBIALLE3         {3'b011, `MERCURY_CPOP_5_TLBIALLE3}
`define MERCURY_CPOP_8_TLBIALLE3IS       {3'b011, `MERCURY_CPOP_5_TLBIALLE3IS}

`define MERCURY_CPOP_TLBIVAE1          {1'b0, `MERCURY_CPOP_8_TLBIVAE1}
`define MERCURY_CPOP_TLBIVAE1IS        {1'b0, `MERCURY_CPOP_8_TLBIVAE1IS}
`define MERCURY_CPOP_TLBIVALE1         {1'b0, `MERCURY_CPOP_8_TLBIVALE1}
`define MERCURY_CPOP_TLBIVALE1IS       {1'b0, `MERCURY_CPOP_8_TLBIVALE1IS}
`define MERCURY_CPOP_TLBIVAAE1         {1'b0, `MERCURY_CPOP_8_TLBIVAAE1}
`define MERCURY_CPOP_TLBIVAAE1IS       {1'b0, `MERCURY_CPOP_8_TLBIVAAE1IS}
`define MERCURY_CPOP_TLBIVAALE1        {1'b0, `MERCURY_CPOP_8_TLBIVAALE1}
`define MERCURY_CPOP_TLBIVAALE1IS      {1'b0, `MERCURY_CPOP_8_TLBIVAALE1IS}
`define MERCURY_CPOP_TLBIIPAS2E1       {1'b0, `MERCURY_CPOP_8_TLBIIPAS2E1}
`define MERCURY_CPOP_TLBIIPAS2E1IS     {1'b0, `MERCURY_CPOP_8_TLBIIPAS2E1IS}
`define MERCURY_CPOP_TLBIIPAS2LE1      {1'b0, `MERCURY_CPOP_8_TLBIIPAS2LE1}
`define MERCURY_CPOP_TLBIIPAS2LE1IS    {1'b0, `MERCURY_CPOP_8_TLBIIPAS2LE1IS}
`define MERCURY_CPOP_TLBIVAE2          {1'b0, `MERCURY_CPOP_8_TLBIVAE2}
`define MERCURY_CPOP_TLBIVAE2IS        {1'b0, `MERCURY_CPOP_8_TLBIVAE2IS}
`define MERCURY_CPOP_TLBIVALE2         {1'b0, `MERCURY_CPOP_8_TLBIVALE2}
`define MERCURY_CPOP_TLBIVALE2IS       {1'b0, `MERCURY_CPOP_8_TLBIVALE2IS}
`define MERCURY_CPOP_TLBIVAE3          {1'b0, `MERCURY_CPOP_8_TLBIVAE3}
`define MERCURY_CPOP_TLBIVAE3IS        {1'b0, `MERCURY_CPOP_8_TLBIVAE3IS}
`define MERCURY_CPOP_TLBIVALE3         {1'b0, `MERCURY_CPOP_8_TLBIVALE3}
`define MERCURY_CPOP_TLBIVALE3IS       {1'b0, `MERCURY_CPOP_8_TLBIVALE3IS}
`define MERCURY_CPOP_TLBIASIDE1        {1'b0, `MERCURY_CPOP_8_TLBIASIDE1}
`define MERCURY_CPOP_TLBIASIDE1IS      {1'b0, `MERCURY_CPOP_8_TLBIASIDE1IS}
`define MERCURY_CPOP_TLBIVMALLE1       {1'b0, `MERCURY_CPOP_8_TLBIVMALLE1}
`define MERCURY_CPOP_TLBIVMALLE1IS     {1'b0, `MERCURY_CPOP_8_TLBIVMALLE1IS}
`define MERCURY_CPOP_TLBIVMALLS12E1    {1'b0, `MERCURY_CPOP_8_TLBIVMALLS12E1}
`define MERCURY_CPOP_TLBIVMALLS12E1IS  {1'b0, `MERCURY_CPOP_8_TLBIVMALLS12E1IS}
`define MERCURY_CPOP_TLBIALLE1         {1'b0, `MERCURY_CPOP_8_TLBIALLE1}
`define MERCURY_CPOP_TLBIALLE1IS       {1'b0, `MERCURY_CPOP_8_TLBIALLE1IS}
`define MERCURY_CPOP_TLBIALLE2         {1'b0, `MERCURY_CPOP_8_TLBIALLE2}
`define MERCURY_CPOP_TLBIALLE2IS       {1'b0, `MERCURY_CPOP_8_TLBIALLE2IS}
`define MERCURY_CPOP_TLBIALLE3         {1'b0, `MERCURY_CPOP_8_TLBIALLE3}
`define MERCURY_CPOP_TLBIALLE3IS       {1'b0, `MERCURY_CPOP_8_TLBIALLE3IS}

`define MERCURY_CPOP_CLREX             9'b011000000  
`define MERCURY_CPOP_NOP               9'b011000011  

`define MERCURY_CPOP_8_ICIALLUIS       8'b11001100  
`define MERCURY_CPOP_8_ICIALLU         8'b11000100  
`define MERCURY_CPOP_8_ICIMVAU         8'b11001111  
`define MERCURY_CPOP_8_ICIVAU          `MERCURY_CPOP_8_ICIMVAU

`define MERCURY_CPOP_8_BPIALLIS        8'b11001010  
`define MERCURY_CPOP_8_BPIMVA          8'b11001011  

`define MERCURY_CPOP_8_DCIMVAC         8'b11011101  
`define MERCURY_CPOP_8_DCISW           8'b11011100  
`define MERCURY_CPOP_8_DCCMVAC         8'b11011011  
`define MERCURY_CPOP_8_DCCSW           8'b11011010  
`define MERCURY_CPOP_8_DCCMVAU         8'b11010011  
`define MERCURY_CPOP_8_DCCIMVAC        8'b11011111  
`define MERCURY_CPOP_8_DCCISW          8'b11011110  

`define MERCURY_CPOP_8_DMBNSHLD        8'b11101100  
`define MERCURY_CPOP_8_DMBISHLD        8'b11101101  
`define MERCURY_CPOP_8_DMBOSHLD        8'b11101110  
`define MERCURY_CPOP_8_DMBLD           8'b11101111  
`define MERCURY_CPOP_8_DSBNS           8'b11110100  
`define MERCURY_CPOP_8_DSBIS           8'b11110101  
`define MERCURY_CPOP_8_DSBOS           8'b11110110  
`define MERCURY_CPOP_8_DSBSY           8'b11110111  
`define MERCURY_CPOP_8_DMBNS           8'b11111100  
`define MERCURY_CPOP_8_DMBIS           8'b11111101  
`define MERCURY_CPOP_8_DMBOS           8'b11111110  
`define MERCURY_CPOP_8_DMBSY           8'b11111111  
`define MERCURY_CPOP_8_DMBNSST         8'b11111000  
`define MERCURY_CPOP_8_DMBISST         8'b11111001  
`define MERCURY_CPOP_8_DMBOSST         8'b11111010  
`define MERCURY_CPOP_8_DMBSYST         8'b11111011  

`define MERCURY_CPOP_ICIALLUIS         {1'b0, `MERCURY_CPOP_8_ICIALLUIS}
`define MERCURY_CPOP_ICIALLU           {1'b0, `MERCURY_CPOP_8_ICIALLU}
`define MERCURY_CPOP_ICIMVAU           {1'b0, `MERCURY_CPOP_8_ICIMVAU}
`define MERCURY_CPOP_ICIVAU            {1'b0, `MERCURY_CPOP_8_ICIVAU}

`define MERCURY_CPOP_BPIALLIS          {1'b0, `MERCURY_CPOP_8_BPIALLIS}
`define MERCURY_CPOP_BPIMVA            {1'b0, `MERCURY_CPOP_8_BPIMVA}

`define MERCURY_CPOP_DCIMVAC           {1'b0, `MERCURY_CPOP_8_DCIMVAC}
`define MERCURY_CPOP_DCISW             {1'b0, `MERCURY_CPOP_8_DCISW}
`define MERCURY_CPOP_DCCMVAC           {1'b0, `MERCURY_CPOP_8_DCCMVAC}
`define MERCURY_CPOP_DCCSW             {1'b0, `MERCURY_CPOP_8_DCCSW}
`define MERCURY_CPOP_DCCMVAU           {1'b0, `MERCURY_CPOP_8_DCCMVAU}
`define MERCURY_CPOP_DCCIMVAC          {1'b0, `MERCURY_CPOP_8_DCCIMVAC}
`define MERCURY_CPOP_DCCISW            {1'b0, `MERCURY_CPOP_8_DCCISW}

`define MERCURY_CPOP_DMBNSHLD          {1'b0, `MERCURY_CPOP_8_DMBNSHLD}
`define MERCURY_CPOP_DMBISHLD          {1'b0, `MERCURY_CPOP_8_DMBISHLD}
`define MERCURY_CPOP_DMBOSHLD          {1'b0, `MERCURY_CPOP_8_DMBOSHLD}
`define MERCURY_CPOP_DMBLD             {1'b0, `MERCURY_CPOP_8_DMBLD}
`define MERCURY_CPOP_DSBNS             {1'b0, `MERCURY_CPOP_8_DSBNS}
`define MERCURY_CPOP_DSBIS             {1'b0, `MERCURY_CPOP_8_DSBIS}
`define MERCURY_CPOP_DSBOS             {1'b0, `MERCURY_CPOP_8_DSBOS}
`define MERCURY_CPOP_DSBSY             {1'b0, `MERCURY_CPOP_8_DSBSY}
`define MERCURY_CPOP_DMBNS             {1'b0, `MERCURY_CPOP_8_DMBNS}
`define MERCURY_CPOP_DMBIS             {1'b0, `MERCURY_CPOP_8_DMBIS}
`define MERCURY_CPOP_DMBOS             {1'b0, `MERCURY_CPOP_8_DMBOS}
`define MERCURY_CPOP_DMBSY             {1'b0, `MERCURY_CPOP_8_DMBSY}
`define MERCURY_CPOP_DMBNSST           {1'b0, `MERCURY_CPOP_8_DMBNSST}
`define MERCURY_CPOP_DMBISST           {1'b0, `MERCURY_CPOP_8_DMBISST}
`define MERCURY_CPOP_DMBOSST           {1'b0, `MERCURY_CPOP_8_DMBOSST}
`define MERCURY_CPOP_DMBSYST           {1'b0, `MERCURY_CPOP_8_DMBSYST}

`define MERCURY_CPOP_CNTFRQ_EL0        9'b110100000
`define MERCURY_CPOP_CNTPCT_EL0        9'b110100001
`define MERCURY_CPOP_CNTKCTL_EL1       9'b110100010
`define MERCURY_CPOP_CNTP_TVAL_EL0     9'b110100011
`define MERCURY_CPOP_CNTP_CTL_EL0      9'b110100100
`define MERCURY_CPOP_CNTV_TVAL_EL0     9'b110100101
`define MERCURY_CPOP_CNTV_CTL_EL0      9'b110100110
`define MERCURY_CPOP_CNTVCT_EL0        9'b110100111
`define MERCURY_CPOP_CNTP_CVAL_EL0     9'b110101000
`define MERCURY_CPOP_CNTV_CVAL_EL0     9'b110101001
`define MERCURY_CPOP_CNTVOFF_EL2       9'b110101010
`define MERCURY_CPOP_CNTHCTL_EL2       9'b110101011
`define MERCURY_CPOP_CNTHP_TVAL_EL2    9'b110101100
`define MERCURY_CPOP_CNTHP_CTL_EL2     9'b110101101
`define MERCURY_CPOP_CNTHP_CVAL_EL2    9'b110101110
`define MERCURY_CPOP_CNTPS_CTL_EL1     9'b110101111
`define MERCURY_CPOP_CNTPS_CVAL_EL1    9'b110110000
`define MERCURY_CPOP_CNTPS_TVAL_EL1    9'b110110001

`define MERCURY_CPOP_L2_ACTLR          9'b110000000
`define MERCURY_CPOP_L2_ECTLR          9'b110000001
`define MERCURY_CPOP_L2_CTLR           9'b110000010
`define MERCURY_CPOP_L2_MEM_ERR_SR     9'b110000011

`define MERCURY_CPOP_GICC_IAR1_EL1     {2'b10, `MERCURY_GICCP_GICC_IAR1_EL1}
`define MERCURY_CPOP_GICC_IAR0_EL1     {2'b10, `MERCURY_GICCP_GICC_IAR0_EL1}
`define MERCURY_CPOP_GICC_EOIR1_EL1    {2'b10, `MERCURY_GICCP_GICC_EOIR1_EL1}
`define MERCURY_CPOP_GICC_EOIR0_EL1    {2'b10, `MERCURY_GICCP_GICC_EOIR0_EL1}
`define MERCURY_CPOP_GICC_HPPIR1_EL1   {2'b10, `MERCURY_GICCP_GICC_HPPIR1_EL1}
`define MERCURY_CPOP_GICC_HPPIR0_EL1   {2'b10, `MERCURY_GICCP_GICC_HPPIR0_EL1}
`define MERCURY_CPOP_GICC_BPR1_EL1     {2'b10, `MERCURY_GICCP_GICC_BPR1_EL1}
`define MERCURY_CPOP_GICC_BPR0_EL1     {2'b10, `MERCURY_GICCP_GICC_BPR0_EL1}
`define MERCURY_CPOP_GICC_DIR_EL1      {2'b10, `MERCURY_GICCP_GICC_DIR_EL1}
`define MERCURY_CPOP_GICC_PMR_EL1      {2'b10, `MERCURY_GICCP_GICC_PMR_EL1}
`define MERCURY_CPOP_GICC_RPR_EL1      {2'b10, `MERCURY_GICCP_GICC_RPR}
`define MERCURY_CPOP_GICC_AP0R0_EL1    {2'b10, `MERCURY_GICCP_GICC_AP0R0_EL1}
`define MERCURY_CPOP_GICC_AP1R0_EL1    {2'b10, `MERCURY_GICCP_GICC_AP1R0_EL1}
`define MERCURY_CPOP_GICC_IGRPEN0_EL1  {2'b10, `MERCURY_GICCP_GICC_IGRPEN0_EL1}
`define MERCURY_CPOP_GICC_IGRPEN1_EL1  {2'b10, `MERCURY_GICCP_GICC_IGRPEN1_EL1}
`define MERCURY_CPOP_GICC_IGRPEN1_EL3  {2'b10, `MERCURY_GICCP_GICC_IGRPEN1_EL3}
`define MERCURY_CPOP_GICC_SRE_EL1      {2'b10, `MERCURY_GICCP_GICC_SRE_EL1}
`define MERCURY_CPOP_GICC_SRE_EL2      {2'b10, `MERCURY_GICCP_GICC_SRE_EL2}
`define MERCURY_CPOP_GICC_SRE_EL3      {2'b10, `MERCURY_GICCP_GICC_SRE_EL3}
`define MERCURY_CPOP_GICC_CTLR_EL1     {2'b10, `MERCURY_GICCP_GICC_CTLR_EL1}
`define MERCURY_CPOP_GICC_CTLR_EL3     {2'b10, `MERCURY_GICCP_GICC_CTLR_EL3}
`define MERCURY_CPOP_GICC_SGI0R_EL1    {2'b10, `MERCURY_GICCP_GICC_SGI0R_EL1}
`define MERCURY_CPOP_GICC_SGI1R_EL1    {2'b10, `MERCURY_GICCP_GICC_SGI1R_EL1}
`define MERCURY_CPOP_GICC_ASGI1R_EL1   {2'b10, `MERCURY_GICCP_GICC_ASGI1R_EL1}
`define MERCURY_CPOP_GICV_IAR1         {2'b10, `MERCURY_GICCP_GICV_AIAR}
`define MERCURY_CPOP_GICV_IAR0         {2'b10, `MERCURY_GICCP_GICV_IAR}
`define MERCURY_CPOP_GICV_EOIR1        {2'b10, `MERCURY_GICCP_GICV_AEOIR}
`define MERCURY_CPOP_GICV_EOIR0        {2'b10, `MERCURY_GICCP_GICV_EOIR}
`define MERCURY_CPOP_GICV_HPPIR1       {2'b10, `MERCURY_GICCP_GICV_AHPPIR}
`define MERCURY_CPOP_GICV_HPPIR0       {2'b10, `MERCURY_GICCP_GICV_HPPIR}
`define MERCURY_CPOP_GICH_VMCR_BPR1    {2'b10, `MERCURY_GICCP_GICH_VMCR_BPR1}
`define MERCURY_CPOP_GICH_VMCR_BPR0    {2'b10, `MERCURY_GICCP_GICH_VMCR_BPR0}
`define MERCURY_CPOP_GICV_DIR          {2'b10, `MERCURY_GICCP_GICV_DIR}
`define MERCURY_CPOP_GICH_VMCR_PMR     {2'b10, `MERCURY_GICCP_GICH_VMCR_PMR}
`define MERCURY_CPOP_GICV_RPR          {2'b10, `MERCURY_GICCP_GICV_RPR}
`define MERCURY_CPOP_GICH_AP0R0        {2'b10, `MERCURY_GICCP_GICH_APR0}
`define MERCURY_CPOP_GICH_AP1R0        {2'b10, `MERCURY_GICCP_GICH_APR1}
`define MERCURY_CPOP_GICH_VMCR_VENG0   {2'b10, `MERCURY_GICCP_GICH_VMCR_VENG0}
`define MERCURY_CPOP_GICH_VMCR_VENG1   {2'b10, `MERCURY_GICCP_GICH_VMCR_VENG1}
`define MERCURY_CPOP_GICH_HCR_SRE      {2'b10, `MERCURY_GICCP_GICH_HCR_SRE}
`define MERCURY_CPOP_GICV_CTLR         {2'b10, `MERCURY_GICCP_GICV_CTLR}
`define MERCURY_CPOP_GICH_HCR          {2'b10, `MERCURY_GICCP_GICH_HCR}
`define MERCURY_CPOP_GICH_VTR          {2'b10, `MERCURY_GICCP_GICH_VTR}
`define MERCURY_CPOP_GICH_VMCR         {2'b10, `MERCURY_GICCP_GICH_VMCR}
`define MERCURY_CPOP_GICH_MISR         {2'b10, `MERCURY_GICCP_GICH_MISR}
`define MERCURY_CPOP_GICH_EISR         {2'b10, `MERCURY_GICCP_GICH_EISR}
`define MERCURY_CPOP_GICH_ELSR         {2'b10, `MERCURY_GICCP_GICH_ELSR}
`define MERCURY_CPOP_GICH_LR0          {2'b10, `MERCURY_GICCP_GICH_LR0}
`define MERCURY_CPOP_GICH_LR0_L        {2'b10, `MERCURY_GICCP_GICH_LR0_L}
`define MERCURY_CPOP_GICH_LR0_H        {2'b10, `MERCURY_GICCP_GICH_LR0_H}
`define MERCURY_CPOP_GICH_LR1          {2'b10, `MERCURY_GICCP_GICH_LR1}
`define MERCURY_CPOP_GICH_LR1_L        {2'b10, `MERCURY_GICCP_GICH_LR1_L}
`define MERCURY_CPOP_GICH_LR1_H        {2'b10, `MERCURY_GICCP_GICH_LR1_H}
`define MERCURY_CPOP_GICH_LR2          {2'b10, `MERCURY_GICCP_GICH_LR2}
`define MERCURY_CPOP_GICH_LR2_L        {2'b10, `MERCURY_GICCP_GICH_LR2_L}
`define MERCURY_CPOP_GICH_LR2_H        {2'b10, `MERCURY_GICCP_GICH_LR2_H}
`define MERCURY_CPOP_GICH_LR3          {2'b10, `MERCURY_GICCP_GICH_LR3}
`define MERCURY_CPOP_GICH_LR3_L        {2'b10, `MERCURY_GICCP_GICH_LR3_L}
`define MERCURY_CPOP_GICH_LR3_H        {2'b10, `MERCURY_GICCP_GICH_LR3_H}


`define MERCURY_CPOP_8_SYNC            8'b11000010   
`define MERCURY_CPOP_8_CLEANUNIQUE     8'b00110001   
`define MERCURY_CPOP_8_WRITE           8'b00110010   


`define MERCURY_SIZE_BYTE  2'b00
`define MERCURY_SIZE_HWORD 2'b01
`define MERCURY_SIZE_WORD  2'b10
`define MERCURY_SIZE_DWORD 2'b11


`define MERCURY_IDATA_RAM_W  ((CPU_CACHE_PROTECTION > 0) ? 38:36)
`define MERCURY_IDATA_WEN_W  2
`define MERCURY_IDATA_STRB_W ((CPU_CACHE_PROTECTION > 0) ? 19:18)
`define MERCURY_ITAG_RAM_W   ((CPU_CACHE_PROTECTION > 0) ? 32:31)
`define MERCURY_ITAG_DATA_W  31                                    

`define MERCURY_DDATA_RAM_W  ((CPU_CACHE_PROTECTION > 0) ? 39:32)
`define MERCURY_DDATA_WEN_W  4
`define MERCURY_DTAG_RAM_W   ((CPU_CACHE_PROTECTION > 0) ? 33:32)
`define MERCURY_DDIRTY_RAM_W ((CPU_CACHE_PROTECTION > 0) ? 10:6)

`define MERCURY_TLB_RAM_ADDR_W   9
`define MERCURY_TLB_RAM_W    ((CPU_CACHE_PROTECTION > 0) ? 116:113)


`define MERCURY_MBIST0_DATA_W ((CPU_CACHE_PROTECTION > 0) ? 116:113) 
`define MERCURY_MBIST1_DATA_W ((SCU_CACHE_PROTECTION > 0) ? 144:128)
`define MERCURY_MBIST0_ADDR_W 14
`define MERCURY_MBIST1_ADDR_W 16
`define MERCURY_MBIST0_RAMARRAY_W 6
`define MERCURY_MBIST0_BE_W 10
`define MERCURY_MBIST1_BE_W 2


`define MERCURY_GIC_ID_W     16  
`define MERCURY_GIC_PRI_W    5   


`define MERCURY_RVBARADDR_W    38  
`define MERCURY_PADDRDBG_W     10  
`define MERCURY_PWDATADBG_W    32  
`define MERCURY_PRDATADBG_W    32  
`define MERCURY_ATREADYM_W     1   
`define MERCURY_AFVALIDM_W     1   
`define MERCURY_ATDATAM_W      32  
`define MERCURY_ATVALIDM_W     1   
`define MERCURY_ATBYTESM_W     2   
`define MERCURY_AFREADYM_W     1   
`define MERCURY_ATIDM_W        7   
`define MERCURY_SYNCREQM_W     1   
`define MERCURY_PMUEVNT_W      30  
`define MERCURY_PMUEVNT_CPU_W  26  
`define MERCURY_CTICH_W        4   
`define MERCURY_ARACTIVE_W     1   
`define MERCURY_ARVALID_W      1   
`define MERCURY_ARID_W         5   
`define MERCURY_ARTYPE_W       5   
`define MERCURY_ARATTRS_W      8   
`define MERCURY_ARWAY_W        5   
`define MERCURY_ARADDR_W       41  
`define MERCURY_ARWRAP_W       1   
`define MERCURY_ARLEN_W        2   
`define MERCURY_ARSIZE_W       3   
`define MERCURY_ARLOCK_W       1   
`define MERCURY_ARPRIV_W       1   
`define MERCURY_DRCREDIT_W     1   
`define MERCURY_DWVALID_W      1   
`define MERCURY_DWL2DB_W       4   
`define MERCURY_DWCHUNKS_W     4   
`define MERCURY_DWLAST_W       1   
`define MERCURY_DWSTRB_W       32  
`define MERCURY_DWDATA_W       256 
`define MERCURY_DWERR_W        1   
`define MERCURY_DWFATAL_W      1   
`define MERCURY_ACREADY_W      1   
`define MERCURY_CRVALID_W      1   
`define MERCURY_CRID_W         3   
`define MERCURY_CRDIRTY_W      1   
`define MERCURY_CRHIT_W        1   
`define MERCURY_CRAGE_W        1   
`define MERCURY_CRALLOC_W      1   
`define MERCURY_CRMIG_W        1   
`define MERCURY_CRVADDR_W      30  
`define MERCURY_INV_ALL_W      1   
`define MERCURY_DVM_COMP_W     1   
`define MERCURY_REQBUFS_BUSY_W 8   
`define MERCURY_DRAIN_STB_W    1   
`define MERCURY_ARCREDIT_W     1   
`define MERCURY_ARBLOCK_W      1   
`define MERCURY_DRVALID_W      1   
`define MERCURY_DRID_W         5   
`define MERCURY_DRRESP_W       6   
`define MERCURY_DRCHUNK_W      2   
`define MERCURY_DRDATA_W       128 
`define MERCURY_RRVALID_W      1   
`define MERCURY_RRID_W         5   
`define MERCURY_RRRESP_W       2   
`define MERCURY_RRL2DB_W       4   
`define MERCURY_EVDONE_W       8   
`define MERCURY_DBEXCLVAL_W    1   
`define MERCURY_DBEXCLRSP_W    2   
`define MERCURY_DBDECERR_W     1   
`define MERCURY_DBSLVERR_W     1   
`define MERCURY_LEAVERAM_W     1   
`define MERCURY_CPUBISTEN_W    1   
`define MERCURY_CPUSEV_W       1   
`define MERCURY_ACVALID_W      1   
`define MERCURY_ACID_W         3   
`define MERCURY_ACL2DB_W       4   
`define MERCURY_ACSNOOP_W      4   
`define MERCURY_ACADDR_W       41  
`define MERCURY_ACWAY_W        4   
`define MERCURY_ETMEXT_W       4   
`define MERCURY_L1DC_SIZE_W    3   
`define MERCURY_EXCP_LEV_W     2   
`define MERCURY_CPDATA_W       64  
`define MERCURY_CPADDR_W       18  
`define MERCURY_CPSEL_W        3   
`define MERCURY_TDATA_W        16  
`define MERCURY_RET_CTL_W      3   
`define MERCURY_GOV_CPDATA_W   64  
`define MERCURY_GOV_CPADDR_W   9   

`define MERCURY_RVBARADDR_PKDED_W    (`MERCURY_RVBARADDR_W    * NUM_CPUS)
`define MERCURY_PADDRDBG_PKDED_W     (`MERCURY_PADDRDBG_W     * NUM_CPUS)
`define MERCURY_PWDATADBG_PKDED_W    (`MERCURY_PWDATADBG_W    * NUM_CPUS)
`define MERCURY_PRDATADBG_PKDED_W    (`MERCURY_PRDATADBG_W    * NUM_CPUS)
`define MERCURY_ATREADYM_PKDED_W     (`MERCURY_ATREADYM_W     * NUM_CPUS)
`define MERCURY_AFVALIDM_PKDED_W     (`MERCURY_AFVALIDM_W     * NUM_CPUS)
`define MERCURY_ATDATAM_PKDED_W      (`MERCURY_ATDATAM_W      * NUM_CPUS)
`define MERCURY_ATVALIDM_PKDED_W     (`MERCURY_ATVALIDM_W     * NUM_CPUS)
`define MERCURY_ATBYTESM_PKDED_W     (`MERCURY_ATBYTESM_W     * NUM_CPUS)
`define MERCURY_AFREADYM_PKDED_W     (`MERCURY_AFREADYM_W     * NUM_CPUS)
`define MERCURY_ATIDM_PKDED_W        (`MERCURY_ATIDM_W        * NUM_CPUS)
`define MERCURY_SYNCREQM_PKDED_W     (`MERCURY_SYNCREQM_W     * NUM_CPUS)
`define MERCURY_PMUEVNT_PKDED_W      (`MERCURY_PMUEVNT_W      * NUM_CPUS)
`define MERCURY_PMUEVNT_CPU_PKDED_W  (`MERCURY_PMUEVNT_CPU_W  * NUM_CPUS)
`define MERCURY_CTICH_PKDED_W        (`MERCURY_CTICH_W        * NUM_CPUS)
`define MERCURY_ARACTIVE_PKDED_W     (`MERCURY_ARACTIVE_W     * NUM_CPUS)
`define MERCURY_ARVALID_PKDED_W      (`MERCURY_ARVALID_W      * NUM_CPUS)
`define MERCURY_ARID_PKDED_W         (`MERCURY_ARID_W         * NUM_CPUS)
`define MERCURY_ARTYPE_PKDED_W       (`MERCURY_ARTYPE_W       * NUM_CPUS)
`define MERCURY_ARATTRS_PKDED_W      (`MERCURY_ARATTRS_W      * NUM_CPUS)
`define MERCURY_ARWAY_PKDED_W        (`MERCURY_ARWAY_W        * NUM_CPUS)
`define MERCURY_ARADDR_PKDED_W       (`MERCURY_ARADDR_W       * NUM_CPUS)
`define MERCURY_ARWRAP_PKDED_W       (`MERCURY_ARWRAP_W       * NUM_CPUS)
`define MERCURY_ARLEN_PKDED_W        (`MERCURY_ARLEN_W        * NUM_CPUS)
`define MERCURY_ARSIZE_PKDED_W       (`MERCURY_ARSIZE_W       * NUM_CPUS)
`define MERCURY_ARLOCK_PKDED_W       (`MERCURY_ARLOCK_W       * NUM_CPUS)
`define MERCURY_ARPRIV_PKDED_W       (`MERCURY_ARPRIV_W       * NUM_CPUS)
`define MERCURY_DRCREDIT_PKDED_W     (`MERCURY_DRCREDIT_W     * NUM_CPUS)
`define MERCURY_DWVALID_PKDED_W      (`MERCURY_DWVALID_W      * NUM_CPUS)
`define MERCURY_DWL2DB_PKDED_W       (`MERCURY_DWL2DB_W       * NUM_CPUS)
`define MERCURY_DWCHUNKS_PKDED_W     (`MERCURY_DWCHUNKS_W     * NUM_CPUS)
`define MERCURY_DWLAST_PKDED_W       (`MERCURY_DWLAST_W       * NUM_CPUS)
`define MERCURY_DWSTRB_PKDED_W       (`MERCURY_DWSTRB_W       * NUM_CPUS)
`define MERCURY_DWDATA_PKDED_W       (`MERCURY_DWDATA_W       * NUM_CPUS)
`define MERCURY_DWERR_PKDED_W        (`MERCURY_DWERR_W        * NUM_CPUS)
`define MERCURY_DWFATAL_PKDED_W      (`MERCURY_DWFATAL_W      * NUM_CPUS)
`define MERCURY_ACREADY_PKDED_W      (`MERCURY_ACREADY_W      * NUM_CPUS)
`define MERCURY_CRVALID_PKDED_W      (`MERCURY_CRVALID_W      * NUM_CPUS)
`define MERCURY_CRID_PKDED_W         (`MERCURY_CRID_W         * NUM_CPUS)
`define MERCURY_CRDIRTY_PKDED_W      (`MERCURY_CRDIRTY_W      * NUM_CPUS)
`define MERCURY_CRHIT_PKDED_W        (`MERCURY_CRHIT_W        * NUM_CPUS)
`define MERCURY_CRAGE_PKDED_W        (`MERCURY_CRAGE_W        * NUM_CPUS)
`define MERCURY_CRALLOC_PKDED_W      (`MERCURY_CRALLOC_W      * NUM_CPUS)
`define MERCURY_CRMIG_PKDED_W        (`MERCURY_CRMIG_W        * NUM_CPUS)
`define MERCURY_CRVADDR_PKDED_W      (`MERCURY_CRVADDR_W      * NUM_CPUS)
`define MERCURY_INV_ALL_PKDED_W      (`MERCURY_INV_ALL_W      * NUM_CPUS)
`define MERCURY_DVM_COMP_PKDED_W     (`MERCURY_DVM_COMP_W     * NUM_CPUS)
`define MERCURY_REQBUFS_BUSY_PKDED_W (`MERCURY_REQBUFS_BUSY_W * NUM_CPUS)
`define MERCURY_DRAIN_STB_PKDED_W    (`MERCURY_DRAIN_STB_W    * NUM_CPUS)
`define MERCURY_ARCREDIT_PKDED_W     (`MERCURY_ARCREDIT_W     * NUM_CPUS)
`define MERCURY_ARBLOCK_PKDED_W      (`MERCURY_ARBLOCK_W      * NUM_CPUS)
`define MERCURY_DRVALID_PKDED_W      (`MERCURY_DRVALID_W      * NUM_CPUS)
`define MERCURY_DRID_PKDED_W         (`MERCURY_DRID_W         * NUM_CPUS)
`define MERCURY_DRRESP_PKDED_W       (`MERCURY_DRRESP_W       * NUM_CPUS)
`define MERCURY_DRCHUNK_PKDED_W      (`MERCURY_DRCHUNK_W      * NUM_CPUS)
`define MERCURY_DRDATA_PKDED_W       (`MERCURY_DRDATA_W       * NUM_CPUS)
`define MERCURY_RRVALID_PKDED_W      (`MERCURY_RRVALID_W      * NUM_CPUS)
`define MERCURY_RRID_PKDED_W         (`MERCURY_RRID_W         * NUM_CPUS)
`define MERCURY_RRRESP_PKDED_W       (`MERCURY_RRRESP_W       * NUM_CPUS)
`define MERCURY_RRL2DB_PKDED_W       (`MERCURY_RRL2DB_W       * NUM_CPUS)
`define MERCURY_EVDONE_PKDED_W       (`MERCURY_EVDONE_W       * NUM_CPUS)
`define MERCURY_DBEXCLVAL_PKDED_W    (`MERCURY_DBEXCLVAL_W    * NUM_CPUS)
`define MERCURY_DBEXCLRSP_PKDED_W    (`MERCURY_DBEXCLRSP_W    * NUM_CPUS)
`define MERCURY_DBDECERR_PKDED_W     (`MERCURY_DBDECERR_W     * NUM_CPUS)
`define MERCURY_DBSLVERR_PKDED_W     (`MERCURY_DBSLVERR_W     * NUM_CPUS)
`define MERCURY_LEAVERAM_PKDED_W     (`MERCURY_LEAVERAM_W     * NUM_CPUS)
`define MERCURY_CPUBISTEN_PKDED_W    (`MERCURY_CPUBISTEN_W    * NUM_CPUS)
`define MERCURY_CPUSEV_PKDED_W       (`MERCURY_CPUSEV_W       * NUM_CPUS)
`define MERCURY_ACVALID_PKDED_W      (`MERCURY_ACVALID_W      * NUM_CPUS)
`define MERCURY_ACID_PKDED_W         (`MERCURY_ACID_W         * NUM_CPUS)
`define MERCURY_ACL2DB_PKDED_W       (`MERCURY_ACL2DB_W       * NUM_CPUS)
`define MERCURY_ACSNOOP_PKDED_W      (`MERCURY_ACSNOOP_W      * NUM_CPUS)
`define MERCURY_ACADDR_PKDED_W       (`MERCURY_ACADDR_W       * NUM_CPUS)
`define MERCURY_ACWAY_PKDED_W        (`MERCURY_ACWAY_W        * NUM_CPUS)
`define MERCURY_ETMEXT_PKDED_W       (`MERCURY_ETMEXT_W       * NUM_CPUS)
`define MERCURY_EXCP_LEV_PKDED_W     (`MERCURY_EXCP_LEV_W     * NUM_CPUS)
`define MERCURY_CPDATA_PKDED_W       (`MERCURY_CPDATA_W       * NUM_CPUS)
`define MERCURY_CPADDR_PKDED_W       (`MERCURY_CPADDR_W       * NUM_CPUS)
`define MERCURY_CPSEL_PKDED_W        (`MERCURY_CPSEL_W        * NUM_CPUS)
`define MERCURY_TDATA_PKDED_W        (`MERCURY_TDATA_W        * NUM_CPUS)
`define MERCURY_RET_CTL_PKDED_W      (`MERCURY_RET_CTL_W      * NUM_CPUS)
`define MERCURY_GOV_CPDATA_PKDED_W   (`MERCURY_GOV_CPDATA_W   * NUM_CPUS)
`define MERCURY_GOV_CPADDR_PKDED_W   (`MERCURY_GOV_CPADDR_W   * NUM_CPUS)


`define MERCURY_SIZE_8K  3'b000 
`define MERCURY_SIZE_16K 3'b001 
`define MERCURY_SIZE_32K 3'b011 
`define MERCURY_SIZE_64K 3'b111 


`define MERCURY_MAX_NUM_CPUS 4


`define MERCURY_RESP_OKAY   2'b00
`define MERCURY_RESP_EXOKAY 2'b01
`define MERCURY_RESP_SLVERR 2'b10
`define MERCURY_RESP_DECERR 2'b11


`define MERCURY_EL0 2'b00
`define MERCURY_EL1 2'b01
`define MERCURY_EL2 2'b10
`define MERCURY_EL3 2'b11

`define MERCURY_ONE_HOT_EL0 4'b0001
`define MERCURY_ONE_HOT_EL1 4'b0010
`define MERCURY_ONE_HOT_EL2 4'b0100
`define MERCURY_ONE_HOT_EL3 4'b1000

`define MERCURY_MODE_USR    4'b0000
`define MERCURY_MODE_FIQ    4'b0001
`define MERCURY_MODE_IRQ    4'b0010
`define MERCURY_MODE_SVC    4'b0011
`define MERCURY_MODE_ABT    4'b0111
`define MERCURY_MODE_UND    4'b1011
`define MERCURY_MODE_SYS    4'b1111
`define MERCURY_MODE_MON    4'b0110
`define MERCURY_MODE_HYP    4'b1010
`define MERCURY_MODE_NONUSE 4'b0100, 4'b0101, 4'b1000, 4'b1001, 4'b1100, 4'b1101, 4'b1110

`define MERCURY_FULL_MODE_USR    5'b10000
`define MERCURY_FULL_MODE_FIQ    5'b10001
`define MERCURY_FULL_MODE_IRQ    5'b10010
`define MERCURY_FULL_MODE_SVC    5'b10011
`define MERCURY_FULL_MODE_ABT    5'b10111
`define MERCURY_FULL_MODE_UND    5'b11011
`define MERCURY_FULL_MODE_SYS    5'b11111
`define MERCURY_FULL_MODE_MON    5'b10110
`define MERCURY_FULL_MODE_HYP    5'b11010

`define MERCURY_FULL_MODE_EL0T   5'b00000
`define MERCURY_FULL_MODE_EL1T   5'b00100
`define MERCURY_FULL_MODE_EL1H   5'b00101
`define MERCURY_FULL_MODE_EL2T   5'b01000
`define MERCURY_FULL_MODE_EL2H   5'b01001
`define MERCURY_FULL_MODE_EL3T   5'b01100
`define MERCURY_FULL_MODE_EL3H   5'b01101

`define MERCURY_FULL_MODE_NONUSE 5'b00001, 5'b00010, 5'b00011, 5'b00110, \
                              5'b00111, 5'b01010, 5'b01011, 5'b01110, \
                              5'b01111, 5'b10100, 5'b10101, 5'b11000, \
                              5'b11001, 5'b11100, 5'b11101, 5'b11110

`define MERCURY_ONEHOT_MODE_USR_SYS 12'b0000_0000_0001
`define MERCURY_ONEHOT_MODE_FIQ     12'b0000_0000_0010
`define MERCURY_ONEHOT_MODE_IRQ     12'b0000_0000_0100
`define MERCURY_ONEHOT_MODE_SVC     12'b0000_0000_1000
`define MERCURY_ONEHOT_MODE_ABT     12'b0000_0001_0000
`define MERCURY_ONEHOT_MODE_UND     12'b0000_0010_0000
`define MERCURY_ONEHOT_MODE_MON     12'b0000_0100_0000
`define MERCURY_ONEHOT_MODE_HYP     12'b0000_1000_0000
`define MERCURY_ONEHOT_MODE_ELXT    12'b0001_0000_0000
`define MERCURY_ONEHOT_MODE_EL1H    12'b0010_0000_0000
`define MERCURY_ONEHOT_MODE_EL2H    12'b0100_0000_0000
`define MERCURY_ONEHOT_MODE_EL3H    12'b1000_0000_0000

`define MERCURY_ONEHOT_MODE_USR_SYS_BIT 0
`define MERCURY_ONEHOT_MODE_FIQ_BIT     1
`define MERCURY_ONEHOT_MODE_IRQ_BIT     2
`define MERCURY_ONEHOT_MODE_SVC_BIT     3
`define MERCURY_ONEHOT_MODE_ABT_BIT     4
`define MERCURY_ONEHOT_MODE_UND_BIT     5
`define MERCURY_ONEHOT_MODE_MON_BIT     6
`define MERCURY_ONEHOT_MODE_HYP_BIT     7
`define MERCURY_ONEHOT_MODE_ELXT_BIT    8
`define MERCURY_ONEHOT_MODE_EL1H_BIT    9
`define MERCURY_ONEHOT_MODE_EL2H_BIT    10
`define MERCURY_ONEHOT_MODE_EL3H_BIT    11


`define MERCURY_LOG2(a) (((a)<=2)     ? 1  : \
                      ((a)<=4)     ? 2  : \
                      ((a)<=8)     ? 3  : \
                      ((a)<=16)    ? 4  : \
                      ((a)<=32)    ? 5  : \
                      ((a)<=64)    ? 6  : \
                      ((a)<=128)   ? 7  : \
                      ((a)<=256)   ? 8  : \
                      ((a)<=512)   ? 9  : \
                      ((a)<=1024)  ? 10 : \
                      ((a)<=2048)  ? 11 : \
                      ((a)<=4096)  ? 12 : \
                      ((a)<=8192)  ? 13 : \
                      ((a)<=16384) ? 14 : \
                      ((a)<=32768) ? 15 : \
                      ((a)<=65536) ? 16 : \
                      ((a)<=131072)? 17 : \
                                     -1)

`define MERCURY_NORAM_PARAM_DECL #(parameter L2_CACHE             = 1'b0, \
                                parameter NEON_FP              = 1'b0, \
                                parameter CRYPTO               = 1'b0, \
                                parameter CPU_CACHE_PROTECTION = 1'b0, \
                                parameter MINISCU              = 1'b0, \
                                parameter ETM                  = 1'b1, \
                                parameter ALL_LINES_UNIQUE     = 1'b0, \
                                parameter L1_ICACHE_SIZE       = 3'b011,\
                                parameter L1_DCACHE_SIZE       = 3'b011)

`define MERCURY_NORAM_PARAM_INST #(.L2_CACHE             (L2_CACHE), \
                                .NEON_FP              (NEON_FP), \
                                .CRYPTO               (CRYPTO), \
                                .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                                .MINISCU              (MINISCU), \
                                .ETM                  (ETM), \
                                .ALL_LINES_UNIQUE     (ALL_LINES_UNIQUE), \
                                .L1_ICACHE_SIZE       (L1_ICACHE_SIZE),\
                                .L1_DCACHE_SIZE       (L1_DCACHE_SIZE))

`define MERCURY_CPU_PARAM_DECL #(parameter MINISCU              = 1'b0,    \
                              parameter L2_CACHE             = 1'b0,    \
                              parameter NEON_FP              = 1'b0,    \
                              parameter CRYPTO               = 1'b0,    \
                              parameter CPU_CACHE_PROTECTION = 1'b0,    \
                              parameter L1_ICACHE_SIZE       = 3'b011,  \
                              parameter L1_DCACHE_SIZE       = 3'b011,  \
                              parameter ETM                  = 1'b1,    \
                              parameter ALL_LINES_UNIQUE     = 1'b0)

`define MERCURY_CPU_PARAM_INST #(.MINISCU              (MINISCU),              \
                              .L2_CACHE             (L2_CACHE),             \
                              .NEON_FP              (NEON_FP[cpu]),         \
                              .CRYPTO               (CRYPTO[cpu]),          \
                              .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                              .L1_ICACHE_SIZE       (L1_ICACHE_SIZE),       \
                              .L1_DCACHE_SIZE       (L1_DCACHE_SIZE),       \
                              .ETM                  (ETM),                  \
                              .ALL_LINES_UNIQUE     (ALL_LINES_UNIQUE))

`define MERCURY_BIU_PARAM_DECL #(parameter CPU_CACHE_PROTECTION = 1'b0, \
                              parameter MINISCU = 1'b0, \
                              parameter ALL_LINES_UNIQUE = 1'b0)

`define MERCURY_BIU_PARAM_INST #(.CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                              .MINISCU(MINISCU),\
                              .ALL_LINES_UNIQUE (ALL_LINES_UNIQUE))

`define MERCURY_DPU_PARAM_DECL #(parameter CPU_CACHE_PROTECTION = 1'b0, \
                              parameter L2_CACHE = 1'b0, \
                              parameter NEON_FP  = 1'b0, \
                              parameter CRYPTO   = 1'b0, \
                              parameter ETM      = 1'b1)
`define MERCURY_DPU_PARAM_INST #(.CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                              .L2_CACHE(L2_CACHE), \
                              .NEON_FP (NEON_FP),  \
                              .CRYPTO  (CRYPTO),   \
                              .ETM     (ETM))

`define MERCURY_DCU_PARAM_DECL #(parameter L2_CACHE             = 1'b0,   \
                              parameter L1_DCACHE_SIZE       = 3'b011, \
                              parameter CPU_CACHE_PROTECTION = 1'b0,   \
                              parameter MINISCU              = 1'b0,   \
                              parameter ALL_LINES_UNIQUE     = 1'b0)
`define MERCURY_DCU_PARAM_INST #(.L2_CACHE             (L2_CACHE),             \
                              .L1_DCACHE_SIZE       (L1_DCACHE_SIZE),       \
                              .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                              .MINISCU              (MINISCU),              \
                              .ALL_LINES_UNIQUE     (ALL_LINES_UNIQUE))

`define MERCURY_TLB_PARAM_DECL #(parameter CPU_CACHE_PROTECTION = 1'b0)
`define MERCURY_TLB_PARAM_INST #(.CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION))

`define MERCURY_IFU_PARAM_DECL #(parameter CPU_CACHE_PROTECTION = 1'b0, \
                              parameter L1_ICACHE_SIZE       = 3'b011)
`define MERCURY_IFU_PARAM_INST #(.CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                              .L1_ICACHE_SIZE       (L1_ICACHE_SIZE))

`define MERCURY_MINISCU_PARAM_DECL #(parameter CPU_CACHE_PROTECTION = 1'b0)
`define MERCURY_MINISCU_PARAM_INST #(.CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION))

`define MERCURY_SCU_PARAM_DECL #(parameter NUM_CPUS             = 4,    \
                              parameter L2_CACHE             = 1'b0, \
                              parameter L1_DCACHE_SIZE       = 3'b0, \
                              parameter L2_CACHE_SIZE        = 4'b0, \
                              parameter SCU_CACHE_PROTECTION = 1'b0, \
                              parameter CPU_CACHE_PROTECTION = 1'b0, \
                              parameter L2_INPUT_LATENCY     = 1'b0, \
                              parameter L2_OUTPUT_LATENCY    = 1'b0, \
                              parameter AXI4                 = 1'b0, \
                              parameter ACE                  = 1'b1, \
                              parameter ACP                  = 1'b0)
`define MERCURY_SCU_PARAM_INST #(.NUM_CPUS             (NUM_CPUS),             \
                              .L2_CACHE             (L2_CACHE),             \
                              .L1_DCACHE_SIZE       (L1_DCACHE_SIZE),       \
                              .L2_CACHE_SIZE        (L2_CACHE_SIZE),        \
                              .SCU_CACHE_PROTECTION (SCU_CACHE_PROTECTION), \
                              .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                              .L2_INPUT_LATENCY     (L2_INPUT_LATENCY),     \
                              .L2_OUTPUT_LATENCY    (L2_OUTPUT_LATENCY),    \
                              .AXI4                 (AXI4),                 \
                              .ACE                  (ACE),                  \
                              .ACP                  (ACP))

`define MERCURY_STB_PARAM_DECL #(parameter CPU_CACHE_PROTECTION = 1'b0, \
                              parameter MINISCU              = 1'b0, \
                              parameter ALL_LINES_UNIQUE     = 1'b0)
                              
`define MERCURY_STB_PARAM_INST #(.CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                              .MINISCU              (MINISCU),              \
                              .ALL_LINES_UNIQUE     (ALL_LINES_UNIQUE))

`define MERCURY_L2_PARAM_DECL #(parameter NUM_CPUS             = 4,       \
                             parameter NEON_FP              = 4'b0000, \
                             parameter CRYPTO               = 4'b0000, \
                             parameter L2_CACHE             = 1'b0,    \
                             parameter L1_DCACHE_SIZE       = 3'b011,  \
                             parameter L2_CACHE_SIZE        = 3'b001,  \
                             parameter L2_INPUT_LATENCY     = 1'b0,    \
                             parameter L2_OUTPUT_LATENCY    = 1'b0,    \
                             parameter SCU_CACHE_PROTECTION = 1'b0,    \
                             parameter CPU_CACHE_PROTECTION = 1'b0,    \
                             parameter AXI4                 = 1'b0,    \
                             parameter ACE                  = 1'b1,    \
                             parameter ACP                  = 1'b0,    \
                             parameter LEGACY_V7_DEBUG_MAP  = 1'b0,    \
                             parameter GIC                  = 1'b1,    \
                             parameter ETM                  = 1'b1     )
`define MERCURY_L2_PARAM_INST #(.NUM_CPUS             (NUM_CPUS),             \
                             .NEON_FP              (NEON_FP),              \
                             .CRYPTO               (CRYPTO),               \
                             .L2_CACHE             (L2_CACHE),             \
                             .L1_DCACHE_SIZE       (L1_DCACHE_SIZE),       \
                             .L2_CACHE_SIZE        (L2_CACHE_SIZE),        \
                             .L2_INPUT_LATENCY     (L2_INPUT_LATENCY),     \
                             .L2_OUTPUT_LATENCY    (L2_OUTPUT_LATENCY),    \
                             .SCU_CACHE_PROTECTION (SCU_CACHE_PROTECTION), \
                             .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                             .AXI4                 (AXI4),                 \
                             .ACE                  (ACE),                  \
                             .ACP                  (ACP),                  \
                             .LEGACY_V7_DEBUG_MAP  (LEGACY_V7_DEBUG_MAP),  \
                             .GIC                  (GIC),                  \
                             .ETM                  (ETM))

`define MERCURY_L1_RAM_PARAM_DECL #(parameter L1_ICACHE_SIZE       = 3'b011, \
                                 parameter L1_DCACHE_SIZE       = 3'b011, \
                                 parameter CPU_CACHE_PROTECTION = 1'b0)
`define MERCURY_L1_RAM_PARAM_INST #(.L1_ICACHE_SIZE       (L1_ICACHE_SIZE), \
                                 .L1_DCACHE_SIZE       (L1_DCACHE_SIZE), \
                                 .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION))

`define MERCURY_L1D_RAM_PARAM_DECL #(parameter NUM_CPUS             = 4,      \
                                  parameter L1_DCACHE_SIZE       = 3'b011, \
                                  parameter SCU_CACHE_PROTECTION = 1'b0,   \
                                  parameter CPU_CACHE_PROTECTION = 1'b0)
`define MERCURY_L1D_RAM_PARAM_INST #(.NUM_CPUS             (NUM_CPUS),             \
                                  .L1_DCACHE_SIZE       (L1_DCACHE_SIZE),       \
                                  .SCU_CACHE_PROTECTION (SCU_CACHE_PROTECTION), \
                                  .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION))

`define MERCURY_L2_RAM_PARAM_DECL #(parameter L2_CACHE_SIZE        = 3'b001,  \
                                 parameter L2_INPUT_LATENCY     = 1'b0,    \
                                 parameter L2_OUTPUT_LATENCY    = 1'b0,    \
                                 parameter SCU_CACHE_PROTECTION = 1'b0,    \
                                 parameter CPU_CACHE_PROTECTION = 1'b0)
`define MERCURY_L2_RAM_PARAM_INST #(.L2_CACHE_SIZE        (L2_CACHE_SIZE),        \
                                 .L2_INPUT_LATENCY     (L2_INPUT_LATENCY),     \
                                 .L2_OUTPUT_LATENCY    (L2_OUTPUT_LATENCY),    \
                                 .SCU_CACHE_PROTECTION (SCU_CACHE_PROTECTION), \
                                 .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION))

`define MERCURY_GOVERNOR_PARAM_DECL #(parameter NUM_CPUS             = 4,       \
                                   parameter NEON_FP              = 4'b0000, \
                                   parameter CRYPTO               = 4'b0000, \
                                   parameter SCU_CACHE_PROTECTION = 1'b0,    \
                                   parameter CPU_CACHE_PROTECTION = 1'b0,    \
                                   parameter L2_INPUT_LATENCY     = 1'b0,    \
                                   parameter L2_OUTPUT_LATENCY    = 1'b0,    \
                                   parameter ACE                  = 1'b1,    \
                                   parameter AXI4                 = 1'b0,    \
                                   parameter LEGACY_V7_DEBUG_MAP  = 1'b0,    \
                                   parameter GIC                  = 1'b1,    \
                                   parameter ETM                  = 1'b1)
`define MERCURY_GOVERNOR_PARAM_INST #(.NUM_CPUS             (NUM_CPUS),             \
                                   .NEON_FP              (NEON_FP),              \
                                   .CRYPTO               (CRYPTO),               \
                                   .SCU_CACHE_PROTECTION (SCU_CACHE_PROTECTION), \
                                   .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                                   .L2_INPUT_LATENCY     (L2_INPUT_LATENCY),     \
                                   .L2_OUTPUT_LATENCY    (L2_OUTPUT_LATENCY),    \
                                   .ACE                  (ACE),                  \
                                   .AXI4                 (AXI4),                 \
                                   .LEGACY_V7_DEBUG_MAP  (LEGACY_V7_DEBUG_MAP),  \
                                   .GIC                  (GIC),                  \
                                   .ETM                  (ETM))

`define MERCURY_GOVERNOR_CPU_PARAM_DECL #(parameter NUM_CPUS             = 4,       \
                                       parameter NEON_FP              = 1'b0,    \
                                       parameter CRYPTO               = 1'b0,    \
                                       parameter SCU_CACHE_PROTECTION = 1'b0,    \
                                       parameter CPU_CACHE_PROTECTION = 1'b0,    \
                                       parameter L2_INPUT_LATENCY     = 1'b0,    \
                                       parameter L2_OUTPUT_LATENCY    = 1'b0,    \
                                       parameter ACE                  = 1'b1,    \
                                       parameter AXI4                 = 1'b0,    \
                                       parameter LEGACY_V7_DEBUG_MAP  = 1'b0,    \
                                       parameter GIC                  = 1'b1,    \
                                       parameter ETM                  = 1'b1)
`define MERCURY_GOVERNOR_CPU_PARAM_INST #(.NUM_CPUS             (NUM_CPUS),             \
                                       .NEON_FP              (NEON_FP[cpu]),         \
                                       .CRYPTO               (CRYPTO[cpu]),          \
                                       .SCU_CACHE_PROTECTION (SCU_CACHE_PROTECTION), \
                                       .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                                       .L2_INPUT_LATENCY     (L2_INPUT_LATENCY),     \
                                       .L2_OUTPUT_LATENCY    (L2_OUTPUT_LATENCY),    \
                                       .ACE                  (ACE),                  \
                                       .AXI4                 (AXI4),                 \
                                       .LEGACY_V7_DEBUG_MAP  (LEGACY_V7_DEBUG_MAP),  \
                                       .GIC                  (GIC),                  \
                                       .ETM                  (ETM))

`define MERCURY_GOVERNOR_SUB_CPU_PARAM_DECL #(parameter NUM_CPUS             = 4,       \
                                           parameter NEON_FP              = 1'b0,    \
                                           parameter CRYPTO               = 1'b0,    \
                                           parameter SCU_CACHE_PROTECTION = 1'b0,    \
                                           parameter CPU_CACHE_PROTECTION = 1'b0,    \
                                           parameter L2_INPUT_LATENCY     = 1'b0,    \
                                           parameter L2_OUTPUT_LATENCY    = 1'b0,    \
                                           parameter ACE                  = 1'b1,    \
                                           parameter AXI4                 = 1'b0,    \
                                           parameter LEGACY_V7_DEBUG_MAP  = 1'b0,    \
                                           parameter GIC                  = 1'b1,    \
                                           parameter ETM                  = 1'b1)
`define MERCURY_GOVERNOR_SUB_CPU_PARAM_INST #(.NUM_CPUS             (NUM_CPUS),             \
                                           .NEON_FP              (NEON_FP),              \
                                           .CRYPTO               (CRYPTO),               \
                                           .SCU_CACHE_PROTECTION (SCU_CACHE_PROTECTION), \
                                           .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                                           .L2_INPUT_LATENCY     (L2_INPUT_LATENCY),     \
                                           .L2_OUTPUT_LATENCY    (L2_OUTPUT_LATENCY),    \
                                           .ACE                  (ACE),                  \
                                           .AXI4                 (AXI4),                 \
                                           .LEGACY_V7_DEBUG_MAP  (LEGACY_V7_DEBUG_MAP),  \
                                           .GIC                  (GIC),                  \
                                           .ETM                  (ETM))

`define MERCURY_GIC_PARAM_DECL #(parameter NUM_CPUS = 4)
`define MERCURY_GIC_PARAM_INST #(.NUM_CPUS(NUM_CPUS))

`define MERCURY_SCU_RAMS_PARAM_DECL parameter L2_CACHE             = 0,    \
                                 parameter CPU_CACHE_PROTECTION = 1'b0, \
                                 parameter SCU_CACHE_PROTECTION = 1'b0, \
                                 parameter L2_INPUT_LATENCY     = 1'b0, \
                                 parameter L2_OUTPUT_LATENCY    = 1'b0
`define MERCURY_SCU_RAMS_PARAM_INST #(.L2_CACHE             (L2_CACHE),             \
                                   .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                                   .SCU_CACHE_PROTECTION (SCU_CACHE_PROTECTION), \
                                   .L2_INPUT_LATENCY     (L2_INPUT_LATENCY),     \
                                   .L2_OUTPUT_LATENCY    (L2_OUTPUT_LATENCY))

`define MERCURY_GOV_SCU_PARAM_DECL parameter NUM_CPUS             = 1,    \
                                parameter CPU_CACHE_PROTECTION = 1'b0, \
                                parameter SCU_CACHE_PROTECTION = 1'b0
`define MERCURY_GOV_SCU_PARAM_INST #(.NUM_CPUS(NUM_CPUS),                          \
                                  .CPU_CACHE_PROTECTION (CPU_CACHE_PROTECTION), \
                                  .SCU_CACHE_PROTECTION (SCU_CACHE_PROTECTION))

`else

`undef MERCURY_AG_WIDTH
`undef MERCURY_REVISION
`undef MERCURY_VARIANT
`undef MERCURY_PERPH_REVISION
`undef MERCURY_PERPH_REV_AND
`undef MERCURY_IMPLEMENTOR
`undef MERCURY_ARCH_REVISED
`undef MERCURY_PART_NUM_11_8
`undef MERCURY_VFP_SUBARCH
`undef MERCURY_VFP_PART_NUM
`undef MERCURY_PART_NUM_7_0
`undef MERCURY_PMCR_IDCODE
`undef MERCURY_VFP_VARIANT
`undef MERCURY_IDCR_READ_VALUE
`undef MERCURY_CTR_CWG
`undef MERCURY_CTR_ERG
`undef MERCURY_CTR_DMINLINE
`undef MERCURY_CTR_L1IP
`undef MERCURY_CTR_IMINLINE
`undef MERCURY_MPIDR_READ_VALUE
`undef MERCURY_CLIDR_READ_VALUE
`undef MERCURY_CCSIDR_L2_READ_VALUE
`undef MERCURY_CCSIDR_L1D_READ_VALUE
`undef MERCURY_CCSIDR_L1I_READ_VALUE
`undef MERCURY_COMP0ID_RD_VAL
`undef MERCURY_COMP1ID_RD_VAL
`undef MERCURY_COMP2ID_RD_VAL
`undef MERCURY_COMP3ID_RD_VAL
`undef MERCURY_PMU_PART_NUM
`undef MERCURY_ETM_PART_NUM
`undef MERCURY_CTI_PART_NUM
`undef MERCURY_CTI_COMPONID0_VAL
`undef MERCURY_CTI_COMPONID1_VAL
`undef MERCURY_CTI_COMPONID2_VAL
`undef MERCURY_CTI_COMPONID3_VAL
`undef MERCURY_CTI_DEVTYPE_VAL
`undef MERCURY_CTI_DEVARCH_VAL
`undef MERCURY_ID_PFR0_READ_VALUE
`undef MERCURY_ID_PFR1_READ_VALUE
`undef MERCURY_ID_DFR0_READ_VALUE
`undef MERCURY_ID_AFR0_READ_VALUE
`undef MERCURY_ID_MMFR0_READ_VALUE
`undef MERCURY_ID_MMFR1_READ_VALUE
`undef MERCURY_ID_MMFR2_READ_VALUE
`undef MERCURY_ID_MMFR3_READ_VALUE
`undef MERCURY_ID_ISAR0_READ_VALUE
`undef MERCURY_ID_ISAR1_READ_VALUE
`undef MERCURY_ID_ISAR2_READ_VALUE
`undef MERCURY_ID_ISAR3_READ_VALUE
`undef MERCURY_ID_ISAR4_READ_VALUE
`undef MERCURY_ID_ISAR5_READ_VALUE
`undef MERCURY_FPSID_READ_VALUE
`undef MERCURY_MVFR0_READ_VALUE
`undef MERCURY_MVFR1_READ_VALUE
`undef MERCURY_MVFR2_READ_VALUE
`undef MERCURY_AA64PFR0_READ_VALUE
`undef MERCURY_AA64PFR1_READ_VALUE
`undef MERCURY_AA64DFR0_READ_VALUE
`undef MERCURY_AA64DFR1_READ_VALUE
`undef MERCURY_AA64AFR0_READ_VALUE
`undef MERCURY_AA64AFR1_READ_VALUE
`undef MERCURY_AA64ISAR0_READ_VALUE
`undef MERCURY_AA64ISAR1_READ_VALUE
`undef MERCURY_AA64MMFR0_READ_VALUE
`undef MERCURY_AA64MMFR1_READ_VALUE
`undef MERCURY_EDAA32PFR_READ_VALUE
`undef MERCURY_NUM_PMN
`undef MERCURY_PMCFGR_READ_VALUE
`undef MERCURY_PMCEID0_READ_VALUE
`undef MERCURY_PMDEVARCH_READ_VALUE
`undef MERCURY_PMDEVTYPE_READ_VALUE
`undef MERCURY_DBG_EDESR
`undef MERCURY_DBG_EDECR
`undef MERCURY_DBG_EDWAR_LO
`undef MERCURY_DBG_EDWAR_HI
`undef MERCURY_DBG_DTRRX
`undef MERCURY_DBG_EDITR
`undef MERCURY_DBG_EDSCR
`undef MERCURY_DBG_DTRTX
`undef MERCURY_DBG_EDRCR
`undef MERCURY_DBG_EDACR
`undef MERCURY_DBG_EDECCR
`undef MERCURY_DBG_EDPCSRlo
`undef MERCURY_DBG_EDCIDSR
`undef MERCURY_DBG_EDVIDSR
`undef MERCURY_DBG_EDPCSRhi
`undef MERCURY_DBG_OSLAR
`undef MERCURY_DBG_EDPRCR
`undef MERCURY_DBG_EDPRSR
`undef MERCURY_DBG_BVR0lo
`undef MERCURY_DBG_BVR0hi
`undef MERCURY_DBG_BCR0
`undef MERCURY_DBG_BVR1lo
`undef MERCURY_DBG_BVR1hi
`undef MERCURY_DBG_BCR1
`undef MERCURY_DBG_BVR2lo
`undef MERCURY_DBG_BVR2hi
`undef MERCURY_DBG_BCR2
`undef MERCURY_DBG_BVR3lo
`undef MERCURY_DBG_BVR3hi
`undef MERCURY_DBG_BCR3
`undef MERCURY_DBG_BVR4lo
`undef MERCURY_DBG_BVR4hi
`undef MERCURY_DBG_BCR4
`undef MERCURY_DBG_BVR5lo
`undef MERCURY_DBG_BVR5hi
`undef MERCURY_DBG_BCR5
`undef MERCURY_DBG_WVR0lo
`undef MERCURY_DBG_WVR0hi
`undef MERCURY_DBG_WCR0
`undef MERCURY_DBG_WVR1lo
`undef MERCURY_DBG_WVR1hi
`undef MERCURY_DBG_WCR1
`undef MERCURY_DBG_WVR2lo
`undef MERCURY_DBG_WVR2hi
`undef MERCURY_DBG_WCR2
`undef MERCURY_DBG_WVR3lo
`undef MERCURY_DBG_WVR3hi
`undef MERCURY_DBG_WCR3
`undef MERCURY_DBG_MIDR
`undef MERCURY_DBG_ID_AA64PFR0lo
`undef MERCURY_DBG_ID_AA64PFR0hi
`undef MERCURY_DBG_ID_AA64DFR0lo
`undef MERCURY_DBG_ID_AA64DFR0hi
`undef MERCURY_DBG_ID_AA64ISAR0lo
`undef MERCURY_DBG_ID_AA64ISAR0hi
`undef MERCURY_DBG_ID_AA64MMFR0lo
`undef MERCURY_DBG_ID_AA64MMFR0hi
`undef MERCURY_DBG_ID_AA64PFR1lo
`undef MERCURY_DBG_ID_AA64PFR1hi
`undef MERCURY_DBG_ID_AA64DFR1lo
`undef MERCURY_DBG_ID_AA64DFR1hi
`undef MERCURY_DBG_ID_AA64ISAR1lo
`undef MERCURY_DBG_ID_AA64ISAR1hi
`undef MERCURY_DBG_ID_AA64MMFR1lo
`undef MERCURY_DBG_ID_AA64MMFR1hi
`undef MERCURY_DBG_EDAA32PFR
`undef MERCURY_DBG_CLAIMSET
`undef MERCURY_DBG_CLAIMCLR
`undef MERCURY_DBG_DEVAFF0
`undef MERCURY_DBG_DEVAFF1
`undef MERCURY_DBG_LAR
`undef MERCURY_DBG_LSR
`undef MERCURY_DBG_AUTHSTATUS
`undef MERCURY_DBG_DEVARCH
`undef MERCURY_DBG_DEVID2
`undef MERCURY_DBG_DEVID1
`undef MERCURY_DBG_DEVID
`undef MERCURY_DBG_DEVTYPE
`undef MERCURY_DBG_PID4
`undef MERCURY_DBG_PID0
`undef MERCURY_DBG_PID1
`undef MERCURY_DBG_PID2
`undef MERCURY_DBG_PID3
`undef MERCURY_DBG_CID0
`undef MERCURY_DBG_CID1
`undef MERCURY_DBG_CID2
`undef MERCURY_DBG_CID3
`undef MERCURY_DBG_BVR
`undef MERCURY_DBG_WVR
`undef MERCURY_PMU_PMEVCNTRn_EL0
`undef MERCURY_PMU_PMCCNTR_EL0_lo
`undef MERCURY_PMU_PMCCNTR_EL0_hi
`undef MERCURY_PMU_PMEVTYPER0_EL0
`undef MERCURY_PMU_PMEVTYPERn_EL0
`undef MERCURY_PMU_PMCCFILTR_EL0
`undef MERCURY_PMU_PMCNTENSET_EL0
`undef MERCURY_PMU_PMCNTENCLR_EL0
`undef MERCURY_PMU_PMINTENSET_EL1
`undef MERCURY_PMU_PMINTENCLR_EL1
`undef MERCURY_PMU_PMOVSCLR_EL0
`undef MERCURY_PMU_PMSWINC_EL0
`undef MERCURY_PMU_PMOVSSET_EL0
`undef MERCURY_PMU_PMCFGR
`undef MERCURY_PMU_PMCR_EL0
`undef MERCURY_PMU_PMCEID0_EL0
`undef MERCURY_PMU_PMCEID1_EL0
`undef MERCURY_PMU_DEVAFF0
`undef MERCURY_PMU_DEVAFF1
`undef MERCURY_PMU_LAR
`undef MERCURY_PMU_LSR
`undef MERCURY_PMU_AUTHSTATUS
`undef MERCURY_PMU_DEVARCH
`undef MERCURY_PMU_DEVTYPE
`undef MERCURY_PMU_PID4
`undef MERCURY_PMU_PID0
`undef MERCURY_PMU_PID1
`undef MERCURY_PMU_PID2
`undef MERCURY_PMU_PID3
`undef MERCURY_PMU_CID0
`undef MERCURY_PMU_CID1
`undef MERCURY_PMU_CID2
`undef MERCURY_PMU_CID3
`undef MERCURY_ETM_OSLAR
`undef MERCURY_ETM_OSLSR
`undef MERCURY_ETM_PDCR
`undef MERCURY_ETM_PDSR
`undef MERCURY_ETM_DEVAFF0
`undef MERCURY_ETM_DEVAFF1
`undef MERCURY_ETM_LAR
`undef MERCURY_ETM_LSR
`undef MERCURY_ETM_AUTHSTATUS
`undef MERCURY_ETM_DEVARCH
`undef MERCURY_ETM_DEVTYPE
`undef MERCURY_ETM_PID4
`undef MERCURY_ETM_PID0
`undef MERCURY_ETM_PID1
`undef MERCURY_ETM_PID2
`undef MERCURY_ETM_PID3
`undef MERCURY_ETM_CID0
`undef MERCURY_ETM_CID1
`undef MERCURY_ETM_CID2
`undef MERCURY_ETM_CID3
`undef MERCURY_CTI_CONTROL_ADD
`undef MERCURY_CTI_INTACK_ADD
`undef MERCURY_CTI_APPSET_ADD
`undef MERCURY_CTI_APPCLR_ADD
`undef MERCURY_CTI_APPPULSE_ADD
`undef MERCURY_CTI_TRIGINSTATUS_ADD
`undef MERCURY_CTI_TRIGOUTSTATUS_ADD
`undef MERCURY_CTI_CHINSTATUS_ADD
`undef MERCURY_CTI_CHOUTSTATUS_ADD
`undef MERCURY_CTI_ITCONTROL_ADD
`undef MERCURY_CTI_CHANNELGATE_ADD
`undef MERCURY_CTI_CLAIMSET_ADD
`undef MERCURY_CTI_CLAIMCLR_ADD
`undef MERCURY_CTI_DEVAFF0
`undef MERCURY_CTI_DEVAFF1
`undef MERCURY_CTI_LOCKACCESS_ADD
`undef MERCURY_CTI_LOCKSTATUS_ADD
`undef MERCURY_CTI_AUTHSTATUS_ADD
`undef MERCURY_CTI_DEVARCH_ADD
`undef MERCURY_CTI_DEVID2_ADD
`undef MERCURY_CTI_DEVID1_ADD
`undef MERCURY_CTI_DEVID_ADD
`undef MERCURY_CTI_DEVTYPE_ADD
`undef MERCURY_CTI_PERIPHID4_ADD
`undef MERCURY_CTI_PERIPHID5_ADD
`undef MERCURY_CTI_PERIPHID6_ADD
`undef MERCURY_CTI_PERIPHID7_ADD
`undef MERCURY_CTI_PERIPHID0_ADD
`undef MERCURY_CTI_PERIPHID1_ADD
`undef MERCURY_CTI_PERIPHID2_ADD
`undef MERCURY_CTI_PERIPHID3_ADD
`undef MERCURY_CTI_COMPONID0_ADD
`undef MERCURY_CTI_COMPONID1_ADD
`undef MERCURY_CTI_COMPONID2_ADD
`undef MERCURY_CTI_COMPONID3_ADD
`undef MERCURY_DBG_VER
`undef MERCURY_NUM_BRP_CID
`undef MERCURY_NUM_BRP
`undef MERCURY_NUM_WRP
`undef MERCURY_DIDR_READ_VALUE
`undef MERCURY_DBGDEVID_READ_VALUE
`undef MERCURY_DBGDEVID1_READ_VALUE
`undef MERCURY_DBGDEVID2_READ_VALUE
`undef MERCURY_EDDEVID_READ_VALUE
`undef MERCURY_EDDEVID1_READ_VALUE
`undef MERCURY_EDDEVID2_READ_VALUE
`undef MERCURY_EDDEVARCH_READ_VALUE
`undef MERCURY_EDDEVTYPE_READ_VALUE
`undef MERCURY_ECC_ODD
`undef MERCURY_ECC_EVEN
`undef MERCURY_FAULT_VMSA_ALIGNMENT
`undef MERCURY_FAULT_VMSA_PAGEWALK_EXT1_DEC
`undef MERCURY_FAULT_VMSA_PAGEWALK_EXT1_SLV
`undef MERCURY_FAULT_VMSA_PAGEWALK_EXT1_ECC
`undef MERCURY_FAULT_VMSA_PAGEWALK_EXT2_DEC
`undef MERCURY_FAULT_VMSA_PAGEWALK_EXT2_SLV
`undef MERCURY_FAULT_VMSA_PAGEWALK_EXT2_ECC
`undef MERCURY_FAULT_VMSA_TRANSLATION_SEC
`undef MERCURY_FAULT_VMSA_TRANSLATION_PAGE
`undef MERCURY_FAULT_VMSA_ACCESS_SEC
`undef MERCURY_FAULT_VMSA_ACCESS_PAGE
`undef MERCURY_FAULT_VMSA_DOMAIN_SEC
`undef MERCURY_FAULT_VMSA_DOMAIN_PAGE
`undef MERCURY_FAULT_VMSA_PERMISSION_SEC
`undef MERCURY_FAULT_VMSA_PERMISSION_PAGE
`undef MERCURY_FAULT_VMSA_EXT_DEC
`undef MERCURY_FAULT_VMSA_EXT_SLV
`undef MERCURY_FAULT_VMSA_ECC
`undef MERCURY_FAULT_VMSA_LDREX
`undef MERCURY_FAULT_LPAE_ALIGNMENT
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_DEC
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_DEC_L0
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_DEC_L1
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_DEC_L2
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_DEC_L3
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_SLV
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_SLV_L0
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_SLV_L1
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_SLV_L2
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_SLV_L3
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_ECC
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_ECC_L0
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_ECC_L1
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_ECC_L2
`undef MERCURY_FAULT_LPAE_PAGEWALK_EXT_ECC_L3
`undef MERCURY_FAULT_LPAE_TRANSLATION
`undef MERCURY_FAULT_LPAE_TRANSLATION_L0
`undef MERCURY_FAULT_LPAE_TRANSLATION_L1
`undef MERCURY_FAULT_LPAE_TRANSLATION_L2
`undef MERCURY_FAULT_LPAE_TRANSLATION_L3
`undef MERCURY_FAULT_LPAE_ACCESS
`undef MERCURY_FAULT_LPAE_ACCESS_L0
`undef MERCURY_FAULT_LPAE_ACCESS_L1
`undef MERCURY_FAULT_LPAE_ACCESS_L2
`undef MERCURY_FAULT_LPAE_ACCESS_L3
`undef MERCURY_FAULT_LPAE_PERMISSION
`undef MERCURY_FAULT_LPAE_PERMISSION_L0
`undef MERCURY_FAULT_LPAE_PERMISSION_L1
`undef MERCURY_FAULT_LPAE_PERMISSION_L2
`undef MERCURY_FAULT_LPAE_PERMISSION_L3
`undef MERCURY_FAULT_LPAE_DOMAIN
`undef MERCURY_FAULT_LPAE_DOMAIN_L1
`undef MERCURY_FAULT_LPAE_DOMAIN_L2
`undef MERCURY_FAULT_LPAE_ADDR_SIZE
`undef MERCURY_FAULT_LPAE_ADDR_SIZE_L0
`undef MERCURY_FAULT_LPAE_ADDR_SIZE_L1
`undef MERCURY_FAULT_LPAE_ADDR_SIZE_L2
`undef MERCURY_FAULT_LPAE_ADDR_SIZE_L3
`undef MERCURY_FAULT_LPAE_EXT_DEC
`undef MERCURY_FAULT_LPAE_EXT_SLV
`undef MERCURY_FAULT_LPAE_LDREX
`undef MERCURY_FAULT_LPAE_ECC
`undef MERCURY_FAULT_LPAE_STACK_ALIGN
`undef MERCURY_FAULT_PAGEWALK_EXT
`undef MERCURY_FAULT_DOMAIN
`undef MERCURY_FAULT_ECC
`undef MERCURY_FAULT_ALIGNMENT
`undef MERCURY_FAULT_EXT
`undef MERCURY_FAULT_GEN_EXT
`undef MERCURY_FAULT_STACK_ALIGN
`undef MERCURY_MEM_NORMAL
`undef MERCURY_MEM_DEVICE
`undef MERCURY_MEM_DEVICE_nG
`undef MERCURY_MEM_nGnRnE
`undef MERCURY_MEM_nGnRE
`undef MERCURY_MEM_nGRE
`undef MERCURY_MEM_GRE
`undef MERCURY_MEM_WB
`undef MERCURY_MEM_WBWA
`undef MERCURY_MEM_WBRA
`undef MERCURY_MEM_WT
`undef MERCURY_MEM_NC
`undef MERCURY_MEM_OUTER_WB
`undef MERCURY_MEM_OUTER_WT
`undef MERCURY_MEM_OUTER_NC
`undef MERCURY_MEM_OUTER_RA
`undef MERCURY_MEM_OUTER_WA
`undef MERCURY_MEM_SHAREABLE
`undef MERCURY_MEM_O_SHAREABLE
`undef MERCURY_MEM_COHERENT
`undef MERCURY_MEM_COHERENT_SHAREABLE
`undef MERCURY_MEM_MERGEABLE
`undef MERCURY_MEM_REORDERABLE
`undef MERCURY_MEM_DEV_OVERRIDE
`undef MERCURY_MEM_TRANSIENT
`undef MERCURY_MEM_UNUSED
`undef MERCURY_ATTR_MATCH
`undef MERCURY_MEM_ICACHE_DISABLED
`undef MERCURY_MEM_DCACHE_DISABLED
`undef MERCURY_MEM_DEFAULT_CACHEABLE
`undef MERCURY_MEM_MMUOFF_ION
`undef MERCURY_MEM_MMUOFF_IOFF
`undef MERCURY_MEM_MMUOFF_D
`undef MERCURY_PAGE_DEV_STAGE1_NGNRNE_SHARE_OS
`undef MERCURY_PAGE_DEV_STAGE1_NGNRE_SHARE_OS
`undef MERCURY_PAGE_DEV_STAGE1_NGRE_SHARE_OS
`undef MERCURY_PAGE_DEV_STAGE1_GRE_SHARE_OS
`undef MERCURY_PAGE_DEV_STAGE2_NGNRNE_SHARE_OS
`undef MERCURY_PAGE_DEV_STAGE2_NGNRE_SHARE_OS
`undef MERCURY_PAGE_DEV_STAGE2_NGRE_SHARE_OS
`undef MERCURY_PAGE_DEV_STAGE2_GRE_SHARE_OS
`undef MERCURY_PAGE_INNER_NC_OUTER_NC_SHARE_OS
`undef MERCURY_PAGE_INNER_NC_OUTER_WT_SHARE_NS
`undef MERCURY_PAGE_INNER_NC_OUTER_WT_SHARE_OS
`undef MERCURY_PAGE_INNER_NC_OUTER_WB_SHARE_NS
`undef MERCURY_PAGE_INNER_NC_OUTER_WB_SHARE_OS
`undef MERCURY_PAGE_INNER_WT_OUTER_NC_SHARE_NS
`undef MERCURY_PAGE_INNER_WT_OUTER_NC_SHARE_OS
`undef MERCURY_PAGE_INNER_WT_OUTER_WT_SHARE_NS
`undef MERCURY_PAGE_INNER_WT_OUTER_WT_SHARE_OS
`undef MERCURY_PAGE_INNER_WT_OUTER_WB_SHARE_NS
`undef MERCURY_PAGE_INNER_WT_OUTER_WB_SHARE_OS
`undef MERCURY_PAGE_INNER_WBRA_OUTER_WBRA_SHARE_NS
`undef MERCURY_PAGE_INNER_WBRA_OUTER_WBRA_SHARE_OS
`undef MERCURY_PAGE_INNER_WBRWA_OUTER_WBRWA_SHARE_NS
`undef MERCURY_PAGE_INNER_WBRWA_OUTER_WBRWA_SHARE_OS
`undef MERCURY_PAGE_INNER_WBWA_OUTER_WBWA_SHARE_NS
`undef MERCURY_PAGE_INNER_WBRA_OUTER_WBRWA_SHARE_NS
`undef MERCURY_PAGE_INNER_WBRA_OUTER_WBRWA_SHARE_OS
`undef MERCURY_PAGE_INNER_WBRWA_OUTER_WBRA_SHARE_NS
`undef MERCURY_PAGE_INNER_WBRWA_OUTER_WBRA_SHARE_OS
`undef MERCURY_LDST_SIZE_BYTE
`undef MERCURY_LDST_SIZE_HWORD
`undef MERCURY_LDST_SIZE_WORD
`undef MERCURY_LDST_SIZE_DWORD
`undef MERCURY_MOESI_INVALID
`undef MERCURY_MOESI_SHARED
`undef MERCURY_MOESI_UNIQUE
`undef MERCURY_TAG_INVALID
`undef MERCURY_TAG_VALID
`undef MERCURY_TAG_SHARED
`undef MERCURY_TAG_UNIQUE
`undef MERCURY_TAG_MIGRATORY
`undef MERCURY_CP15_REG_CDBGDR0
`undef MERCURY_CP15_REG_CDBGDR1
`undef MERCURY_CP15_REG_CDBGDR2
`undef MERCURY_CP15_REG_CDBGDR3
`undef MERCURY_CP15_V2P_PAR
`undef MERCURY_CP15_REG_TTBR0
`undef MERCURY_CP15_REG_TTBR1
`undef MERCURY_CP15_REG_TTBR0_EL1
`undef MERCURY_CP15_REG_TTBR1_EL1
`undef MERCURY_CP15_REG_TTBCR
`undef MERCURY_CP15_REG_TCR_EL1
`undef MERCURY_CP15_REG_HTTBR
`undef MERCURY_CP15_REG_VTTBR
`undef MERCURY_CP15_REG_TTBR0_EL2
`undef MERCURY_CP15_REG_VTTBR_EL2
`undef MERCURY_CP15_REG_HTCR
`undef MERCURY_CP15_REG_VTCR
`undef MERCURY_CP15_REG_TCR_EL2
`undef MERCURY_CP15_REG_VTCR_EL2
`undef MERCURY_CP15_REG_PAR
`undef MERCURY_CP15_REG_PAR_EL1
`undef MERCURY_CP15_REG_MAIR0
`undef MERCURY_CP15_REG_MAIR_EL1
`undef MERCURY_CP15_REG_MAIR1
`undef MERCURY_CP15_REG_HMAIR0
`undef MERCURY_CP15_REG_MAIR_EL2
`undef MERCURY_CP15_REG_HMAIR1
`undef MERCURY_CP15_REG_CTXTID
`undef MERCURY_CP15_REG_CTXTID_EL1
`undef MERCURY_CP15_REG_TTBR0_EL3
`undef MERCURY_CP15_REG_TCR_EL3
`undef MERCURY_CP15_REG_MAIR_EL3
`undef MERCURY_CP15_REG_DBGBVR0
`undef MERCURY_CP15_REG_DBGBVR1
`undef MERCURY_CP15_REG_DBGBVR2
`undef MERCURY_CP15_REG_DBGBVR3
`undef MERCURY_CP15_REG_DBGBVR4
`undef MERCURY_CP15_REG_DBGBVR5
`undef MERCURY_CP15_REG_DBGBCR0
`undef MERCURY_CP15_REG_DBGBCR1
`undef MERCURY_CP15_REG_DBGBCR2
`undef MERCURY_CP15_REG_DBGBCR3
`undef MERCURY_CP15_REG_DBGBCR4
`undef MERCURY_CP15_REG_DBGBCR5
`undef MERCURY_CP15_REG_DBGWVR0
`undef MERCURY_CP15_REG_DBGWVR1
`undef MERCURY_CP15_REG_DBGWVR2
`undef MERCURY_CP15_REG_DBGWVR3
`undef MERCURY_CP15_REG_DBGWCR0
`undef MERCURY_CP15_REG_DBGWCR1
`undef MERCURY_CP15_REG_DBGWCR2
`undef MERCURY_CP15_REG_DBGWCR3
`undef MERCURY_CP15_REG_DBGVCR
`undef MERCURY_CP15_REG_DBGBXVR4
`undef MERCURY_CP15_REG_DBGBXVR5
`undef MERCURY_GICREG_PCPU
`undef MERCURY_GICREG_PCPU_W
`undef MERCURY_GICREG_PCPU_RESERVED
`undef MERCURY_GICREG_GICC_IAR1_EL1
`undef MERCURY_GICREG_GICC_IAR0_EL1
`undef MERCURY_GICREG_GICC_EOIR1_EL1
`undef MERCURY_GICREG_GICC_EOIR0_EL1
`undef MERCURY_GICREG_GICC_HPPIR1_EL1
`undef MERCURY_GICREG_GICC_HPPIR0_EL1
`undef MERCURY_GICREG_GICC_BPR1_EL1
`undef MERCURY_GICREG_GICC_BPR0_EL1
`undef MERCURY_GICREG_GICC_DIR_EL1
`undef MERCURY_GICREG_GICC_PMR_EL1
`undef MERCURY_GICREG_GICC_RPR
`undef MERCURY_GICREG_GICC_AP0R0_EL1
`undef MERCURY_GICREG_GICC_AP1R0_EL1
`undef MERCURY_GICREG_GICC_IGRPEN0_EL1
`undef MERCURY_GICREG_GICC_IGRPEN1_EL1
`undef MERCURY_GICREG_GICC_IGRPEN1_EL3
`undef MERCURY_GICREG_GICC_SRE_EL1
`undef MERCURY_GICREG_GICC_SRE_EL2
`undef MERCURY_GICREG_GICC_SRE_EL3
`undef MERCURY_GICREG_GICC_CTLR_EL1
`undef MERCURY_GICREG_GICC_CTLR_EL3
`undef MERCURY_GICREG_GICC_SGI0R_EL1
`undef MERCURY_GICREG_GICC_SGI1R_EL1
`undef MERCURY_GICREG_GICC_ASGI1R_EL1
`undef MERCURY_GICREG_VCPU
`undef MERCURY_GICREG_VCPU_W
`undef MERCURY_GICREG_VCPU_RESERVED
`undef MERCURY_GICREG_GICV_AIAR
`undef MERCURY_GICREG_GICV_IAR
`undef MERCURY_GICREG_GICV_AEOIR
`undef MERCURY_GICREG_GICV_EOIR
`undef MERCURY_GICREG_GICV_AHPPIR
`undef MERCURY_GICREG_GICV_HPPIR
`undef MERCURY_GICREG_GICH_VMCR_BPR1
`undef MERCURY_GICREG_GICH_VMCR_BPR0
`undef MERCURY_GICREG_GICV_DIR
`undef MERCURY_GICREG_GICH_VMCR_PMR
`undef MERCURY_GICREG_GICV_RPR
`undef MERCURY_GICREG_GICV_CTLR
`undef MERCURY_GICREG_GICH_APR0
`undef MERCURY_GICREG_GICH_APR1
`undef MERCURY_GICREG_GICH_VMCR_VENG0
`undef MERCURY_GICREG_GICH_VMCR_VENG1
`undef MERCURY_GICREG_GICH_HCR_SRE
`undef MERCURY_GICREG_GICH_HCR
`undef MERCURY_GICREG_GICH_VTR
`undef MERCURY_GICREG_GICH_VMCR
`undef MERCURY_GICREG_GICH_MISR
`undef MERCURY_GICREG_GICH_EISR
`undef MERCURY_GICREG_GICH_ELSR
`undef MERCURY_GICREG_GICH_LR0
`undef MERCURY_GICREG_GICH_LR1
`undef MERCURY_GICREG_GICH_LR2
`undef MERCURY_GICREG_GICH_LR3
`undef MERCURY_GICREG_GICH_LR0_L
`undef MERCURY_GICREG_GICH_LR1_L
`undef MERCURY_GICREG_GICH_LR2_L
`undef MERCURY_GICREG_GICH_LR3_L
`undef MERCURY_GICREG_GICH_LR0_H
`undef MERCURY_GICREG_GICH_LR1_H
`undef MERCURY_GICREG_GICH_LR2_H
`undef MERCURY_GICREG_GICH_LR3_H
`undef MERCURY_GICCP_W
`undef MERCURY_GICCP_GICC_IAR1_EL1
`undef MERCURY_GICCP_GICC_IAR0_EL1
`undef MERCURY_GICCP_GICC_EOIR1_EL1
`undef MERCURY_GICCP_GICC_EOIR0_EL1
`undef MERCURY_GICCP_GICC_HPPIR1_EL1
`undef MERCURY_GICCP_GICC_HPPIR0_EL1
`undef MERCURY_GICCP_GICC_BPR1_EL1
`undef MERCURY_GICCP_GICC_BPR0_EL1
`undef MERCURY_GICCP_GICC_DIR_EL1
`undef MERCURY_GICCP_GICC_PMR_EL1
`undef MERCURY_GICCP_GICC_RPR
`undef MERCURY_GICCP_GICC_AP0R0_EL1
`undef MERCURY_GICCP_GICC_AP1R0_EL1
`undef MERCURY_GICCP_GICC_IGRPEN0_EL1
`undef MERCURY_GICCP_GICC_IGRPEN1_EL1
`undef MERCURY_GICCP_GICC_IGRPEN1_EL3
`undef MERCURY_GICCP_GICC_SRE_EL1
`undef MERCURY_GICCP_GICC_SRE_EL2
`undef MERCURY_GICCP_GICC_SRE_EL3
`undef MERCURY_GICCP_GICC_CTLR_EL1
`undef MERCURY_GICCP_GICC_CTLR_EL3
`undef MERCURY_GICCP_GICC_SGI0R_EL1
`undef MERCURY_GICCP_GICC_SGI1R_EL1
`undef MERCURY_GICCP_GICC_ASGI1R_EL1
`undef MERCURY_GICCP_GICV_AIAR
`undef MERCURY_GICCP_GICV_IAR
`undef MERCURY_GICCP_GICV_AEOIR
`undef MERCURY_GICCP_GICV_EOIR
`undef MERCURY_GICCP_GICV_AHPPIR
`undef MERCURY_GICCP_GICV_HPPIR
`undef MERCURY_GICCP_GICH_VMCR_BPR1
`undef MERCURY_GICCP_GICH_VMCR_BPR0
`undef MERCURY_GICCP_GICV_DIR
`undef MERCURY_GICCP_GICH_VMCR_PMR
`undef MERCURY_GICCP_GICV_RPR
`undef MERCURY_GICCP_GICH_APR0
`undef MERCURY_GICCP_GICH_APR1
`undef MERCURY_GICCP_GICH_VMCR_VENG0
`undef MERCURY_GICCP_GICH_VMCR_VENG1
`undef MERCURY_GICCP_GICH_HCR_SRE
`undef MERCURY_GICCP_GICV_CTLR
`undef MERCURY_GICCP_GICH_HCR
`undef MERCURY_GICCP_GICH_VTR
`undef MERCURY_GICCP_GICH_VMCR
`undef MERCURY_GICCP_GICH_MISR
`undef MERCURY_GICCP_GICH_EISR
`undef MERCURY_GICCP_GICH_ELSR
`undef MERCURY_GICCP_GICH_LR0
`undef MERCURY_GICCP_GICH_LR0_L
`undef MERCURY_GICCP_GICH_LR0_H
`undef MERCURY_GICCP_GICH_LR1
`undef MERCURY_GICCP_GICH_LR1_L
`undef MERCURY_GICCP_GICH_LR1_H
`undef MERCURY_GICCP_GICH_LR2
`undef MERCURY_GICCP_GICH_LR2_L
`undef MERCURY_GICCP_GICH_LR2_H
`undef MERCURY_GICCP_GICH_LR3
`undef MERCURY_GICCP_GICH_LR3_L
`undef MERCURY_GICCP_GICH_LR3_H
`undef MERCURY_CPOP_IS_GOV
`undef MERCURY_CPOP_IS_GIC
`undef MERCURY_CPOP_IS_V2P
`undef MERCURY_CPOP_IS_TLBM
`undef MERCURY_CPOP_IS_DCM
`undef MERCURY_CPOP_IS_ICM
`undef MERCURY_CPOP_IS_BPM
`undef MERCURY_CPOP_IS_BAR
`undef MERCURY_CPOP_IS_DSB
`undef MERCURY_CPOP_IS_DMB
`undef MERCURY_CPOP_IS_DMBLD
`undef MERCURY_CPOP_IS_DCM_MVA
`undef MERCURY_CPOP_IS_DCM_SW
`undef MERCURY_CPOP_IS_ICM_MVA
`undef MERCURY_CPOP_IS_CLREX
`undef MERCURY_CPOP_IS_CLREX_NOP
`undef MERCURY_CPOP_IS_CDBG
`undef MERCURY_CPOP_IS_CDBG_DC
`undef MERCURY_CPOP_IS_CDBG_IC
`undef MERCURY_CPOP_IS_CDBG_TLB
`undef MERCURY_CPOP_IS_REG
`undef MERCURY_CPOP_8_IS_TLBM
`undef MERCURY_CPOP_8_IS_DCM
`undef MERCURY_CPOP_8_IS_ICM
`undef MERCURY_CPOP_8_IS_BPM
`undef MERCURY_CPOP_8_IS_BAR
`undef MERCURY_CPOP_8_IS_DSB
`undef MERCURY_CPOP_8_IS_DMB
`undef MERCURY_CPOP_8_IS_DMBST
`undef MERCURY_CPOP_8_IS_DCM_SW
`undef MERCURY_CPOP_8_IS_ICM_MVA
`undef MERCURY_CPOP_8_TLBM_IS_AA64
`undef MERCURY_CPOP_8_TLBM_AS_AA64
`undef MERCURY_CPOP_5_TLBM_AS_NON_IS
`undef MERCURY_CPOP_W
`undef MERCURY_CPOP_0
`undef MERCURY_CPOP_CDBGDCT
`undef MERCURY_CPOP_CDBGDCD
`undef MERCURY_CPOP_CDBGICT
`undef MERCURY_CPOP_CDBGICD
`undef MERCURY_CPOP_CDBGTD
`undef MERCURY_CPOP_CDBGDR0
`undef MERCURY_CPOP_CDBGDR1
`undef MERCURY_CPOP_CDBGDR2
`undef MERCURY_CPOP_CDBGDR3
`undef MERCURY_CPOP_TTBR0
`undef MERCURY_CPOP_TTBR0_EL1
`undef MERCURY_CPOP_TTBR1
`undef MERCURY_CPOP_TTBR1_EL1
`undef MERCURY_CPOP_TTBCR
`undef MERCURY_CPOP_TCR_EL1
`undef MERCURY_CPOP_HTTBR
`undef MERCURY_CPOP_TTBR0_EL2
`undef MERCURY_CPOP_VTTBR
`undef MERCURY_CPOP_VTTBR_EL2
`undef MERCURY_CPOP_HTCR
`undef MERCURY_CPOP_TCR_EL2
`undef MERCURY_CPOP_VTCR
`undef MERCURY_CPOP_VTCR_EL2
`undef MERCURY_CPOP_PAR
`undef MERCURY_CPOP_PAR_EL1
`undef MERCURY_CPOP_MAIR0
`undef MERCURY_CPOP_MAIR_EL1
`undef MERCURY_CPOP_MAIR1
`undef MERCURY_CPOP_HMAIR0
`undef MERCURY_CPOP_MAIR_EL2
`undef MERCURY_CPOP_HMAIR1
`undef MERCURY_CPOP_CONTEXTIDR
`undef MERCURY_CPOP_CONTEXTIDR_EL1
`undef MERCURY_CPOP_TTBR0_EL3
`undef MERCURY_CPOP_TCR_EL3
`undef MERCURY_CPOP_MAIR_EL3
`undef MERCURY_CPOP_DBGBVR0
`undef MERCURY_CPOP_DBGBVR1
`undef MERCURY_CPOP_DBGBVR2
`undef MERCURY_CPOP_DBGBVR3
`undef MERCURY_CPOP_DBGBVR4
`undef MERCURY_CPOP_DBGBVR5
`undef MERCURY_CPOP_DBGBCR0
`undef MERCURY_CPOP_DBGBCR1
`undef MERCURY_CPOP_DBGBCR2
`undef MERCURY_CPOP_DBGBCR3
`undef MERCURY_CPOP_DBGBCR4
`undef MERCURY_CPOP_DBGBCR5
`undef MERCURY_CPOP_DBGBXVR4
`undef MERCURY_CPOP_DBGBXVR5
`undef MERCURY_CPOP_DBGWVR0
`undef MERCURY_CPOP_DBGWVR1
`undef MERCURY_CPOP_DBGWVR2
`undef MERCURY_CPOP_DBGWVR3
`undef MERCURY_CPOP_DBGWCR0
`undef MERCURY_CPOP_DBGWCR1
`undef MERCURY_CPOP_DBGWCR2
`undef MERCURY_CPOP_DBGWCR3
`undef MERCURY_CPOP_DBGVCR
`undef MERCURY_CPOP_ATS1C
`undef MERCURY_CPOP_ATS12NSO
`undef MERCURY_CPOP_ATS1H
`undef MERCURY_CPOP_ATS1E01
`undef MERCURY_CPOP_ATS12E01
`undef MERCURY_CPOP_ATS1E2
`undef MERCURY_CPOP_ATS1E3
`undef MERCURY_CPOP_5_W
`undef MERCURY_CPOP_5_TLBIALL
`undef MERCURY_CPOP_5_TLBIALLIS
`undef MERCURY_CPOP_5_TLBIMVA
`undef MERCURY_CPOP_5_TLBIMVAIS
`undef MERCURY_CPOP_5_TLBIASID
`undef MERCURY_CPOP_5_TLBIASIDIS
`undef MERCURY_CPOP_5_TLBIMVAA
`undef MERCURY_CPOP_5_TLBIMVAAIS
`undef MERCURY_CPOP_5_TLBIMVAH
`undef MERCURY_CPOP_5_TLBIMVAHIS
`undef MERCURY_CPOP_5_TLBIALLH
`undef MERCURY_CPOP_5_TLBIALLHIS
`undef MERCURY_CPOP_5_TLBIALLNSNH
`undef MERCURY_CPOP_5_TLBIALLNSNHIS
`undef MERCURY_CPOP_5_TLBIMVAL
`undef MERCURY_CPOP_5_TLBIMVALIS
`undef MERCURY_CPOP_5_TLBIMVAAL
`undef MERCURY_CPOP_5_TLBIMVAALIS
`undef MERCURY_CPOP_5_TLBIMVALH
`undef MERCURY_CPOP_5_TLBIMVALHIS
`undef MERCURY_CPOP_5_TLBIIPAS2
`undef MERCURY_CPOP_5_TLBIIPAS2IS
`undef MERCURY_CPOP_5_TLBIIPAS2L
`undef MERCURY_CPOP_5_TLBIIPAS2LIS
`undef MERCURY_CPOP_8_W
`undef MERCURY_CPOP_8_TLBIALL
`undef MERCURY_CPOP_8_TLBIALLIS
`undef MERCURY_CPOP_8_TLBIMVA
`undef MERCURY_CPOP_8_TLBIMVAIS
`undef MERCURY_CPOP_8_TLBIASID
`undef MERCURY_CPOP_8_TLBIASIDIS
`undef MERCURY_CPOP_8_TLBIMVAA
`undef MERCURY_CPOP_8_TLBIMVAAIS
`undef MERCURY_CPOP_8_TLBIMVAH
`undef MERCURY_CPOP_8_TLBIMVAHIS
`undef MERCURY_CPOP_8_TLBIALLH
`undef MERCURY_CPOP_8_TLBIALLHIS
`undef MERCURY_CPOP_8_TLBIALLNSNH
`undef MERCURY_CPOP_8_TLBIALLNSNHIS
`undef MERCURY_CPOP_8_TLBIMVAL
`undef MERCURY_CPOP_8_TLBIMVALIS
`undef MERCURY_CPOP_8_TLBIMVAAL
`undef MERCURY_CPOP_8_TLBIMVAALIS
`undef MERCURY_CPOP_8_TLBIMVALH
`undef MERCURY_CPOP_8_TLBIMVALHIS
`undef MERCURY_CPOP_8_TLBIIPAS2
`undef MERCURY_CPOP_8_TLBIIPAS2IS
`undef MERCURY_CPOP_8_TLBIIPAS2L
`undef MERCURY_CPOP_8_TLBIIPAS2LIS
`undef MERCURY_CPOP_TLBIALL
`undef MERCURY_CPOP_TLBIALLIS
`undef MERCURY_CPOP_TLBIMVA
`undef MERCURY_CPOP_TLBIMVAIS
`undef MERCURY_CPOP_TLBIASID
`undef MERCURY_CPOP_TLBIASIDIS
`undef MERCURY_CPOP_TLBIMVAA
`undef MERCURY_CPOP_TLBIMVAAIS
`undef MERCURY_CPOP_TLBIMVAH
`undef MERCURY_CPOP_TLBIMVAHIS
`undef MERCURY_CPOP_TLBIALLH
`undef MERCURY_CPOP_TLBIALLHIS
`undef MERCURY_CPOP_TLBIALLNSNH
`undef MERCURY_CPOP_TLBIALLNSNHIS
`undef MERCURY_CPOP_TLBIMVAL
`undef MERCURY_CPOP_TLBIMVALIS
`undef MERCURY_CPOP_TLBIMVAAL
`undef MERCURY_CPOP_TLBIMVAALIS
`undef MERCURY_CPOP_TLBIMVALH
`undef MERCURY_CPOP_TLBIMVALHIS
`undef MERCURY_CPOP_TLBIIPAS2
`undef MERCURY_CPOP_TLBIIPAS2IS
`undef MERCURY_CPOP_TLBIIPAS2L
`undef MERCURY_CPOP_TLBIIPAS2LIS
`undef MERCURY_CPOP_5_TLBIVAE1
`undef MERCURY_CPOP_5_TLBIVAE1IS
`undef MERCURY_CPOP_5_TLBIVALE1
`undef MERCURY_CPOP_5_TLBIVALE1IS
`undef MERCURY_CPOP_5_TLBIVAAE1
`undef MERCURY_CPOP_5_TLBIVAAE1IS
`undef MERCURY_CPOP_5_TLBIVAALE1
`undef MERCURY_CPOP_5_TLBIVAALE1IS
`undef MERCURY_CPOP_5_TLBIIPAS2E1
`undef MERCURY_CPOP_5_TLBIIPAS2E1IS
`undef MERCURY_CPOP_5_TLBIIPAS2LE1
`undef MERCURY_CPOP_5_TLBIIPAS2LE1IS
`undef MERCURY_CPOP_5_TLBIVAE2
`undef MERCURY_CPOP_5_TLBIVAE2IS
`undef MERCURY_CPOP_5_TLBIVALE2
`undef MERCURY_CPOP_5_TLBIVALE2IS
`undef MERCURY_CPOP_5_TLBIVAE3
`undef MERCURY_CPOP_5_TLBIVAE3IS
`undef MERCURY_CPOP_5_TLBIVALE3
`undef MERCURY_CPOP_5_TLBIVALE3IS
`undef MERCURY_CPOP_5_TLBIASIDE1
`undef MERCURY_CPOP_5_TLBIASIDE1IS
`undef MERCURY_CPOP_5_TLBIVMALLE1
`undef MERCURY_CPOP_5_TLBIVMALLE1IS
`undef MERCURY_CPOP_5_TLBIVMALLS12E1
`undef MERCURY_CPOP_5_TLBIVMALLS12E1IS
`undef MERCURY_CPOP_5_TLBIALLE1
`undef MERCURY_CPOP_5_TLBIALLE1IS
`undef MERCURY_CPOP_5_TLBIALLE2
`undef MERCURY_CPOP_5_TLBIALLE2IS
`undef MERCURY_CPOP_5_TLBIALLE3
`undef MERCURY_CPOP_5_TLBIALLE3IS
`undef MERCURY_CPOP_8_TLBIVAE1
`undef MERCURY_CPOP_8_TLBIVAE1IS
`undef MERCURY_CPOP_8_TLBIVALE1
`undef MERCURY_CPOP_8_TLBIVALE1IS
`undef MERCURY_CPOP_8_TLBIVAAE1
`undef MERCURY_CPOP_8_TLBIVAAE1IS
`undef MERCURY_CPOP_8_TLBIVAALE1
`undef MERCURY_CPOP_8_TLBIVAALE1IS
`undef MERCURY_CPOP_8_TLBIIPAS2E1
`undef MERCURY_CPOP_8_TLBIIPAS2E1IS
`undef MERCURY_CPOP_8_TLBIIPAS2LE1
`undef MERCURY_CPOP_8_TLBIIPAS2LE1IS
`undef MERCURY_CPOP_8_TLBIVAE2
`undef MERCURY_CPOP_8_TLBIVAE2IS
`undef MERCURY_CPOP_8_TLBIVALE2
`undef MERCURY_CPOP_8_TLBIVALE2IS
`undef MERCURY_CPOP_8_TLBIVAE3
`undef MERCURY_CPOP_8_TLBIVAE3IS
`undef MERCURY_CPOP_8_TLBIVALE3
`undef MERCURY_CPOP_8_TLBIVALE3IS
`undef MERCURY_CPOP_8_TLBIASIDE1
`undef MERCURY_CPOP_8_TLBIASIDE1IS
`undef MERCURY_CPOP_8_TLBIVMALLE1
`undef MERCURY_CPOP_8_TLBIVMALLE1IS
`undef MERCURY_CPOP_8_TLBIVMALLS12E1
`undef MERCURY_CPOP_8_TLBIVMALLS12E1IS
`undef MERCURY_CPOP_8_TLBIALLE1
`undef MERCURY_CPOP_8_TLBIALLE1IS
`undef MERCURY_CPOP_8_TLBIALLE2
`undef MERCURY_CPOP_8_TLBIALLE2IS
`undef MERCURY_CPOP_8_TLBIALLE3
`undef MERCURY_CPOP_8_TLBIALLE3IS
`undef MERCURY_CPOP_TLBIVAE1
`undef MERCURY_CPOP_TLBIVAE1IS
`undef MERCURY_CPOP_TLBIVALE1
`undef MERCURY_CPOP_TLBIVALE1IS
`undef MERCURY_CPOP_TLBIVAAE1
`undef MERCURY_CPOP_TLBIVAAE1IS
`undef MERCURY_CPOP_TLBIVAALE1
`undef MERCURY_CPOP_TLBIVAALE1IS
`undef MERCURY_CPOP_TLBIIPAS2E1
`undef MERCURY_CPOP_TLBIIPAS2E1IS
`undef MERCURY_CPOP_TLBIIPAS2LE1
`undef MERCURY_CPOP_TLBIIPAS2LE1IS
`undef MERCURY_CPOP_TLBIVAE2
`undef MERCURY_CPOP_TLBIVAE2IS
`undef MERCURY_CPOP_TLBIVALE2
`undef MERCURY_CPOP_TLBIVALE2IS
`undef MERCURY_CPOP_TLBIVAE3
`undef MERCURY_CPOP_TLBIVAE3IS
`undef MERCURY_CPOP_TLBIVALE3
`undef MERCURY_CPOP_TLBIVALE3IS
`undef MERCURY_CPOP_TLBIASIDE1
`undef MERCURY_CPOP_TLBIASIDE1IS
`undef MERCURY_CPOP_TLBIVMALLE1
`undef MERCURY_CPOP_TLBIVMALLE1IS
`undef MERCURY_CPOP_TLBIVMALLS12E1
`undef MERCURY_CPOP_TLBIVMALLS12E1IS
`undef MERCURY_CPOP_TLBIALLE1
`undef MERCURY_CPOP_TLBIALLE1IS
`undef MERCURY_CPOP_TLBIALLE2
`undef MERCURY_CPOP_TLBIALLE2IS
`undef MERCURY_CPOP_TLBIALLE3
`undef MERCURY_CPOP_TLBIALLE3IS
`undef MERCURY_CPOP_CLREX
`undef MERCURY_CPOP_NOP
`undef MERCURY_CPOP_8_ICIALLUIS
`undef MERCURY_CPOP_8_ICIALLU
`undef MERCURY_CPOP_8_ICIMVAU
`undef MERCURY_CPOP_8_ICIVAU
`undef MERCURY_CPOP_8_BPIALLIS
`undef MERCURY_CPOP_8_BPIMVA
`undef MERCURY_CPOP_8_DCIMVAC
`undef MERCURY_CPOP_8_DCISW
`undef MERCURY_CPOP_8_DCCMVAC
`undef MERCURY_CPOP_8_DCCSW
`undef MERCURY_CPOP_8_DCCMVAU
`undef MERCURY_CPOP_8_DCCIMVAC
`undef MERCURY_CPOP_8_DCCISW
`undef MERCURY_CPOP_8_DMBNSHLD
`undef MERCURY_CPOP_8_DMBISHLD
`undef MERCURY_CPOP_8_DMBOSHLD
`undef MERCURY_CPOP_8_DMBLD
`undef MERCURY_CPOP_8_DSBNS
`undef MERCURY_CPOP_8_DSBIS
`undef MERCURY_CPOP_8_DSBOS
`undef MERCURY_CPOP_8_DSBSY
`undef MERCURY_CPOP_8_DMBNS
`undef MERCURY_CPOP_8_DMBIS
`undef MERCURY_CPOP_8_DMBOS
`undef MERCURY_CPOP_8_DMBSY
`undef MERCURY_CPOP_8_DMBNSST
`undef MERCURY_CPOP_8_DMBISST
`undef MERCURY_CPOP_8_DMBOSST
`undef MERCURY_CPOP_8_DMBSYST
`undef MERCURY_CPOP_ICIALLUIS
`undef MERCURY_CPOP_ICIALLU
`undef MERCURY_CPOP_ICIMVAU
`undef MERCURY_CPOP_ICIVAU
`undef MERCURY_CPOP_BPIALLIS
`undef MERCURY_CPOP_BPIMVA
`undef MERCURY_CPOP_DCIMVAC
`undef MERCURY_CPOP_DCISW
`undef MERCURY_CPOP_DCCMVAC
`undef MERCURY_CPOP_DCCSW
`undef MERCURY_CPOP_DCCMVAU
`undef MERCURY_CPOP_DCCIMVAC
`undef MERCURY_CPOP_DCCISW
`undef MERCURY_CPOP_DMBNSHLD
`undef MERCURY_CPOP_DMBISHLD
`undef MERCURY_CPOP_DMBOSHLD
`undef MERCURY_CPOP_DMBLD
`undef MERCURY_CPOP_DSBNS
`undef MERCURY_CPOP_DSBIS
`undef MERCURY_CPOP_DSBOS
`undef MERCURY_CPOP_DSBSY
`undef MERCURY_CPOP_DMBNS
`undef MERCURY_CPOP_DMBIS
`undef MERCURY_CPOP_DMBOS
`undef MERCURY_CPOP_DMBSY
`undef MERCURY_CPOP_DMBNSST
`undef MERCURY_CPOP_DMBISST
`undef MERCURY_CPOP_DMBOSST
`undef MERCURY_CPOP_DMBSYST
`undef MERCURY_CPOP_CNTFRQ_EL0
`undef MERCURY_CPOP_CNTPCT_EL0
`undef MERCURY_CPOP_CNTKCTL_EL1
`undef MERCURY_CPOP_CNTP_TVAL_EL0
`undef MERCURY_CPOP_CNTP_CTL_EL0
`undef MERCURY_CPOP_CNTV_TVAL_EL0
`undef MERCURY_CPOP_CNTV_CTL_EL0
`undef MERCURY_CPOP_CNTVCT_EL0
`undef MERCURY_CPOP_CNTP_CVAL_EL0
`undef MERCURY_CPOP_CNTV_CVAL_EL0
`undef MERCURY_CPOP_CNTVOFF_EL2
`undef MERCURY_CPOP_CNTHCTL_EL2
`undef MERCURY_CPOP_CNTHP_TVAL_EL2
`undef MERCURY_CPOP_CNTHP_CTL_EL2
`undef MERCURY_CPOP_CNTHP_CVAL_EL2
`undef MERCURY_CPOP_CNTPS_CTL_EL1
`undef MERCURY_CPOP_CNTPS_CVAL_EL1
`undef MERCURY_CPOP_CNTPS_TVAL_EL1
`undef MERCURY_CPOP_L2_ACTLR
`undef MERCURY_CPOP_L2_ECTLR
`undef MERCURY_CPOP_L2_CTLR
`undef MERCURY_CPOP_L2_MEM_ERR_SR
`undef MERCURY_CPOP_GICC_IAR1_EL1
`undef MERCURY_CPOP_GICC_IAR0_EL1
`undef MERCURY_CPOP_GICC_EOIR1_EL1
`undef MERCURY_CPOP_GICC_EOIR0_EL1
`undef MERCURY_CPOP_GICC_HPPIR1_EL1
`undef MERCURY_CPOP_GICC_HPPIR0_EL1
`undef MERCURY_CPOP_GICC_BPR1_EL1
`undef MERCURY_CPOP_GICC_BPR0_EL1
`undef MERCURY_CPOP_GICC_DIR_EL1
`undef MERCURY_CPOP_GICC_PMR_EL1
`undef MERCURY_CPOP_GICC_RPR_EL1
`undef MERCURY_CPOP_GICC_AP0R0_EL1
`undef MERCURY_CPOP_GICC_AP1R0_EL1
`undef MERCURY_CPOP_GICC_IGRPEN0_EL1
`undef MERCURY_CPOP_GICC_IGRPEN1_EL1
`undef MERCURY_CPOP_GICC_IGRPEN1_EL3
`undef MERCURY_CPOP_GICC_SRE_EL1
`undef MERCURY_CPOP_GICC_SRE_EL2
`undef MERCURY_CPOP_GICC_SRE_EL3
`undef MERCURY_CPOP_GICC_CTLR_EL1
`undef MERCURY_CPOP_GICC_CTLR_EL3
`undef MERCURY_CPOP_GICC_SGI0R_EL1
`undef MERCURY_CPOP_GICC_SGI1R_EL1
`undef MERCURY_CPOP_GICC_ASGI1R_EL1
`undef MERCURY_CPOP_GICV_IAR1
`undef MERCURY_CPOP_GICV_IAR0
`undef MERCURY_CPOP_GICV_EOIR1
`undef MERCURY_CPOP_GICV_EOIR0
`undef MERCURY_CPOP_GICV_HPPIR1
`undef MERCURY_CPOP_GICV_HPPIR0
`undef MERCURY_CPOP_GICH_VMCR_BPR1
`undef MERCURY_CPOP_GICH_VMCR_BPR0
`undef MERCURY_CPOP_GICV_DIR
`undef MERCURY_CPOP_GICH_VMCR_PMR
`undef MERCURY_CPOP_GICV_RPR
`undef MERCURY_CPOP_GICH_AP0R0
`undef MERCURY_CPOP_GICH_AP1R0
`undef MERCURY_CPOP_GICH_VMCR_VENG0
`undef MERCURY_CPOP_GICH_VMCR_VENG1
`undef MERCURY_CPOP_GICH_HCR_SRE
`undef MERCURY_CPOP_GICV_CTLR
`undef MERCURY_CPOP_GICH_HCR
`undef MERCURY_CPOP_GICH_VTR
`undef MERCURY_CPOP_GICH_VMCR
`undef MERCURY_CPOP_GICH_MISR
`undef MERCURY_CPOP_GICH_EISR
`undef MERCURY_CPOP_GICH_ELSR
`undef MERCURY_CPOP_GICH_LR0
`undef MERCURY_CPOP_GICH_LR0_L
`undef MERCURY_CPOP_GICH_LR0_H
`undef MERCURY_CPOP_GICH_LR1
`undef MERCURY_CPOP_GICH_LR1_L
`undef MERCURY_CPOP_GICH_LR1_H
`undef MERCURY_CPOP_GICH_LR2
`undef MERCURY_CPOP_GICH_LR2_L
`undef MERCURY_CPOP_GICH_LR2_H
`undef MERCURY_CPOP_GICH_LR3
`undef MERCURY_CPOP_GICH_LR3_L
`undef MERCURY_CPOP_GICH_LR3_H
`undef MERCURY_CPOP_8_SYNC
`undef MERCURY_CPOP_8_CLEANUNIQUE
`undef MERCURY_CPOP_8_WRITE
`undef MERCURY_SIZE_BYTE
`undef MERCURY_SIZE_HWORD
`undef MERCURY_SIZE_WORD
`undef MERCURY_SIZE_DWORD
`undef MERCURY_IDATA_RAM_W
`undef MERCURY_IDATA_WEN_W
`undef MERCURY_IDATA_STRB_W
`undef MERCURY_ITAG_RAM_W
`undef MERCURY_ITAG_DATA_W
`undef MERCURY_DDATA_RAM_W
`undef MERCURY_DDATA_WEN_W
`undef MERCURY_DTAG_RAM_W
`undef MERCURY_DDIRTY_RAM_W
`undef MERCURY_TLB_RAM_ADDR_W
`undef MERCURY_TLB_RAM_W
`undef MERCURY_MBIST0_DATA_W
`undef MERCURY_MBIST1_DATA_W
`undef MERCURY_MBIST0_ADDR_W
`undef MERCURY_MBIST1_ADDR_W
`undef MERCURY_MBIST0_RAMARRAY_W
`undef MERCURY_MBIST0_BE_W
`undef MERCURY_MBIST1_BE_W
`undef MERCURY_GIC_ID_W
`undef MERCURY_GIC_PRI_W
`undef MERCURY_RVBARADDR_W
`undef MERCURY_PADDRDBG_W
`undef MERCURY_PWDATADBG_W
`undef MERCURY_PRDATADBG_W
`undef MERCURY_ATREADYM_W
`undef MERCURY_AFVALIDM_W
`undef MERCURY_ATDATAM_W
`undef MERCURY_ATVALIDM_W
`undef MERCURY_ATBYTESM_W
`undef MERCURY_AFREADYM_W
`undef MERCURY_ATIDM_W
`undef MERCURY_SYNCREQM_W
`undef MERCURY_PMUEVNT_W
`undef MERCURY_PMUEVNT_CPU_W
`undef MERCURY_CTICH_W
`undef MERCURY_ARACTIVE_W
`undef MERCURY_ARVALID_W
`undef MERCURY_ARID_W
`undef MERCURY_ARTYPE_W
`undef MERCURY_ARATTRS_W
`undef MERCURY_ARWAY_W
`undef MERCURY_ARADDR_W
`undef MERCURY_ARWRAP_W
`undef MERCURY_ARLEN_W
`undef MERCURY_ARSIZE_W
`undef MERCURY_ARLOCK_W
`undef MERCURY_ARPRIV_W
`undef MERCURY_DRCREDIT_W
`undef MERCURY_DWVALID_W
`undef MERCURY_DWL2DB_W
`undef MERCURY_DWCHUNKS_W
`undef MERCURY_DWLAST_W
`undef MERCURY_DWSTRB_W
`undef MERCURY_DWDATA_W
`undef MERCURY_DWERR_W
`undef MERCURY_DWFATAL_W
`undef MERCURY_ACREADY_W
`undef MERCURY_CRVALID_W
`undef MERCURY_CRID_W
`undef MERCURY_CRDIRTY_W
`undef MERCURY_CRHIT_W
`undef MERCURY_CRAGE_W
`undef MERCURY_CRALLOC_W
`undef MERCURY_CRMIG_W
`undef MERCURY_CRVADDR_W
`undef MERCURY_INV_ALL_W
`undef MERCURY_DVM_COMP_W
`undef MERCURY_REQBUFS_BUSY_W
`undef MERCURY_DRAIN_STB_W
`undef MERCURY_ARCREDIT_W
`undef MERCURY_ARBLOCK_W
`undef MERCURY_DRVALID_W
`undef MERCURY_DRID_W
`undef MERCURY_DRRESP_W
`undef MERCURY_DRCHUNK_W
`undef MERCURY_DRDATA_W
`undef MERCURY_RRVALID_W
`undef MERCURY_RRID_W
`undef MERCURY_RRRESP_W
`undef MERCURY_RRL2DB_W
`undef MERCURY_EVDONE_W
`undef MERCURY_DBEXCLVAL_W
`undef MERCURY_DBEXCLRSP_W
`undef MERCURY_DBDECERR_W
`undef MERCURY_DBSLVERR_W
`undef MERCURY_LEAVERAM_W
`undef MERCURY_CPUBISTEN_W
`undef MERCURY_CPUSEV_W
`undef MERCURY_ACVALID_W
`undef MERCURY_ACID_W
`undef MERCURY_ACL2DB_W
`undef MERCURY_ACSNOOP_W
`undef MERCURY_ACADDR_W
`undef MERCURY_ACWAY_W
`undef MERCURY_ETMEXT_W
`undef MERCURY_L1DC_SIZE_W
`undef MERCURY_EXCP_LEV_W
`undef MERCURY_CPDATA_W
`undef MERCURY_CPADDR_W
`undef MERCURY_CPSEL_W
`undef MERCURY_TDATA_W
`undef MERCURY_RET_CTL_W
`undef MERCURY_GOV_CPDATA_W
`undef MERCURY_GOV_CPADDR_W
`undef MERCURY_RVBARADDR_PKDED_W
`undef MERCURY_PADDRDBG_PKDED_W
`undef MERCURY_PWDATADBG_PKDED_W
`undef MERCURY_PRDATADBG_PKDED_W
`undef MERCURY_ATREADYM_PKDED_W
`undef MERCURY_AFVALIDM_PKDED_W
`undef MERCURY_ATDATAM_PKDED_W
`undef MERCURY_ATVALIDM_PKDED_W
`undef MERCURY_ATBYTESM_PKDED_W
`undef MERCURY_AFREADYM_PKDED_W
`undef MERCURY_ATIDM_PKDED_W
`undef MERCURY_SYNCREQM_PKDED_W
`undef MERCURY_PMUEVNT_PKDED_W
`undef MERCURY_PMUEVNT_CPU_PKDED_W
`undef MERCURY_CTICH_PKDED_W
`undef MERCURY_ARACTIVE_PKDED_W
`undef MERCURY_ARVALID_PKDED_W
`undef MERCURY_ARID_PKDED_W
`undef MERCURY_ARTYPE_PKDED_W
`undef MERCURY_ARATTRS_PKDED_W
`undef MERCURY_ARWAY_PKDED_W
`undef MERCURY_ARADDR_PKDED_W
`undef MERCURY_ARWRAP_PKDED_W
`undef MERCURY_ARLEN_PKDED_W
`undef MERCURY_ARSIZE_PKDED_W
`undef MERCURY_ARLOCK_PKDED_W
`undef MERCURY_ARPRIV_PKDED_W
`undef MERCURY_DRCREDIT_PKDED_W
`undef MERCURY_DWVALID_PKDED_W
`undef MERCURY_DWL2DB_PKDED_W
`undef MERCURY_DWCHUNKS_PKDED_W
`undef MERCURY_DWLAST_PKDED_W
`undef MERCURY_DWSTRB_PKDED_W
`undef MERCURY_DWDATA_PKDED_W
`undef MERCURY_DWERR_PKDED_W
`undef MERCURY_DWFATAL_PKDED_W
`undef MERCURY_ACREADY_PKDED_W
`undef MERCURY_CRVALID_PKDED_W
`undef MERCURY_CRID_PKDED_W
`undef MERCURY_CRDIRTY_PKDED_W
`undef MERCURY_CRHIT_PKDED_W
`undef MERCURY_CRAGE_PKDED_W
`undef MERCURY_CRALLOC_PKDED_W
`undef MERCURY_CRMIG_PKDED_W
`undef MERCURY_CRVADDR_PKDED_W
`undef MERCURY_INV_ALL_PKDED_W
`undef MERCURY_DVM_COMP_PKDED_W
`undef MERCURY_REQBUFS_BUSY_PKDED_W
`undef MERCURY_DRAIN_STB_PKDED_W
`undef MERCURY_ARCREDIT_PKDED_W
`undef MERCURY_ARBLOCK_PKDED_W
`undef MERCURY_DRVALID_PKDED_W
`undef MERCURY_DRID_PKDED_W
`undef MERCURY_DRRESP_PKDED_W
`undef MERCURY_DRCHUNK_PKDED_W
`undef MERCURY_DRDATA_PKDED_W
`undef MERCURY_RRVALID_PKDED_W
`undef MERCURY_RRID_PKDED_W
`undef MERCURY_RRRESP_PKDED_W
`undef MERCURY_RRL2DB_PKDED_W
`undef MERCURY_EVDONE_PKDED_W
`undef MERCURY_DBEXCLVAL_PKDED_W
`undef MERCURY_DBEXCLRSP_PKDED_W
`undef MERCURY_DBDECERR_PKDED_W
`undef MERCURY_DBSLVERR_PKDED_W
`undef MERCURY_LEAVERAM_PKDED_W
`undef MERCURY_CPUBISTEN_PKDED_W
`undef MERCURY_CPUSEV_PKDED_W
`undef MERCURY_ACVALID_PKDED_W
`undef MERCURY_ACID_PKDED_W
`undef MERCURY_ACL2DB_PKDED_W
`undef MERCURY_ACSNOOP_PKDED_W
`undef MERCURY_ACADDR_PKDED_W
`undef MERCURY_ACWAY_PKDED_W
`undef MERCURY_ETMEXT_PKDED_W
`undef MERCURY_EXCP_LEV_PKDED_W
`undef MERCURY_CPDATA_PKDED_W
`undef MERCURY_CPADDR_PKDED_W
`undef MERCURY_CPSEL_PKDED_W
`undef MERCURY_TDATA_PKDED_W
`undef MERCURY_RET_CTL_PKDED_W
`undef MERCURY_GOV_CPDATA_PKDED_W
`undef MERCURY_GOV_CPADDR_PKDED_W
`undef MERCURY_SIZE_8K
`undef MERCURY_SIZE_16K
`undef MERCURY_SIZE_32K
`undef MERCURY_SIZE_64K
`undef MERCURY_MAX_NUM_CPUS
`undef MERCURY_RESP_OKAY
`undef MERCURY_RESP_EXOKAY
`undef MERCURY_RESP_SLVERR
`undef MERCURY_RESP_DECERR
`undef MERCURY_EL0
`undef MERCURY_EL1
`undef MERCURY_EL2
`undef MERCURY_EL3
`undef MERCURY_ONE_HOT_EL0
`undef MERCURY_ONE_HOT_EL1
`undef MERCURY_ONE_HOT_EL2
`undef MERCURY_ONE_HOT_EL3
`undef MERCURY_MODE_USR
`undef MERCURY_MODE_FIQ
`undef MERCURY_MODE_IRQ
`undef MERCURY_MODE_SVC
`undef MERCURY_MODE_ABT
`undef MERCURY_MODE_UND
`undef MERCURY_MODE_SYS
`undef MERCURY_MODE_MON
`undef MERCURY_MODE_HYP
`undef MERCURY_MODE_NONUSE
`undef MERCURY_FULL_MODE_USR
`undef MERCURY_FULL_MODE_FIQ
`undef MERCURY_FULL_MODE_IRQ
`undef MERCURY_FULL_MODE_SVC
`undef MERCURY_FULL_MODE_ABT
`undef MERCURY_FULL_MODE_UND
`undef MERCURY_FULL_MODE_SYS
`undef MERCURY_FULL_MODE_MON
`undef MERCURY_FULL_MODE_HYP
`undef MERCURY_FULL_MODE_EL0T
`undef MERCURY_FULL_MODE_EL1T
`undef MERCURY_FULL_MODE_EL1H
`undef MERCURY_FULL_MODE_EL2T
`undef MERCURY_FULL_MODE_EL2H
`undef MERCURY_FULL_MODE_EL3T
`undef MERCURY_FULL_MODE_EL3H
`undef MERCURY_FULL_MODE_NONUSE
`undef MERCURY_ONEHOT_MODE_USR_SYS
`undef MERCURY_ONEHOT_MODE_FIQ
`undef MERCURY_ONEHOT_MODE_IRQ
`undef MERCURY_ONEHOT_MODE_SVC
`undef MERCURY_ONEHOT_MODE_ABT
`undef MERCURY_ONEHOT_MODE_UND
`undef MERCURY_ONEHOT_MODE_MON
`undef MERCURY_ONEHOT_MODE_HYP
`undef MERCURY_ONEHOT_MODE_ELXT
`undef MERCURY_ONEHOT_MODE_EL1H
`undef MERCURY_ONEHOT_MODE_EL2H
`undef MERCURY_ONEHOT_MODE_EL3H
`undef MERCURY_ONEHOT_MODE_USR_SYS_BIT
`undef MERCURY_ONEHOT_MODE_FIQ_BIT
`undef MERCURY_ONEHOT_MODE_IRQ_BIT
`undef MERCURY_ONEHOT_MODE_SVC_BIT
`undef MERCURY_ONEHOT_MODE_ABT_BIT
`undef MERCURY_ONEHOT_MODE_UND_BIT
`undef MERCURY_ONEHOT_MODE_MON_BIT
`undef MERCURY_ONEHOT_MODE_HYP_BIT
`undef MERCURY_ONEHOT_MODE_ELXT_BIT
`undef MERCURY_ONEHOT_MODE_EL1H_BIT
`undef MERCURY_ONEHOT_MODE_EL2H_BIT
`undef MERCURY_ONEHOT_MODE_EL3H_BIT
`undef MERCURY_LOG2
`undef MERCURY_NORAM_PARAM_DECL
`undef MERCURY_NORAM_PARAM_INST
`undef MERCURY_CPU_PARAM_DECL
`undef MERCURY_CPU_PARAM_INST
`undef MERCURY_BIU_PARAM_DECL
`undef MERCURY_BIU_PARAM_INST
`undef MERCURY_DPU_PARAM_DECL
`undef MERCURY_DPU_PARAM_INST
`undef MERCURY_DCU_PARAM_DECL
`undef MERCURY_DCU_PARAM_INST
`undef MERCURY_TLB_PARAM_DECL
`undef MERCURY_TLB_PARAM_INST
`undef MERCURY_IFU_PARAM_DECL
`undef MERCURY_IFU_PARAM_INST
`undef MERCURY_MINISCU_PARAM_DECL
`undef MERCURY_MINISCU_PARAM_INST
`undef MERCURY_SCU_PARAM_DECL
`undef MERCURY_SCU_PARAM_INST
`undef MERCURY_STB_PARAM_DECL
`undef MERCURY_STB_PARAM_INST
`undef MERCURY_L2_PARAM_DECL
`undef MERCURY_L2_PARAM_INST
`undef MERCURY_L1_RAM_PARAM_DECL
`undef MERCURY_L1_RAM_PARAM_INST
`undef MERCURY_L1D_RAM_PARAM_DECL
`undef MERCURY_L1D_RAM_PARAM_INST
`undef MERCURY_L2_RAM_PARAM_DECL
`undef MERCURY_L2_RAM_PARAM_INST
`undef MERCURY_GOVERNOR_PARAM_DECL
`undef MERCURY_GOVERNOR_PARAM_INST
`undef MERCURY_GIC_PARAM_DECL
`undef MERCURY_GIC_PARAM_INST
`undef MERCURY_SCU_RAMS_PARAM_DECL
`undef MERCURY_SCU_RAMS_PARAM_INST
`undef MERCURY_GOV_SCU_PARAM_DECL
`undef MERCURY_GOV_SCU_PARAM_INST


`endif
